=== modified file '.bzrignore'
--- .bzrignore	2009-05-23 04:55:52 +0000
+++ .bzrignore	2009-06-10 19:56:16 +0000
@@ -38,12 +38,14 @@
 ./api
 doc/**/*.html
 doc/developers/performance.png
+bzrlib/_bencode_pyx.c
 bzrlib/_btree_serializer_c.c
 bzrlib/_chk_map_pyx.c
 bzrlib/_chunks_to_lines_pyx.c
 bzrlib/_dirstate_helpers_c.c
 bzrlib/_groupcompress_pyx.c
 bzrlib/_knit_load_data_c.c
+bzrlib/_known_graph_pyx.c
 bzrlib/_readdir_pyx.c
 bzrlib/_rio_pyx.c
 bzrlib/_walkdirs_win32.c

=== modified file 'Makefile'
--- Makefile	2009-05-28 18:03:38 +0000
+++ Makefile	2009-06-10 09:34:02 +0000
@@ -93,7 +93,11 @@
 	$(wildcard doc/es/guia-usario/*.txt) \
 	doc/es/mini-tutorial/index.txt \
 	doc/index.txt \
-	doc/index.es.txt
+	doc/index.es.txt \
+	doc/index.ru.txt \
+	doc/ru/user-guide/index.txt \
+	doc/ru/mini-tutorial/index.txt \
+	$(wildcard doc/ru/tutorials/*.txt)
 non_txt_files := \
        doc/default.css \
        doc/en/quick-reference/quick-start-summary.svg \
@@ -103,7 +107,11 @@
        doc/es/referencia-rapida/referencia-rapida.svg \
        doc/es/referencia-rapida/referencia-rapida.png \
        doc/es/referencia-rapida/referencia-rapida.pdf \
-       $(wildcard doc/es/guia-usuario/images/*.png)
+       $(wildcard doc/es/guia-usuario/images/*.png) \
+       doc/ru/quick-reference/quick-start-summary.svg \
+       doc/ru/quick-reference/quick-start-summary.png \
+       doc/ru/quick-reference/quick-start-summary.pdf \
+       $(wildcard doc/ru/user-guide/images/*.png)
 htm_files := $(patsubst %.txt, %.html, $(txt_files)) 
 
 # doc/developers/*.txt files that should *not* be individually
@@ -120,7 +128,6 @@
 	doc/developers/initial-push-pull.txt \
 	doc/developers/merge-scaling.txt \
 	doc/developers/missing.txt \
-	doc/developers/performance-contributing.txt \
 	doc/developers/performance-roadmap-rationale.txt \
 	doc/developers/performance-use-case-analysis.txt \
 	doc/developers/planned-change-integration.txt \
@@ -133,12 +140,13 @@
 dev_txt_files := $(filter-out $(dev_txt_nohtml), $(dev_txt_all))
 dev_htm_files := $(patsubst %.txt, %.html, $(dev_txt_files)) 
 
-doc/en/user-guide/index.html: $(wildcard $(addsuffix /*.txt, doc/en/user-guide)) 
-	$(rst2html) --stylesheet=../../default.css doc/en/user-guide/index.txt $@
+doc/%/user-guide/index.html: $(wildcard $(addsuffix /*.txt, doc/%/user-guide)) 
+	$(rst2html) --stylesheet=../../default.css $(dir $@)index.txt $@
 
 # Set the paper size for PDF files.
 # Options:  'a4' (ISO A4 size), 'letter' (US Letter size)
 PAPERSIZE = a4
+# TODO: Add generation for Russian PDF
 PDF_DOCS := doc/en/user-guide/user-guide.$(PAPERSIZE).pdf
 
 # Copy and modify the RST sources, and convert SVG images to PDF
@@ -162,6 +170,9 @@
 doc/index.html: doc/index.txt
 	$(rst2html) --stylesheet=default.css $< $@
 
+doc/index.%.html: doc/index.%.txt
+	$(rst2html) --stylesheet=default.css $< $@
+
 %.html: %.txt
 	$(rst2html) --stylesheet=../../default.css $< $@
 
@@ -189,11 +200,13 @@
 	$(PYTHON) generate_docs.py -o $@ man
 
 # build a png of our performance task list
+# 
+# this is no longer built by default; you can build it if you want to look at it
 doc/developers/performance.png: doc/developers/performance.dot
 	@echo Generating $@
 	@dot -Tpng $< -o$@ || echo "Dot not installed; skipping generation of $@"
 
-derived_web_docs = $(htm_files) $(dev_htm_files) doc/developers/performance.png
+derived_web_docs = $(htm_files) $(dev_htm_files) 
 WEB_DOCS = $(derived_web_docs) $(non_txt_files)
 ALL_DOCS = $(derived_web_docs) $(MAN_PAGES)
 
@@ -212,8 +225,8 @@
 clean-docs:
 	$(PYTHON) tools/win32/ostools.py remove $(ALL_DOCS) \
 	    $(HTMLDIR) $(derived_txt_files)
-	rm -f doc/en/user-guide/*.pdf
-	rm -rf doc/en/user-guide/latex_prepared
+	rm -f doc/*/user-guide/*.pdf
+	rm -rf doc/*/user-guide/latex_prepared
 
 
 ### Windows Support ###

=== modified file 'NEWS'
--- NEWS	2009-06-02 01:37:30 +0000
+++ NEWS	2009-06-17 10:04:37 +0000
@@ -9,12 +9,124 @@
 In Development
 ##############
 
+New Features
+************
+
+* ``bzr push`` now checks if uncommitted changes are present in the working
+  tree if the ``--strict`` option is used.
+  (Vincent Ladeuil, #284038)
+
+
+Bug Fixes
+*********
+
+* Add documentation about diverged branches and how to fix them in the
+  centralized workflow with local commits.  Mention ``bzr help
+  diverged-branches`` when a push fails because the branches have
+  diverged.  (Neil Martinsen-Burrell, #269477)
+
+* Better message in ``bzr split`` error suggesting a rich root format.
+  (Neil Martinsen-Burrell, #220067)
+
+* ``Branch.set_append_revisions_only`` now works with branches on a smart
+  server. (Andrew Bennetts, #365865)
+
+* Progress bars are now suppressed again when the environment variable
+  ``BZR_PROGRESS_BAR`` is set to ``none``.
+  (Martin Pool, #339385)
+
+Internals
+*********
+
+* Command lookup has had hooks added. ``bzrlib.Command.hooks`` has
+  three new hook points: ``get_command``, ``get_missing_command`` and
+  ``list_commands``, which allow just-in-time command name provision
+  rather than requiring all command names be known a-priori.
+  (Robert Collins)
+
+* ``graph.KnownGraph`` has been added. This is a class that can give
+  answers to ``heads()`` very quickly. However, it has the assumption that
+  the whole graph has already been loaded. This is true during
+  ``annotate`` so it is used there with good success (as much as 2x faster
+  for files with long ancestry and 'cherrypicked' changes.)
+  (John Arbash Meinel)
+
+
+Improvements
+************
+
+* Resolving a revno to a revision id on a branch accessed via ``bzr://``
+  or ``bzr+ssh://`` is now much faster and involves no VFS operations.
+  This speeds up commands like ``bzr pull -r 123``.  (Andrew Bennetts)
+
+Documentation
+*************
+
+* Minor clarifications to the help for End-Of-Line conversions.
+  (Ian Clatworthy)
+
+API Changes
+***********
+
+* Removed overspecific error class ``InvalidProgressBarType``.
+  (Martin Pool)
+
+* The method ``ProgressView._show_transport_activity`` is now
+  ``show_transport_activity`` because it's part of the contract between
+  this class and the UI.  (Martin Pool)
+
+
+bzr 1.16rc1 "It's yesterday in California" 2009-06-11
+#####################################################
+:Codename: yesterday-in-california
+
+This version of Bazaar contains the beta release of the new ``2a`` repository
+format, suitable for testing by fearless, advanced users. This format or an
+updated version of it will become the default format in Bazaar 2.0. Please
+read the NEWS entry before even thinking about upgrading to the new format.
+
+Also included are speedups for many operations on huge projects, a bug fix for
+pushing stacked new stacked branches to smart servers and the usual bevy of
+bug fixes and improvements.
+
+
 Compatibility Breaks
 ********************
 
+* Display prompt on stderr (instead of stdout) when querying users so
+  that the output of commands can be safely redirected.
+  (Vincent Ladeuil, #376582)
+
+
 New Features
 ************
 
+* A new repository format ``2a`` has been added.  This is a beta release
+  of the the brisbane-core (aka group-compress) project.  This format now
+  suitable for wider testing by advanced users willing to deal with some
+  bugs.  We would appreciate test reports, either positive or negative.
+  Format 2a is substantially smaller and faster for many operations on
+  many trees.  This format or an updated version will become the default
+  in bzr 2.0.
+
+  This is a rich-root format, so this repository format can be used with
+  bzr-svn.  Bazaar branches in previous non-rich-root formats can be
+  converted (including by merge, push and pull) to format 2a, but not vice
+  versa.  We recommend upgrading previous development formats to 2a.
+
+  Upgrading to this format can take considerable time because it expands
+  and more concisely repacks the full history.
+
+  If you use stacked branches, you must upgrade the stacked branches
+  before the stacked-on branches.  (See <https://bugs.launchpad.net/bugs/374735>)
+
+* ``--development7-rich-root`` is a new dev format, similar to ``--dev6``
+  but using a Revision serializer using bencode rather than XML.
+  (Jelmer Vernooij, John Arbash Meinel)
+
+* mail_client=claws now supports --body (and message body hooks).  Also uses
+  configured from address.  (Barry Warsaw)
+
 Improvements
 ************
 
@@ -23,6 +135,12 @@
   bugs with stacking and non default formats.)
   (John Arbash Meinel, #373455)
 
+* ``--development6-rich-root`` delays generating a delta index for the
+  first object inserted into a group. This has a beneficial impact on
+  ``bzr commit`` since each committed texts goes to its own group. For
+  committing a 90MB file, it drops peak memory by about 200MB, and speeds
+  up commit from 7s => 4s. (John Arbash Meinel)
+
 * Numerous operations are now faster for huge projects, i.e. those
   with a large number of files and/or a large number of revisions,
   particularly when the latest development format is used. These
@@ -35,13 +153,28 @@
 
   (Ian Clatworthy)
 
+* Pyrex version of ``bencode`` support. This provides optimized support
+  for both encoding and decoding, and is now found at ``bzrlib.bencode``.
+  ``bzrlib.utils.bencode`` is now deprecated.
+  (Alexander Belchenko, Jelmer Vernooij, John Arbash Meinel)
+
 
 Bug Fixes
 *********
 
+* Bazaar can now pass attachment files to the mutt email client.
+  (Edwin Grubbs, #384158)
+
 * Better message in ``bzr add`` output suggesting using ``bzr ignored`` to
   see which files can also be added.  (Jason Spashett, #76616)
 
+* ``bzr pull -r 123`` from a stacked branch on a smart server no longer fails.
+  Also, the ``Branch.revision_history()`` API now works in the same
+  situation.  (Andrew Bennetts, #380314)
+  
+* ``bzr serve`` on Windows no longer displays a traceback simply because a
+  TCP client disconnected. (Andrew Bennetts)
+
 * Clarify the rules for locking and fallback repositories. Fix bugs in how
   ``RemoteRepository`` was handling fallbacks along with the
   ``_real_repository``. (Andrew Bennetts, John Arbash Meinel, #375496)
@@ -51,36 +184,109 @@
   the fetched revisions, not in the stacked-on ancestry.
   (John Arbash Meinel)
 
+* Fix status and commit to work with content filtered trees, addressing
+  numerous bad bugs with line-ending support. (Ian Clatworthy, #362030)
+
+* Fix problem of "directory not empty" when contending for a lock over
+  sftp.  (Martin Pool, #340352)
+
+* Fix rule handling so that eol is optional, not mandatory.
+  (Ian Clatworthy, #379370)
+
+* Pushing a new stacked branch to a 1.15 smart server was broken due to a
+  bug in the ``BzrDirFormat.initialize_ex`` smart verb.  This is fixed in
+  1.16, but required changes to the network protocol, so the
+  ``BzrDirFormat.initialize_ex`` verb has been removed and replaced with a
+  corrected ``BzrDirFormat.initialize_ex_1.16`` verb.  1.15 clients will
+  still work with a 1.16 server as they will fallback to slower (and
+  bug-free) methods.
+  (Jonathan Lange, Robert Collins, Andrew Bennetts, #385132)
+
+* Reconcile can now deal with text revisions that originated in revisions 
+  that are ghosts. (Jelmer Vernooij, #336749)
+
+* Support cloning of branches with ghosts in the left hand side history.
+  (Jelmer Vernooij, #248540)
+
+* The ''bzr diff'' now catches OSError from osutils.rmtree and logs a
+  helpful message to the trace file, unless the temp directory really was
+  removed (which would be very strange).  Since the diff operation has
+  succeeded from the user's perspective, no output is written to stderr 
+  or stdout.  (Maritza Mendez, #363837)
+
+* Translate errors received from a smart server in response to a
+  ``BzrDirFormat.initialize`` or ``BzrDirFormat.initialize_ex`` request.
+  This was causing tracebacks even for mundane errors like
+  ``PermissionDenied``.  (Andrew Bennetts, #381329)
 
 Documentation
 *************
 
+* Added directory structure and started translation of docs in Russian.
+  (Alexey Shtokalo, Alexander Iljin, Alexander Belchenko, Dmitry Vasiliev,
+  Volodymyr Kotulskyi)
+
+
 API Changes
 ***********
 
 * Added osutils.parent_directories(). (Ian Clatworthy)
 
+* ``bzrlib.progress.ProgressBar``, ``ChildProgress``, ``DotsProgressBar``,
+  ``TTYProgressBar`` and ``child_progress`` are now deprecated; use
+  ``ui_factory.nested_progress_bar`` instead.  (Martin Pool)
+
+* ``graph.StackedParentsProvider`` is now a public API, replacing
+  ``graph._StackedParentsProvider``. The api is now considered stable and ready
+  for external users. (Gary van der Merwe)
+
+* ``bzrlib.user_encoding`` is deprecated in favor of
+  ``get_user_encoding``.  (Alexander Belchenko)
+
 * TreeTransformBase no longer assumes that limbo is provided via disk.
   DiskTreeTransform now provides disk functionality.  (Aaron Bentley)
 
-
 Internals
 *********
 
+* Remove ``weave.py`` script for accessing internals of old weave-format
+  repositories.  (Martin Pool)
+
 Testing
 *******
 
+* The number of cores is now correctly detected on OSX. (John Szakmeister)
+
+* The number of cores is also detected on Solaris and win32. (Vincent Ladeuil)
+
+* The number of cores is also detected on FreeBSD. (Matthew Fuller)
+
 
 bzr 1.15
 ########
 :1.15rc1: 2009-05-16
 :1.15: 2009-05-22
+:1.15.1: 2009-06-09
 
 The smart server will no longer raise 'NoSuchRevision' when streaming content
 with a size mismatch in a reconstructed graph search. New command ``bzr
 dpush``. Plugins can now define their own annotation tie-breaker when two
 revisions introduce the exact same line.
 
+Changes from 1.15.1 to 1.15.2
+*****************************
+
+* Use zdll on Windows to build ``_chk_map_pyx`` extension.
+  (Alexander Belchenko)
+
+Changes from 1.15final to 1.15.1
+*********************************
+
+* Translate errors received from a smart server in response to a
+  ``BzrDirFormat.initialize`` or ``BzrDirFormat.initialize_ex`` request.
+  This was causing tracebacks even for mundane errors like
+  ``PermissionDenied``.  (Andrew Bennetts, #381329)
+
 Changes from 1.15rc1 to 1.15final
 *********************************
 

=== modified file 'bzr'
--- bzr	2009-05-23 04:55:52 +0000
+++ bzr	2009-06-17 01:40:19 +0000
@@ -20,9 +20,10 @@
 
 import os
 import sys
+import warnings
 
 # update this on each release
-_script_version = (1, 16, 0)
+_script_version = (1, 17, 0)
 
 if __doc__ is None:
     print "bzr does not support python -OO."
@@ -78,6 +79,17 @@
 else:
     import locale
 
+
+# The python2.6 release includes some libraries that have deprecation warnings
+# against the interpreter - see https://bugs.launchpad.net/bzr/+bug/387139
+warnings.filterwarnings('ignore',
+    r"(struct integer overflow masking is deprecated|"
+    r"'L' format requires 0 <= number <= 4294967295)",
+    DeprecationWarning,
+    'gzip',
+    )
+
+
 try:
     locale.setlocale(locale.LC_ALL, '')
 except locale.Error, e:

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2009-05-23 04:55:52 +0000
+++ bzrlib/__init__.py	2009-06-17 06:59:03 +0000
@@ -50,10 +50,10 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (1, 16, 0, 'dev', 0)
+version_info = (1, 17, 0, 'dev', 0)
 
-# API compatibility version: bzrlib is currently API compatible with 1.13.
-api_minimum_version = (1, 15, 0)
+# API compatibility version: bzrlib is currently API compatible with 1.15.
+api_minimum_version = (1, 17, 0)
 
 def _format_version_tuple(version_info):
     """Turn a version number 2, 3 or 5-tuple into a short string.

=== added file 'bzrlib/_bencode_pyx.h'
--- bzrlib/_bencode_pyx.h	1970-01-01 00:00:00 +0000
+++ bzrlib/_bencode_pyx.h	2009-06-04 16:50:33 +0000
@@ -0,0 +1,22 @@
+/* Copyright (C) 2009 Canonical Ltd
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+/* Simple header providing some macro definitions for _bencode_pyx.pyx
+ */
+
+#define D_UPDATE_TAIL(self, n) (((self)->size -= (n), (self)->tail += (n)))
+#define E_UPDATE_TAIL(self, n) (((self)->size += (n), (self)->tail += (n)))

=== added file 'bzrlib/_bencode_pyx.pyx'
--- bzrlib/_bencode_pyx.pyx	1970-01-01 00:00:00 +0000
+++ bzrlib/_bencode_pyx.pyx	2009-06-05 01:48:32 +0000
@@ -0,0 +1,392 @@
+# Copyright (C) 2007,2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Pyrex implementation for bencode coder/decoder"""
+
+
+cdef extern from "stddef.h":
+    ctypedef unsigned int size_t
+
+cdef extern from "Python.h":
+    ctypedef int  Py_ssize_t
+    int PyInt_CheckExact(object o)
+    int PyLong_CheckExact(object o)
+    int PyString_CheckExact(object o)
+    int PyTuple_CheckExact(object o)
+    int PyList_CheckExact(object o)
+    int PyDict_CheckExact(object o)
+    int PyBool_Check(object o)
+    object PyString_FromStringAndSize(char *v, Py_ssize_t len)
+    char *PyString_AS_STRING(object o) except NULL
+    Py_ssize_t PyString_GET_SIZE(object o) except -1
+    object PyInt_FromString(char *str, char **pend, int base)
+    int Py_GetRecursionLimit()
+    int Py_EnterRecursiveCall(char *)
+    void Py_LeaveRecursiveCall()
+
+    int PyList_Append(object, object) except -1
+
+cdef extern from "stdlib.h":
+    void free(void *memblock)
+    void *malloc(size_t size)
+    void *realloc(void *memblock, size_t size)
+    long strtol(char *, char **, int)
+
+cdef extern from "string.h":
+    void *memcpy(void *dest, void *src, size_t count)
+
+cdef extern from "python-compat.h":
+    int snprintf(char* buffer, size_t nsize, char* fmt, ...)
+
+cdef class Decoder
+cdef class Encoder
+
+cdef extern from "_bencode_pyx.h":
+    void D_UPDATE_TAIL(Decoder, int n)
+    void E_UPDATE_TAIL(Encoder, int n)
+
+
+cdef class Decoder:
+    """Bencode decoder"""
+
+    cdef readonly char *tail
+    cdef readonly int size
+    cdef readonly int _yield_tuples
+    cdef object text
+
+    def __init__(self, s, yield_tuples=0):
+        """Initialize decoder engine.
+        @param  s:  Python string.
+        """
+        if not PyString_CheckExact(s):
+            raise TypeError("String required")
+
+        self.text = s
+        self.tail = PyString_AS_STRING(s)
+        self.size = PyString_GET_SIZE(s)
+        self._yield_tuples = int(yield_tuples)
+
+    def decode(self):
+        result = self._decode_object()
+        if self.size != 0:
+            raise ValueError('junk in stream')
+        return result
+
+    def decode_object(self):
+        return self._decode_object()
+
+    cdef object _decode_object(self):
+        cdef char ch
+
+        if 0 == self.size:
+            raise ValueError('stream underflow')
+
+        if Py_EnterRecursiveCall("_decode_object"):
+            raise RuntimeError("too deeply nested")
+        try:
+            ch = self.tail[0]
+            if c'0' <= ch <= c'9':
+                return self._decode_string()
+            elif ch == c'l':
+                D_UPDATE_TAIL(self, 1)
+                return self._decode_list()
+            elif ch == c'i':
+                D_UPDATE_TAIL(self, 1)
+                return self._decode_int()
+            elif ch == c'd':
+                D_UPDATE_TAIL(self, 1)
+                return self._decode_dict()
+            else:
+                raise ValueError('unknown object type identifier %r' % ch)
+        finally:
+            Py_LeaveRecursiveCall()
+
+    cdef int _read_digits(self, char stop_char) except -1:
+        cdef int i
+        i = 0
+        while ((self.tail[i] >= c'0' and self.tail[i] <= c'9') or
+               self.tail[i] == c'-') and i < self.size:
+            i = i + 1
+
+        if self.tail[i] != stop_char:
+            raise ValueError("Stop character %c not found: %c" % 
+                (stop_char, self.tail[i]))
+        if (self.tail[0] == c'0' or 
+                (self.tail[0] == c'-' and self.tail[1] == c'0')):
+            if i == 1:
+                return i
+            else:
+                raise ValueError # leading zeroes are not allowed
+        return i
+
+    cdef object _decode_int(self):
+        cdef int i
+        i = self._read_digits(c'e')
+        self.tail[i] = 0
+        try:
+            ret = PyInt_FromString(self.tail, NULL, 10)
+        finally:
+            self.tail[i] = c'e'
+        D_UPDATE_TAIL(self, i+1)
+        return ret
+
+    cdef object _decode_string(self):
+        cdef int n
+        cdef char *next_tail
+        # strtol allows leading whitespace, negatives, and leading zeros
+        # however, all callers have already checked that '0' <= tail[0] <= '9'
+        # or they wouldn't have called _decode_string
+        # strtol will stop at trailing whitespace, etc
+        n = strtol(self.tail, &next_tail, 10)
+        if next_tail == NULL or next_tail[0] != c':':
+            raise ValueError('string len not terminated by ":"')
+        # strtol allows leading zeros, so validate that we don't have that
+        if (self.tail[0] == c'0'
+            and (n != 0 or (next_tail - self.tail != 1))):
+            raise ValueError('leading zeros are not allowed')
+        D_UPDATE_TAIL(self, next_tail - self.tail + 1)
+        if n == 0:
+            return ''
+        if n > self.size:
+            raise ValueError('stream underflow')
+        if n < 0:
+            raise ValueError('string size below zero: %d' % n)
+
+        result = PyString_FromStringAndSize(self.tail, n)
+        D_UPDATE_TAIL(self, n)
+        return result
+
+    cdef object _decode_list(self):
+        result = []
+
+        while self.size > 0:
+            if self.tail[0] == c'e':
+                D_UPDATE_TAIL(self, 1)
+                if self._yield_tuples:
+                    return tuple(result)
+                else:
+                    return result
+            else:
+                # As a quick shortcut, check to see if the next object is a
+                # string, since we know that won't be creating recursion
+                # if self.tail[0] >= c'0' and self.tail[0] <= c'9':
+                PyList_Append(result, self._decode_object())
+
+        raise ValueError('malformed list')
+
+    cdef object _decode_dict(self):
+        cdef char ch
+
+        result = {}
+        lastkey = None
+
+        while self.size > 0:
+            ch = self.tail[0]
+            if ch == c'e':
+                D_UPDATE_TAIL(self, 1)
+                return result
+            else:
+                # keys should be strings only
+                if self.tail[0] < c'0' or self.tail[0] > c'9':
+                    raise ValueError('key was not a simple string.')
+                key = self._decode_string()
+                if lastkey >= key:
+                    raise ValueError('dict keys disordered')
+                else:
+                    lastkey = key
+                value = self._decode_object()
+                result[key] = value
+
+        raise ValueError('malformed dict')
+
+
+def bdecode(object s):
+    """Decode string x to Python object"""
+    return Decoder(s).decode()
+
+
+def bdecode_as_tuple(object s):
+    """Decode string x to Python object, using tuples rather than lists."""
+    return Decoder(s, True).decode()
+
+
+class Bencached(object):
+    __slots__ = ['bencoded']
+
+    def __init__(self, s):
+        self.bencoded = s
+
+
+cdef enum:
+    INITSIZE = 1024     # initial size for encoder buffer
+    INT_BUF_SIZE = 32
+
+
+cdef class Encoder:
+    """Bencode encoder"""
+
+    cdef readonly char *tail
+    cdef readonly int size
+    cdef readonly char *buffer
+    cdef readonly int maxsize
+
+    def __init__(self, int maxsize=INITSIZE):
+        """Initialize encoder engine
+        @param  maxsize:    initial size of internal char buffer
+        """
+        cdef char *p
+
+        self.maxsize = 0
+        self.size = 0
+        self.tail = NULL
+
+        p = <char*>malloc(maxsize)
+        if p == NULL:
+            raise MemoryError('Not enough memory to allocate buffer '
+                              'for encoder')
+        self.buffer = p
+        self.maxsize = maxsize
+        self.tail = p
+
+    def __del__(self):
+        free(self.buffer)
+        self.buffer = NULL
+        self.maxsize = 0
+
+    def __str__(self):
+        if self.buffer != NULL and self.size != 0:
+            return PyString_FromStringAndSize(self.buffer, self.size)
+        else:
+            return ''
+
+    cdef int _ensure_buffer(self, int required) except 0:
+        """Ensure that tail of CharTail buffer has enough size.
+        If buffer is not big enough then function try to
+        realloc buffer.
+        """
+        cdef char *new_buffer
+        cdef int   new_size
+
+        if self.size + required < self.maxsize:
+            return 1
+
+        new_size = self.maxsize
+        while new_size < self.size + required:
+            new_size = new_size * 2
+        new_buffer = <char*>realloc(self.buffer, <size_t>new_size)
+        if new_buffer == NULL:
+            raise MemoryError('Cannot realloc buffer for encoder')
+
+        self.buffer = new_buffer
+        self.maxsize = new_size
+        self.tail = &new_buffer[self.size]
+        return 1
+
+    cdef int _encode_int(self, int x) except 0:
+        """Encode int to bencode string iNNNe
+        @param  x:  value to encode
+        """
+        cdef int n
+        self._ensure_buffer(INT_BUF_SIZE)
+        n = snprintf(self.tail, INT_BUF_SIZE, "i%de", x)
+        if n < 0:
+            raise MemoryError('int %d too big to encode' % x)
+        E_UPDATE_TAIL(self, n)
+        return 1
+
+    cdef int _encode_long(self, x) except 0:
+        return self._append_string(''.join(('i', str(x), 'e')))
+
+    cdef int _append_string(self, s) except 0:
+        cdef Py_ssize_t n
+        n = PyString_GET_SIZE(s)
+        self._ensure_buffer(n)
+        memcpy(self.tail, PyString_AS_STRING(s), n)
+        E_UPDATE_TAIL(self, n)
+        return 1
+
+    cdef int _encode_string(self, x) except 0:
+        cdef int n
+        cdef Py_ssize_t x_len
+        x_len = PyString_GET_SIZE(x)
+        self._ensure_buffer(x_len + INT_BUF_SIZE)
+        n = snprintf(self.tail, INT_BUF_SIZE, '%d:', x_len)
+        if n < 0:
+            raise MemoryError('string %s too big to encode' % x)
+        memcpy(<void *>(self.tail+n), PyString_AS_STRING(x), x_len)
+        E_UPDATE_TAIL(self, n + x_len)
+        return 1
+
+    cdef int _encode_list(self, x) except 0:
+        self._ensure_buffer(1)
+        self.tail[0] = c'l'
+        E_UPDATE_TAIL(self, 1)
+
+        for i in x:
+            self.process(i)
+
+        self._ensure_buffer(1)
+        self.tail[0] = c'e'
+        E_UPDATE_TAIL(self, 1)
+        return 1
+
+    cdef int _encode_dict(self, x) except 0:
+        self._ensure_buffer(1)
+        self.tail[0] = c'd'
+        E_UPDATE_TAIL(self, 1)
+
+        keys = x.keys()
+        keys.sort()
+        for k in keys:
+            if not PyString_CheckExact(k):
+                raise TypeError('key in dict should be string')
+            self._encode_string(k)
+            self.process(x[k])
+
+        self._ensure_buffer(1)
+        self.tail[0] = c'e'
+        E_UPDATE_TAIL(self, 1)
+        return 1
+
+    def process(self, object x):
+        if Py_EnterRecursiveCall("encode"):
+            raise RuntimeError("too deeply nested")
+        try:
+            if PyString_CheckExact(x):
+                self._encode_string(x)
+            elif PyInt_CheckExact(x):
+                self._encode_int(x)
+            elif PyLong_CheckExact(x):
+                self._encode_long(x)
+            elif PyList_CheckExact(x) or PyTuple_CheckExact(x):
+                self._encode_list(x)
+            elif PyDict_CheckExact(x):
+                self._encode_dict(x)
+            elif PyBool_Check(x):
+                self._encode_int(int(x))
+            elif isinstance(x, Bencached):
+                self._append_string(x.bencoded)
+            else:
+                raise TypeError('unsupported type %r' % x)
+        finally:
+            Py_LeaveRecursiveCall()
+
+
+def bencode(x):
+    """Encode Python object x to string"""
+    encoder = Encoder()
+    encoder.process(x)
+    return str(encoder)

=== modified file 'bzrlib/_dirstate_helpers_c.pyx'
--- bzrlib/_dirstate_helpers_c.pyx	2009-03-23 14:59:43 +0000
+++ bzrlib/_dirstate_helpers_c.pyx	2009-06-09 01:52:10 +0000
@@ -1140,19 +1140,17 @@
                     if source_minikind != c'f':
                         content_change = 1
                     else:
-                        # If the size is the same, check the sha:
-                        if target_details[2] == source_details[2]:
-                            if link_or_sha1 is None:
-                                # Stat cache miss:
-                                statvalue, link_or_sha1 = \
-                                    self.state._sha1_provider.stat_and_sha1(
-                                    path_info[4])
-                                self.state._observed_sha1(entry, link_or_sha1,
-                                    statvalue)
-                            content_change = (link_or_sha1 != source_details[1])
-                        else:
-                            # Size changed, so must be different
-                            content_change = 1
+                        # Check the sha. We can't just rely on the size as
+                        # content filtering may mean differ sizes actually
+                        # map to the same content
+                        if link_or_sha1 is None:
+                            # Stat cache miss:
+                            statvalue, link_or_sha1 = \
+                                self.state._sha1_provider.stat_and_sha1(
+                                path_info[4])
+                            self.state._observed_sha1(entry, link_or_sha1,
+                                statvalue)
+                        content_change = (link_or_sha1 != source_details[1])
                     # Target details is updated at update_entry time
                     if self.use_filesystem_for_exec:
                         # We don't need S_ISREG here, because we are sure

=== modified file 'bzrlib/_groupcompress_pyx.pyx'
--- bzrlib/_groupcompress_pyx.pyx	2009-04-09 20:23:07 +0000
+++ bzrlib/_groupcompress_pyx.pyx	2009-06-10 03:56:49 +0000
@@ -118,6 +118,9 @@
             self._index = NULL
         safe_free(<void **>&self._source_infos)
 
+    def _has_index(self):
+        return (self._index != NULL)
+
     def add_delta_source(self, delta, unadded_bytes):
         """Add a new delta to the source texts.
 
@@ -171,6 +174,9 @@
         source_location = len(self._sources)
         if source_location >= self._max_num_sources:
             self._expand_sources()
+        if source_location != 0 and self._index == NULL:
+            # We were lazy about populating the index, create it now
+            self._populate_first_index()
         self._sources.append(source)
         c_source = PyString_AS_STRING(source)
         c_source_size = PyString_GET_SIZE(source)
@@ -179,11 +185,24 @@
         src.size = c_source_size
 
         src.agg_offset = self._source_offset + unadded_bytes
-        index = create_delta_index(src, self._index)
         self._source_offset = src.agg_offset + src.size
-        if index != NULL:
-            free_delta_index(self._index)
-            self._index = index
+        # We delay creating the index on the first insert
+        if source_location != 0:
+            index = create_delta_index(src, self._index)
+            if index != NULL:
+                free_delta_index(self._index)
+                self._index = index
+
+    cdef _populate_first_index(self):
+        cdef delta_index *index
+        if len(self._sources) != 1 or self._index != NULL:
+            raise AssertionError('_populate_first_index should only be'
+                ' called when we have a single source and no index yet')
+
+        # We know that self._index is already NULL, so whatever
+        # create_delta_index returns is fine
+        self._index = create_delta_index(&self._source_infos[0], NULL)
+        assert self._index != NULL
 
     cdef _expand_sources(self):
         raise RuntimeError('if we move self._source_infos, then we need to'
@@ -201,7 +220,10 @@
         cdef unsigned long delta_size
 
         if self._index == NULL:
-            return None
+            if len(self._sources) == 0:
+                return None
+            # We were just lazy about generating the index
+            self._populate_first_index()
 
         if not PyString_CheckExact(target_bytes):
             raise TypeError('target is not a str')

=== added file 'bzrlib/_known_graph_py.py'
--- bzrlib/_known_graph_py.py	1970-01-01 00:00:00 +0000
+++ bzrlib/_known_graph_py.py	2009-06-16 15:35:14 +0000
@@ -0,0 +1,344 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Implementation of Graph algorithms when we have already loaded everything.
+"""
+
+import heapq
+
+from bzrlib import (
+    revision,
+    )
+
+
+class _KnownGraphNode(object):
+    """Represents a single object in the known graph."""
+
+    __slots__ = ('key', 'parent_keys', 'child_keys', 'linear_dominator',
+                 'gdfo', 'ancestor_of')
+
+    def __init__(self, key, parent_keys):
+        self.key = key
+        self.parent_keys = parent_keys
+        self.child_keys = []
+        # oldest ancestor, such that no parents between here and there have >1
+        # child or >1 parent.
+        self.linear_dominator = None
+        # Greatest distance from origin
+        self.gdfo = None
+        # This will become a tuple of known heads that have this node as an
+        # ancestor
+        self.ancestor_of = None
+
+    def __repr__(self):
+        return '%s(%s  gdfo:%s par:%s child:%s %s)' % (
+            self.__class__.__name__, self.key, self.gdfo,
+            self.parent_keys, self.child_keys,
+            self.linear_dominator)
+
+
+class KnownGraph(object):
+    """This is a class which assumes we already know the full graph."""
+
+    def __init__(self, parent_map, do_cache=True):
+        """Create a new KnownGraph instance.
+
+        :param parent_map: A dictionary mapping key => parent_keys
+        """
+        self._nodes = {}
+        # Maps {sorted(revision_id, revision_id): heads}
+        self._known_heads = {}
+        self.do_cache = do_cache
+        self._initialize_nodes(parent_map)
+        self._find_linear_dominators()
+        self._find_gdfo()
+
+    def _initialize_nodes(self, parent_map):
+        """Populate self._nodes.
+
+        After this has finished, self._nodes will have an entry for every entry
+        in parent_map. Ghosts will have a parent_keys = None, all nodes found
+        will also have .child_keys populated with all known child_keys.
+        """
+        nodes = self._nodes
+        for key, parent_keys in parent_map.iteritems():
+            if key in nodes:
+                node = nodes[key]
+                node.parent_keys = parent_keys
+            else:
+                node = _KnownGraphNode(key, parent_keys)
+                nodes[key] = node
+            for parent_key in parent_keys:
+                try:
+                    parent_node = nodes[parent_key]
+                except KeyError:
+                    parent_node = _KnownGraphNode(parent_key, None)
+                    nodes[parent_key] = parent_node
+                parent_node.child_keys.append(key)
+
+    def _find_linear_dominators(self):
+        """For each node in the set, find any linear dominators.
+
+        For any given node, the 'linear dominator' is an ancestor, such that
+        all parents between this node and that one have a single parent, and a
+        single child. So if A->B->C->D then B,C,D all have a linear dominator
+        of A.
+
+        There are two main benefits:
+        1) When walking the graph, we can jump to the nearest linear dominator,
+           rather than walking all of the nodes inbetween.
+        2) When caching heads() results, dominators give the "same" results as
+           their children. (If the dominator is a head, then the descendant is
+           a head, if the dominator is not a head, then the child isn't
+           either.)
+        """
+        def check_node(node):
+            if node.parent_keys is None or len(node.parent_keys) != 1:
+                # This node is either a ghost, a tail, or has multiple parents
+                # It its own dominator
+                node.linear_dominator = node.key
+                return None
+            parent_node = self._nodes[node.parent_keys[0]]
+            if len(parent_node.child_keys) > 1:
+                # The parent has multiple children, so *this* node is the
+                # dominator
+                node.linear_dominator = node.key
+                return None
+            # The parent is already filled in, so add and continue
+            if parent_node.linear_dominator is not None:
+                node.linear_dominator = parent_node.linear_dominator
+                return None
+            # We don't know this node, or its parent node, so start walking to
+            # next
+            return parent_node
+
+        for node in self._nodes.itervalues():
+            # The parent is not filled in, so walk until we get somewhere
+            if node.linear_dominator is not None: #already done
+                continue
+            next_node = check_node(node)
+            if next_node is None:
+                # Nothing more needs to be done
+                continue
+            stack = []
+            while next_node is not None:
+                stack.append(node)
+                node = next_node
+                next_node = check_node(node)
+            # The stack now contains the linear chain, and 'node' should have
+            # been labeled
+            dominator = node.linear_dominator
+            while stack:
+                next_node = stack.pop()
+                next_node.linear_dominator = dominator
+                node = next_node
+
+    def _find_gdfo(self):
+        def find_tails():
+            return [node for node in self._nodes.itervalues()
+                       if not node.parent_keys]
+        tails = find_tails()
+        todo = []
+        heappush = heapq.heappush
+        heappop = heapq.heappop
+        nodes = self._nodes
+        for node in tails:
+            node.gdfo = 1
+            heappush(todo, (1, node))
+        processed = 0
+        while todo:
+            gdfo, next = heappop(todo)
+            processed += 1
+            if next.gdfo is not None and gdfo < next.gdfo:
+                # This node was reached from a longer path, we assume it was
+                # enqued correctly with the longer gdfo, so don't continue
+                # processing now
+                continue
+            next_gdfo = gdfo + 1
+            for child_key in next.child_keys:
+                child_node = nodes[child_key]
+                if child_node.gdfo is None or child_node.gdfo < next_gdfo:
+                    # Only enque children when all of their parents have been
+                    # resolved
+                    for parent_key in child_node.parent_keys:
+                        # We know that 'this' parent is counted
+                        if parent_key != next.key:
+                            parent_node = nodes[parent_key]
+                            if parent_node.gdfo is None:
+                                break
+                    else:
+                        child_node.gdfo = next_gdfo
+                        heappush(todo, (next_gdfo, child_node))
+
+    def _get_dominators_to_nodes(self, candidate_nodes):
+        """Get the reverse mapping from dominator_key => candidate_nodes.
+
+        As a side effect, this can also remove potential candidate nodes if we
+        determine that they share a dominator.
+        """
+        dom_to_node = {}
+        keys_to_remove = []
+        for node in candidate_nodes.values():
+            if node.linear_dominator in dom_to_node:
+                # This node already exists, resolve which node supersedes the
+                # other
+                other_node = dom_to_node[node.linear_dominator]
+                # There should be no way that nodes sharing a dominator could
+                # 'tie' for gdfo
+                if other_node.gdfo > node.gdfo:
+                    # The other node has this node as an ancestor
+                    keys_to_remove.append(node.key)
+                else:
+                    # Replace the other node, and set this as the new key
+                    keys_to_remove.append(other_node.key)
+                    dom_to_node[node.linear_dominator] = node
+            else:
+                dom_to_node[node.linear_dominator] = node
+        for key in keys_to_remove:
+            candidate_nodes.pop(key)
+        return dom_to_node
+
+    def heads(self, keys):
+        """Return the heads from amongst keys.
+
+        This is done by searching the ancestries of each key.  Any key that is
+        reachable from another key is not returned; all the others are.
+
+        This operation scales with the relative depth between any two keys. If
+        any two keys are completely disconnected all ancestry of both sides
+        will be retrieved.
+
+        :param keys: An iterable of keys.
+        :return: A set of the heads. Note that as a set there is no ordering
+            information. Callers will need to filter their input to create
+            order if they need it.
+        """
+        candidate_nodes = dict((key, self._nodes[key]) for key in keys)
+        if revision.NULL_REVISION in candidate_nodes:
+            # NULL_REVISION is only a head if it is the only entry
+            candidate_nodes.pop(revision.NULL_REVISION)
+            if not candidate_nodes:
+                return set([revision.NULL_REVISION])
+        if len(candidate_nodes) < 2:
+            return frozenset(candidate_nodes)
+        heads_key = frozenset(candidate_nodes)
+        if heads_key != frozenset(keys):
+            note('%s != %s', heads_key, frozenset(keys))
+        try:
+            heads = self._known_heads[heads_key]
+            return heads
+        except KeyError:
+            pass # compute it ourselves
+        dom_to_node = self._get_dominators_to_nodes(candidate_nodes)
+        if len(candidate_nodes) < 2:
+            # We shrunk candidate_nodes and determined a new head
+            return frozenset(candidate_nodes)
+        dom_heads_key = None
+        # Check the linear dominators of these keys, to see if we already
+        # know the heads answer
+        dom_heads_key = frozenset([node.linear_dominator
+                                   for node in candidate_nodes.itervalues()])
+        if dom_heads_key in self._known_heads:
+            # map back into the original keys
+            heads = self._known_heads[dom_heads_key]
+            heads = frozenset([dom_to_node[key].key for key in heads])
+            return heads
+        heads = self._heads_from_candidate_nodes(candidate_nodes, dom_to_node)
+        if self.do_cache:
+            self._known_heads[heads_key] = heads
+            # Cache the dominator heads
+            if dom_heads_key is not None:
+                dom_heads = frozenset([candidate_nodes[key].linear_dominator
+                                       for key in heads])
+                self._known_heads[dom_heads_key] = dom_heads
+        return heads
+
+    def _heads_from_candidate_nodes(self, candidate_nodes, dom_to_node):
+        queue = []
+        to_cleanup = []
+        to_cleanup_append = to_cleanup.append
+        for node in candidate_nodes.itervalues():
+            node.ancestor_of = (node.key,)
+            queue.append((-node.gdfo, node))
+            to_cleanup_append(node)
+        heapq.heapify(queue)
+        # These are nodes that we determined are 'common' that we are no longer
+        # walking
+        # Now we walk nodes until all nodes that are being walked are 'common'
+        num_candidates = len(candidate_nodes)
+        nodes = self._nodes
+        heappop = heapq.heappop
+        heappush = heapq.heappush
+        while queue and len(candidate_nodes) > 1:
+            _, node = heappop(queue)
+            next_ancestor_of = node.ancestor_of
+            if len(next_ancestor_of) == num_candidates:
+                # This node is now considered 'common'
+                # Make sure all parent nodes are marked as such
+                for parent_key in node.parent_keys:
+                    parent_node = nodes[parent_key]
+                    if parent_node.ancestor_of is not None:
+                        parent_node.ancestor_of = next_ancestor_of
+                if node.linear_dominator != node.key:
+                    parent_node = nodes[node.linear_dominator]
+                    if parent_node.ancestor_of is not None:
+                        parent_node.ancestor_of = next_ancestor_of
+                continue
+            if node.parent_keys is None:
+                # This is a ghost
+                continue
+            # Now project the current nodes ancestor list to the parent nodes,
+            # and queue them up to be walked
+            # Note: using linear_dominator speeds things up quite a bit
+            #       enough that we actually start to be slightly faster
+            #       than the default heads() implementation
+            if node.linear_dominator != node.key:
+                # We are at the tip of a long linear region
+                # We know that there is nothing between here and the tail
+                # that is interesting, so skip to the end
+                parent_keys = [node.linear_dominator]
+            else:
+                parent_keys = node.parent_keys
+            for parent_key in parent_keys:
+                if parent_key in candidate_nodes:
+                    candidate_nodes.pop(parent_key)
+                    if len(candidate_nodes) <= 1:
+                        break
+                elif parent_key in dom_to_node:
+                    orig_node = dom_to_node[parent_key]
+                    if orig_node is not node:
+                        if orig_node.key in candidate_nodes:
+                            candidate_nodes.pop(orig_node.key)
+                            if len(candidate_nodes) <= 1:
+                                break
+                parent_node = nodes[parent_key]
+                ancestor_of = parent_node.ancestor_of
+                if ancestor_of is None:
+                    # This node hasn't been walked yet
+                    parent_node.ancestor_of = next_ancestor_of
+                    # Enqueue this node
+                    heappush(queue, (-parent_node.gdfo, parent_node))
+                    to_cleanup_append(parent_node)
+                elif ancestor_of != next_ancestor_of:
+                    # Combine to get the full set of parents
+                    all_ancestors = set(ancestor_of)
+                    all_ancestors.update(next_ancestor_of)
+                    parent_node.ancestor_of = tuple(sorted(all_ancestors))
+        def cleanup():
+            for node in to_cleanup:
+                node.ancestor_of = None
+        cleanup()
+        return frozenset(candidate_nodes)

=== added file 'bzrlib/_known_graph_pyx.pyx'
--- bzrlib/_known_graph_pyx.pyx	1970-01-01 00:00:00 +0000
+++ bzrlib/_known_graph_pyx.pyx	2009-06-16 15:35:14 +0000
@@ -0,0 +1,605 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Implementation of Graph algorithms when we have already loaded everything.
+"""
+
+cdef extern from "python-compat.h":
+    pass
+
+cdef extern from "Python.h":
+    ctypedef int Py_ssize_t
+    ctypedef struct PyObject:
+        pass
+
+    object PyFrozenSet_New(object)
+    object PyTuple_New(Py_ssize_t n)
+    void PyTuple_SET_ITEM(object t, Py_ssize_t o, object v)
+    PyObject * PyTuple_GET_ITEM(object t, Py_ssize_t o)
+    Py_ssize_t PyTuple_GET_SIZE(object t)
+    PyObject * PyDict_GetItem(object d, object k)
+    Py_ssize_t PyDict_Size(object d) except -1
+    int PyDict_CheckExact(object d)
+    int PyDict_Next(object d, Py_ssize_t *pos, PyObject **k, PyObject **v)
+    int PyList_Append(object l, object v) except -1
+    PyObject * PyList_GET_ITEM(object l, Py_ssize_t o)
+    Py_ssize_t PyList_GET_SIZE(object l)
+    int PyDict_SetItem(object d, object k, object v) except -1
+    int PySet_Add(object s, object k) except -1
+    void Py_INCREF(object)
+
+
+import heapq
+
+from bzrlib import revision
+
+# Define these as cdef objects, so we don't have to getattr them later
+cdef object heappush, heappop, heapify, heapreplace
+heappush = heapq.heappush
+heappop = heapq.heappop
+heapify = heapq.heapify
+heapreplace = heapq.heapreplace
+
+
+cdef class _KnownGraphNode:
+    """Represents a single object in the known graph."""
+
+    cdef object key
+    cdef object parents
+    cdef object children
+    cdef _KnownGraphNode linear_dominator_node
+    cdef public object gdfo # Int
+    # This could also be simplified
+    cdef object ancestor_of
+
+    def __init__(self, key):
+        cdef int i
+
+        self.key = key
+        self.parents = None
+
+        self.children = []
+        # oldest ancestor, such that no parents between here and there have >1
+        # child or >1 parent.
+        self.linear_dominator_node = None
+        # Greatest distance from origin
+        self.gdfo = -1
+        # This will become a tuple of known heads that have this node as an
+        # ancestor
+        self.ancestor_of = None
+
+    property child_keys:
+        def __get__(self):
+            cdef _KnownGraphNode child
+
+            keys = []
+            for child in self.children:
+                PyList_Append(keys, child.key)
+            return keys
+
+    property linear_dominator:
+        def __get__(self):
+            if self.linear_dominator_node is None:
+                return None
+            else:
+                return self.linear_dominator_node.key
+
+    cdef clear_references(self):
+        self.parents = None
+        self.children = None
+        self.linear_dominator_node = None
+
+    def __repr__(self):
+        cdef _KnownGraphNode node
+
+        parent_keys = []
+        if self.parents is not None:
+            for node in self.parents:
+                parent_keys.append(node.key)
+        child_keys = []
+        if self.children is not None:
+            for node in self.children:
+                child_keys.append(node.key)
+        return '%s(%s  gdfo:%s par:%s child:%s %s)' % (
+            self.__class__.__name__, self.key, self.gdfo,
+            parent_keys, child_keys,
+            self.linear_dominator)
+
+
+cdef _KnownGraphNode _get_list_node(lst, Py_ssize_t pos):
+    cdef PyObject *temp_node
+
+    temp_node = PyList_GET_ITEM(lst, pos)
+    return <_KnownGraphNode>temp_node
+
+
+cdef _KnownGraphNode _get_parent(parents, Py_ssize_t pos):
+    cdef PyObject *temp_node
+    cdef _KnownGraphNode node
+
+    temp_node = PyTuple_GET_ITEM(parents, pos)
+    return <_KnownGraphNode>temp_node
+
+
+cdef _KnownGraphNode _peek_node(queue):
+    cdef PyObject *temp_node
+    cdef _KnownGraphNode node
+
+    temp_node = PyTuple_GET_ITEM(<object>PyList_GET_ITEM(queue, 0), 1)
+    node = <_KnownGraphNode>temp_node
+    return node
+
+# TODO: slab allocate all _KnownGraphNode objects.
+#       We already know how many we are going to need, except for a couple of
+#       ghosts that could be allocated on demand.
+
+cdef class KnownGraph:
+    """This is a class which assumes we already know the full graph."""
+
+    cdef public object _nodes
+    cdef object _known_heads
+    cdef public int do_cache
+    # Nodes we've touched that we'll need to reset their info when heads() is
+    # done
+    cdef object _to_cleanup
+
+    def __init__(self, parent_map, do_cache=True):
+        """Create a new KnownGraph instance.
+
+        :param parent_map: A dictionary mapping key => parent_keys
+        """
+        self._nodes = {}
+        # Maps {sorted(revision_id, revision_id): heads}
+        self._known_heads = {}
+        self._to_cleanup = []
+        self.do_cache = int(do_cache)
+        self._initialize_nodes(parent_map)
+        self._find_linear_dominators()
+        self._find_gdfo()
+
+    def __dealloc__(self):
+        cdef _KnownGraphNode child
+        cdef Py_ssize_t pos
+        cdef PyObject *temp_node
+
+        while PyDict_Next(self._nodes, &pos, NULL, &temp_node):
+            child = <_KnownGraphNode>temp_node
+            child.clear_references()
+
+    cdef _KnownGraphNode _get_or_create_node(self, key):
+        cdef PyObject *temp_node
+        cdef _KnownGraphNode node
+
+        temp_node = PyDict_GetItem(self._nodes, key)
+        if temp_node == NULL:
+            node = _KnownGraphNode(key)
+            PyDict_SetItem(self._nodes, key, node)
+        else:
+            node = <_KnownGraphNode>temp_node
+        return node
+
+    def _initialize_nodes(self, parent_map):
+        """Populate self._nodes.
+
+        After this has finished, self._nodes will have an entry for every entry
+        in parent_map. Ghosts will have a parent_keys = None, all nodes found
+        will also have .child_keys populated with all known child_keys.
+        """
+        cdef PyObject *temp_key, *temp_parent_keys, *temp_node
+        cdef Py_ssize_t pos, pos2, num_parent_keys
+        cdef _KnownGraphNode node
+        cdef _KnownGraphNode parent_node
+
+        nodes = self._nodes
+
+        if not PyDict_CheckExact(parent_map):
+            raise TypeError('parent_map should be a dict of {key:parent_keys}')
+        # for key, parent_keys in parent_map.iteritems():
+        pos = 0
+        while PyDict_Next(parent_map, &pos, &temp_key, &temp_parent_keys):
+            key = <object>temp_key
+            parent_keys = <object>temp_parent_keys
+            node = self._get_or_create_node(key)
+            # We know how many parents, so we could pre allocate an exact sized
+            # tuple here
+            num_parent_keys = len(parent_keys)
+            parent_nodes = PyTuple_New(num_parent_keys)
+            # We use iter here, because parent_keys maybe be a list or tuple
+            for pos2 from 0 <= pos2 < num_parent_keys:
+                parent_key = parent_keys[pos2]
+                parent_node = self._get_or_create_node(parent_keys[pos2])
+                # PyTuple_SET_ITEM will steal a reference, so INCREF first
+                Py_INCREF(parent_node)
+                PyTuple_SET_ITEM(parent_nodes, pos2, parent_node)
+                PyList_Append(parent_node.children, node)
+            node.parents = parent_nodes
+
+    cdef _KnownGraphNode _check_is_linear(self, _KnownGraphNode node):
+        """Check to see if a given node is part of a linear chain."""
+        cdef _KnownGraphNode parent_node
+        if node.parents is None or PyTuple_GET_SIZE(node.parents) != 1:
+            # This node is either a ghost, a tail, or has multiple parents
+            # It its own dominator
+            node.linear_dominator_node = node
+            return None
+        parent_node = _get_parent(node.parents, 0)
+        if PyList_GET_SIZE(parent_node.children) > 1:
+            # The parent has multiple children, so *this* node is the
+            # dominator
+            node.linear_dominator_node = node
+            return None
+        # The parent is already filled in, so add and continue
+        if parent_node.linear_dominator_node is not None:
+            node.linear_dominator_node = parent_node.linear_dominator_node
+            return None
+        # We don't know this node, or its parent node, so start walking to
+        # next
+        return parent_node
+
+    def _find_linear_dominators(self):
+        """
+        For any given node, the 'linear dominator' is an ancestor, such that
+        all parents between this node and that one have a single parent, and a
+        single child. So if A->B->C->D then B,C,D all have a linear dominator
+        of A.
+
+        There are two main benefits:
+        1) When walking the graph, we can jump to the nearest linear dominator,
+           rather than walking all of the nodes inbetween.
+        2) When caching heads() results, dominators give the "same" results as
+           their children. (If the dominator is a head, then the descendant is
+           a head, if the dominator is not a head, then the child isn't
+           either.)
+        """
+        cdef PyObject *temp_node
+        cdef Py_ssize_t pos
+        cdef _KnownGraphNode node
+        cdef _KnownGraphNode next_node
+        cdef _KnownGraphNode dominator
+        cdef int i, num_elements
+
+        pos = 0
+        while PyDict_Next(self._nodes, &pos, NULL, &temp_node):
+            node = <_KnownGraphNode>temp_node
+            # The parent is not filled in, so walk until we get somewhere
+            if node.linear_dominator_node is not None: #already done
+                continue
+            next_node = self._check_is_linear(node)
+            if next_node is None:
+                # Nothing more needs to be done
+                continue
+            stack = []
+            while next_node is not None:
+                PyList_Append(stack, node)
+                node = next_node
+                next_node = self._check_is_linear(node)
+            # The stack now contains the linear chain, and 'node' should have
+            # been labeled
+            dominator = node.linear_dominator_node
+            num_elements = len(stack)
+            for i from num_elements > i >= 0:
+                next_node = _get_list_node(stack, i)
+                next_node.linear_dominator_node = dominator
+                node = next_node
+
+    cdef object _find_tails(self):
+        cdef object tails
+        cdef PyObject *temp_node
+        cdef Py_ssize_t pos
+        cdef _KnownGraphNode node
+
+        tails = []
+        pos = 0
+        while PyDict_Next(self._nodes, &pos, NULL, &temp_node):
+            node = <_KnownGraphNode>temp_node
+            if node.parents is None or PyTuple_GET_SIZE(node.parents) == 0:
+                PyList_Append(tails, node)
+        return tails
+
+    def _find_gdfo(self):
+        cdef Py_ssize_t pos, pos2
+        cdef _KnownGraphNode node
+        cdef _KnownGraphNode child_node
+        cdef _KnownGraphNode parent_node
+        cdef int replace_node, missing_parent
+
+        tails = self._find_tails()
+        todo = []
+        for pos from 0 <= pos < PyList_GET_SIZE(tails):
+            node = _get_list_node(tails, pos)
+            node.gdfo = 1
+            PyList_Append(todo, (1, node))
+        # No need to heapify, because all tails have priority=1
+        while PyList_GET_SIZE(todo) > 0:
+            node = _peek_node(todo)
+            next_gdfo = node.gdfo + 1
+            replace_node = 1
+            for pos from 0 <= pos < PyList_GET_SIZE(node.children):
+                child_node = _get_list_node(node.children, pos)
+                # We should never have numbered children before we numbered
+                # a parent
+                if child_node.gdfo != -1:
+                    continue
+                # Only enque children when all of their parents have been
+                # resolved. With a single parent, we can just take 'this' value
+                child_gdfo = next_gdfo
+                if PyTuple_GET_SIZE(child_node.parents) > 1:
+                    missing_parent = 0
+                    for pos2 from 0 <= pos2 < PyTuple_GET_SIZE(child_node.parents):
+                        parent_node = _get_parent(child_node.parents, pos2)
+                        if parent_node.gdfo == -1:
+                            missing_parent = 1
+                            break
+                        if parent_node.gdfo >= child_gdfo:
+                            child_gdfo = parent_node.gdfo + 1
+                    if missing_parent:
+                        # One of the parents is not numbered, so wait until we get
+                        # back here
+                        continue
+                child_node.gdfo = child_gdfo
+                if replace_node:
+                    heapreplace(todo, (child_gdfo, child_node))
+                    replace_node = 0
+                else:
+                    heappush(todo, (child_gdfo, child_node))
+            if replace_node:
+                heappop(todo)
+
+    def heads(self, keys):
+        """Return the heads from amongst keys.
+
+        This is done by searching the ancestries of each key.  Any key that is
+        reachable from another key is not returned; all the others are.
+
+        This operation scales with the relative depth between any two keys. If
+        any two keys are completely disconnected all ancestry of both sides
+        will be retrieved.
+
+        :param keys: An iterable of keys.
+        :return: A set of the heads. Note that as a set there is no ordering
+            information. Callers will need to filter their input to create
+            order if they need it.
+        """
+        cdef PyObject *maybe_node
+        cdef PyObject *maybe_heads
+
+        heads_key = PyFrozenSet_New(keys)
+        maybe_heads = PyDict_GetItem(self._known_heads, heads_key)
+        if maybe_heads != NULL:
+            return <object>maybe_heads
+
+        # Not cached, compute it ourselves
+        candidate_nodes = {}
+        nodes = self._nodes
+        for key in keys:
+            maybe_node = PyDict_GetItem(nodes, key)
+            if maybe_node == NULL:
+                raise KeyError('key %s not in nodes' % (key,))
+            PyDict_SetItem(candidate_nodes, key, <object>maybe_node)
+        if revision.NULL_REVISION in candidate_nodes:
+            # NULL_REVISION is only a head if it is the only entry
+            candidate_nodes.pop(revision.NULL_REVISION)
+            if not candidate_nodes:
+                return set([revision.NULL_REVISION])
+            # The keys changed, so recalculate heads_key
+            heads_key = PyFrozenSet_New(candidate_nodes)
+        if len(candidate_nodes) < 2:
+            return heads_key
+        dom_to_node = self._get_dominators_to_nodes(candidate_nodes)
+        if PyDict_Size(candidate_nodes) < 2:
+            return frozenset(candidate_nodes)
+        dom_lookup_key, heads = self._heads_from_dominators(candidate_nodes,
+                                                            dom_to_node)
+        if heads is not None:
+            if self.do_cache:
+                # This heads was not in the cache, or it would have been caught
+                # earlier, but the dom head *was*, so do the simple cache
+                PyDict_SetItem(self._known_heads, heads_key, heads)
+            return heads
+        heads = self._heads_from_candidate_nodes(candidate_nodes, dom_to_node)
+        if self.do_cache:
+            self._cache_heads(heads, heads_key, dom_lookup_key, candidate_nodes)
+        return heads
+
+    cdef object _cache_heads(self, heads, heads_key, dom_lookup_key,
+                             candidate_nodes):
+        cdef PyObject *maybe_node
+        cdef _KnownGraphNode node
+
+        PyDict_SetItem(self._known_heads, heads_key, heads)
+        dom_heads = []
+        for key in heads:
+            maybe_node = PyDict_GetItem(candidate_nodes, key)
+            if maybe_node == NULL:
+                raise KeyError
+            node = <_KnownGraphNode>maybe_node
+            PyList_Append(dom_heads, node.linear_dominator_node.key)
+        PyDict_SetItem(self._known_heads, dom_lookup_key,
+                       PyFrozenSet_New(dom_heads))
+
+    cdef _get_dominators_to_nodes(self, candidate_nodes):
+        """Get the reverse mapping from dominator_key => candidate_nodes.
+
+        As a side effect, this can also remove potential candidate nodes if we
+        determine that they share a dominator.
+        """
+        cdef Py_ssize_t pos
+        cdef _KnownGraphNode node, other_node
+        cdef PyObject *temp_node
+        cdef PyObject *maybe_node
+
+        dom_to_node = {}
+        keys_to_remove = []
+        pos = 0
+        while PyDict_Next(candidate_nodes, &pos, NULL, &temp_node):
+            node = <_KnownGraphNode>temp_node
+            dom_key = node.linear_dominator_node.key
+            maybe_node = PyDict_GetItem(dom_to_node, dom_key)
+            if maybe_node == NULL:
+                PyDict_SetItem(dom_to_node, dom_key, node)
+            else:
+                other_node = <_KnownGraphNode>maybe_node
+                # These nodes share a dominator, one of them obviously
+                # supersedes the other, figure out which
+                if other_node.gdfo > node.gdfo:
+                    PyList_Append(keys_to_remove, node.key)
+                else:
+                    # This wins, replace the other
+                    PyList_Append(keys_to_remove, other_node.key)
+                    PyDict_SetItem(dom_to_node, dom_key, node)
+        for pos from 0 <= pos < PyList_GET_SIZE(keys_to_remove):
+            key = <object>PyList_GET_ITEM(keys_to_remove, pos)
+            candidate_nodes.pop(key)
+        return dom_to_node
+
+    cdef object _heads_from_dominators(self, candidate_nodes, dom_to_node):
+        cdef PyObject *maybe_heads
+        cdef PyObject *maybe_node
+        cdef _KnownGraphNode node
+        cdef Py_ssize_t pos
+        cdef PyObject *temp_node
+
+        dom_list_key = []
+        pos = 0
+        while PyDict_Next(candidate_nodes, &pos, NULL, &temp_node):
+            node = <_KnownGraphNode>temp_node
+            PyList_Append(dom_list_key, node.linear_dominator_node.key)
+        dom_lookup_key = PyFrozenSet_New(dom_list_key)
+        maybe_heads = PyDict_GetItem(self._known_heads, dom_lookup_key)
+        if maybe_heads == NULL:
+            return dom_lookup_key, None
+        # We need to map back from the dominator head to the original keys
+        dom_heads = <object>maybe_heads
+        heads = []
+        for dom_key in dom_heads:
+            maybe_node = PyDict_GetItem(dom_to_node, dom_key)
+            if maybe_node == NULL:
+                # Should never happen
+                raise KeyError
+            node = <_KnownGraphNode>maybe_node
+            PyList_Append(heads, node.key)
+        return dom_lookup_key, PyFrozenSet_New(heads)
+
+    cdef int _process_parent(self, _KnownGraphNode node,
+                             _KnownGraphNode parent_node,
+                             candidate_nodes, dom_to_node,
+                             queue, int *replace_item) except -1:
+        """Process the parent of a node, seeing if we need to walk it."""
+        cdef PyObject *maybe_candidate
+        cdef PyObject *maybe_node
+        cdef _KnownGraphNode dom_child_node
+        maybe_candidate = PyDict_GetItem(candidate_nodes, parent_node.key)
+        if maybe_candidate != NULL:
+            candidate_nodes.pop(parent_node.key)
+            # We could pass up a flag that tells the caller to stop processing,
+            # but it doesn't help much, and makes the code uglier
+            return 0
+        maybe_node = PyDict_GetItem(dom_to_node, parent_node.key)
+        if maybe_node != NULL:
+            # This is a dominator of a node
+            dom_child_node = <_KnownGraphNode>maybe_node
+            if dom_child_node is not node:
+                # It isn't a dominator of a node we are searching, so we should
+                # remove it from the search
+                maybe_candidate = PyDict_GetItem(candidate_nodes, dom_child_node.key)
+                if maybe_candidate != NULL:
+                    candidate_nodes.pop(dom_child_node.key)
+                    return 0
+        if parent_node.ancestor_of is None:
+            # This node hasn't been walked yet, so just project node's ancestor
+            # info directly to parent_node, and enqueue it for later processing
+            parent_node.ancestor_of = node.ancestor_of
+            if replace_item[0]:
+                heapreplace(queue, (-parent_node.gdfo, parent_node))
+                replace_item[0] = 0
+            else:
+                heappush(queue, (-parent_node.gdfo, parent_node))
+            PyList_Append(self._to_cleanup, parent_node)
+        elif parent_node.ancestor_of != node.ancestor_of:
+            # Combine to get the full set of parents
+            # Rewrite using PySet_* functions, unfortunately you have to use
+            # PySet_Add since there is no PySet_Update... :(
+            all_ancestors = set(parent_node.ancestor_of)
+            for k in node.ancestor_of:
+                PySet_Add(all_ancestors, k)
+            parent_node.ancestor_of = tuple(sorted(all_ancestors))
+        return 0
+
+    cdef object _heads_from_candidate_nodes(self, candidate_nodes, dom_to_node):
+        cdef _KnownGraphNode node
+        cdef _KnownGraphNode parent_node
+        cdef Py_ssize_t num_candidates
+        cdef int num_parents, replace_item
+        cdef Py_ssize_t pos
+        cdef PyObject *temp_node
+
+        queue = []
+        pos = 0
+        while PyDict_Next(candidate_nodes, &pos, NULL, &temp_node):
+            node = <_KnownGraphNode>temp_node
+            node.ancestor_of = (node.key,)
+            PyList_Append(queue, (-node.gdfo, node))
+            PyList_Append(self._to_cleanup, node)
+        heapify(queue)
+        # These are nodes that we determined are 'common' that we are no longer
+        # walking
+        # Now we walk nodes until all nodes that are being walked are 'common'
+        num_candidates = len(candidate_nodes)
+        replace_item = 0
+        while PyList_GET_SIZE(queue) > 0 and PyDict_Size(candidate_nodes) > 1:
+            if replace_item:
+                # We still need to pop the smallest member out of the queue
+                # before we peek again
+                heappop(queue)
+                if PyList_GET_SIZE(queue) == 0:
+                    break
+            # peek at the smallest item. We don't pop, because we expect we'll
+            # need to push more things into the queue anyway
+            node = _peek_node(queue)
+            replace_item = 1
+            if PyTuple_GET_SIZE(node.ancestor_of) == num_candidates:
+                # This node is now considered 'common'
+                # Make sure all parent nodes are marked as such
+                for pos from 0 <= pos < PyTuple_GET_SIZE(node.parents):
+                    parent_node = _get_parent(node.parents, pos)
+                    if parent_node.ancestor_of is not None:
+                        parent_node.ancestor_of = node.ancestor_of
+                if node.linear_dominator_node is not node:
+                    parent_node = node.linear_dominator_node
+                    if parent_node.ancestor_of is not None:
+                        parent_node.ancestor_of = node.ancestor_of
+                continue
+            if node.parents is None:
+                # This is a ghost
+                continue
+            # Now project the current nodes ancestor list to the parent nodes,
+            # and queue them up to be walked
+            if node.linear_dominator_node is not node:
+                # We are at the tip of a long linear region
+                # We know that there is nothing between here and the tail
+                # that is interesting, so skip to the end
+                self._process_parent(node, node.linear_dominator_node,
+                                     candidate_nodes, dom_to_node, queue, &replace_item)
+            else:
+                for pos from 0 <= pos < PyTuple_GET_SIZE(node.parents):
+                    parent_node = _get_parent(node.parents, pos)
+                    self._process_parent(node, parent_node, candidate_nodes,
+                                         dom_to_node, queue, &replace_item)
+        for pos from 0 <= pos < PyList_GET_SIZE(self._to_cleanup):
+            node = _get_list_node(self._to_cleanup, pos)
+            node.ancestor_of = None
+        self._to_cleanup = []
+        return PyFrozenSet_New(candidate_nodes)

=== modified file 'bzrlib/benchmarks/__init__.py'
--- bzrlib/benchmarks/__init__.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/__init__.py	2009-06-10 03:56:49 +0000
@@ -190,6 +190,7 @@
                    'bzrlib.benchmarks.bench_rocks',
                    'bzrlib.benchmarks.bench_startup',
                    'bzrlib.benchmarks.bench_status',
+                   'bzrlib.benchmarks.bench_tags',
                    'bzrlib.benchmarks.bench_transform',
                    'bzrlib.benchmarks.bench_workingtree',
                    'bzrlib.benchmarks.bench_sftp',

=== added file 'bzrlib/benchmarks/bench_tags.py'
--- bzrlib/benchmarks/bench_tags.py	1970-01-01 00:00:00 +0000
+++ bzrlib/benchmarks/bench_tags.py	2009-05-27 08:33:37 +0000
@@ -0,0 +1,58 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Test for tags serialization (indirect testing for bencode)"""
+
+
+import time
+
+from bzrlib.benchmarks import Benchmark
+import bzrlib.bencode
+import bzrlib.tag
+
+
+class TagsBencodeBenchmark(Benchmark):
+    """Benchmark for serialization/deserialization of tags"""
+
+    def setUp(self):
+        super(TagsBencodeBenchmark, self).setUp()
+        self.tobj = bzrlib.tag.BasicTags(None)
+        tags = {}
+        revid = 'j.random@example.com-20070812132500-%016d'
+        for i in xrange(100):
+            tags[str(i)] = revid % i
+        self.tags = tags
+        self.bencoded_tags = bzrlib.bencode.bencode(tags)
+
+    def time_N(self, N, kallable, *args, **kwargs):
+        def _func(N, kallable, *args, **kwargs):
+            for i in xrange(N):
+                kallable(*args, **kwargs)
+        self.time(_func, N, kallable, *args, **kwargs)
+
+    def test_serialize_empty_tags(self):
+        # Measure overhead of operation
+        self.time_N(10000, self.tobj._serialize_tag_dict, {})
+
+    def test_deserialize_empty_tags(self):
+        # Measure overhead of operation
+        self.time_N(10000, self.tobj._deserialize_tag_dict, 'de')
+
+    def test_serialize_tags(self):
+        self.time_N(1000, self.tobj._serialize_tag_dict, self.tags)
+
+    def test_deserialize_tags(self):
+        self.time_N(1000, self.tobj._deserialize_tag_dict, self.bencoded_tags)

=== added file 'bzrlib/bencode.py'
--- bzrlib/bencode.py	1970-01-01 00:00:00 +0000
+++ bzrlib/bencode.py	2009-06-03 14:14:31 +0000
@@ -0,0 +1,22 @@
+# Copyright (C) 2007,2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Wrapper around the bencode pyrex and python implementation"""
+
+try:
+    from bzrlib._bencode_pyx import bdecode, bdecode_as_tuple, bencode, Bencached
+except ImportError:
+    from bzrlib.util._bencode_py import bdecode, bdecode_as_tuple, bencode, Bencached

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2009-05-29 10:25:37 +0000
+++ bzrlib/branch.py	2009-06-17 03:53:51 +0000
@@ -91,6 +91,7 @@
         self._revision_history_cache = None
         self._revision_id_to_revno_cache = None
         self._partial_revision_id_to_revno_cache = {}
+        self._partial_revision_history_cache = []
         self._last_revision_info_cache = None
         self._merge_sorted_revisions_cache = None
         self._open_hook()
@@ -125,6 +126,27 @@
             raise errors.UnstackableRepositoryFormat(self.repository._format,
                 self.repository.base)
 
+    def _extend_partial_history(self, stop_index=None, stop_revision=None):
+        """Extend the partial history to include a given index
+
+        If a stop_index is supplied, stop when that index has been reached.
+        If a stop_revision is supplied, stop when that revision is
+        encountered.  Otherwise, stop when the beginning of history is
+        reached.
+
+        :param stop_index: The index which should be present.  When it is
+            present, history extension will stop.
+        :param stop_revision: The revision id which should be present.  When
+            it is encountered, history extension will stop.
+        """
+        if len(self._partial_revision_history_cache) == 0:
+            self._partial_revision_history_cache = [self.last_revision()]
+        repository._iter_for_revno(
+            self.repository, self._partial_revision_history_cache,
+            stop_index=stop_index, stop_revision=stop_revision)
+        if self._partial_revision_history_cache[-1] == _mod_revision.NULL_REVISION:
+            self._partial_revision_history_cache.pop()
+
     @staticmethod
     def open(base, _unsupported=False, possible_transports=None):
         """Open the branch rooted at base.
@@ -498,6 +520,16 @@
         """
         raise errors.UpgradeRequired(self.base)
 
+    def set_append_revisions_only(self, enabled):
+        if not self._format.supports_set_append_revisions_only():
+            raise errors.UpgradeRequired(self.base)
+        if enabled:
+            value = 'True'
+        else:
+            value = 'False'
+        self.get_config().set_user_option('append_revisions_only', value,
+            warn_masked=True)
+
     def set_reference_info(self, file_id, tree_path, branch_location):
         """Set the branch location to use for a tree reference."""
         raise errors.UnsupportedOperation(self.set_reference_info, self)
@@ -698,6 +730,8 @@
         self._revision_id_to_revno_cache = None
         self._last_revision_info_cache = None
         self._merge_sorted_revisions_cache = None
+        self._partial_revision_history_cache = []
+        self._partial_revision_id_to_revno_cache = {}
 
     def _gen_revision_history(self):
         """Return sequence of revision hashes on to this branch.
@@ -742,10 +776,6 @@
         """Older format branches cannot bind or unbind."""
         raise errors.UpgradeRequired(self.base)
 
-    def set_append_revisions_only(self, enabled):
-        """Older format branches are never restricted to append-only"""
-        raise errors.UpgradeRequired(self.base)
-
     def last_revision(self):
         """Return last revision id, or NULL_REVISION."""
         return self.last_revision_info()[1]
@@ -831,15 +861,20 @@
         except ValueError:
             raise errors.NoSuchRevision(self, revision_id)
 
+    @needs_read_lock
     def get_rev_id(self, revno, history=None):
         """Find the revision id of the specified revno."""
         if revno == 0:
             return _mod_revision.NULL_REVISION
-        if history is None:
-            history = self.revision_history()
-        if revno <= 0 or revno > len(history):
+        last_revno, last_revid = self.last_revision_info()
+        if revno == last_revno:
+            return last_revid
+        if revno <= 0 or revno > last_revno:
             raise errors.NoSuchRevision(self, revno)
-        return history[revno - 1]
+        distance_from_last = last_revno - revno
+        if len(self._partial_revision_history_cache) <= distance_from_last:
+            self._extend_partial_history(distance_from_last)
+        return self._partial_revision_history_cache[distance_from_last]
 
     @needs_write_lock
     def pull(self, source, overwrite=False, stop_revision=None,
@@ -1085,18 +1120,14 @@
         source_revno, source_revision_id = self.last_revision_info()
         if revision_id is None:
             revno, revision_id = source_revno, source_revision_id
-        elif source_revision_id == revision_id:
-            # we know the revno without needing to walk all of history
-            revno = source_revno
         else:
-            # To figure out the revno for a random revision, we need to build
-            # the revision history, and count its length.
-            # We don't care about the order, just how long it is.
-            # Alternatively, we could start at the current location, and count
-            # backwards. But there is no guarantee that we will find it since
-            # it may be a merged revision.
-            revno = len(list(self.repository.iter_reverse_revision_history(
-                                                                revision_id)))
+            graph = self.repository.get_graph()
+            try:
+                revno = graph.find_distance_to_null(revision_id, 
+                    [(source_revision_id, source_revno)])
+            except errors.GhostRevisionsHaveNoRevno:
+                # Default to 1, if we can't find anything else
+                revno = 1
         destination.set_last_revision_info(revno, revision_id)
 
     @needs_read_lock
@@ -1147,10 +1178,18 @@
 
         :return: A BranchCheckResult.
         """
+        ret = BranchCheckResult(self)
         mainline_parent_id = None
         last_revno, last_revision_id = self.last_revision_info()
-        real_rev_history = list(self.repository.iter_reverse_revision_history(
-                                last_revision_id))
+        real_rev_history = []
+        try:
+            for revid in self.repository.iter_reverse_revision_history(
+                last_revision_id):
+                real_rev_history.append(revid)
+        except errors.RevisionNotPresent:
+            ret.ghosts_in_mainline = True
+        else:
+            ret.ghosts_in_mainline = False
         real_rev_history.reverse()
         if len(real_rev_history) != last_revno:
             raise errors.BzrCheckError('revno does not match len(mainline)'
@@ -1172,7 +1211,7 @@
                                         "parents of {%s}"
                                         % (mainline_parent_id, revision_id))
             mainline_parent_id = revision_id
-        return BranchCheckResult(self)
+        return ret
 
     def _get_checkout_format(self):
         """Return the most suitable metadir for a checkout of this branch.
@@ -1345,6 +1384,8 @@
     _formats = {}
     """The known formats."""
 
+    can_set_append_revisions_only = True
+
     def __eq__(self, other):
         return self.__class__ is other.__class__
 
@@ -1503,6 +1544,10 @@
     def set_default_format(klass, format):
         klass._default_format = format
 
+    def supports_set_append_revisions_only(self):
+        """True if this format supports set_append_revisions_only."""
+        return False
+
     def supports_stacking(self):
         """True if this format records a stacked-on branch."""
         return False
@@ -1790,6 +1835,8 @@
         """See bzrlib.branch.BranchFormat.make_tags()."""
         return BasicTags(branch)
 
+    def supports_set_append_revisions_only(self):
+        return True
 
 
 class BzrBranchFormat8(BranchFormatMetadir):
@@ -1824,6 +1871,9 @@
         """See bzrlib.branch.BranchFormat.make_tags()."""
         return BasicTags(branch)
 
+    def supports_set_append_revisions_only(self):
+        return True
+
     def supports_stacking(self):
         return True
 
@@ -1858,6 +1908,9 @@
         """See BranchFormat.get_format_description()."""
         return "Branch format 7"
 
+    def supports_set_append_revisions_only(self):
+        return True
+
     supports_reference_locations = False
 
 
@@ -2372,13 +2425,11 @@
         self._ignore_fallbacks = kwargs.get('ignore_fallbacks', False)
         super(BzrBranch8, self).__init__(*args, **kwargs)
         self._last_revision_info_cache = None
-        self._partial_revision_history_cache = []
         self._reference_info = None
 
     def _clear_cached_state(self):
         super(BzrBranch8, self)._clear_cached_state()
         self._last_revision_info_cache = None
-        self._partial_revision_history_cache = []
         self._reference_info = None
 
     def _last_revision_info(self):
@@ -2440,35 +2491,6 @@
         self._extend_partial_history(stop_index=last_revno-1)
         return list(reversed(self._partial_revision_history_cache))
 
-    def _extend_partial_history(self, stop_index=None, stop_revision=None):
-        """Extend the partial history to include a given index
-
-        If a stop_index is supplied, stop when that index has been reached.
-        If a stop_revision is supplied, stop when that revision is
-        encountered.  Otherwise, stop when the beginning of history is
-        reached.
-
-        :param stop_index: The index which should be present.  When it is
-            present, history extension will stop.
-        :param revision_id: The revision id which should be present.  When
-            it is encountered, history extension will stop.
-        """
-        repo = self.repository
-        if len(self._partial_revision_history_cache) == 0:
-            iterator = repo.iter_reverse_revision_history(self.last_revision())
-        else:
-            start_revision = self._partial_revision_history_cache[-1]
-            iterator = repo.iter_reverse_revision_history(start_revision)
-            #skip the last revision in the list
-            next_revision = iterator.next()
-        for revision_id in iterator:
-            self._partial_revision_history_cache.append(revision_id)
-            if (stop_index is not None and
-                len(self._partial_revision_history_cache) > stop_index):
-                break
-            if revision_id == stop_revision:
-                break
-
     def _write_revision_history(self, history):
         """Factored out of set_revision_history.
 
@@ -2617,14 +2639,6 @@
             raise errors.NotStacked(self)
         return stacked_url
 
-    def set_append_revisions_only(self, enabled):
-        if enabled:
-            value = 'True'
-        else:
-            value = 'False'
-        self.get_config().set_user_option('append_revisions_only', value,
-            warn_masked=True)
-
     def _get_append_revisions_only(self):
         value = self.get_config().get_user_option('append_revisions_only')
         return value == 'True'
@@ -2780,6 +2794,7 @@
 
     def __init__(self, branch):
         self.branch = branch
+        self.ghosts_in_mainline = False
 
     def report_results(self, verbose):
         """Report the check results via trace.note.
@@ -2790,6 +2805,8 @@
         note('checked branch %s format %s',
              self.branch.base,
              self.branch._format)
+        if self.ghosts_in_mainline:
+            note('branch contains ghosts in mainline')
 
 
 class Converter5to6(object):

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2009-05-30 06:21:01 +0000
+++ bzrlib/builtins.py	2009-06-17 08:08:36 +0000
@@ -946,29 +946,36 @@
             if branch_to.get_parent() is None or remember:
                 branch_to.set_parent(branch_from.base)
 
-        if revision is not None:
-            revision_id = revision.as_revision_id(branch_from)
-
-        branch_to.lock_write()
+        if branch_from is not branch_to:
+            branch_from.lock_read()
         try:
-            if tree_to is not None:
-                view_info = _get_view_info_for_change_reporter(tree_to)
-                change_reporter = delta._ChangeReporter(
-                    unversioned_filter=tree_to.is_ignored, view_info=view_info)
-                result = tree_to.pull(branch_from, overwrite, revision_id,
-                                      change_reporter,
-                                      possible_transports=possible_transports,
-                                      local=local)
-            else:
-                result = branch_to.pull(branch_from, overwrite, revision_id,
-                                      local=local)
-
-            result.report(self.outf)
-            if verbose and result.old_revid != result.new_revid:
-                log.show_branch_change(branch_to, self.outf, result.old_revno,
-                                       result.old_revid)
+            if revision is not None:
+                revision_id = revision.as_revision_id(branch_from)
+
+            branch_to.lock_write()
+            try:
+                if tree_to is not None:
+                    view_info = _get_view_info_for_change_reporter(tree_to)
+                    change_reporter = delta._ChangeReporter(
+                        unversioned_filter=tree_to.is_ignored,
+                        view_info=view_info)
+                    result = tree_to.pull(
+                        branch_from, overwrite, revision_id, change_reporter,
+                        possible_transports=possible_transports, local=local)
+                else:
+                    result = branch_to.pull(
+                        branch_from, overwrite, revision_id, local=local)
+
+                result.report(self.outf)
+                if verbose and result.old_revid != result.new_revid:
+                    log.show_branch_change(
+                        branch_to, self.outf, result.old_revno,
+                        result.old_revid)
+            finally:
+                branch_to.unlock()
         finally:
-            branch_to.unlock()
+            if branch_from is not branch_to:
+                branch_from.unlock()
 
 
 class cmd_push(Command):
@@ -1021,6 +1028,9 @@
                 'for the commit history. Only the work not present in the '
                 'referenced branch is included in the branch created.',
             type=unicode),
+        Option('strict',
+               help='Refuse to push if there are uncommitted changes in'
+               ' the working tree.'),
         ]
     takes_args = ['location?']
     encoding_type = 'replace'
@@ -1028,13 +1038,29 @@
     def run(self, location=None, remember=False, overwrite=False,
         create_prefix=False, verbose=False, revision=None,
         use_existing_dir=False, directory=None, stacked_on=None,
-        stacked=False):
+        stacked=False, strict=None):
         from bzrlib.push import _show_push_branch
 
-        # Get the source branch and revision_id
         if directory is None:
             directory = '.'
-        br_from = Branch.open_containing(directory)[0]
+        # Get the source branch
+        tree, br_from = bzrdir.BzrDir.open_tree_or_branch(directory)
+        if strict is None:
+            strict = br_from.get_config().get_user_option('push_strict')
+            if strict is not None:
+                # FIXME: This should be better supported by config
+                # -- vila 20090611
+                bools = dict(yes=True, no=False, on=True, off=False,
+                             true=True, false=False)
+                try:
+                    strict = bools[strict.lower()]
+                except KeyError:
+                    strict = None
+        if strict:
+            changes = tree.changes_from(tree.basis_tree())
+            if changes.has_changed():
+                raise errors.UncommittedChanges(tree)
+        # Get the tip's revision_id
         revision = _get_one_revision('push', revision)
         if revision is not None:
             revision_id = revision.in_history(br_from).rev_id
@@ -1078,7 +1104,7 @@
 
 
 class cmd_branch(Command):
-    """Create a new copy of a branch.
+    """Create a new branch that is a copy of an existing branch.
 
     If the TO_LOCATION is omitted, the last component of the FROM_LOCATION will
     be used.  In other words, "branch ../foo/bar" will attempt to create ./bar.
@@ -1112,6 +1138,9 @@
 
         accelerator_tree, br_from = bzrdir.BzrDir.open_tree_or_branch(
             from_location)
+        if (accelerator_tree is not None and
+            accelerator_tree.supports_content_filtering()):
+            accelerator_tree = None
         revision = _get_one_revision('branch', revision)
         br_from.lock_read()
         try:
@@ -1621,7 +1650,7 @@
                 branch.set_append_revisions_only(True)
             except errors.UpgradeRequired:
                 raise errors.BzrCommandError('This branch format cannot be set'
-                    ' to append-revisions-only.  Try --experimental-branch6')
+                    ' to append-revisions-only.  Try --default.')
         if not is_quiet():
             from bzrlib.info import describe_layout, describe_format
             try:
@@ -2409,6 +2438,7 @@
                             continue
                     kindch = entry.kind_character()
                     outstring = fp + kindch
+                    ui.ui_factory.clear_term()
                     if verbose:
                         outstring = '%-8s %s' % (fc, outstring)
                         if show_ids and fid is not None:
@@ -4664,7 +4694,7 @@
         try:
             containing_tree.extract(sub_id)
         except errors.RootNotRich:
-            raise errors.UpgradeRequired(containing_tree.branch.base)
+            raise errors.RichRootUpgradeRequired(containing_tree.branch.base)
 
 
 class cmd_merge_directive(Command):

=== modified file 'bzrlib/bundle/serializer/v4.py'
--- bzrlib/bundle/serializer/v4.py	2009-04-02 15:28:11 +0000
+++ bzrlib/bundle/serializer/v4.py	2009-06-10 03:56:49 +0000
@@ -30,7 +30,7 @@
     serializer,
     )
 from bzrlib.bundle import bundle_data, serializer as bundle_serializer
-from bzrlib.util import bencode
+from bzrlib import bencode
 
 
 class BundleWriter(object):

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2009-05-28 11:46:14 +0000
+++ bzrlib/bzrdir.py	2009-06-12 03:44:12 +0000
@@ -2358,26 +2358,95 @@
     def set_branch_format(self, format):
         self._branch_format = format
 
-    def require_stacking(self):
+    def require_stacking(self, stack_on=None, possible_transports=None):
+        """We have a request to stack, try to ensure the formats support it.
+
+        :param stack_on: If supplied, it is the URL to a branch that we want to
+            stack on. Check to see if that format supports stacking before
+            forcing an upgrade.
+        """
+        # Stacking is desired. requested by the target, but does the place it
+        # points at support stacking? If it doesn't then we should
+        # not implicitly upgrade. We check this here.
+        new_repo_format = None
+        new_branch_format = None
+
+        # a bit of state for get_target_branch so that we don't try to open it
+        # 2 times, for both repo *and* branch
+        target = [None, False, None] # target_branch, checked, upgrade anyway
+        def get_target_branch():
+            if target[1]:
+                # We've checked, don't check again
+                return target
+            if stack_on is None:
+                # No target format, that means we want to force upgrading
+                target[:] = [None, True, True]
+                return target
+            try:
+                target_dir = BzrDir.open(stack_on,
+                    possible_transports=possible_transports)
+            except errors.NotBranchError:
+                # Nothing there, don't change formats
+                target[:] = [None, True, False]
+                return target
+            except errors.JailBreak:
+                # JailBreak, JFDI and upgrade anyway
+                target[:] = [None, True, True]
+                return target
+            try:
+                target_branch = target_dir.open_branch()
+            except errors.NotBranchError:
+                # No branch, don't upgrade formats
+                target[:] = [None, True, False]
+                return target
+            target[:] = [target_branch, True, False]
+            return target
+
+        if not (self.repository_format.supports_external_lookups):
+            # We need to upgrade the Repository.
+            target_branch, _, do_upgrade = get_target_branch()
+            if target_branch is None:
+                # We don't have a target branch, should we upgrade anyway?
+                if do_upgrade:
+                    # stack_on is inaccessible, JFDI.
+                    # TODO: bad monkey, hard-coded formats...
+                    if self.repository_format.rich_root_data:
+                        new_repo_format = pack_repo.RepositoryFormatKnitPack5RichRoot()
+                    else:
+                        new_repo_format = pack_repo.RepositoryFormatKnitPack5()
+            else:
+                # If the target already supports stacking, then we know the
+                # project is already able to use stacking, so auto-upgrade
+                # for them
+                new_repo_format = target_branch.repository._format
+                if not new_repo_format.supports_external_lookups:
+                    # target doesn't, source doesn't, so don't auto upgrade
+                    # repo
+                    new_repo_format = None
+            if new_repo_format is not None:
+                self.repository_format = new_repo_format
+                note('Source repository format does not support stacking,'
+                     ' using format:\n  %s',
+                     new_repo_format.get_format_description())
+
         if not self.get_branch_format().supports_stacking():
-            # We need to make a stacked branch, but the default format for the
-            # target doesn't support stacking.  So force a branch that *can*
-            # support stacking.
-            from bzrlib.branch import BzrBranchFormat7
-            branch_format = BzrBranchFormat7()
-            self.set_branch_format(branch_format)
-            mutter("using %r for stacking" % (branch_format,))
-            from bzrlib.repofmt import pack_repo
-            if self.repository_format.rich_root_data:
-                bzrdir_format_name = '1.6.1-rich-root'
-                repo_format = pack_repo.RepositoryFormatKnitPack5RichRoot()
+            # We just checked the repo, now lets check if we need to
+            # upgrade the branch format
+            target_branch, _, do_upgrade = get_target_branch()
+            if target_branch is None:
+                if do_upgrade:
+                    # TODO: bad monkey, hard-coded formats...
+                    new_branch_format = branch.BzrBranchFormat7()
             else:
-                bzrdir_format_name = '1.6'
-                repo_format = pack_repo.RepositoryFormatKnitPack5()
-            note('Source format does not support stacking, using format:'
-                 ' \'%s\'\n  %s\n',
-                 bzrdir_format_name, repo_format.get_format_description())
-            self.repository_format = repo_format
+                new_branch_format = target_branch._format
+                if not new_branch_format.supports_stacking():
+                    new_branch_format = None
+            if new_branch_format is not None:
+                # Does support stacking, use its format.
+                self.set_branch_format(new_branch_format)
+                note('Source branch format does not support stacking,'
+                     ' using format:\n  %s',
+                     new_branch_format.get_format_description())
 
     def get_converter(self, format=None):
         """See BzrDirFormat.get_converter()."""
@@ -2699,7 +2768,7 @@
         del ie.text_id
 
     def get_parent_map(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parent_map"""
+        """See graph.StackedParentsProvider.get_parent_map"""
         return dict((revision_id, self.revisions[revision_id])
                     for revision_id in revision_ids
                      if revision_id in self.revisions)
@@ -3049,7 +3118,10 @@
             return local_dir_format.initialize_on_transport(transport)
         client = _SmartClient(client_medium)
         path = client.remote_path_from_transport(transport)
-        response = client.call('BzrDirFormat.initialize', path)
+        try:
+            response = client.call('BzrDirFormat.initialize', path)
+        except errors.ErrorFromSmartServer, err:
+            remote._translate_error(err, path=path)
         if response[0] != 'ok':
             raise errors.SmartProtocolError('unexpected response code %s' % (response,))
         format = RemoteBzrDirFormat()
@@ -3103,7 +3175,7 @@
         if not do_vfs:
             client = _SmartClient(client_medium)
             path = client.remote_path_from_transport(transport)
-            if client_medium._is_remote_before((1, 15)):
+            if client_medium._is_remote_before((1, 16)):
                 do_vfs = True
         if do_vfs:
             # TODO: lookup the local format from a server hint.
@@ -3115,6 +3187,13 @@
                 stack_on_pwd=stack_on_pwd, repo_format_name=repo_format_name,
                 make_working_trees=make_working_trees, shared_repo=shared_repo,
                 vfs_only=True)
+        return self._initialize_on_transport_ex_rpc(client, path, transport,
+            use_existing_dir, create_prefix, force_new_repo, stacked_on,
+            stack_on_pwd, repo_format_name, make_working_trees, shared_repo)
+
+    def _initialize_on_transport_ex_rpc(self, client, path, transport,
+        use_existing_dir, create_prefix, force_new_repo, stacked_on,
+        stack_on_pwd, repo_format_name, make_working_trees, shared_repo):
         args = []
         args.append(self._serialize_NoneTrueFalse(use_existing_dir))
         args.append(self._serialize_NoneTrueFalse(create_prefix))
@@ -3136,9 +3215,10 @@
             self._network_name = \
             BzrDirFormat.get_default_format().network_name()
         try:
-            response = client.call('BzrDirFormat.initialize_ex',
+            response = client.call('BzrDirFormat.initialize_ex_1.16',
                 self.network_name(), path, *args)
         except errors.UnknownSmartMethod:
+            client._medium._remember_remote_is_before((1,16))
             local_dir_format = BzrDirMetaFormat1()
             self._supply_sub_formats_to(local_dir_format)
             return local_dir_format.initialize_on_transport_ex(transport,
@@ -3147,6 +3227,8 @@
                 stack_on_pwd=stack_on_pwd, repo_format_name=repo_format_name,
                 make_working_trees=make_working_trees, shared_repo=shared_repo,
                 vfs_only=True)
+        except errors.ErrorFromSmartServer, err:
+            remote._translate_error(err, path=path)
         repo_path = response[0]
         bzrdir_name = response[6]
         require_stacking = response[7]
@@ -3168,6 +3250,9 @@
                 repo_bzr = bzrdir
             final_stack = response[8] or None
             final_stack_pwd = response[9] or None
+            if final_stack_pwd:
+                final_stack_pwd = urlutils.join(
+                    transport.base, final_stack_pwd)
             remote_repo = remote.RemoteRepository(repo_bzr, repo_format)
             if len(response) > 10:
                 # Updated server verb that locks remotely.
@@ -3520,54 +3605,9 @@
         """
         stack_on = self._get_full_stack_on()
         if stack_on:
-            # Stacking is desired. requested by the target, but does the place it
-            # points at support stacking? If it doesn't then we should
-            # not implicitly upgrade. We check this here.
             format = self._bzrdir._format
-            if not (format.repository_format.supports_external_lookups
-                and format.get_branch_format().supports_stacking()):
-                # May need to upgrade - but only do if the target also
-                # supports stacking. Note that this currently wastes
-                # network round trips to check - but we only do this
-                # when the source can't stack so it will fade away
-                # as people do upgrade.
-                branch_format = None
-                repo_format = None
-                try:
-                    target_dir = BzrDir.open(stack_on,
-                        possible_transports=[self._bzrdir.root_transport])
-                except errors.NotBranchError:
-                    # Nothing there, don't change formats
-                    pass
-                except errors.JailBreak:
-                    # stack_on is inaccessible, JFDI.
-                    if format.repository_format.rich_root_data:
-                        repo_format = pack_repo.RepositoryFormatKnitPack6RichRoot()
-                    else:
-                        repo_format = pack_repo.RepositoryFormatKnitPack6()
-                    branch_format = branch.BzrBranchFormat7()
-                else:
-                    try:
-                        target_branch = target_dir.open_branch()
-                    except errors.NotBranchError:
-                        # No branch, don't change formats
-                        pass
-                    else:
-                        branch_format = target_branch._format
-                        repo_format = target_branch.repository._format
-                        if not (branch_format.supports_stacking()
-                            and repo_format.supports_external_lookups):
-                            # Doesn't stack itself, don't force an upgrade
-                            branch_format = None
-                            repo_format = None
-                if branch_format and repo_format:
-                    # Does support stacking, use its format.
-                    format.repository_format = repo_format
-                    format.set_branch_format(branch_format)
-                    note('Source format does not support stacking, '
-                        'using format: \'%s\'\n  %s\n',
-                        branch_format.get_format_description(),
-                        repo_format.get_format_description())
+            format.require_stacking(stack_on=stack_on,
+                                    possible_transports=[self._bzrdir.root_transport])
             if not self._require_stacking:
                 # We have picked up automatic stacking somewhere.
                 note('Using default stacking branch %s at %s', self._stack_on,
@@ -3780,6 +3820,30 @@
     experimental=True,
     )
 
+format_registry.register_metadir('development7-rich-root',
+    'bzrlib.repofmt.groupcompress_repo.RepositoryFormatCHK2',
+    help='pack-1.9 with 255-way hashed CHK inv, bencode revision, group compress, '
+        'rich roots. Please read '
+        'http://doc.bazaar-vcs.org/latest/developers/development-repo.html '
+        'before use.',
+    branch_format='bzrlib.branch.BzrBranchFormat7',
+    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
+    hidden=True,
+    experimental=True,
+    )
+
+format_registry.register_metadir('2a',
+    'bzrlib.repofmt.groupcompress_repo.RepositoryFormat2a',
+    help='First format for bzr 2.0 series.\n'
+        'Uses group-compress storage.\n'
+        'Provides rich roots which are a one-way transition.\n',
+        # 'storage in packs, 255-way hashed CHK inventory, bencode revision, group compress, '
+        # 'rich roots. Supported by bzr 1.16 and later.',
+    branch_format='bzrlib.branch.BzrBranchFormat7',
+    tree_format='bzrlib.workingtree.WorkingTreeFormat6',
+    experimental=True,
+    )
+
 # The following format should be an alias for the rich root equivalent 
 # of the default format
 format_registry.register_metadir('default-rich-root',

=== modified file 'bzrlib/cache_utf8.py'
--- bzrlib/cache_utf8.py	2009-03-23 14:59:43 +0000
+++ bzrlib/cache_utf8.py	2009-06-10 03:56:49 +0000
@@ -22,8 +22,8 @@
 import codecs
 
 
-_utf8_encode = codecs.getencoder("utf-8")
-_utf8_decode = codecs.getdecoder("utf-8")
+_utf8_encode = codecs.utf_8_encode
+_utf8_decode = codecs.utf_8_decode
 def _utf8_decode_with_None(bytestring, _utf8_decode=_utf8_decode):
     """wrap _utf8_decode to support None->None for optional strings.
 

=== modified file 'bzrlib/chk_map.py'
--- bzrlib/chk_map.py	2009-05-13 21:59:57 +0000
+++ bzrlib/chk_map.py	2009-06-15 14:49:27 +0000
@@ -121,7 +121,7 @@
 
     def _ensure_root(self):
         """Ensure that the root node is an object not a key."""
-        if type(self._root_node) == tuple:
+        if type(self._root_node) is tuple:
             # Demand-load the root
             self._root_node = self._get_node(self._root_node)
 
@@ -135,7 +135,7 @@
         :param node: A tuple key or node object.
         :return: A node object.
         """
-        if type(node) == tuple:
+        if type(node) is tuple:
             bytes = self._read_bytes(node)
             return _deserialise(bytes, node,
                 search_key_func=self._search_key_func)
@@ -465,7 +465,7 @@
 
     def _node_key(self, node):
         """Get the key for a node whether it's a tuple or node."""
-        if type(node) == tuple:
+        if type(node) is tuple:
             return node
         else:
             return node._key
@@ -491,7 +491,7 @@
 
         :return: The key of the root node.
         """
-        if type(self._root_node) == tuple:
+        if type(self._root_node) is tuple:
             # Already saved.
             return self._root_node
         keys = list(self._root_node.serialise(self._store))
@@ -955,34 +955,99 @@
         # prefix is the key in self._items to use, key_filter is the key_filter
         # entries that would match this node
         keys = {}
+        shortcut = False
         if key_filter is None:
+            # yielding all nodes, yield whatever we have, and queue up a read
+            # for whatever we are missing
+            shortcut = True
             for prefix, node in self._items.iteritems():
-                if type(node) == tuple:
+                if node.__class__ is tuple:
                     keys[node] = (prefix, None)
                 else:
                     yield node, None
-        else:
-            # XXX defaultdict ?
+        elif len(key_filter) == 1:
+            # Technically, this path could also be handled by the first check
+            # in 'self._node_width' in length_filters. However, we can handle
+            # this case without spending any time building up the
+            # prefix_to_keys, etc state.
+
+            # This is a bit ugly, but TIMEIT showed it to be by far the fastest
+            # 0.626us   list(key_filter)[0]
+            #       is a func() for list(), 2 mallocs, and a getitem
+            # 0.489us   [k for k in key_filter][0]
+            #       still has the mallocs, avoids the func() call
+            # 0.350us   iter(key_filter).next()
+            #       has a func() call, and mallocs an iterator
+            # 0.125us   for key in key_filter: pass
+            #       no func() overhead, might malloc an iterator
+            # 0.105us   for key in key_filter: break
+            #       no func() overhead, might malloc an iterator, probably
+            #       avoids checking an 'else' clause as part of the for
+            for key in key_filter:
+                break
+            search_prefix = self._search_prefix_filter(key)
+            if len(search_prefix) == self._node_width:
+                # This item will match exactly, so just do a dict lookup, and
+                # see what we can return
+                shortcut = True
+                try:
+                    node = self._items[search_prefix]
+                except KeyError:
+                    # A given key can only match 1 child node, if it isn't
+                    # there, then we can just return nothing
+                    return
+                if node.__class__ is tuple:
+                    keys[node] = (search_prefix, [key])
+                else:
+                    # This is loaded, and the only thing that can match,
+                    # return
+                    yield node, [key]
+                    return
+        if not shortcut:
+            # First, convert all keys into a list of search prefixes
+            # Aggregate common prefixes, and track the keys they come from
             prefix_to_keys = {}
             length_filters = {}
             for key in key_filter:
-                search_key = self._search_prefix_filter(key)
+                search_prefix = self._search_prefix_filter(key)
                 length_filter = length_filters.setdefault(
-                                    len(search_key), set())
-                length_filter.add(search_key)
-                prefix_to_keys.setdefault(search_key, []).append(key)
-            length_filters = length_filters.items()
-            for prefix, node in self._items.iteritems():
-                node_key_filter = []
-                for length, length_filter in length_filters:
-                    sub_prefix = prefix[:length]
-                    if sub_prefix in length_filter:
-                        node_key_filter.extend(prefix_to_keys[sub_prefix])
-                if node_key_filter: # this key matched something, yield it
-                    if type(node) == tuple:
-                        keys[node] = (prefix, node_key_filter)
+                                    len(search_prefix), set())
+                length_filter.add(search_prefix)
+                prefix_to_keys.setdefault(search_prefix, []).append(key)
+
+            if (self._node_width in length_filters
+                and len(length_filters) == 1):
+                # all of the search prefixes match exactly _node_width. This
+                # means that everything is an exact match, and we can do a
+                # lookup into self._items, rather than iterating over the items
+                # dict.
+                search_prefixes = length_filters[self._node_width]
+                for search_prefix in search_prefixes:
+                    try:
+                        node = self._items[search_prefix]
+                    except KeyError:
+                        # We can ignore this one
+                        continue
+                    node_key_filter = prefix_to_keys[search_prefix]
+                    if node.__class__ is tuple:
+                        keys[node] = (search_prefix, node_key_filter)
                     else:
                         yield node, node_key_filter
+            else:
+                # The slow way. We walk every item in self._items, and check to
+                # see if there are any matches
+                length_filters = length_filters.items()
+                for prefix, node in self._items.iteritems():
+                    node_key_filter = []
+                    for length, length_filter in length_filters:
+                        sub_prefix = prefix[:length]
+                        if sub_prefix in length_filter:
+                            node_key_filter.extend(prefix_to_keys[sub_prefix])
+                    if node_key_filter: # this key matched something, yield it
+                        if node.__class__ is tuple:
+                            keys[node] = (prefix, node_key_filter)
+                        else:
+                            yield node, node_key_filter
         if keys:
             # Look in the page cache for some more bytes
             found_keys = set()
@@ -1117,7 +1182,7 @@
         :return: An iterable of the keys inserted by this operation.
         """
         for node in self._items.itervalues():
-            if type(node) == tuple:
+            if type(node) is tuple:
                 # Never deserialised.
                 continue
             if node._key is not None:
@@ -1134,7 +1199,7 @@
         lines.append('%s\n' % (self._search_prefix,))
         prefix_len = len(self._search_prefix)
         for prefix, node in sorted(self._items.items()):
-            if type(node) == tuple:
+            if type(node) is tuple:
                 key = node[0]
             else:
                 key = node._key[0]
@@ -1179,7 +1244,7 @@
             raise AssertionError("unserialised nodes have no refs.")
         refs = []
         for value in self._items.itervalues():
-            if type(value) == tuple:
+            if type(value) is tuple:
                 refs.append(value)
             else:
                 refs.append(value.key())

=== modified file 'bzrlib/chk_serializer.py'
--- bzrlib/chk_serializer.py	2009-04-09 20:23:07 +0000
+++ bzrlib/chk_serializer.py	2009-06-15 19:04:38 +0000
@@ -16,14 +16,127 @@
 
 """Serializer object for CHK based inventory storage."""
 
+from cStringIO import (
+    StringIO,
+    )
+
 from bzrlib import (
+    bencode,
+    cache_utf8,
     inventory,
+    osutils,
+    revision as _mod_revision,
     xml5,
     xml6,
     )
 
 
-class CHKSerializerSubtree(xml6.Serializer_v6):
+def _validate_properties(props, _decode=cache_utf8._utf8_decode):
+    # TODO: we really want an 'isascii' check for key
+    # Cast the utf8 properties into Unicode 'in place'
+    for key, value in props.iteritems():
+        props[key] = _decode(value)[0]
+    return props
+
+
+def _is_format_10(value):
+    if value != 10:
+        raise ValueError('Format number was not recognized, expected 10 got %d'
+                         % (value,))
+    return 10
+
+
+class BEncodeRevisionSerializer1(object):
+    """Simple revision serializer based around bencode.
+    """
+
+    squashes_xml_invalid_characters = False
+
+    # Maps {key:(Revision attribute, bencode_type, validator)}
+    # This tells us what kind we expect bdecode to create, what variable on
+    # Revision we should be using, and a function to call to validate/transform
+    # the type.
+    # TODO: add a 'validate_utf8' for things like revision_id and file_id
+    #       and a validator for parent-ids
+    _schema = {'format': (None, int, _is_format_10),
+               'committer': ('committer', str, cache_utf8.decode),
+               'timezone': ('timezone', int, None),
+               'timestamp': ('timestamp', str, float),
+               'revision-id': ('revision_id', str, None),
+               'parent-ids': ('parent_ids', list, None),
+               'inventory-sha1': ('inventory_sha1', str, None),
+               'message': ('message', str, cache_utf8.decode),
+               'properties': ('properties', dict, _validate_properties),
+    }
+
+    def write_revision_to_string(self, rev):
+        encode_utf8 = cache_utf8._utf8_encode
+        # Use a list of tuples rather than a dict
+        # This lets us control the ordering, so that we are able to create
+        # smaller deltas
+        ret = [
+            ("format", 10),
+            ("committer", encode_utf8(rev.committer)[0]),
+        ]
+        if rev.timezone is not None:
+            ret.append(("timezone", rev.timezone))
+        # For bzr revisions, the most common property is just 'branch-nick'
+        # which changes infrequently.
+        revprops = {}
+        for key, value in rev.properties.iteritems():
+            revprops[key] = encode_utf8(value)[0]
+        ret.append(('properties', revprops))
+        ret.extend([
+            ("timestamp", "%.3f" % rev.timestamp),
+            ("revision-id", rev.revision_id),
+            ("parent-ids", rev.parent_ids),
+            ("inventory-sha1", rev.inventory_sha1),
+            ("message", encode_utf8(rev.message)[0]),
+        ])
+        return bencode.bencode(ret)
+
+    def write_revision(self, rev, f):
+        f.write(self.write_revision_to_string(rev))
+
+    def read_revision_from_string(self, text):
+        # TODO: consider writing a Revision decoder, rather than using the
+        #       generic bencode decoder
+        #       However, to decode all 25k revisions of bzr takes approx 1.3s
+        #       If we remove all extra validation that goes down to about 1.2s.
+        #       Of that time, probably 0.6s is spend in bencode.bdecode().
+        #       Regardless 'time bzr log' of everything is 7+s, so 1.3s to
+        #       extract revision texts isn't a majority of time.
+        ret = bencode.bdecode(text)
+        if not isinstance(ret, list):
+            raise ValueError("invalid revision text")
+        schema = self._schema
+        # timezone is allowed to be missing, but should be set
+        bits = {'timezone': None}
+        for key, value in ret:
+            # Will raise KeyError if not a valid part of the schema, or an
+            # entry is given 2 times.
+            var_name, expected_type, validator = schema[key]
+            if value.__class__ is not expected_type:
+                raise ValueError('key %s did not conform to the expected type'
+                                 ' %s, but was %s'
+                                 % (key, expected_type, type(value)))
+            if validator is not None:
+                value = validator(value)
+            bits[var_name] = value
+        if len(bits) != len(schema):
+            missing = [key for key, (var_name, _, _) in schema.iteritems()
+                       if var_name not in bits]
+            raise ValueError('Revision text was missing expected keys %s.'
+                             ' text %r' % (missing, text))
+        del bits[None]  # Get rid of 'format' since it doesn't get mapped
+        rev = _mod_revision.Revision(**bits)
+        return rev
+
+    def read_revision(self, f):
+        return self.read_revision_from_string(f.read())
+
+
+class CHKSerializerSubtree(BEncodeRevisionSerializer1, xml6.Serializer_v6):
     """A CHKInventory based serializer that supports tree references"""
 
     supported_kinds = set(['file', 'directory', 'symlink', 'tree-reference'])
@@ -64,3 +177,12 @@
 
 
 chk_serializer_255_bigpage = CHKSerializer(65536, 'hash-255-way')
+
+
+class CHKBEncodeSerializer(BEncodeRevisionSerializer1, CHKSerializer):
+    """A CHKInventory and BEncode based serializer with 'plain' behaviour."""
+
+    format_num = '10'
+
+
+chk_bencode_serializer = CHKBEncodeSerializer(65536, 'hash-255-way')

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2009-05-23 04:55:52 +0000
+++ bzrlib/commands.py	2009-06-15 09:07:02 +0000
@@ -49,10 +49,15 @@
     )
 """)
 
-from bzrlib import registry
-# Compatibility
 from bzrlib.hooks import HookPoint, Hooks
+# Compatibility - Option used to be in commands.
 from bzrlib.option import Option
+from bzrlib import registry
+from bzrlib.symbol_versioning import (
+    deprecated_function,
+    deprecated_in,
+    suppress_deprecation_warnings,
+    )
 
 
 class CommandInfo(object):
@@ -133,98 +138,176 @@
 
 def _builtin_commands():
     import bzrlib.builtins
+    return _scan_module_for_commands(bzrlib.builtins)
+
+
+def _scan_module_for_commands(module):
     r = {}
-    builtins = bzrlib.builtins.__dict__
-    for name in builtins:
+    for name, obj in module.__dict__.iteritems():
         if name.startswith("cmd_"):
             real_name = _unsquish_command_name(name)
-            r[real_name] = builtins[name]
+            r[real_name] = obj
     return r
 
 
+def _list_bzr_commands(names):
+    """Find commands from bzr's core and plugins."""
+    # to eliminate duplicates
+    names.update(builtin_command_names())
+    names.update(plugin_command_names())
+    return names
+
+
+def all_command_names():
+    """Return a set of all command names."""
+    names = set()
+    for hook in Command.hooks['list_commands']:
+        names = hook(names)
+        if names is None:
+            raise AssertionError(
+                'hook %s returned None' % Command.hooks.get_hook_name(hook))
+    return names
+
+
 def builtin_command_names():
-    """Return list of builtin command names."""
+    """Return list of builtin command names.
+    
+    Use of all_command_names() is encouraged rather than builtin_command_names
+    and/or plugin_command_names.
+    """
     return _builtin_commands().keys()
 
 
 def plugin_command_names():
+    """Returns command names from commands registered by plugins."""
     return plugin_cmds.keys()
 
 
-def _get_cmd_dict(plugins_override=True):
-    """Return name->class mapping for all commands."""
+@deprecated_function(deprecated_in((1, 17, 0)))
+def get_all_cmds(plugins_override=False):
+    """Return canonical name and class for most commands.
+    
+    NB: This does not return all commands since the introduction of
+    command hooks, and returning the class is not sufficient to 
+    get correctly setup commands, which is why it is deprecated.
+
+    Use 'all_command_names' + 'get_cmd_object' instead.
+    """
     d = _builtin_commands()
     if plugins_override:
         d.update(plugin_cmds.iteritems())
-    return d
-
-
-def get_all_cmds(plugins_override=True):
-    """Return canonical name and class for all registered commands."""
-    for k, v in _get_cmd_dict(plugins_override=plugins_override).iteritems():
+    for k, v in d.iteritems():
         yield k,v
 
 
 def get_cmd_object(cmd_name, plugins_override=True):
-    """Return the canonical name and command class for a command.
+    """Return the command object for a command.
 
     plugins_override
         If true, plugin commands can override builtins.
     """
     try:
-        cmd = _get_cmd_object(cmd_name, plugins_override)
-        # Allow plugins to extend commands
-        for hook in Command.hooks['extend_command']:
-            hook(cmd)
-        return cmd
+        return _get_cmd_object(cmd_name, plugins_override)
     except KeyError:
         raise errors.BzrCommandError('unknown command "%s"' % cmd_name)
 
 
 def _get_cmd_object(cmd_name, plugins_override=True):
-    """Worker for get_cmd_object which raises KeyError rather than BzrCommandError."""
-    from bzrlib.externalcommand import ExternalCommand
+    """Get a command object.
 
+    :param cmd_name: The name of the command.
+    :param plugins_override: Allow plugins to override builtins.
+    :return: A Command object instance
+    :raises KeyError: If no command is found.
+    """
     # We want only 'ascii' command names, but the user may have typed
     # in a Unicode name. In that case, they should just get a
     # 'command not found' error later.
     # In the future, we may actually support Unicode command names.
-
-    # first look up this command under the specified name
-    if plugins_override:
+    cmd = None
+    # Get a command
+    for hook in Command.hooks['get_command']:
+        cmd = hook(cmd, cmd_name)
+        if cmd is not None and not plugins_override and not cmd.plugin_name():
+            # We've found a non-plugin command, don't permit it to be
+            # overridden.
+            break
+    if cmd is None:
+        for hook in Command.hooks['get_missing_command']:
+            cmd = hook(cmd_name)
+            if cmd is not None:
+                break
+    if cmd is None:
+        # No command found.
+        raise KeyError
+    # Allow plugins to extend commands
+    for hook in Command.hooks['extend_command']:
+        hook(cmd)
+    return cmd
+
+
+def _try_plugin_provider(cmd_name):
+    """Probe for a plugin provider having cmd_name."""
+    try:
+        plugin_metadata, provider = probe_for_provider(cmd_name)
+        raise errors.CommandAvailableInPlugin(cmd_name,
+            plugin_metadata, provider)
+    except errors.NoPluginAvailable:
+        pass
+
+
+def probe_for_provider(cmd_name):
+    """Look for a provider for cmd_name.
+
+    :param cmd_name: The command name.
+    :return: plugin_metadata, provider for getting cmd_name.
+    :raises NoPluginAvailable: When no provider can supply the plugin.
+    """
+    # look for providers that provide this command but aren't installed
+    for provider in command_providers_registry:
         try:
-            return plugin_cmds.get(cmd_name)()
-        except KeyError:
+            return provider.plugin_for_command(cmd_name), provider
+        except errors.NoPluginAvailable:
             pass
-    cmds = _get_cmd_dict(plugins_override=False)
+    raise errors.NoPluginAvailable(cmd_name)
+
+
+def _get_bzr_command(cmd_or_None, cmd_name):
+    """Get a command from bzr's core."""
+    cmds = _builtin_commands()
     try:
         return cmds[cmd_name]()
     except KeyError:
         pass
-    if plugins_override:
-        for key in plugin_cmds.keys():
-            info = plugin_cmds.get_info(key)
-            if cmd_name in info.aliases:
-                return plugin_cmds.get(key)()
     # look for any command which claims this as an alias
     for real_cmd_name, cmd_class in cmds.iteritems():
         if cmd_name in cmd_class.aliases:
             return cmd_class()
-
+    return cmd_or_None
+
+
+def _get_external_command(cmd_or_None, cmd_name):
+    """Lookup a command that is a shell script."""
+    # Only do external command lookups when no command is found so far.
+    if cmd_or_None is not None:
+        return cmd_or_None
+    from bzrlib.externalcommand import ExternalCommand
     cmd_obj = ExternalCommand.find_command(cmd_name)
     if cmd_obj:
         return cmd_obj
 
-    # look for plugins that provide this command but aren't installed
-    for provider in command_providers_registry:
-        try:
-            plugin_metadata = provider.plugin_for_command(cmd_name)
-        except errors.NoPluginAvailable:
-            pass
-        else:
-            raise errors.CommandAvailableInPlugin(cmd_name,
-                                                  plugin_metadata, provider)
-    raise KeyError
+
+def _get_plugin_command(cmd_or_None, cmd_name):
+    """Get a command from bzr's plugins."""
+    try:
+        return plugin_cmds.get(cmd_name)()
+    except KeyError:
+        pass
+    for key in plugin_cmds.keys():
+        info = plugin_cmds.get_info(key)
+        if cmd_name in info.aliases:
+            return plugin_cmds.get(key)()
+    return cmd_or_None
 
 
 class Command(object):
@@ -608,6 +691,25 @@
             "Called after creating a command object to allow modifications "
             "such as adding or removing options, docs etc. Called with the "
             "new bzrlib.commands.Command object.", (1, 13), None))
+        self.create_hook(HookPoint('get_command',
+            "Called when creating a single command. Called with "
+            "(cmd_or_None, command_name). get_command should either return "
+            "the cmd_or_None parameter, or a replacement Command object that "
+            "should be used for the command. Note that the Command.hooks "
+            "hooks are core infrastructure. Many users will prefer to use "
+            "bzrlib.commands.register_command or plugin_cmds.register_lazy.",
+            (1, 17), None))
+        self.create_hook(HookPoint('get_missing_command',
+            "Called when creating a single command if no command could be "
+            "found. Called with (command_name). get_missing_command should "
+            "either return None, or a Command object to be used for the "
+            "command.", (1, 17), None))
+        self.create_hook(HookPoint('list_commands',
+            "Called when enumerating commands. Called with a set of "
+            "cmd_name strings for all the commands found so far. This set "
+            " is safe to mutate - e.g. to remove a command. "
+            "list_commands should return the updated set of command names.",
+            (1, 17), None))
 
 Command.hooks = CommandHooks()
 
@@ -952,6 +1054,22 @@
     return ignore_pipe
 
 
+def install_bzr_command_hooks():
+    """Install the hooks to supply bzr's own commands."""
+    if _list_bzr_commands in Command.hooks["list_commands"]:
+        return
+    Command.hooks.install_named_hook("list_commands", _list_bzr_commands,
+        "bzr commands")
+    Command.hooks.install_named_hook("get_command", _get_bzr_command,
+        "bzr commands")
+    Command.hooks.install_named_hook("get_command", _get_plugin_command,
+        "bzr plugin commands")
+    Command.hooks.install_named_hook("get_command", _get_external_command,
+        "bzr external command lookup")
+    Command.hooks.install_named_hook("get_missing_command", _try_plugin_provider,
+        "bzr plugin-provider-db check")
+
+
 def main(argv=None):
     """Main entry point of command-line interface.
 
@@ -968,8 +1086,7 @@
 
     # Is this a final release version? If so, we should suppress warnings
     if bzrlib.version_info[3] == 'final':
-        from bzrlib import symbol_versioning
-        symbol_versioning.suppress_deprecation_warnings(override=False)
+        suppress_deprecation_warnings(override=False)
     if argv is None:
         argv = osutils.get_unicode_argv()
     else:
@@ -995,6 +1112,7 @@
     This function assumed that that UI layer is setup, that symbol deprecations
     are already applied, and that unicode decoding has already been performed on argv.
     """
+    install_bzr_command_hooks()
     return exception_to_return_code(run_bzr, argv)
 
 
@@ -1004,6 +1122,7 @@
     This is used for the test suite, and might be useful for other programs
     that want to wrap the commandline interface.
     """
+    install_bzr_command_hooks()
     try:
         return run_bzr(argv)
     except Exception, e:

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2009-05-23 04:55:52 +0000
+++ bzrlib/commit.py	2009-06-15 19:04:38 +0000
@@ -108,9 +108,6 @@
     def deleted(self, path):
         pass
 
-    def escaped(self, escape_count, message):
-        pass
-
     def missing(self, path):
         pass
 
@@ -153,9 +150,6 @@
     def deleted(self, path):
         self._note('deleted %s', path)
 
-    def escaped(self, escape_count, message):
-        self._note("replaced %d control characters in message", escape_count)
-
     def missing(self, path):
         self._note('missing %s', path)
 
@@ -373,7 +367,6 @@
                 # Prompt the user for a commit message if none provided
                 message = message_callback(self)
                 self.message = message
-                self._escape_commit_message()
 
                 # Add revision data to the local branch
                 self.rev_id = self.builder.commit(self.message)
@@ -602,17 +595,6 @@
         if self.master_locked:
             self.master_branch.unlock()
 
-    def _escape_commit_message(self):
-        """Replace xml-incompatible control characters."""
-        # FIXME: RBC 20060419 this should be done by the revision
-        # serialiser not by commit. Then we can also add an unescaper
-        # in the deserializer and start roundtripping revision messages
-        # precisely. See repository_implementations/test_repository.py
-        self.message, escape_count = xml_serializer.escape_invalid_chars(
-            self.message)
-        if escape_count:
-            self.reporter.escaped(escape_count, self.message)
-
     def _gather_parents(self):
         """Record the parents of a merge for merge detection."""
         # TODO: Make sure that this list doesn't contain duplicate

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2009-04-27 16:10:10 +0000
+++ bzrlib/config.py	2009-06-11 06:49:21 +0000
@@ -930,7 +930,6 @@
             return self._config.get_option(name, section, default)
         finally:
             self.branch.unlock()
-        return result
 
     def set_option(self, value, name, section=None):
         """Set a per-branch configuration option"""

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2009-05-27 07:18:20 +0000
+++ bzrlib/diff.py	2009-06-10 03:56:49 +0000
@@ -735,7 +735,12 @@
         return old_disk_path, new_disk_path
 
     def finish(self):
-        osutils.rmtree(self._root)
+        try:
+            osutils.rmtree(self._root)
+        except OSError, e:
+            if e.errno != errno.ENOENT:
+                mutter("The temporary directory \"%s\" was not "
+                        "cleanly removed: %s." % (self._root, e))
 
     def diff(self, file_id, old_path, new_path, old_kind, new_kind):
         if (old_kind, new_kind) != ('file', 'file'):

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2009-05-06 05:36:28 +0000
+++ bzrlib/dirstate.py	2009-06-01 08:55:17 +0000
@@ -3062,19 +3062,17 @@
                     if source_minikind != 'f':
                         content_change = True
                     else:
-                        # If the size is the same, check the sha:
-                        if target_details[2] == source_details[2]:
-                            if link_or_sha1 is None:
-                                # Stat cache miss:
-                                statvalue, link_or_sha1 = \
-                                    self.state._sha1_provider.stat_and_sha1(
-                                    path_info[4])
-                                self.state._observed_sha1(entry, link_or_sha1,
-                                    statvalue)
-                            content_change = (link_or_sha1 != source_details[1])
-                        else:
-                            # Size changed, so must be different
-                            content_change = True
+                        # Check the sha. We can't just rely on the size as
+                        # content filtering may mean differ sizes actually
+                        # map to the same content
+                        if link_or_sha1 is None:
+                            # Stat cache miss:
+                            statvalue, link_or_sha1 = \
+                                self.state._sha1_provider.stat_and_sha1(
+                                path_info[4])
+                            self.state._observed_sha1(entry, link_or_sha1,
+                                statvalue)
+                        content_change = (link_or_sha1 != source_details[1])
                     # Target details is updated at update_entry time
                     if self.use_filesystem_for_exec:
                         # We don't need S_ISREG here, because we are sure

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2009-05-23 04:55:52 +0000
+++ bzrlib/errors.py	2009-06-17 05:05:28 +0000
@@ -2161,20 +2161,17 @@
     _fmt = "To use this feature you must upgrade your repository at %(path)s."
 
 
+class RichRootUpgradeRequired(UpgradeRequired):
+
+    _fmt = ("To use this feature you must upgrade your branch at %(path)s to"
+           " a format which supports rich roots.")
+
+
 class LocalRequiresBoundBranch(BzrError):
 
     _fmt = "Cannot perform local-only commits on unbound branches."
 
 
-class InvalidProgressBarType(BzrError):
-
-    _fmt = ("Environment variable BZR_PROGRESS_BAR='%(bar_type)s"
-            " is not a supported type Select one of: %(valid_types)s")
-
-    def __init__(self, bar_type, valid_types):
-        BzrError.__init__(self, bar_type=bar_type, valid_types=valid_types)
-
-
 class UnsupportedOperation(BzrError):
 
     _fmt = ("The method %(mname)s is not supported on"

=== modified file 'bzrlib/filters/__init__.py'
--- bzrlib/filters/__init__.py	2009-04-20 08:37:32 +0000
+++ bzrlib/filters/__init__.py	2009-06-10 08:54:56 +0000
@@ -247,6 +247,8 @@
         return stack
     stack = []
     for k, v in preferences:
+        if v is None:
+            continue
         try:
             stack_map_lookup = _filter_stacks_registry.get(k)
         except KeyError:

=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2009-05-27 09:40:33 +0000
+++ bzrlib/graph.py	2009-06-12 18:05:15 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,10 +20,10 @@
     debug,
     errors,
     revision,
-    symbol_versioning,
     trace,
     tsort,
     )
+from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 
 STEP_UNIQUE_SEARCHER_EVERY = 5
 
@@ -60,18 +60,25 @@
         return 'DictParentsProvider(%r)' % self.ancestry
 
     def get_parent_map(self, keys):
-        """See _StackedParentsProvider.get_parent_map"""
+        """See StackedParentsProvider.get_parent_map"""
         ancestry = self.ancestry
         return dict((k, ancestry[k]) for k in keys if k in ancestry)
 
-
-class _StackedParentsProvider(object):
-
+@deprecated_function(deprecated_in((1, 16, 0)))
+def _StackedParentsProvider(*args, **kwargs):
+    return StackedParentsProvider(*args, **kwargs)
+
+class StackedParentsProvider(object):
+    """A parents provider which stacks (or unions) multiple providers.
+    
+    The providers are queries in the order of the provided parent_providers.
+    """
+    
     def __init__(self, parent_providers):
         self._parent_providers = parent_providers
 
     def __repr__(self):
-        return "_StackedParentsProvider(%r)" % self._parent_providers
+        return "%s(%r)" % (self.__class__.__name__, self._parent_providers)
 
     def get_parent_map(self, keys):
         """Get a mapping of keys => parents
@@ -148,7 +155,7 @@
         return dict(self._cache)
 
     def get_parent_map(self, keys):
-        """See _StackedParentsProvider.get_parent_map."""
+        """See StackedParentsProvider.get_parent_map."""
         cache = self._cache
         if cache is None:
             cache = self._get_parent_map(keys)
@@ -1648,3 +1655,10 @@
             removed.add(node)
 
     return result
+
+
+_counters = [0,0,0,0,0,0,0]
+try:
+    from bzrlib._known_graph_pyx import KnownGraph
+except ImportError:
+    from bzrlib._known_graph_py import KnownGraph

=== modified file 'bzrlib/groupcompress.py'
--- bzrlib/groupcompress.py	2009-05-29 10:25:37 +0000
+++ bzrlib/groupcompress.py	2009-06-11 20:34:56 +0000
@@ -324,7 +324,11 @@
                 raise ValueError('invalid content_len %d for record @ pos %d'
                                  % (content_len, pos - len_len - 1))
             if kind == 'f': # Fulltext
-                result.append(('f', content_len))
+                if include_text:
+                    text = self._content[pos:pos+content_len]
+                    result.append(('f', content_len, text))
+                else:
+                    result.append(('f', content_len))
             elif kind == 'd': # Delta
                 delta_content = self._content[pos:pos+content_len]
                 delta_info = []
@@ -339,7 +343,11 @@
                         (offset, length,
                          delta_pos) = decode_copy_instruction(delta_content, c,
                                                               delta_pos)
-                        delta_info.append(('c', offset, length))
+                        if include_text:
+                            text = self._content[offset:offset+length]
+                            delta_info.append(('c', offset, length, text))
+                        else:
+                            delta_info.append(('c', offset, length))
                         measured_len += length
                     else: # Insert
                         if include_text:
@@ -746,6 +754,14 @@
 
         After calling this, the compressor should no longer be used
         """
+        # TODO: this causes us to 'bloat' to 2x the size of content in the
+        #       group. This has an impact for 'commit' of large objects.
+        #       One possibility is to use self._content_chunks, and be lazy and
+        #       only fill out self._content as a full string when we actually
+        #       need it. That would at least drop the peak memory consumption
+        #       for 'commit' down to ~1x the size of the largest file, at a
+        #       cost of increased complexity within this code. 2x is still <<
+        #       3x the size of the largest file, so we are doing ok.
         content = ''.join(self.chunks)
         self.chunks = None
         self._delta_index = None
@@ -1006,23 +1022,15 @@
         if not parent_map:
             raise errors.RevisionNotPresent(key, self)
         if parent_map[key] is not None:
-            search = graph._make_breadth_first_searcher([key])
-            keys = set()
-            while True:
-                try:
-                    present, ghosts = search.next_with_ghosts()
-                except StopIteration:
-                    break
-                keys.update(present)
-            parent_map = self.get_parent_map(keys)
+            parent_map = dict((k, v) for k, v in graph.iter_ancestry([key])
+                              if v is not None)
+            keys = parent_map.keys()
         else:
             keys = [key]
             parent_map = {key:()}
-        # So we used Graph(self) to load the parent_map, but now that we have
-        # it, we can just query the parent map directly, so create a new Graph
-        # object
-        graph = _mod_graph.Graph(_mod_graph.DictParentsProvider(parent_map))
-        head_cache = _mod_graph.FrozenHeadsCache(graph)
+        # We used Graph(self) to load the parent_map, but now that we have it,
+        # we can just query the parent map directly, so create a KnownGraph
+        heads_provider = _mod_graph.KnownGraph(parent_map)
         parent_cache = {}
         reannotate = annotate.reannotate
         for record in self.get_record_stream(keys, 'topological', True):
@@ -1030,7 +1038,7 @@
             lines = osutils.chunks_to_lines(record.get_bytes_as('chunked'))
             parent_lines = [parent_cache[parent] for parent in parent_map[key]]
             parent_cache[key] = list(
-                reannotate(parent_lines, lines, key, None, head_cache))
+                reannotate(parent_lines, lines, key, None, heads_provider))
         return parent_cache[key]
 
     def check(self, progress_bar=None):

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2009-03-23 14:59:43 +0000
+++ bzrlib/help.py	2009-05-23 20:57:12 +0000
@@ -73,8 +73,7 @@
         hidden = True
     else:
         hidden = False
-    names = set(_mod_commands.builtin_command_names()) # to eliminate duplicates
-    names.update(_mod_commands.plugin_command_names())
+    names = list(_mod_commands.all_command_names())
     commands = ((n, _mod_commands.get_cmd_object(n)) for n in names)
     shown_commands = [(n, o) for n, o in commands if o.hidden == hidden]
     max_name = max(len(n) for n, o in shown_commands)

=== modified file 'bzrlib/help_topics/__init__.py'
--- bzrlib/help_topics/__init__.py	2009-04-02 04:12:11 +0000
+++ bzrlib/help_topics/__init__.py	2009-06-15 15:20:24 +0000
@@ -489,7 +489,7 @@
 Related commands::
 
   init    Change a directory into a versioned branch.
-  branch  Create a new copy of a branch.
+  branch  Create a new branch that is a copy of an existing branch.
   merge   Perform a three-way merge.
 """
 
@@ -732,6 +732,8 @@
                         'Options to show or record debug information')
 topic_registry.register('log-formats', _load_from_file,
                         'Details on the logging formats available')
+topic_registry.register('diverged-branches', _load_from_file,
+                        'How to fix diverged branches')
 
 
 # Register concept topics.

=== modified file 'bzrlib/help_topics/en/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2009-03-06 05:51:20 +0000
+++ bzrlib/help_topics/en/configuration.txt	2009-06-10 13:18:48 +0000
@@ -404,6 +404,12 @@
 If present, the location of the default branch for push.  This option
 is normally set by ``push --remember``.
 
+push_strict
+~~~~~~~~~~~
+
+If present, defines the ``--strict`` option default value for checking
+uncommitted changes before pushing.
+
 bound_location
 ~~~~~~~~~~~~~~
 

=== added file 'bzrlib/help_topics/en/diverged-branches.txt'
--- bzrlib/help_topics/en/diverged-branches.txt	1970-01-01 00:00:00 +0000
+++ bzrlib/help_topics/en/diverged-branches.txt	2009-06-08 05:00:01 +0000
@@ -0,0 +1,39 @@
+Diverged Branches
+=================
+
+When Bazaar tries to push one branch onto another, it requires that the
+destination branch must be ready to receive the source branch.  If this isn't
+the case, then we say that the branches have ``diverged``.  Branches are
+considered diverged if the destination branch's most recent commit is one that
+has not been merged (directly or indirectly) by the source branch.  To recover
+from diverged branches, one must merge the missing revisions into the source
+branch.
+
+This situation commonly arises when using a centralized workflow with local
+commits.  If someone else has committed new work to the mainline since your
+last pull and you have local commits that have not yet been pushed to the
+mainline, then your local branch and the mainline have diverged.
+
+Discovering What Has Diverged
+-----------------------------
+
+The ``bzr missing`` command is used to find out what revisions are in another
+branch that are not present in the current branch, and vice-versa.  It shows a
+summary of  which extra revisions exist in each branch.  If you want to see the
+precise effects of those revisions, you can use ``bzr diff --old=other_branch``
+to show the differences between other_branch and your current branch.
+
+A Solution
+----------
+
+The solution is to merge the revisions from the mainline into your local
+branch.  To do so, use ``bzr merge`` to get the new revisions from the
+mainline.  This merge may result in conflicts if the other developer's changes
+overlap with your changes.  These conflicts should be resolved before
+continuing. After any conflicts have been resolved, or even if there were no
+conflicts, Bazaar requires that you explicitly commit these new revisions
+to your local branch.  This requirement gives you an opportunity to test the
+resulting working tree for correctness, since the merged revisions could have
+made arbitrary changes.  After testing, you should commit the merge using
+``bzr commit``.  This clears up the diverged branches situation.  Your local
+branch can now be pushed to the mainline.

=== modified file 'bzrlib/help_topics/en/eol.txt'
--- bzrlib/help_topics/en/eol.txt	2009-05-12 02:01:15 +0000
+++ bzrlib/help_topics/en/eol.txt	2009-06-16 12:58:23 +0000
@@ -6,10 +6,17 @@
 ``bzr help content-filters`` for general information about using these.
 
 Note: Content filtering is only supported in recently added formats,
-e.g. 1.14.
+e.g. 1.14. Be sure that both the repository *and* the branch are
+in a recent format. (Just setting the format on the repository
+is not enough.) If content filtering does not appear to be working, use
+'bzr info -v' to confirm that the branch is using "Working tree format 5"
+or later.
 
-EOL conversion needs to be enabled for selected branches and files using
+EOL conversion needs to be enabled for selected file patterns using
 rules. See ``bzr help rules`` for general information on defining rules.
+Currently, rules are only supported in $BZR_HOME/.bazaar/rules (or
+%BZR_HOME%/bazaar/2.0/rules on Windows). Branch specific rules will be
+supported in a future verison of Bazaar.
 
 To configure which files to filter, set ``eol`` to one of the values below.
 (If a value is not set, ``exact`` is the default.)

=== modified file 'bzrlib/index.py'
--- bzrlib/index.py	2009-03-24 01:53:42 +0000
+++ bzrlib/index.py	2009-06-10 03:56:49 +0000
@@ -1192,7 +1192,7 @@
                 ', '.join(map(repr, self._indices)))
 
     def get_parent_map(self, keys):
-        """See graph._StackedParentsProvider.get_parent_map"""
+        """See graph.StackedParentsProvider.get_parent_map"""
         search_keys = set(keys)
         if NULL_REVISION in search_keys:
             search_keys.discard(NULL_REVISION)

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2009-05-26 10:08:17 +0000
+++ bzrlib/inventory.py	2009-06-10 03:56:49 +0000
@@ -747,8 +747,13 @@
             [parent.name for parent in
              self._iter_file_id_parents(file_id)][:-1]))
 
-    def iter_entries(self, from_dir=None):
-        """Return (path, entry) pairs, in order by name."""
+    def iter_entries(self, from_dir=None, recursive=True):
+        """Return (path, entry) pairs, in order by name.
+        
+        :param from_dir: if None, start from the root,
+          otherwise start from this directory (either file-id or entry)
+        :param recursive: recurse into directories or not
+        """
         if from_dir is None:
             if self.root is None:
                 return
@@ -761,6 +766,10 @@
         # 440ms/663ms (inline/total) to 116ms/116ms
         children = from_dir.children.items()
         children.sort()
+        if not recursive:
+            for name, ie in children:
+                yield name, ie
+            return
         children = collections.deque(children)
         stack = [(u'', children)]
         while stack:

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2009-05-29 10:25:37 +0000
+++ bzrlib/knit.py	2009-06-11 20:34:56 +0000
@@ -3552,12 +3552,8 @@
         """Create a heads provider for resolving ancestry issues."""
         if self._heads_provider is not None:
             return self._heads_provider
-        parent_provider = _mod_graph.DictParentsProvider(
-            self._revision_id_graph)
-        graph_obj = _mod_graph.Graph(parent_provider)
-        head_cache = _mod_graph.FrozenHeadsCache(graph_obj)
-        self._heads_provider = head_cache
-        return head_cache
+        self._heads_provider = _mod_graph.KnownGraph(self._revision_id_graph)
+        return self._heads_provider
 
     def annotate(self, key):
         """Return the annotated fulltext at the given key.
@@ -3586,19 +3582,15 @@
         being able to produce line deltas.
         """
         # TODO: this code generates a parent maps of present ancestors; it
-        # could be split out into a separate method, and probably should use
-        # iter_ancestry instead. -- mbp and robertc 20080704
+        #       could be split out into a separate method
+        #       -- mbp and robertc 20080704
         graph = _mod_graph.Graph(self._knit)
-        head_cache = _mod_graph.FrozenHeadsCache(graph)
-        search = graph._make_breadth_first_searcher([key])
-        keys = set()
-        while True:
-            try:
-                present, ghosts = search.next_with_ghosts()
-            except StopIteration:
-                break
-            keys.update(present)
-        parent_map = self._knit.get_parent_map(keys)
+        parent_map = dict((k, v) for k, v in graph.iter_ancestry([key])
+                          if v is not None)
+        if not parent_map:
+            raise errors.RevisionNotPresent(key, self)
+        keys = parent_map.keys()
+        heads_provider = _mod_graph.KnownGraph(parent_map)
         parent_cache = {}
         reannotate = annotate.reannotate
         for record in self._knit.get_record_stream(keys, 'topological', True):
@@ -3610,7 +3602,7 @@
             else:
                 parent_lines = []
             parent_cache[key] = list(
-                reannotate(parent_lines, fulltext, key, None, head_cache))
+                reannotate(parent_lines, fulltext, key, None, heads_provider))
         try:
             return parent_cache[key]
         except KeyError, e:

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2009-05-08 15:39:11 +0000
+++ bzrlib/lock.py	2009-06-10 03:56:49 +0000
@@ -391,7 +391,6 @@
     LOCK_NB = LOCKFILE_FAIL_IMMEDIATELY
     _LockFileEx = ctypes.windll.kernel32.LockFileEx
     _UnlockFileEx = ctypes.windll.kernel32.UnlockFileEx
-    _GetLastError = ctypes.windll.kernel32.GetLastError
 
     ### Define the OVERLAPPED structure.
     #   http://msdn2.microsoft.com/en-us/library/ms684342.aspx
@@ -440,8 +439,8 @@
                                  ctypes.byref(overlapped), # lpOverlapped
                                 )
             if result == 0:
+                last_err = ctypes.GetLastError()
                 self._clear_f()
-                last_err = _GetLastError()
                 if last_err in (ERROR_LOCK_VIOLATION,):
                     raise errors.LockContention(filename)
                 raise errors.LockContention(filename,
@@ -455,12 +454,12 @@
                                    0x00000000, # DWORD nNumberOfBytesToLockHigh
                                    ctypes.byref(overlapped), # lpOverlapped
                                   )
-            self._clear_f()
             if result == 0:
+                last_err = ctypes.GetLastError()
                 self._clear_f()
-                last_err = _GetLastError()
                 raise errors.LockContention(self.filename,
                     'Unknown unlocking error: %s' % (last_err,))
+            self._clear_f()
 
 
     class _ctypes_ReadLock(_ctypes_FileLock):

=== modified file 'bzrlib/mail_client.py'
--- bzrlib/mail_client.py	2009-05-11 18:35:20 +0000
+++ bzrlib/mail_client.py	2009-06-10 03:56:49 +0000
@@ -155,7 +155,7 @@
                       extension, **kwargs)
 
     def _compose(self, prompt, to, subject, attach_path, mime_subtype,
-                extension, body=None):
+                 extension, body=None, from_=None):
         """Invoke a mail client as a commandline process.
 
         Overridden by MAPIClient.
@@ -166,6 +166,8 @@
             "text", but the precise subtype can be specified here
         :param extension: A file extension (including period) associated with
             the attachment type.
+        :param body: Optional body text.
+        :param from_: Optional From: header.
         """
         for name in self._get_client_commands():
             cmdline = [self._encode_path(name, 'executable')]
@@ -173,6 +175,8 @@
                 kwargs = {'body': body}
             else:
                 kwargs = {}
+            if from_ is not None:
+                kwargs['from_'] = from_
             cmdline.extend(self._get_compose_commandline(to, subject,
                                                          attach_path,
                                                          **kwargs))
@@ -253,12 +257,12 @@
                               help=Evolution.__doc__)
 
 
-class Mutt(ExternalMailClient):
+class Mutt(BodyExternalMailClient):
     """Mutt mail client."""
 
     _client_commands = ['mutt']
 
-    def _get_compose_commandline(self, to, subject, attach_path):
+    def _get_compose_commandline(self, to, subject, attach_path, body=None):
         """See ExternalMailClient._get_compose_commandline"""
         message_options = []
         if subject is not None:
@@ -266,6 +270,14 @@
         if attach_path is not None:
             message_options.extend(['-a',
                 self._encode_path(attach_path, 'attachment')])
+        if body is not None:
+            # Store the temp file object in self, so that it does not get
+            # garbage collected and delete the file before mutt can read it.
+            self._temp_file = tempfile.NamedTemporaryFile(
+                prefix="mutt-body-", suffix=".txt")
+            self._temp_file.write(body)
+            self._temp_file.flush()
+            message_options.extend(['-i', self._temp_file.name])
         if to is not None:
             message_options.extend(['--', self._encode_safe(to)])
         return message_options
@@ -331,25 +343,45 @@
 class Claws(ExternalMailClient):
     """Claws mail client."""
 
+    supports_body = True
+
     _client_commands = ['claws-mail']
 
-    def _get_compose_commandline(self, to, subject, attach_path):
+    def _get_compose_commandline(self, to, subject, attach_path, body=None,
+                                 from_=None):
         """See ExternalMailClient._get_compose_commandline"""
-        compose_url = ['mailto:']
-        if to is not None:
-            compose_url.append(self._encode_safe(to))
-        compose_url.append('?')
+        compose_url = []
+        if from_ is not None:
+            compose_url.append('from=' + urllib.quote(from_))
         if subject is not None:
             # Don't use urllib.quote_plus because Claws doesn't seem
             # to recognise spaces encoded as "+".
             compose_url.append(
-                'subject=%s' % urllib.quote(self._encode_safe(subject)))
+                'subject=' + urllib.quote(self._encode_safe(subject)))
+        if body is not None:
+            compose_url.append(
+                'body=' + urllib.quote(self._encode_safe(body)))
+        # to must be supplied for the claws-mail --compose syntax to work.
+        if to is None:
+            raise errors.NoMailAddressSpecified()
+        compose_url = 'mailto:%s?%s' % (
+            self._encode_safe(to), '&'.join(compose_url))
         # Collect command-line options.
-        message_options = ['--compose', ''.join(compose_url)]
+        message_options = ['--compose', compose_url]
         if attach_path is not None:
             message_options.extend(
                 ['--attach', self._encode_path(attach_path, 'attachment')])
         return message_options
+
+    def _compose(self, prompt, to, subject, attach_path, mime_subtype,
+                 extension, body=None, from_=None):
+        """See ExternalMailClient._compose"""
+        if from_ is None:
+            from_ = self.config.get_user_option('email')
+        super(Claws, self)._compose(prompt, to, subject, attach_path,
+                                    mime_subtype, extension, body, from_)
+
+
 mail_client_registry.register('claws', Claws,
                               help=Claws.__doc__)
 
@@ -506,6 +538,8 @@
     """Default mail handling.  Tries XDGEmail (or MAPIClient on Windows),
     falls back to Editor"""
 
+    supports_body = True
+
     def _mail_client(self):
         """Determine the preferred mail client for this platform"""
         if osutils.supports_mapi():

=== modified file 'bzrlib/multiparent.py'
--- bzrlib/multiparent.py	2009-04-04 02:50:01 +0000
+++ bzrlib/multiparent.py	2009-06-10 03:56:49 +0000
@@ -28,7 +28,7 @@
     trace,
     ui,
     )
-from bzrlib.util import bencode
+from bzrlib import bencode
 """)
 from bzrlib.tuned_gzip import GzipFile
 

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2009-05-23 04:55:52 +0000
+++ bzrlib/osutils.py	2009-06-10 06:25:56 +0000
@@ -38,6 +38,7 @@
 from shutil import (
     rmtree,
     )
+import subprocess
 import tempfile
 from tempfile import (
     mkdtemp,
@@ -721,7 +722,7 @@
                _format_date(t, offset, timezone, date_fmt, show_offset)
     date_str = time.strftime(date_fmt, tt)
     if not isinstance(date_str, unicode):
-        date_str = date_str.decode(bzrlib.user_encoding, 'replace')
+        date_str = date_str.decode(get_user_encoding(), 'replace')
     return date_str + offset_str
 
 def _format_date(t, offset, timezone, date_fmt, show_offset):
@@ -1826,3 +1827,58 @@
         finally:
             termios.tcsetattr(fd, termios.TCSADRAIN, settings)
         return ch
+
+
+if sys.platform == 'linux2':
+    def _local_concurrency():
+        concurrency = None
+        prefix = 'processor'
+        for line in file('/proc/cpuinfo', 'rb'):
+            if line.startswith(prefix):
+                concurrency = int(line[line.find(':')+1:]) + 1
+        return concurrency
+elif sys.platform == 'darwin':
+    def _local_concurrency():
+        return subprocess.Popen(['sysctl', '-n', 'hw.availcpu'],
+                                stdout=subprocess.PIPE).communicate()[0]
+elif sys.platform[0:7] == 'freebsd':
+    def _local_concurrency():
+        return subprocess.Popen(['sysctl', '-n', 'hw.ncpu'],
+                                stdout=subprocess.PIPE).communicate()[0]
+elif sys.platform == 'sunos5':
+    def _local_concurrency():
+        return subprocess.Popen(['psrinfo', '-p',],
+                                stdout=subprocess.PIPE).communicate()[0]
+elif sys.platform == "win32":
+    def _local_concurrency():
+        # This appears to return the number of cores.
+        return os.environ.get('NUMBER_OF_PROCESSORS')
+else:
+    def _local_concurrency():
+        # Who knows ?
+        return None
+
+
+_cached_local_concurrency = None
+
+def local_concurrency(use_cache=True):
+    """Return how many processes can be run concurrently.
+
+    Rely on platform specific implementations and default to 1 (one) if
+    anything goes wrong.
+    """
+    global _cached_local_concurrency
+    if _cached_local_concurrency is not None and use_cache:
+        return _cached_local_concurrency
+
+    try:
+        concurrency = _local_concurrency()
+    except (OSError, IOError):
+        concurrency = None
+    try:
+        concurrency = int(concurrency)
+    except (TypeError, ValueError):
+        concurrency = 1
+    if use_cache:
+        _cached_concurrency = concurrency
+    return concurrency

=== modified file 'bzrlib/plugins/launchpad/test_register.py'
--- bzrlib/plugins/launchpad/test_register.py	2009-03-23 14:59:43 +0000
+++ bzrlib/plugins/launchpad/test_register.py	2009-06-10 03:56:49 +0000
@@ -335,12 +335,14 @@
         g_conf = config.GlobalConfig()
         g_conf.set_user_option('email', 'Test User <test@user.com>')
         stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
         ui.ui_factory = tests.TestUIFactory(stdin='userpass\n',
-                                            stdout=stdout)
+                                            stdout=stdout, stderr=stderr)
         self.assertIs(None, service.registrant_password)
         service.gather_user_credentials()
         self.assertEqual('test@user.com', service.registrant_email)
         self.assertEqual('userpass', service.registrant_password)
-        self.assertContainsRe(stdout.getvalue(),
+        self.assertEquals('', stdout.getvalue())
+        self.assertContainsRe(stderr.getvalue(),
                              'launchpad.net password for test@user\\.com')
 

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2009-03-23 14:59:43 +0000
+++ bzrlib/progress.py	2009-06-10 03:56:49 +0000
@@ -36,11 +36,13 @@
     )
 from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import (
+    deprecated_function,
     deprecated_in,
     deprecated_method,
     )
 
 
+# XXX: deprecated; can be removed when the ProgressBar factory is removed
 def _supports_progress(f):
     """Detect if we can use pretty progress bars on the output stream f.
 
@@ -140,6 +142,7 @@
         self.ui_factory.clear_term()
 
 
+@deprecated_function(deprecated_in((1, 16, 0)))
 def ProgressBar(to_file=None, **kwargs):
     """Abstract factory"""
     if to_file is None:
@@ -163,75 +166,6 @@
         return _progress_bar_types[requested_bar_type](to_file=to_file, **kwargs)
 
 
-class ProgressBarStack(object):
-    """A stack of progress bars.
-
-    This class is deprecated: instead, ask the ui factory for a new progress
-    task and finish it when it's done.
-    """
-
-    @deprecated_method(deprecated_in((1, 12, 0)))
-    def __init__(self,
-                 to_file=None,
-                 show_pct=False,
-                 show_spinner=True,
-                 show_eta=False,
-                 show_bar=True,
-                 show_count=True,
-                 to_messages_file=None,
-                 klass=None):
-        """Setup the stack with the parameters the progress bars should have."""
-        if to_file is None:
-            to_file = sys.stderr
-        if to_messages_file is None:
-            to_messages_file = sys.stdout
-        self._to_file = to_file
-        self._show_pct = show_pct
-        self._show_spinner = show_spinner
-        self._show_eta = show_eta
-        self._show_bar = show_bar
-        self._show_count = show_count
-        self._to_messages_file = to_messages_file
-        self._stack = []
-        self._klass = klass or ProgressBar
-
-    def top(self):
-        if len(self._stack) != 0:
-            return self._stack[-1]
-        else:
-            return None
-
-    def bottom(self):
-        if len(self._stack) != 0:
-            return self._stack[0]
-        else:
-            return None
-
-    def get_nested(self):
-        """Return a nested progress bar."""
-        if len(self._stack) == 0:
-            func = self._klass
-        else:
-            func = self.top().child_progress
-        new_bar = func(to_file=self._to_file,
-                       show_pct=self._show_pct,
-                       show_spinner=self._show_spinner,
-                       show_eta=self._show_eta,
-                       show_bar=self._show_bar,
-                       show_count=self._show_count,
-                       to_messages_file=self._to_messages_file,
-                       _stack=self)
-        self._stack.append(new_bar)
-        return new_bar
-
-    def return_pb(self, bar):
-        """Return bar after its been used."""
-        if bar is not self._stack[-1]:
-            warnings.warn("%r is not currently active" % (bar,))
-        else:
-            self._stack.pop()
-
-
 class _BaseProgressBar(object):
 
     def __init__(self,
@@ -278,6 +212,7 @@
         self.to_messages_file.write(fmt_string % args)
         self.to_messages_file.write('\n')
 
+    @deprecated_function(deprecated_in((1, 16, 0)))
     def child_progress(self, **kwargs):
         return ChildProgress(**kwargs)
 
@@ -309,6 +244,7 @@
 
 class DotsProgressBar(_BaseProgressBar):
 
+    @deprecated_function(deprecated_in((1, 16, 0)))
     def __init__(self, **kwargs):
         _BaseProgressBar.__init__(self, **kwargs)
         self.last_msg = None
@@ -335,8 +271,6 @@
         self.tick()
 
 
-
-
 class TTYProgressBar(_BaseProgressBar):
     """Progress bar display object.
 
@@ -359,7 +293,7 @@
     """
     SPIN_CHARS = r'/-\|'
 
-
+    @deprecated_function(deprecated_in((1, 16, 0)))
     def __init__(self, **kwargs):
         from bzrlib.osutils import terminal_width
         _BaseProgressBar.__init__(self, **kwargs)
@@ -519,11 +453,10 @@
         #self.to_file.flush()
 
 
-
-
 class ChildProgress(_BaseProgressBar):
     """A progress indicator that pushes its data to the parent"""
 
+    @deprecated_function(deprecated_in((1, 16, 0)))
     def __init__(self, _stack, **kwargs):
         _BaseProgressBar.__init__(self, _stack=_stack, **kwargs)
         self.parent = _stack.top()
@@ -565,23 +498,6 @@
         self.parent.note(*args, **kwargs)
 
 
-class InstrumentedProgress(TTYProgressBar):
-    """TTYProgress variant that tracks outcomes"""
-
-    def __init__(self, *args, **kwargs):
-        self.always_throttled = True
-        self.never_throttle = False
-        TTYProgressBar.__init__(self, *args, **kwargs)
-
-    def throttle(self, old_message):
-        if self.never_throttle:
-            result =  False
-        else:
-            result = TTYProgressBar.throttle(self, old_message)
-        if result is False:
-            self.always_throttled = False
-
-
 def str_tdelta(delt):
     if delt is None:
         return "-:--:--"

=== modified file 'bzrlib/push.py'
--- bzrlib/push.py	2009-04-23 23:35:44 +0000
+++ bzrlib/push.py	2009-06-08 05:00:01 +0000
@@ -128,7 +128,8 @@
                 remember)
         except errors.DivergedBranches:
             raise errors.BzrCommandError('These branches have diverged.'
-                                    '  Try using "merge" and then "push".')
+                                    '  See "bzr help diverged-branches"'
+                                    ' for more information.')
         except errors.NoRepositoryPresent:
             # we have a bzrdir but no branch or repository
             # XXX: Figure out what to do other than complain.

=== modified file 'bzrlib/python-compat.h'
--- bzrlib/python-compat.h	2009-03-23 14:59:43 +0000
+++ bzrlib/python-compat.h	2009-06-10 03:56:49 +0000
@@ -67,5 +67,10 @@
     #include "arpa/inet.h"
 #endif
 
+#include <stdio.h>
+
+#ifdef _MSC_VER
+#define  snprintf  _snprintf
+#endif
 
 #endif /* _BZR_PYTHON_COMPAT_H */

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2009-04-09 20:23:07 +0000
+++ bzrlib/reconcile.py	2009-06-10 03:56:49 +0000
@@ -137,8 +137,13 @@
     def _reconcile_revision_history(self):
         repo = self.branch.repository
         last_revno, last_revision_id = self.branch.last_revision_info()
-        real_history = list(repo.iter_reverse_revision_history(
-                                last_revision_id))
+        real_history = []
+        try:
+            for revid in repo.iter_reverse_revision_history(
+                    last_revision_id):
+                real_history.append(revid)
+        except errors.RevisionNotPresent:
+            pass # Hit a ghost left hand parent
         real_history.reverse()
         if last_revno != len(real_history):
             self.fixed_history = True

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2009-05-28 09:37:15 +0000
+++ bzrlib/remote.py	2009-06-17 03:53:51 +0000
@@ -20,6 +20,7 @@
 import bz2
 
 from bzrlib import (
+    bencode,
     branch,
     bzrdir,
     config,
@@ -27,12 +28,10 @@
     errors,
     graph,
     lockdir,
-    pack,
     repository,
     revision,
     revision as _mod_revision,
     symbol_versioning,
-    urlutils,
 )
 from bzrlib.branch import BranchReferenceFormat
 from bzrlib.bzrdir import BzrDir, RemoteBzrDirFormat
@@ -45,7 +44,6 @@
 from bzrlib.smart import client, vfs, repository as smart_repo
 from bzrlib.revision import ensure_null, NULL_REVISION
 from bzrlib.trace import mutter, note, warning
-from bzrlib.util import bencode
 
 
 class _RpcHelper(object):
@@ -675,6 +673,37 @@
         return self._real_repository.get_missing_parent_inventories(
             check_for_missing_texts=check_for_missing_texts)
 
+    def _get_rev_id_for_revno_vfs(self, revno, known_pair):
+        self._ensure_real()
+        return self._real_repository.get_rev_id_for_revno(
+            revno, known_pair)
+
+    def get_rev_id_for_revno(self, revno, known_pair):
+        """See Repository.get_rev_id_for_revno."""
+        path = self.bzrdir._path_for_remote_call(self._client)
+        try:
+            if self._client._medium._is_remote_before((1, 17)):
+                return self._get_rev_id_for_revno_vfs(revno, known_pair)
+            response = self._call(
+                'Repository.get_rev_id_for_revno', path, revno, known_pair)
+        except errors.UnknownSmartMethod:
+            self._client._medium._remember_remote_is_before((1, 17))
+            return self._get_rev_id_for_revno_vfs(revno, known_pair)
+        if response[0] == 'ok':
+            return True, response[1]
+        elif response[0] == 'history-incomplete':
+            known_pair = response[1:3]
+            for fallback in self._fallback_repositories:
+                found, result = fallback.get_rev_id_for_revno(revno, known_pair)
+                if found:
+                    return True, result
+                else:
+                    known_pair = result
+            # Not found in any fallbacks
+            return False, known_pair
+        else:
+            raise errors.UnexpectedSmartServerResponse(response)
+
     def _ensure_real(self):
         """Ensure that there is a _real_repository set.
 
@@ -1576,7 +1605,7 @@
             providers.insert(0, other)
         providers.extend(r._make_parents_provider() for r in
                          self._fallback_repositories)
-        return graph._StackedParentsProvider(providers)
+        return graph.StackedParentsProvider(providers)
 
     def _serialise_search_recipe(self, recipe):
         """Serialise a graph search recipe.
@@ -1895,6 +1924,10 @@
         self._ensure_real()
         return self._custom_format.supports_stacking()
 
+    def supports_set_append_revisions_only(self):
+        self._ensure_real()
+        return self._custom_format.supports_set_append_revisions_only()
+
 
 class RemoteBranch(branch.Branch, _RpcHelper):
     """Branch stored on a server accessed by HPSS RPC.
@@ -1919,11 +1952,6 @@
         # We intentionally don't call the parent class's __init__, because it
         # will try to assign to self.tags, which is a property in this subclass.
         # And the parent's __init__ doesn't do much anyway.
-        self._revision_id_to_revno_cache = None
-        self._partial_revision_id_to_revno_cache = {}
-        self._revision_history_cache = None
-        self._last_revision_info_cache = None
-        self._merge_sorted_revisions_cache = None
         self.bzrdir = remote_bzrdir
         if _client is not None:
             self._client = _client
@@ -1943,6 +1971,7 @@
         else:
             self._real_branch = None
         # Fill out expected attributes of branch for bzrlib API users.
+        self._clear_cached_state()
         self.base = self.bzrdir.root_transport.base
         self._control_files = None
         self._lock_mode = None
@@ -1970,6 +1999,7 @@
         hooks = branch.Branch.hooks['open']
         for hook in hooks:
             hook(self)
+        self._is_stacked = False
         if setup_stacking:
             self._setup_stacking()
 
@@ -1981,6 +2011,7 @@
         except (errors.NotStacked, errors.UnstackableBranchFormat,
             errors.UnstackableRepositoryFormat), e:
             return
+        self._is_stacked = True
         self._activate_fallback_location(fallback_url)
 
     def _get_config(self):
@@ -2088,6 +2119,13 @@
             raise errors.UnexpectedSmartServerResponse(response)
         return response[1]
 
+    def set_stacked_on_url(self, url):
+        branch.Branch.set_stacked_on_url(self, url)
+        if not url:
+            self._is_stacked = False
+        else:
+            self._is_stacked = True
+        
     def _vfs_get_tags_bytes(self):
         self._ensure_real()
         return self._real_branch._get_tags_bytes()
@@ -2220,6 +2258,23 @@
             raise NotImplementedError(self.dont_leave_lock_in_place)
         self._leave_lock = False
 
+    def get_rev_id(self, revno, history=None):
+        if revno == 0:
+            return _mod_revision.NULL_REVISION
+        last_revision_info = self.last_revision_info()
+        ok, result = self.repository.get_rev_id_for_revno(
+            revno, last_revision_info)
+        if ok:
+            return result
+        missing_parent = result[1]
+        # Either the revision named by the server is missing, or its parent
+        # is.  Call get_parent_map to determine which, so that we report a
+        # useful error.
+        parent_map = self.repository.get_parent_map([missing_parent])
+        if missing_parent in parent_map:
+            missing_parent = parent_map[missing_parent]
+        raise errors.RevisionNotPresent(missing_parent, self.repository)
+
     def _last_revision_info(self):
         response = self._call('Branch.last_revision_info', self._remote_path())
         if response[0] != 'ok':
@@ -2230,6 +2285,9 @@
 
     def _gen_revision_history(self):
         """See Branch._gen_revision_history()."""
+        if self._is_stacked:
+            self._ensure_real()
+            return self._real_branch._gen_revision_history()
         response_tuple, response_handler = self._call_expecting_body(
             'Branch.revision_history', self._remote_path())
         if response_tuple[0] != 'ok':

=== modified file 'bzrlib/repofmt/groupcompress_repo.py'
--- bzrlib/repofmt/groupcompress_repo.py	2009-06-01 19:16:32 +0000
+++ bzrlib/repofmt/groupcompress_repo.py	2009-06-17 17:57:15 +0000
@@ -1035,3 +1035,41 @@
                 'Does not support nested trees', target_format)
 
 
+
+class RepositoryFormatCHK2(RepositoryFormatCHK1):
+    """A CHK repository that uses the bencode revision serializer."""
+
+    _serializer = chk_serializer.chk_bencode_serializer
+
+    def _get_matching_bzrdir(self):
+        return bzrdir.format_registry.make_bzrdir('development7-rich-root')
+
+    def _ignore_setting_bzrdir(self, format):
+        pass
+
+    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
+
+    def get_format_string(self):
+        """See RepositoryFormat.get_format_string()."""
+        return ('Bazaar development format - chk repository with bencode '
+                'revision serialization (needs bzr.dev from 1.16)\n')
+
+
+class RepositoryFormat2a(RepositoryFormatCHK2):
+    """A CHK repository that uses the bencode revision serializer.
+    
+    This is the same as RepositoryFormatCHK2 but with a public name.
+    """
+
+    _serializer = chk_serializer.chk_bencode_serializer
+
+    def _get_matching_bzrdir(self):
+        return bzrdir.format_registry.make_bzrdir('2a')
+
+    def _ignore_setting_bzrdir(self, format):
+        pass
+
+    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
+
+    def get_format_string(self):
+        return ('Bazaar repository format 2a (needs bzr 1.16 or later)\n')

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2009-04-09 20:23:07 +0000
+++ bzrlib/repofmt/knitrepo.py	2009-06-10 03:56:49 +0000
@@ -54,7 +54,7 @@
         return 'KnitParentsProvider(%r)' % self._knit
 
     def get_parent_map(self, keys):
-        """See graph._StackedParentsProvider.get_parent_map"""
+        """See graph.StackedParentsProvider.get_parent_map"""
         parent_map = {}
         for revision_id in keys:
             if revision_id is None:
@@ -85,7 +85,7 @@
         return 'KnitsParentsProvider(%r)' % self._knit
 
     def get_parent_map(self, keys):
-        """See graph._StackedParentsProvider.get_parent_map"""
+        """See graph.StackedParentsProvider.get_parent_map"""
         parent_map = self._knit.get_parent_map(
             [self._prefix + (key,) for key in keys])
         result = {}

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2009-05-29 15:12:14 +0000
+++ bzrlib/repofmt/pack_repo.py	2009-06-17 17:57:15 +0000
@@ -1307,7 +1307,7 @@
         # space (we only topo sort the revisions, which is smaller).
         topo_order = tsort.topo_sort(ancestors)
         rev_order = dict(zip(topo_order, range(len(topo_order))))
-        bad_texts.sort(key=lambda key:rev_order[key[0][1]])
+        bad_texts.sort(key=lambda key:rev_order.get(key[0][1], 0))
         transaction = repo.get_transaction()
         file_id_index = GraphIndexPrefixAdapter(
             self.new_pack.text_index,
@@ -2295,7 +2295,11 @@
 
     def _resume_write_group(self, tokens):
         self._start_write_group()
-        self._pack_collection._resume_write_group(tokens)
+        try:
+            self._pack_collection._resume_write_group(tokens)
+        except errors.UnresumableWriteGroup:
+            self._abort_write_group()
+            raise
         for pack in self._pack_collection._resumed_packs:
             self.revisions._index.scan_unvalidated_index(pack.revision_index)
 

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2009-06-01 19:16:32 +0000
+++ bzrlib/repository.py	2009-06-17 17:57:15 +0000
@@ -2257,6 +2257,41 @@
         """
         return self.get_revision(revision_id).inventory_sha1
 
+    def get_rev_id_for_revno(self, revno, known_pair):
+        """Return the revision id of a revno, given a later (revno, revid)
+        pair in the same history.
+
+        :return: if found (True, revid).  If the available history ran out
+            before reaching the revno, then this returns
+            (False, (closest_revno, closest_revid)).
+        """
+        known_revno, known_revid = known_pair
+        partial_history = [known_revid]
+        distance_from_known = known_revno - revno
+        if distance_from_known < 0:
+            raise ValueError(
+                'requested revno (%d) is later than given known revno (%d)'
+                % (revno, known_revno))
+        try:
+            _iter_for_revno(
+                self, partial_history, stop_index=distance_from_known)
+        except errors.RevisionNotPresent, err:
+            if err.revision_id == known_revid:
+                # The start revision (known_revid) wasn't found.
+                raise
+            # This is a stacked repository with no fallbacks, or a there's a
+            # left-hand ghost.  Either way, even though the revision named in
+            # the error isn't in this repo, we know it's the next step in this
+            # left-hand history.
+            partial_history.append(err.revision_id)
+        if len(partial_history) <= distance_from_known:
+            # Didn't find enough history to get a revid for the revno.
+            earliest_revno = known_revno - len(partial_history) + 1
+            return (False, (earliest_revno, partial_history[-1]))
+        if len(partial_history) - 1 > distance_from_known:
+            raise AssertionError('_iter_for_revno returned too much history')
+        return (True, partial_history[-1])
+
     def iter_reverse_revision_history(self, revision_id):
         """Iterate backwards through revision ids in the lefthand history
 
@@ -2268,13 +2303,11 @@
         while True:
             if next_id in (None, _mod_revision.NULL_REVISION):
                 return
+            try:
+                parents = graph.get_parent_map([next_id])[next_id]
+            except KeyError:
+                raise errors.RevisionNotPresent(next_id, self)
             yield next_id
-            # Note: The following line may raise KeyError in the event of
-            # truncated history. We decided not to have a try:except:raise
-            # RevisionNotPresent here until we see a use for it, because of the
-            # cost in an inner loop that is by its very nature O(history).
-            # Robert Collins 20080326
-            parents = graph.get_parent_map([next_id])[next_id]
             if len(parents) == 0:
                 return
             else:
@@ -2409,7 +2442,7 @@
         return self.control_files.get_transaction()
 
     def get_parent_map(self, revision_ids):
-        """See graph._StackedParentsProvider.get_parent_map"""
+        """See graph.StackedParentsProvider.get_parent_map"""
         # revisions index works in keys; this just works in revisions
         # therefore wrap and unwrap
         query_keys = []
@@ -2438,7 +2471,7 @@
         parents_provider = self._make_parents_provider()
         if (other_repository is not None and
             not self.has_same_location(other_repository)):
-            parents_provider = graph._StackedParentsProvider(
+            parents_provider = graph.StackedParentsProvider(
                 [parents_provider, other_repository._make_parents_provider()])
         return graph.Graph(parents_provider)
 
@@ -3085,6 +3118,18 @@
     'RepositoryFormatCHK1',
     )
 
+format_registry.register_lazy(
+    'Bazaar development format - chk repository with bencode revision '
+        'serialization (needs bzr.dev from 1.16)\n',
+    'bzrlib.repofmt.groupcompress_repo',
+    'RepositoryFormatCHK2',
+    )
+format_registry.register_lazy(
+    'Bazaar repository format 2a (needs bzr 1.16 or later)\n',
+    'bzrlib.repofmt.groupcompress_repo',
+    'RepositoryFormat2a',
+    )
+
 
 class InterRepository(InterObject):
     """This class represents operations taking place between two repositories.
@@ -4291,3 +4336,35 @@
             yield versionedfile.FulltextContentFactory(
                 key, parent_keys, None, as_bytes)
 
+
+def _iter_for_revno(repo, partial_history_cache, stop_index=None,
+                    stop_revision=None):
+    """Extend the partial history to include a given index
+
+    If a stop_index is supplied, stop when that index has been reached.
+    If a stop_revision is supplied, stop when that revision is
+    encountered.  Otherwise, stop when the beginning of history is
+    reached.
+
+    :param stop_index: The index which should be present.  When it is
+        present, history extension will stop.
+    :param stop_revision: The revision id which should be present.  When
+        it is encountered, history extension will stop.
+    """
+    start_revision = partial_history_cache[-1]
+    iterator = repo.iter_reverse_revision_history(start_revision)
+    try:
+        #skip the last revision in the list
+        iterator.next()
+        while True:
+            if (stop_index is not None and
+                len(partial_history_cache) > stop_index):
+                break
+            if partial_history_cache[-1] == stop_revision:
+                break
+            revision_id = iterator.next()
+            partial_history_cache.append(revision_id)
+    except StopIteration:
+        # No more history
+        return
+

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2009-05-23 04:55:52 +0000
+++ bzrlib/revisiontree.py	2009-06-17 03:41:33 +0000
@@ -114,11 +114,18 @@
     def has_filename(self, filename):
         return bool(self.inventory.path2id(filename))
 
-    def list_files(self, include_root=False):
+    def list_files(self, include_root=False, from_dir=None, recursive=True):
         # The only files returned by this are those from the version
-        entries = self.inventory.iter_entries()
-        # skip the root for compatability with the current apis.
-        if self.inventory.root is not None and not include_root:
+        inv = self.inventory
+        if from_dir is None:
+            from_dir_id = None
+        else:
+            from_dir_id = inv.path2id(from_dir)
+            if from_dir_id is None:
+                # Directory not versioned
+                return
+        entries = inv.iter_entries(from_dir=from_dir_id, recursive=recursive)
+        if inv.root is not None and not include_root and from_dir is None:
             # skip the root for compatability with the current apis.
             entries.next()
         for path, entry in entries:

=== modified file 'bzrlib/serializer.py'
--- bzrlib/serializer.py	2009-04-03 21:50:40 +0000
+++ bzrlib/serializer.py	2009-06-15 19:04:38 +0000
@@ -24,6 +24,8 @@
 class Serializer(object):
     """Inventory and revision serialization/deserialization."""
 
+    squashes_xml_invalid_characters = False
+
     def write_inventory(self, inv, f):
         """Write inventory to a file"""
         raise NotImplementedError(self.write_inventory)
@@ -75,3 +77,7 @@
 format_registry.register_lazy('6', 'bzrlib.xml6', 'serializer_v6')
 format_registry.register_lazy('7', 'bzrlib.xml7', 'serializer_v7')
 format_registry.register_lazy('8', 'bzrlib.xml8', 'serializer_v8')
+format_registry.register_lazy('9', 'bzrlib.chk_serializer',
+    'chk_serializer_255_bigpage')
+format_registry.register_lazy('10', 'bzrlib.chk_serializer',
+    'chk_bencode_serializer')

=== modified file 'bzrlib/shelf.py'
--- bzrlib/shelf.py	2009-03-23 14:59:43 +0000
+++ bzrlib/shelf.py	2009-06-10 03:56:49 +0000
@@ -19,6 +19,7 @@
 import re
 
 from bzrlib import (
+    bencode,
     errors,
     merge,
     merge3,
@@ -28,7 +29,6 @@
     ui,
     workingtree,
 )
-from bzrlib.util import bencode
 
 
 class ShelfCreator(object):

=== modified file 'bzrlib/shellcomplete.py'
--- bzrlib/shellcomplete.py	2009-03-23 14:59:43 +0000
+++ bzrlib/shellcomplete.py	2009-06-15 11:05:33 +0000
@@ -60,19 +60,22 @@
     import commands
     from inspect import getdoc
 
+    commands.install_bzr_command_hooks()
+
     if outfile is None:
         outfile = sys.stdout
 
     cmds = []
-    for cmdname, cmdclass in commands.get_all_cmds():
-        cmds.append((cmdname, cmdclass))
-        for alias in cmdclass.aliases:
-            cmds.append((alias, cmdclass))
+    for cmdname in commands.all_command_names():
+        cmd = commands.get_cmd_object(cmdname)
+        cmds.append((cmdname, cmd))
+        for alias in cmd.aliases:
+            cmds.append((alias, cmd))
     cmds.sort()
-    for cmdname, cmdclass in cmds:
-        if cmdclass.hidden:
+    for cmdname, cmd in cmds:
+        if cmd.hidden:
             continue
-        doc = getdoc(cmdclass)
+        doc = getdoc(cmd)
         if doc is None:
             outfile.write(cmdname + '\n')
         else:

=== modified file 'bzrlib/smart/bzrdir.py'
--- bzrlib/smart/bzrdir.py	2009-04-28 03:55:56 +0000
+++ bzrlib/smart/bzrdir.py	2009-06-12 01:48:43 +0000
@@ -17,7 +17,7 @@
 """Server-side bzrdir related request implmentations."""
 
 
-from bzrlib import branch, errors, repository
+from bzrlib import branch, errors, repository, urlutils
 from bzrlib.bzrdir import (
     BzrDir,
     BzrDirFormat,
@@ -354,7 +354,10 @@
     def do(self, bzrdir_network_name, path, use_existing_dir, create_prefix,
         force_new_repo, stacked_on, stack_on_pwd, repo_format_name,
         make_working_trees, shared_repo):
-        """Initialize a bzrdir at path as per BzrDirFormat.initialize_ex
+        """Initialize a bzrdir at path as per
+        BzrDirFormat.initialize_on_transport_ex.
+
+        New in 1.16.  (Replaces BzrDirFormat.initialize_ex verb from 1.15).
 
         :return: return SuccessfulSmartServerResponse((repo_path, rich_root,
             tree_ref, external_lookup, repo_network_name,
@@ -407,6 +410,19 @@
             repo.unlock()
         final_stack = final_stack or ''
         final_stack_pwd = final_stack_pwd or ''
+
+        # We want this to be relative to the bzrdir.
+        if final_stack_pwd:
+            final_stack_pwd = urlutils.relative_url(
+                target_transport.base, final_stack_pwd)
+
+        # Can't meaningfully return a root path.
+        if final_stack.startswith('/'):
+            client_path = self._root_client_path + final_stack[1:]
+            final_stack = urlutils.relative_url(
+                self._root_client_path, client_path)
+            final_stack_pwd = '.'
+
         return SuccessfulSmartServerResponse((repo_path, rich_root, tree_ref,
             external_lookup, repo_name, repo_bzrdir_name,
             bzrdir._format.network_name(),

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2009-05-05 22:11:41 +0000
+++ bzrlib/smart/medium.py	2009-06-10 03:56:49 +0000
@@ -285,11 +285,8 @@
         self._push_back(protocol.unused_data)
 
     def _read_bytes(self, desired_count):
-        # We ignore the desired_count because on sockets it's more efficient to
-        # read large chunks (of _MAX_READ_SIZE bytes) at a time.
-        bytes = osutils.until_no_eintr(self.socket.recv, _MAX_READ_SIZE)
-        self._report_activity(len(bytes), 'read')
-        return bytes
+        return _read_bytes_from_socket(
+            self.socket.recv, desired_count, self._report_activity)
 
     def terminate_due_to_error(self):
         # TODO: This should log to a server log file, but no such thing
@@ -884,19 +881,8 @@
         """See SmartClientMedium.read_bytes."""
         if not self._connected:
             raise errors.MediumNotConnected(self)
-        # We ignore the desired_count because on sockets it's more efficient to
-        # read large chunks (of _MAX_READ_SIZE bytes) at a time.
-        try:
-            bytes = osutils.until_no_eintr(self._socket.recv, _MAX_READ_SIZE)
-        except socket.error, e:
-            if len(e.args) and e.args[0] == errno.ECONNRESET:
-                # Callers expect an empty string in that case
-                return ''
-            else:
-                raise
-        else:
-            self._report_activity(len(bytes), 'read')
-            return bytes
+        return _read_bytes_from_socket(
+            self._socket.recv, count, self._report_activity)
 
 
 class SmartClientStreamMediumRequest(SmartClientMediumRequest):
@@ -938,3 +924,20 @@
         """
         self._medium._flush()
 
+
+def _read_bytes_from_socket(sock, desired_count, report_activity):
+    # We ignore the desired_count because on sockets it's more efficient to
+    # read large chunks (of _MAX_READ_SIZE bytes) at a time.
+    try:
+        bytes = osutils.until_no_eintr(sock, _MAX_READ_SIZE)
+    except socket.error, e:
+        if len(e.args) and e.args[0] in (errno.ECONNRESET, 10054):
+            # The connection was closed by the other side.  Callers expect an
+            # empty string to signal end-of-stream.
+            bytes = ''
+        else:
+            raise
+    else:
+        report_activity(len(bytes), 'read')
+    return bytes
+

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2009-03-23 14:59:43 +0000
+++ bzrlib/smart/protocol.py	2009-06-10 03:56:49 +0000
@@ -29,7 +29,7 @@
 from bzrlib import errors
 from bzrlib.smart import message, request
 from bzrlib.trace import log_exception_quietly, mutter
-from bzrlib.util.bencode import bdecode_as_tuple, bencode
+from bzrlib.bencode import bdecode_as_tuple, bencode
 
 
 # Protocol version strings.  These are sent as prefixes of bzr requests and

=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2009-06-01 18:13:46 +0000
+++ bzrlib/smart/repository.py	2009-06-16 06:46:32 +0000
@@ -19,13 +19,13 @@
 import bz2
 import os
 import Queue
-import struct
 import sys
 import tarfile
 import tempfile
 import threading
 
 from bzrlib import (
+    bencode,
     errors,
     graph,
     osutils,
@@ -39,7 +39,6 @@
     )
 from bzrlib.repository import _strip_NULL_ghosts, network_format_registry
 from bzrlib import revision as _mod_revision
-from bzrlib.util import bencode
 from bzrlib.versionedfile import NetworkRecordStream, record_to_fulltext_bytes
 
 
@@ -284,6 +283,31 @@
         return SuccessfulSmartServerResponse(('ok', ), '\n'.join(lines))
 
 
+class SmartServerRepositoryGetRevIdForRevno(SmartServerRepositoryReadLocked):
+
+    def do_readlocked_repository_request(self, repository, revno,
+            known_pair):
+        """Find the revid for a given revno, given a known revno/revid pair.
+        
+        New in 1.17.
+        """
+        try:
+            found_flag, result = repository.get_rev_id_for_revno(revno, known_pair)
+        except errors.RevisionNotPresent, err:
+            if err.revision_id != known_pair[1]:
+                raise AssertionError(
+                    'get_rev_id_for_revno raised RevisionNotPresent for '
+                    'non-initial revision: ' + err.revision_id)
+            return FailedSmartServerResponse(
+                ('nosuchrevision', err.revision_id))
+        if found_flag:
+            return SuccessfulSmartServerResponse(('ok', result))
+        else:
+            earliest_revno, earliest_revid = result
+            return SuccessfulSmartServerResponse(
+                ('history-incomplete', earliest_revno, earliest_revid))
+
+
 class SmartServerRequestHasRevision(SmartServerRepositoryRequest):
 
     def do_repository_request(self, repository, revision_id):

=== modified file 'bzrlib/smart/request.py'
--- bzrlib/smart/request.py	2009-04-24 05:08:51 +0000
+++ bzrlib/smart/request.py	2009-06-15 06:47:14 +0000
@@ -492,7 +492,7 @@
     'BzrDirFormat.initialize', 'bzrlib.smart.bzrdir',
     'SmartServerRequestInitializeBzrDir')
 request_handlers.register_lazy(
-    'BzrDirFormat.initialize_ex', 'bzrlib.smart.bzrdir',
+    'BzrDirFormat.initialize_ex_1.16', 'bzrlib.smart.bzrdir',
     'SmartServerRequestBzrDirInitializeEx')
 request_handlers.register_lazy(
     'BzrDir.open', 'bzrlib.smart.bzrdir', 'SmartServerRequestOpenBzrDir')
@@ -555,6 +555,9 @@
 request_handlers.register_lazy(
     'Repository.unlock', 'bzrlib.smart.repository', 'SmartServerRepositoryUnlock')
 request_handlers.register_lazy(
+    'Repository.get_rev_id_for_revno', 'bzrlib.smart.repository',
+    'SmartServerRepositoryGetRevIdForRevno')
+request_handlers.register_lazy(
     'Repository.get_stream', 'bzrlib.smart.repository',
     'SmartServerRepositoryGetStream')
 request_handlers.register_lazy(

=== modified file 'bzrlib/tag.py'
--- bzrlib/tag.py	2009-05-06 05:36:28 +0000
+++ bzrlib/tag.py	2009-06-10 03:56:49 +0000
@@ -28,12 +28,8 @@
 
 from warnings import warn
 
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
-from bzrlib.util import bencode
-""")
-
 from bzrlib import (
+    bencode,
     errors,
     trace,
     )

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2009-05-23 04:55:52 +0000
+++ bzrlib/tests/__init__.py	2009-06-10 18:58:02 +0000
@@ -728,9 +728,11 @@
     def finished(self):
         """See progress.ProgressBar.finished()."""
 
-    def note(self, fmt_string, *args, **kwargs):
+    def note(self, fmt_string, *args):
         """See progress.ProgressBar.note()."""
-        self.stdout.write((fmt_string + "\n") % args)
+        if args:
+            fmt_string = fmt_string % args
+        self.stdout.write(fmt_string + "\n")
 
     def progress_bar(self):
         return self
@@ -2753,7 +2755,7 @@
 
 
 def fork_decorator(suite):
-    concurrency = local_concurrency()
+    concurrency = osutils.local_concurrency()
     if concurrency == 1:
         return suite
     from testtools import ConcurrentTestSuite
@@ -2762,7 +2764,7 @@
 
 
 def subprocess_decorator(suite):
-    concurrency = local_concurrency()
+    concurrency = osutils.local_concurrency()
     if concurrency == 1:
         return suite
     from testtools import ConcurrentTestSuite
@@ -2954,7 +2956,7 @@
     :return: An iterable of TestCase-like objects which can each have
         run(result) called on them to feed tests to result.
     """
-    concurrency = local_concurrency()
+    concurrency = osutils.local_concurrency()
     result = []
     from subunit import TestProtocolClient, ProtocolTestCase
     class TestInOtherProcess(ProtocolTestCase):
@@ -3003,7 +3005,7 @@
     :return: An iterable of TestCase-like objects which can each have
         run(result) called on them to feed tests to result.
     """
-    concurrency = local_concurrency()
+    concurrency = osutils.local_concurrency()
     result = []
     from subunit import TestProtocolClient, ProtocolTestCase
     class TestInSubprocess(ProtocolTestCase):
@@ -3049,24 +3051,6 @@
     return result
 
 
-def cpucount(content):
-    lines = content.splitlines()
-    prefix = 'processor'
-    for line in lines:
-        if line.startswith(prefix):
-            concurrency = int(line[line.find(':')+1:]) + 1
-    return concurrency
-
-
-def local_concurrency():
-    try:
-        content = file('/proc/cpuinfo', 'rb').read()
-        concurrency = cpucount(content)
-    except Exception, e:
-        concurrency = 1
-    return concurrency
-
-
 class BZRTransformingResult(unittest.TestResult):
 
     def __init__(self, target):
@@ -3363,6 +3347,7 @@
                    'bzrlib.tests.test__chk_map',
                    'bzrlib.tests.test__dirstate_helpers',
                    'bzrlib.tests.test__groupcompress',
+                   'bzrlib.tests.test__known_graph',
                    'bzrlib.tests.test__rio',
                    'bzrlib.tests.test__walkdirs_win32',
                    'bzrlib.tests.test_ancestry',
@@ -3370,6 +3355,7 @@
                    'bzrlib.tests.test_api',
                    'bzrlib.tests.test_atomicfile',
                    'bzrlib.tests.test_bad_files',
+                   'bzrlib.tests.test_bencode',
                    'bzrlib.tests.test_bisect_multi',
                    'bzrlib.tests.test_branch',
                    'bzrlib.tests.test_branchbuilder',
@@ -3380,6 +3366,7 @@
                    'bzrlib.tests.test__chunks_to_lines',
                    'bzrlib.tests.test_cache_utf8',
                    'bzrlib.tests.test_chk_map',
+                   'bzrlib.tests.test_chk_serializer',
                    'bzrlib.tests.test_chunk_writer',
                    'bzrlib.tests.test_clean_tree',
                    'bzrlib.tests.test_commands',
@@ -3517,7 +3504,6 @@
                    'bzrlib.tests.test_xml',
                    'bzrlib.tests.tree_implementations',
                    'bzrlib.tests.workingtree_implementations',
-                   'bzrlib.util.tests.test_bencode',
                    ]
 
     loader = TestUtil.TestLoader()

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2009-04-15 04:45:06 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2009-06-10 03:56:49 +0000
@@ -237,9 +237,10 @@
             ['branch', '--stacked', 'trunk', 'shallow'])
         # We should notify the user that we upgraded their format
         self.assertEqualDiff(
-            'Source format does not support stacking, using format: \'1.6\'\n'
+            'Source repository format does not support stacking, using format:\n'
             '  Packs 5 (adds stacking support, requires bzr 1.6)\n'
-            '\n'
+            'Source branch format does not support stacking, using format:\n'
+            '  Branch format 7\n'
             'Created new stacked branch referring to %s.\n' % (trunk.base,),
             err)
 
@@ -249,10 +250,10 @@
             ['branch', '--stacked', 'trunk', 'shallow'])
         # We should notify the user that we upgraded their format
         self.assertEqualDiff(
-            'Source format does not support stacking, using format:'
-            ' \'1.6.1-rich-root\'\n'
+            'Source repository format does not support stacking, using format:\n'
             '  Packs 5 rich-root (adds stacking support, requires bzr 1.6.1)\n'
-            '\n'
+            'Source branch format does not support stacking, using format:\n'
+            '  Branch format 7\n'
             'Created new stacked branch referring to %s.\n' % (trunk.base,),
             err)
 

=== modified file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2009-06-17 05:11:41 +0000
@@ -360,18 +360,11 @@
         # subprocess.py that we had to workaround).
         # However, if 'diff' may not be available
         self.make_example_branch()
-        orig_progress = os.environ.get('BZR_PROGRESS_BAR')
-        try:
-            os.environ['BZR_PROGRESS_BAR'] = 'none'
-            out, err = self.run_bzr_subprocess('diff -r 1 --diff-options -ub',
-                                               universal_newlines=True,
-                                               retcode=None)
-        finally:
-            if orig_progress is None:
-                del os.environ['BZR_PROGRESS_BAR']
-            else:
-                os.environ['BZR_PROGRESS_BAR'] = orig_progress
-
+        # this will be automatically restored by the base bzr test class
+        os.environ['BZR_PROGRESS_BAR'] = 'none'
+        out, err = self.run_bzr_subprocess('diff -r 1 --diff-options -ub',
+                                           universal_newlines=True,
+                                           retcode=None)
         if 'Diff is not installed on this machine' in err:
             raise TestSkipped("No external 'diff' is available")
         self.assertEqual('', err)

=== modified file 'bzrlib/tests/blackbox/test_export.py'
--- bzrlib/tests/blackbox/test_export.py	2009-04-06 14:18:33 +0000
+++ bzrlib/tests/blackbox/test_export.py	2009-06-10 03:56:49 +0000
@@ -60,7 +60,7 @@
 
         if sys.version_info < (2, 5, 2) and sys.platform == 'darwin':
             raise tests.KnownFailure('python %r has a tar related bug, upgrade'
-                                     % sys.version_info)
+                                     % (sys.version_info,))
         out, err = self.run_bzr('export --format=tgz --root=test -')
         ball = tarfile.open('', fileobj=StringIO(out))
         self.assertEqual(['test/a'], sorted(ball.getnames()))

=== modified file 'bzrlib/tests/blackbox/test_init.py'
--- bzrlib/tests/blackbox/test_init.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_init.py	2009-06-11 04:04:14 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -49,6 +49,13 @@
             out)
         self.assertEqual('', err)
 
+    def test_init_format_2a(self):
+        """Smoke test for constructing a format 2a repoistory."""
+        out, err = self.run_bzr('init --format=2a')
+        self.assertEqual("""Created a standalone tree (format: 2a)\n""",
+            out)
+        self.assertEqual('', err)
+
     def test_init_at_repository_root(self):
         # bzr init at the root of a repository should create a branch
         # and working tree even when creation of working trees is disabled.

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2009-05-06 05:36:28 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2009-06-15 06:47:14 +0000
@@ -359,3 +359,35 @@
         self.assertContainsRe(out, r'\n {4}1 .*\n {6}setup\n')
         self.assertNotContainsRe(
             out, r'revno: 1\ncommitter: .*\nbranch nick: source')
+
+    def test_pull_smart_stacked_streaming_acceptance(self):
+        """'bzr pull -r 123' works on stacked, smart branches, even when the
+        revision specified by the revno is only present in the fallback
+        repository.
+
+        See <https://launchpad.net/bugs/380314>
+        """
+        self.setup_smart_server_with_call_log()
+        # Make a stacked-on branch with two commits so that the
+        # revision-history can't be determined just by looking at the parent
+        # field in the revision in the stacked repo.
+        parent = self.make_branch_and_tree('parent', format='1.9')
+        parent.commit(message='first commit')
+        parent.commit(message='second commit')
+        local = parent.bzrdir.sprout('local').open_workingtree()
+        local.commit(message='local commit')
+        local.branch.create_clone_on_transport(
+            self.get_transport('stacked'), stacked_on=self.get_url('parent'))
+        empty = self.make_branch_and_tree('empty', format='1.9')
+        self.reset_smart_call_log()
+        self.run_bzr(['pull', '-r', '1', self.get_url('stacked')],
+            working_dir='empty')
+        # This figure represent the amount of work to perform this use case. It
+        # is entirely ok to reduce this number if a test fails due to rpc_count
+        # being too low. If rpc_count increases, more network roundtrips have
+        # become necessary for this use case. Please do not adjust this number
+        # upwards without agreement from bzr's network support maintainers.
+        self.assertLength(18, self.hpss_calls)
+        remote = Branch.open('stacked')
+        self.assertEndsWith(remote.get_stacked_on_url(), '/parent')
+

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2009-05-08 13:39:32 +0000
+++ bzrlib/tests/blackbox/test_push.py	2009-06-17 08:08:36 +0000
@@ -17,33 +17,30 @@
 
 """Black-box tests for bzr push."""
 
-import os
 import re
 
 from bzrlib import (
+    branch,
+    bzrdir,
     errors,
+    osutils,
+    tests,
     transport,
+    uncommit,
     urlutils,
+    workingtree
     )
-from bzrlib.branch import Branch
-from bzrlib.bzrdir import BzrDirMetaFormat1
-from bzrlib.osutils import abspath
-from bzrlib.repofmt.knitrepo import RepositoryFormatKnit1
-from bzrlib.smart import client, server
-from bzrlib.tests.blackbox import ExternalBase
-from bzrlib.tests.http_server import HttpServer
-from bzrlib.transport.memory import MemoryServer, MemoryTransport
-from bzrlib.uncommit import uncommit
-from bzrlib.urlutils import local_path_from_url
-from bzrlib.workingtree import WorkingTree
-
-
-class TestPush(ExternalBase):
+from bzrlib.repofmt import knitrepo
+from bzrlib.tests import http_server
+from bzrlib.transport import memory
+
+
+class TestPush(tests.TestCaseWithTransport):
 
     def test_push_error_on_vfs_http(self):
         """ pushing a branch to a HTTP server fails cleanly. """
         # the trunk is published on a web server
-        self.transport_readonly_server = HttpServer
+        self.transport_readonly_server = http_server.HttpServer
         self.make_branch('source')
         public_url = self.get_readonly_url('target')
         self.run_bzr_error(['http does not support mkdir'],
@@ -72,41 +69,42 @@
         self.assertEqual(None, branch_b.get_push_location())
 
         # test push for failure without push location set
-        os.chdir('branch_a')
-        out = self.run_bzr('push', retcode=3)
+        out = self.run_bzr('push', working_dir='branch_a', retcode=3)
         self.assertEquals(out,
                 ('','bzr: ERROR: No push location known or specified.\n'))
 
         # test not remembered if cannot actually push
-        self.run_bzr('push ../path/which/doesnt/exist', retcode=3)
-        out = self.run_bzr('push', retcode=3)
+        self.run_bzr('push path/which/doesnt/exist',
+                     working_dir='branch_a', retcode=3)
+        out = self.run_bzr('push', working_dir='branch_a', retcode=3)
         self.assertEquals(
                 ('', 'bzr: ERROR: No push location known or specified.\n'),
                 out)
 
         # test implicit --remember when no push location set, push fails
-        out = self.run_bzr('push ../branch_b', retcode=3)
+        out = self.run_bzr('push ../branch_b',
+                           working_dir='branch_a', retcode=3)
         self.assertEquals(out,
                 ('','bzr: ERROR: These branches have diverged.  '
-                    'Try using "merge" and then "push".\n'))
-        self.assertEquals(abspath(branch_a.get_push_location()),
-                          abspath(branch_b.bzrdir.root_transport.base))
+                 'See "bzr help diverged-branches" for more information.\n'))
+        self.assertEquals(osutils.abspath(branch_a.get_push_location()),
+                          osutils.abspath(branch_b.bzrdir.root_transport.base))
 
         # test implicit --remember after resolving previous failure
-        uncommit(branch=branch_b, tree=tree_b)
+        uncommit.uncommit(branch=branch_b, tree=tree_b)
         transport.delete('branch_b/c')
-        out, err = self.run_bzr('push')
+        out, err = self.run_bzr('push', working_dir='branch_a')
         path = branch_a.get_push_location()
         self.assertEquals(out,
                           'Using saved push location: %s\n'
-                          % local_path_from_url(path))
+                          % urlutils.local_path_from_url(path))
         self.assertEqual(err,
                          'All changes applied successfully.\n'
                          'Pushed up to revision 2.\n')
         self.assertEqual(path,
                          branch_b.bzrdir.root_transport.base)
         # test explicit --remember
-        self.run_bzr('push ../branch_c --remember')
+        self.run_bzr('push ../branch_c --remember', working_dir='branch_a')
         self.assertEquals(branch_a.get_push_location(),
                           branch_c.bzrdir.root_transport.base)
 
@@ -116,7 +114,7 @@
         out, err = self.run_bzr('push pushed-location')
         self.assertEqual('', out)
         self.assertEqual('Created new branch.\n', err)
-        b2 = Branch.open('pushed-location')
+        b2 = branch.Branch.open('pushed-location')
         self.assertEndsWith(b2.base, 'pushed-location/')
 
     def test_push_new_branch_revision_count(self):
@@ -127,23 +125,21 @@
         self.build_tree(['tree/file'])
         t.add('file')
         t.commit('commit 1')
-        os.chdir('tree')
-        out, err = self.run_bzr('push pushed-to')
-        os.chdir('..')
+        out, err = self.run_bzr('push -d tree pushed-to')
         self.assertEqual('', out)
         self.assertEqual('Created new branch.\n', err)
 
     def test_push_only_pushes_history(self):
         # Knit branches should only push the history for the current revision.
-        format = BzrDirMetaFormat1()
-        format.repository_format = RepositoryFormatKnit1()
+        format = bzrdir.BzrDirMetaFormat1()
+        format.repository_format = knitrepo.RepositoryFormatKnit1()
         shared_repo = self.make_repository('repo', format=format, shared=True)
         shared_repo.set_make_working_trees(True)
 
         def make_shared_tree(path):
             shared_repo.bzrdir.root_transport.mkdir(path)
             shared_repo.bzrdir.create_branch_convenience('repo/' + path)
-            return WorkingTree.open('repo/' + path)
+            return workingtree.WorkingTree.open('repo/' + path)
         tree_a = make_shared_tree('a')
         self.build_tree(['repo/a/file'])
         tree_a.add('file')
@@ -164,9 +160,8 @@
 
         # Now that we have a repository with shared files, make sure
         # that things aren't copied out by a 'push'
-        os.chdir('repo/b')
-        self.run_bzr('push ../../push-b')
-        pushed_tree = WorkingTree.open('../../push-b')
+        self.run_bzr('push ../../push-b', working_dir='repo/b')
+        pushed_tree = workingtree.WorkingTree.open('push-b')
         pushed_repo = pushed_tree.branch.repository
         self.assertFalse(pushed_repo.has_revision('a-1'))
         self.assertFalse(pushed_repo.has_revision('a-2'))
@@ -174,11 +169,10 @@
 
     def test_push_funky_id(self):
         t = self.make_branch_and_tree('tree')
-        os.chdir('tree')
-        self.build_tree(['filename'])
+        self.build_tree(['tree/filename'])
         t.add('filename', 'funky-chars<>%&;"\'')
         t.commit('commit filename')
-        self.run_bzr('push ../new-tree')
+        self.run_bzr('push -d tree new-tree')
 
     def test_push_dash_d(self):
         t = self.make_branch_and_tree('from')
@@ -218,9 +212,34 @@
         # become necessary for this use case. Please do not adjust this number
         # upwards without agreement from bzr's network support maintainers.
         self.assertLength(14, self.hpss_calls)
-        remote = Branch.open('public')
+        remote = branch.Branch.open('public')
         self.assertEndsWith(remote.get_stacked_on_url(), '/parent')
 
+    def test_push_smart_with_default_stacking_url_path_segment(self):
+        # If the default stacked-on location is a path element then branches
+        # we push there over the smart server are stacked and their
+        # stacked_on_url is that exact path segment. Added to nail bug 385132.
+        self.setup_smart_server_with_call_log()
+        self.make_branch('stack-on', format='1.9')
+        self.make_bzrdir('.').get_config().set_default_stack_on(
+            '/stack-on')
+        self.make_branch('from', format='1.9')
+        out, err = self.run_bzr(['push', '-d', 'from', self.get_url('to')])
+        b = branch.Branch.open(self.get_url('to'))
+        self.assertEqual('/extra/stack-on', b.get_stacked_on_url())
+
+    def test_push_smart_with_default_stacking_relative_path(self):
+        # If the default stacked-on location is a relative path then branches
+        # we push there over the smart server are stacked and their
+        # stacked_on_url is a relative path. Added to nail bug 385132.
+        self.setup_smart_server_with_call_log()
+        self.make_branch('stack-on', format='1.9')
+        self.make_bzrdir('.').get_config().set_default_stack_on('stack-on')
+        self.make_branch('from', format='1.9')
+        out, err = self.run_bzr(['push', '-d', 'from', self.get_url('to')])
+        b = branch.Branch.open(self.get_url('to'))
+        self.assertEqual('../stack-on', b.get_stacked_on_url())
+
     def create_simple_tree(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a'])
@@ -237,7 +256,7 @@
                            working_dir='tree')
         self.run_bzr('push ../new/tree --create-prefix',
                      working_dir='tree')
-        new_tree = WorkingTree.open('new/tree')
+        new_tree = workingtree.WorkingTree.open('new/tree')
         self.assertEqual(tree.last_revision(), new_tree.last_revision())
         self.failUnlessExists('new/tree/a')
 
@@ -257,7 +276,7 @@
         self.run_bzr('push --use-existing-dir ../target',
                      working_dir='tree')
 
-        new_tree = WorkingTree.open('target')
+        new_tree = workingtree.WorkingTree.open('target')
         self.assertEqual(tree.last_revision(), new_tree.last_revision())
         # The push should have created target/a
         self.failUnlessExists('target/a')
@@ -273,8 +292,9 @@
         # Pushing onto an existing bzrdir will create a repository and
         # branch as needed, but will only create a working tree if there was
         # no BzrDir before.
-        self.assertRaises(errors.NoWorkingTree, WorkingTree.open, 'repo')
-        new_branch = Branch.open('repo')
+        self.assertRaises(errors.NoWorkingTree,
+                          workingtree.WorkingTree.open, 'repo')
+        new_branch = branch.Branch.open('repo')
         self.assertEqual(tree.last_revision(), new_branch.last_revision())
 
     def test_push_onto_just_bzrdir(self):
@@ -299,7 +319,7 @@
 
         self.run_bzr('push -r1 ../to', working_dir='from')
 
-        tree_to = WorkingTree.open('to')
+        tree_to = workingtree.WorkingTree.open('to')
         repo_to = tree_to.branch.repository
         self.assertTrue(repo_to.has_revision('from-1'))
         self.assertFalse(repo_to.has_revision('from-2'))
@@ -326,7 +346,7 @@
 
     def assertPublished(self, branch_revid, stacked_on):
         """Assert that the branch 'published' has been published correctly."""
-        published_branch = Branch.open('published')
+        published_branch = branch.Branch.open('published')
         # The published branch refers to the mainline
         self.assertEqual(stacked_on, published_branch.get_stacked_on_url())
         # and the branch's work was pushed
@@ -354,13 +374,14 @@
         self.assertEqual('', out)
         self.assertEqual('Created new stacked branch referring to %s.\n' %
             trunk_tree.branch.base, err)
-        self.assertPublished(branch_tree.last_revision(), trunk_tree.branch.base)
+        self.assertPublished(branch_tree.last_revision(),
+                             trunk_tree.branch.base)
 
     def test_push_new_branch_stacked_uses_parent_public(self):
         """Pushing a new branch with --stacked creates a stacked branch."""
         trunk_tree, branch_tree = self.create_trunk_and_feature_branch()
         # the trunk is published on a web server
-        self.transport_readonly_server = HttpServer
+        self.transport_readonly_server = http_server.HttpServer
         trunk_public = self.make_branch('public_trunk', format='1.9')
         trunk_public.pull(trunk_tree.branch)
         trunk_public_url = self.get_readonly_url('public_trunk')
@@ -398,17 +419,16 @@
         self.make_bzrdir('.').get_config().set_default_stack_on('stack_on')
         self.make_branch('from', format='pack-0.92')
         out, err = self.run_bzr('push -d from to')
-        branch = Branch.open('to')
-        self.assertEqual('../stack_on', branch.get_stacked_on_url())
+        b = branch.Branch.open('to')
+        self.assertEqual('../stack_on', b.get_stacked_on_url())
 
     def test_push_does_not_change_format_with_default_if_target_cannot(self):
         self.make_branch('stack_on', format='pack-0.92')
         self.make_bzrdir('.').get_config().set_default_stack_on('stack_on')
         self.make_branch('from', format='pack-0.92')
         out, err = self.run_bzr('push -d from to')
-        branch = Branch.open('to')
-        self.assertRaises(errors.UnstackableBranchFormat,
-            branch.get_stacked_on_url)
+        b = branch.Branch.open('to')
+        self.assertRaises(errors.UnstackableBranchFormat, b.get_stacked_on_url)
 
     def test_push_doesnt_create_broken_branch(self):
         """Pushing a new standalone branch works even when there's a default
@@ -456,11 +476,10 @@
         self.assertNotContainsRe(out, 'rev1')
 
 
-class RedirectingMemoryTransport(MemoryTransport):
+class RedirectingMemoryTransport(memory.MemoryTransport):
 
     def mkdir(self, relpath, mode=None):
         from bzrlib.trace import mutter
-        mutter('cwd: %r, rel: %r, abs: %r' % (self._cwd, relpath, abspath))
         if self._cwd == '/source/':
             raise errors.RedirectRequested(self.abspath(relpath),
                                            self.abspath('../target'),
@@ -478,7 +497,7 @@
         return transport.get_transport(target)
 
 
-class RedirectingMemoryServer(MemoryServer):
+class RedirectingMemoryServer(memory.MemoryServer):
 
     def setUp(self):
         self._dirs = {'/': None}
@@ -498,10 +517,10 @@
         transport.unregister_transport(self._scheme, self._memory_factory)
 
 
-class TestPushRedirect(ExternalBase):
+class TestPushRedirect(tests.TestCaseWithTransport):
 
     def setUp(self):
-        ExternalBase.setUp(self)
+        tests.TestCaseWithTransport.setUp(self)
         self.memory_server = RedirectingMemoryServer()
         self.memory_server.setUp()
         self.addCleanup(self.memory_server.tearDown)
@@ -521,8 +540,8 @@
         destination_url = self.memory_server.get_url() + 'source'
         self.run_bzr(['push', '-d', 'tree', destination_url])
 
-        local_revision = Branch.open('tree').last_revision()
-        remote_revision = Branch.open(
+        local_revision = branch.Branch.open('tree').last_revision()
+        remote_revision = branch.Branch.open(
             self.memory_server.get_url() + 'target').last_revision()
         self.assertEqual(remote_revision, local_revision)
 
@@ -536,3 +555,77 @@
              % re.escape(destination_url)],
             ['push', '-d', 'tree', destination_url], retcode=3)
         self.assertEqual('', out)
+
+
+class TestPushStrict(tests.TestCaseWithTransport):
+
+    def make_local_branch_and_tree(self):
+        tree = self.make_branch_and_tree('local')
+        self.build_tree_contents([('local/file', 'initial')])
+        tree.add('file')
+        tree.commit('adding file', rev_id='from-1')
+        return tree
+
+    def make_local_branch_and_tree_with_changes(self):
+        tree = self.make_local_branch_and_tree()
+        # Make some changes
+        self.build_tree_contents([('local/file', 'modified')])
+        return tree
+
+    def set_config_push_strict(self, tree, value):
+        # set config var (any of bazaar.conf, locations.conf, branch.conf
+        # should do)
+        conf = tree.branch.get_config()
+        conf.set_user_option('push_strict', value)
+
+    def assertPushFails(self, location, *args):
+        self.run_bzr_error(['Working tree ".*/local/"'
+                            ' has uncommitted changes.$',],
+                           ['push', '../' + location] + list(args),
+                           working_dir='local', retcode=3)
+
+    def assertPushSucceeds(self, location, *args):
+        self.run_bzr(['push', '../' + location] + list(args),
+                     working_dir='local')
+        tree_to = workingtree.WorkingTree.open(location)
+        repo_to = tree_to.branch.repository
+        self.assertTrue(repo_to.has_revision('from-1'))
+        self.assertEqual(tree_to.branch.last_revision_info()[1], 'from-1')
+
+    def test_push_default(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.assertPushSucceeds('to')
+
+    def test_push_no_strict_with_changes(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.assertPushSucceeds('to', '--no-strict')
+
+    def test_push_strict_with_changes(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.assertPushFails('to', '--strict')
+
+    def test_push_strict_without_changes(self):
+        tree = self.make_local_branch_and_tree()
+        self.assertPushSucceeds('to', '--strict')
+
+    def test_push_respect_config_var_strict(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.set_config_push_strict(tree, 'true')
+        self.assertPushFails('to')
+
+    def test_push_bogus_config_var_ignored(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.set_config_push_strict(tree, "I don't want you to be strict")
+        self.assertPushSucceeds('to')
+
+    def test_push_no_strict_command_line_override_config(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.set_config_push_strict(tree, 'yES')
+        self.assertPushFails('to')
+        self.assertPushSucceeds('to', '--no-strict')
+
+    def test_push_strict_command_line_override_config(self):
+        tree = self.make_local_branch_and_tree_with_changes()
+        self.set_config_push_strict(tree, 'oFF')
+        self.assertPushFails('to', '--strict')
+        self.assertPushSucceeds('to')

=== modified file 'bzrlib/tests/blackbox/test_split.py'
--- bzrlib/tests/blackbox/test_split.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_split.py	2009-06-08 02:02:08 +0000
@@ -47,7 +47,7 @@
         self.build_tree(['tree/subtree/'])
         tree.add('subtree')
         tree.commit('added subtree')
-        self.run_bzr_error(('must upgrade your branch at .*tree',),
+        self.run_bzr_error(('must upgrade your branch at .*tree','rich roots'),
                            'split tree/subtree')
 
     def split_formats(self, format, repo_format):

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_status.py	2009-06-10 01:44:08 +0000
@@ -656,7 +656,7 @@
         self.stdout = sys.stdout
 
     def tearDown(self):
-        bzrlib.user_encoding = self.user_encoding
+        osutils._cached_user_encoding = self.user_encoding
         sys.stdout = self.stdout
         TestCaseWithTransport.tearDown(self)
 

=== modified file 'bzrlib/tests/branch_implementations/test_check.py'
--- bzrlib/tests/branch_implementations/test_check.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/branch_implementations/test_check.py	2009-06-10 03:56:49 +0000
@@ -67,4 +67,11 @@
         result.report_results(verbose=True)
         result.report_results(verbose=False)
 
+    def test_check_detects_ghosts_in_mainline(self):
+        tree = self.make_branch_and_tree('test')
+        tree.set_parent_ids(['thisisaghost'], allow_leftmost_as_ghost=True)
+        r1 = tree.commit('one')
+        r2 = tree.commit('two')
+        result = tree.branch.check()
+        self.assertEquals(True, result.ghosts_in_mainline)
 

=== modified file 'bzrlib/tests/branch_implementations/test_dotted_revno_to_revision_id.py'
--- bzrlib/tests/branch_implementations/test_dotted_revno_to_revision_id.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/branch_implementations/test_dotted_revno_to_revision_id.py	2009-06-16 08:06:58 +0000
@@ -26,6 +26,8 @@
     def test_lookup_revision_id_by_dotted(self):
         tree = self.create_tree_with_merge()
         the_branch = tree.branch
+        the_branch.lock_read()
+        self.addCleanup(the_branch.unlock)
         self.assertEqual('null:', the_branch.dotted_revno_to_revision_id((0,)))
         self.assertEqual('rev-1', the_branch.dotted_revno_to_revision_id((1,)))
         self.assertEqual('rev-2', the_branch.dotted_revno_to_revision_id((2,)))

=== modified file 'bzrlib/tests/branch_implementations/test_push.py'
--- bzrlib/tests/branch_implementations/test_push.py	2009-05-23 04:55:52 +0000
+++ bzrlib/tests/branch_implementations/test_push.py	2009-06-17 08:08:36 +0000
@@ -427,7 +427,7 @@
         cmd = builtins.cmd_push()
         cmd.outf = tests.StringIOWrapper()
         cmd.run(
-            directory=self.get_url() + 'empty',
+            directory=self.get_url('empty'),
             location=self.smart_server.get_url() + 'target')
         # HPSS calls as of 2008/09/22:
         # [BzrDir.open, BzrDir.open_branch, BzrDir.find_repositoryV2,

=== modified file 'bzrlib/tests/branch_implementations/test_reconcile.py'
--- bzrlib/tests/branch_implementations/test_reconcile.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/branch_implementations/test_reconcile.py	2009-06-10 03:56:49 +0000
@@ -70,3 +70,13 @@
         a_branch = self.make_branch('a_branch')
         a_branch.reconcile(thorough=False)
         a_branch.reconcile(thorough=True)
+
+    def test_reconcile_handles_ghosts_in_revhistory(self):
+        tree = self.make_branch_and_tree('test')
+        tree.set_parent_ids(["spooky"], allow_leftmost_as_ghost=True)
+        r1 = tree.commit('one')
+        r2 = tree.commit('two')
+        tree.branch.set_last_revision_info(2, r2)
+
+        reconciler = tree.branch.reconcile()
+        self.assertEquals([r1, r2], tree.branch.revision_history())

=== modified file 'bzrlib/tests/branch_implementations/test_sprout.py'
--- bzrlib/tests/branch_implementations/test_sprout.py	2009-05-06 05:36:28 +0000
+++ bzrlib/tests/branch_implementations/test_sprout.py	2009-06-10 03:56:49 +0000
@@ -155,6 +155,14 @@
         self.assertEqual(target,
                          tree.basis_tree().get_symlink_target('link-id'))
 
+    def test_sprout_with_ghost_in_mainline(self):
+        tree = self.make_branch_and_tree('tree1')
+        tree.set_parent_ids(["spooky"], allow_leftmost_as_ghost=True)
+        tree.add('')
+        tree.commit('msg1', rev_id='rev1')
+        tree.commit('msg2', rev_id='rev2')
+        tree.bzrdir.sprout('target', revision_id='rev1')
+
     def assertBranchHookBranchIsStacked(self, pre_change_params):
         # Just calling will either succeed or fail.
         pre_change_params.branch.get_stacked_on_url()

=== modified file 'bzrlib/tests/branch_implementations/test_stacking.py'
--- bzrlib/tests/branch_implementations/test_stacking.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/branch_implementations/test_stacking.py	2009-06-11 07:43:56 +0000
@@ -421,6 +421,31 @@
         # Ensure that opening the branch doesn't raise.
         branch.Branch.open(transport.base)
 
+    def test_revision_history_of_stacked(self):
+        # See <https://launchpad.net/bugs/380314>.
+        stack_on = self.make_branch_and_tree('stack-on')
+        stack_on.commit('first commit', rev_id='rev1')
+        try:
+            stacked_dir = stack_on.bzrdir.sprout(
+                self.get_url('stacked'), stacked=True)
+        except unstackable_format_errors, e:
+            raise TestNotApplicable('Format does not support stacking.')
+        try:
+            stacked = stacked_dir.open_workingtree()
+        except errors.NoWorkingTree:
+            stacked = stacked_dir.open_branch().create_checkout(
+                'stacked-checkout', lightweight=True)
+        stacked.commit('second commit', rev_id='rev2')
+        # Sanity check: stacked's repo should not contain rev1, otherwise this
+        # test isn't testing what it's supposed to.
+        repo = stacked.branch.repository.bzrdir.open_repository()
+        repo.lock_read()
+        self.addCleanup(repo.unlock)
+        self.assertEqual({}, repo.get_parent_map(['rev1']))
+        # revision_history should work, even though the history is spread over
+        # multiple repositories.
+        self.assertLength(2, stacked.branch.revision_history())
+
 
 class TestStackingConnections(
     transport_util.TestCaseWithConnectionHookedTransport):

=== modified file 'bzrlib/tests/bzrdir_implementations/test_bzrdir.py'
--- bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2009-04-28 03:55:56 +0000
+++ bzrlib/tests/bzrdir_implementations/test_bzrdir.py	2009-06-11 03:15:57 +0000
@@ -1246,6 +1246,36 @@
         self.assertTrue(repo.is_write_locked())
         repo.unlock()
 
+    def test_format_initialize_on_transport_ex_default_stack_on(self):
+        # When initialize_on_transport_ex uses a stacked-on branch because of
+        # a stacking policy on the target, the location of the fallback
+        # repository is the same as the external location of the stacked-on
+        # branch.
+        balloon = self.make_bzrdir('balloon')
+        if isinstance(balloon, bzrdir.BzrDirMetaFormat1):
+            stack_on = self.make_branch('stack-on', format='1.9')
+        else:
+            stack_on = self.make_branch('stack-on')
+        config = self.make_bzrdir('.').get_config()
+        try:
+            config.set_default_stack_on('stack-on')
+        except errors.BzrError:
+            raise TestNotApplicable('Only relevant for stackable formats.')
+        # Initialize a bzrdir subject to the policy.
+        t = self.get_transport('stacked')
+        repo_fmt = bzrdir.format_registry.make_bzrdir('1.9')
+        repo_name = repo_fmt.repository_format.network_name()
+        repo, control = self.assertInitializeEx(
+            t, need_meta=True, repo_format_name=repo_name, stacked_on=None)
+        if control is None:
+            # uninitialisable format
+            return
+        # There's one fallback repo, with a public location.
+        self.assertLength(1, repo._fallback_repositories)
+        fallback_repo = repo._fallback_repositories[0]
+        self.assertEqual(
+            stack_on.base, fallback_repo.bzrdir.root_transport.base)
+
     def test_format_initialize_on_transport_ex_repo_fmt_name_None(self):
         t = self.get_transport('dir')
         repo, control = self.assertInitializeEx(t)

=== modified file 'bzrlib/tests/inventory_implementations/basics.py'
--- bzrlib/tests/inventory_implementations/basics.py	2009-04-09 20:23:07 +0000
+++ bzrlib/tests/inventory_implementations/basics.py	2009-06-10 03:56:49 +0000
@@ -211,8 +211,12 @@
                      ('doc', 'directory', 'doc-id'),
                      ('src/hello.c', 'file', 'hello-id'),
                      ('src/bye.c', 'file', 'bye-id'),
+                     ('src/sub', 'directory', 'sub-id'),
+                     ('src/sub/a', 'file', 'a-id'),
                      ('Makefile', 'file', 'makefile-id')]:
             inv.add_path(*args)
+
+        # Test all entries
         self.assertEqual([
             ('', 'tree-root'),
             ('Makefile', 'makefile-id'),
@@ -220,8 +224,36 @@
             ('src', 'src-id'),
             ('src/bye.c', 'bye-id'),
             ('src/hello.c', 'hello-id'),
+            ('src/sub', 'sub-id'),
+            ('src/sub/a', 'a-id'),
             ], [(path, ie.file_id) for path, ie in inv.iter_entries()])
 
+        # Test a subdirectory
+        self.assertEqual([
+            ('bye.c', 'bye-id'),
+            ('hello.c', 'hello-id'),
+            ('sub', 'sub-id'),
+            ('sub/a', 'a-id'),
+            ], [(path, ie.file_id) for path, ie in inv.iter_entries(
+            from_dir='src-id')])
+
+        # Test not recursing at the root level
+        self.assertEqual([
+            ('', 'tree-root'),
+            ('Makefile', 'makefile-id'),
+            ('doc', 'doc-id'),
+            ('src', 'src-id'),
+            ], [(path, ie.file_id) for path, ie in inv.iter_entries(
+            recursive=False)])
+
+        # Test not recursing at a subdirectory level
+        self.assertEqual([
+            ('bye.c', 'bye-id'),
+            ('hello.c', 'hello-id'),
+            ('sub', 'sub-id'),
+            ], [(path, ie.file_id) for path, ie in inv.iter_entries(
+            from_dir='src-id', recursive=False)])
+
     def test_iter_just_entries(self):
         inv = self.make_inventory('tree-root')
         for args in [('src', 'directory', 'src-id'),

=== modified file 'bzrlib/tests/per_repository/test_iter_reverse_revision_history.py'
--- bzrlib/tests/per_repository/test_iter_reverse_revision_history.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/per_repository/test_iter_reverse_revision_history.py	2009-06-10 03:56:49 +0000
@@ -145,3 +145,23 @@
                                   repo, 'rev-2-4')
         self.assertRevHistoryList(['rev-2-5', 'rev-2-4', 'rev-2-3', 'rev-2-2',
                                    'rev-1-1'], repo, 'rev-2-5')
+
+    def test_ghost(self):
+        tree = self.make_branch_and_memory_tree('tree')
+        tree.lock_write()
+        try:
+            tree.add('')
+            tree.set_parent_ids(['spooky'], allow_leftmost_as_ghost=True)
+            tree.commit('1', rev_id='rev1')
+            tree.commit('2', rev_id='rev2')
+        finally:
+            tree.unlock()
+        iter = tree.branch.repository.iter_reverse_revision_history('rev2')
+        tree.branch.repository.lock_read()
+        try:
+            self.assertEquals('rev2', iter.next())
+            self.assertEquals('rev1', iter.next())
+            self.assertRaises(errors.RevisionNotPresent, iter.next)
+        finally:
+            tree.branch.repository.unlock()
+

=== modified file 'bzrlib/tests/per_repository/test_reconcile.py'
--- bzrlib/tests/per_repository/test_reconcile.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/per_repository/test_reconcile.py	2009-06-10 03:56:49 +0000
@@ -264,6 +264,40 @@
         self.assertEqual([None, 'the_ghost', 'ghost'], repo.get_ancestry('ghost'))
         self.assertEqual([None, 'the_ghost'], repo.get_ancestry('the_ghost'))
 
+    def test_text_from_ghost_revision(self):
+        repo = self.make_repository('text-from-ghost')
+        inv = Inventory(revision_id='final-revid')
+        inv.root.revision = 'root-revid'
+        ie = inv.add_path('bla', 'file', 'myfileid')
+        ie.revision = 'ghostrevid'
+        ie.text_size = 42
+        ie.text_sha1 = "bee68c8acd989f5f1765b4660695275948bf5c00"
+        rev = bzrlib.revision.Revision(timestamp=0,
+                                       timezone=None,
+                                       committer="Foo Bar <foo@example.com>",
+                                       message="Message",
+                                       revision_id='final-revid')
+        repo.lock_write()
+        try:
+            repo.start_write_group()
+            try:
+                repo.add_revision('final-revid', rev, inv)
+                try:
+                    repo.texts.add_lines(('myfileid', 'ghostrevid'),
+                        (('myfileid', 'ghost-text-parent'),),
+                        ["line1\n", "line2\n"])
+                except errors.RevisionNotPresent:
+                    raise TestSkipped("text ghost parents not supported")
+                if repo.supports_rich_root():
+                    root_id = inv.root.file_id
+                    repo.texts.add_lines((inv.root.file_id, inv.root.revision),
+                        [], [])
+            finally:
+                repo.commit_write_group()
+        finally:
+            repo.unlock()
+        repo.reconcile(thorough=True)
+
 
 class TestReconcileWithIncorrectRevisionCache(TestReconcile):
     """Ancestry data gets cached in knits and weaves should be reconcilable.

=== modified file 'bzrlib/tests/per_repository/test_repository.py'
--- bzrlib/tests/per_repository/test_repository.py	2009-05-11 07:18:30 +0000
+++ bzrlib/tests/per_repository/test_repository.py	2009-06-15 19:11:56 +0000
@@ -28,6 +28,7 @@
     osutils,
     remote,
     repository,
+    xml_serializer,
     )
 from bzrlib.branch import BzrBranchFormat6
 from bzrlib.delta import TreeDelta
@@ -527,16 +528,16 @@
         tree = self.make_branch_and_tree('.')
         tree.commit(message, rev_id='a', allow_pointless=True)
         rev = tree.branch.repository.get_revision('a')
-        # we have to manually escape this as we dont try to
-        # roundtrip xml invalid characters at this point.
-        # when escaping is moved to the serialiser, this test
-        # can check against the literal message rather than
-        # this escaped version.
-        escaped_message, escape_count = re.subn(
-            u'[^\x09\x0A\x0D\u0020-\uD7FF\uE000-\uFFFD]+',
-            lambda match: match.group(0).encode('unicode_escape'),
-            message)
-        self.assertEqual(rev.message, escaped_message)
+        if tree.branch.repository._serializer.squashes_xml_invalid_characters:
+            # we have to manually escape this as we dont try to
+            # roundtrip xml invalid characters in the xml-based serializers.
+            escaped_message, escape_count = re.subn(
+                u'[^\x09\x0A\x0D\u0020-\uD7FF\uE000-\uFFFD]+',
+                lambda match: match.group(0).encode('unicode_escape'),
+                message)
+            self.assertEqual(rev.message, escaped_message)
+        else:
+            self.assertEqual(rev.message, message)
         # insist the class is unicode no matter what came in for
         # consistency.
         self.assertIsInstance(rev.message, unicode)

=== modified file 'bzrlib/tests/per_repository/test_revision.py'
--- bzrlib/tests/per_repository/test_revision.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/per_repository/test_revision.py	2009-06-10 03:56:49 +0000
@@ -72,7 +72,7 @@
         tree1.commit(message="quux", allow_pointless=True, committer="jaq",
                      revprops={'empty':'',
                                'value':'one',
-                               'unicode':'\xb5',
+                               'unicode':u'\xb5',
                                'multiline':'foo\nbar\n\n'
                               })
         self.assertTrue(len(tree1.branch.revision_history()) > 0)

=== modified file 'bzrlib/tests/per_repository_reference/__init__.py'
--- bzrlib/tests/per_repository_reference/__init__.py	2009-05-27 09:40:33 +0000
+++ bzrlib/tests/per_repository_reference/__init__.py	2009-06-15 06:47:14 +0000
@@ -98,6 +98,7 @@
         'bzrlib.tests.per_repository_reference.test_check',
         'bzrlib.tests.per_repository_reference.test_default_stacking',
         'bzrlib.tests.per_repository_reference.test_fetch',
+        'bzrlib.tests.per_repository_reference.test_get_rev_id_for_revno',
         'bzrlib.tests.per_repository_reference.test_initialize',
         'bzrlib.tests.per_repository_reference.test_unlock',
         ]

=== added file 'bzrlib/tests/per_repository_reference/test_get_rev_id_for_revno.py'
--- bzrlib/tests/per_repository_reference/test_get_rev_id_for_revno.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_repository_reference/test_get_rev_id_for_revno.py	2009-06-15 06:41:49 +0000
@@ -0,0 +1,46 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for get_rev_id_for_revno on a repository with external references."""
+
+from bzrlib import errors
+from bzrlib.tests.per_repository_reference import (
+    TestCaseWithExternalReferenceRepository,
+    )
+
+class TestGetRevIdForRevno(TestCaseWithExternalReferenceRepository):
+
+    def test_uses_fallback(self):
+        tree = self.make_branch_and_tree('base')
+        base = tree.branch.repository
+        revid = tree.commit('one')
+        revid2 = tree.commit('two')
+        spare_tree = tree.bzrdir.sprout('spare').open_workingtree()
+        revid3 = spare_tree.commit('three')
+        branch = spare_tree.branch.create_clone_on_transport(
+            self.get_transport('referring'), stacked_on=self.get_url('base'))
+        repo = branch.repository
+        # Sanity check: now repo has 'revid3', and base has 'revid' + 'revid2'
+        self.assertEqual(set([revid3]),
+                set(repo.bzrdir.open_repository().all_revision_ids()))
+        self.assertEqual(set([revid2, revid]),
+                set(base.bzrdir.open_repository().all_revision_ids()))
+        # get_rev_id_for_revno will find revno 1 == 'revid', even though
+        # that revision can only be found in the fallback.
+        repo.lock_read()
+        self.addCleanup(repo.unlock)
+        self.assertEqual(
+            (True, revid), repo.get_rev_id_for_revno(1, (3, revid3)))

=== modified file 'bzrlib/tests/per_repository_reference/test_initialize.py'
--- bzrlib/tests/per_repository_reference/test_initialize.py	2009-05-29 09:56:12 +0000
+++ bzrlib/tests/per_repository_reference/test_initialize.py	2009-06-03 18:08:53 +0000
@@ -52,8 +52,4 @@
         trans = self.make_smart_server('stacked')
         repo = self.initialize_and_check_on_transport(base, trans)
         network_name = base.repository._format.network_name()
-        if network_name != repo._format.network_name():
-            raise tests.KnownFailure('Remote initialize_on_transport_ex()'
-                ' tries to "upgrade" the format because it doesn\'t have a'
-                ' branch format, and hard-codes the new repository format.')
         self.assertEqual(network_name, repo._format.network_name())

=== modified file 'bzrlib/tests/test__groupcompress.py'
--- bzrlib/tests/test__groupcompress.py	2009-04-29 05:53:21 +0000
+++ bzrlib/tests/test__groupcompress.py	2009-06-10 03:56:49 +0000
@@ -272,6 +272,25 @@
         di = self._gc_module.DeltaIndex('test text\n')
         self.assertEqual('DeltaIndex(1, 10)', repr(di))
 
+    def test_first_add_source_doesnt_index_until_make_delta(self):
+        di = self._gc_module.DeltaIndex()
+        self.assertFalse(di._has_index())
+        di.add_source(_text1, 0)
+        self.assertFalse(di._has_index())
+        # However, asking to make a delta will trigger the index to be
+        # generated, and will generate a proper delta
+        delta = di.make_delta(_text2)
+        self.assertTrue(di._has_index())
+        self.assertEqual('N\x90/\x1fdiffer from\nagainst other text\n', delta)
+
+    def test_second_add_source_triggers_make_index(self):
+        di = self._gc_module.DeltaIndex()
+        self.assertFalse(di._has_index())
+        di.add_source(_text1, 0)
+        self.assertFalse(di._has_index())
+        di.add_source(_text2, 0)
+        self.assertTrue(di._has_index())
+
     def test_make_delta(self):
         di = self._gc_module.DeltaIndex(_text1)
         delta = di.make_delta(_text2)

=== added file 'bzrlib/tests/test__known_graph.py'
--- bzrlib/tests/test__known_graph.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test__known_graph.py	2009-06-16 15:35:14 +0000
@@ -0,0 +1,231 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for the python and pyrex extensions of groupcompress"""
+
+from bzrlib import (
+    errors,
+    graph as _mod_graph,
+    _known_graph_py,
+    tests,
+    )
+from bzrlib.tests import test_graph
+from bzrlib.revision import NULL_REVISION
+
+
+def load_tests(standard_tests, module, loader):
+    """Parameterize tests for all versions of groupcompress."""
+    scenarios = [
+        ('python', {'module': _known_graph_py, 'do_cache': True}),
+        ('python-nocache', {'module': _known_graph_py, 'do_cache': False}),
+    ]
+    suite = loader.suiteClass()
+    if CompiledKnownGraphFeature.available():
+        from bzrlib import _known_graph_pyx
+        scenarios.append(('C', {'module': _known_graph_pyx, 'do_cache': True}))
+        scenarios.append(('C-nocache',
+                          {'module': _known_graph_pyx, 'do_cache': False}))
+    else:
+        # the compiled module isn't available, so we add a failing test
+        class FailWithoutFeature(tests.TestCase):
+            def test_fail(self):
+                self.requireFeature(CompiledKnownGraphFeature)
+        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
+    result = tests.multiply_tests(standard_tests, scenarios, suite)
+    return result
+
+
+class _CompiledKnownGraphFeature(tests.Feature):
+
+    def _probe(self):
+        try:
+            import bzrlib._known_graph_pyx
+        except ImportError:
+            return False
+        return True
+
+    def feature_name(self):
+        return 'bzrlib._known_graph_pyx'
+
+CompiledKnownGraphFeature = _CompiledKnownGraphFeature()
+
+
+class TestKnownGraph(tests.TestCase):
+
+    module = None # Set by load_tests
+    do_cache = None # Set by load_tests
+
+    def make_known_graph(self, ancestry):
+        return self.module.KnownGraph(ancestry, do_cache=self.do_cache)
+
+    def assertDominator(self, graph, rev, dominator):
+        node = graph._nodes[rev]
+        self.assertEqual(dominator, node.linear_dominator)
+
+    def assertGDFO(self, graph, rev, gdfo):
+        node = graph._nodes[rev]
+        self.assertEqual(gdfo, node.gdfo)
+
+    def test_children_ancestry1(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertEqual(['rev1'], graph._nodes[NULL_REVISION].child_keys)
+        self.assertEqual(['rev2a', 'rev2b'],
+                         sorted(graph._nodes['rev1'].child_keys))
+        self.assertEqual(['rev3'], sorted(graph._nodes['rev2a'].child_keys))
+        self.assertEqual(['rev4'], sorted(graph._nodes['rev3'].child_keys))
+        self.assertEqual(['rev4'], sorted(graph._nodes['rev2b'].child_keys))
+
+    def test_dominators_ancestry_1(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertDominator(graph, 'rev1', NULL_REVISION)
+        self.assertDominator(graph, 'rev2b', 'rev2b')
+        self.assertDominator(graph, 'rev2a', 'rev2a')
+        self.assertDominator(graph, 'rev3', 'rev2a')
+        self.assertDominator(graph, 'rev4', 'rev4')
+
+    def test_dominators_feature_branch(self):
+        graph = self.make_known_graph(test_graph.feature_branch)
+        self.assertDominator(graph, 'rev1', NULL_REVISION)
+        self.assertDominator(graph, 'rev2b', NULL_REVISION)
+        self.assertDominator(graph, 'rev3b', NULL_REVISION)
+
+    def test_dominators_extended_history_shortcut(self):
+        graph = self.make_known_graph(test_graph.extended_history_shortcut)
+        self.assertDominator(graph, 'a', NULL_REVISION)
+        self.assertDominator(graph, 'b', 'b')
+        self.assertDominator(graph, 'c', 'b')
+        self.assertDominator(graph, 'd', 'b')
+        self.assertDominator(graph, 'e', 'e')
+        self.assertDominator(graph, 'f', 'f')
+
+    def test_gdfo_ancestry_1(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertGDFO(graph, 'rev1', 2)
+        self.assertGDFO(graph, 'rev2b', 3)
+        self.assertGDFO(graph, 'rev2a', 3)
+        self.assertGDFO(graph, 'rev3', 4)
+        self.assertGDFO(graph, 'rev4', 5)
+
+    def test_gdfo_feature_branch(self):
+        graph = self.make_known_graph(test_graph.feature_branch)
+        self.assertGDFO(graph, 'rev1', 2)
+        self.assertGDFO(graph, 'rev2b', 3)
+        self.assertGDFO(graph, 'rev3b', 4)
+
+    def test_gdfo_extended_history_shortcut(self):
+        graph = self.make_known_graph(test_graph.extended_history_shortcut)
+        self.assertGDFO(graph, 'a', 2)
+        self.assertGDFO(graph, 'b', 3)
+        self.assertGDFO(graph, 'c', 4)
+        self.assertGDFO(graph, 'd', 5)
+        self.assertGDFO(graph, 'e', 6)
+        self.assertGDFO(graph, 'f', 6)
+
+    def test_gdfo_with_ghost(self):
+        graph = self.make_known_graph(test_graph.with_ghost)
+        self.assertGDFO(graph, 'f', 2)
+        self.assertGDFO(graph, 'e', 3)
+        self.assertGDFO(graph, 'g', 1)
+        self.assertGDFO(graph, 'b', 4)
+        self.assertGDFO(graph, 'd', 4)
+        self.assertGDFO(graph, 'a', 5)
+        self.assertGDFO(graph, 'c', 5)
+
+    def test_heads_null(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertEqual(set(['null:']), graph.heads(['null:']))
+        self.assertEqual(set(['rev1']), graph.heads(['null:', 'rev1']))
+        self.assertEqual(set(['rev1']), graph.heads(['rev1', 'null:']))
+        self.assertEqual(set(['rev1']), graph.heads(set(['rev1', 'null:'])))
+        self.assertEqual(set(['rev1']), graph.heads(('rev1', 'null:')))
+
+    def test_heads_one(self):
+        # A single node will always be a head
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertEqual(set(['null:']), graph.heads(['null:']))
+        self.assertEqual(set(['rev1']), graph.heads(['rev1']))
+        self.assertEqual(set(['rev2a']), graph.heads(['rev2a']))
+        self.assertEqual(set(['rev2b']), graph.heads(['rev2b']))
+        self.assertEqual(set(['rev3']), graph.heads(['rev3']))
+        self.assertEqual(set(['rev4']), graph.heads(['rev4']))
+
+    def test_heads_single(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertEqual(set(['rev4']), graph.heads(['null:', 'rev4']))
+        self.assertEqual(set(['rev2a']), graph.heads(['rev1', 'rev2a']))
+        self.assertEqual(set(['rev2b']), graph.heads(['rev1', 'rev2b']))
+        self.assertEqual(set(['rev3']), graph.heads(['rev1', 'rev3']))
+        self.assertEqual(set(['rev3']), graph.heads(['rev3', 'rev2a']))
+        self.assertEqual(set(['rev4']), graph.heads(['rev1', 'rev4']))
+        self.assertEqual(set(['rev4']), graph.heads(['rev2a', 'rev4']))
+        self.assertEqual(set(['rev4']), graph.heads(['rev2b', 'rev4']))
+        self.assertEqual(set(['rev4']), graph.heads(['rev3', 'rev4']))
+
+    def test_heads_two_heads(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertEqual(set(['rev2a', 'rev2b']),
+                         graph.heads(['rev2a', 'rev2b']))
+        self.assertEqual(set(['rev3', 'rev2b']),
+                         graph.heads(['rev3', 'rev2b']))
+
+    def test_heads_criss_cross(self):
+        graph = self.make_known_graph(test_graph.criss_cross)
+        self.assertEqual(set(['rev2a']),
+                         graph.heads(['rev2a', 'rev1']))
+        self.assertEqual(set(['rev2b']),
+                         graph.heads(['rev2b', 'rev1']))
+        self.assertEqual(set(['rev3a']),
+                         graph.heads(['rev3a', 'rev1']))
+        self.assertEqual(set(['rev3b']),
+                         graph.heads(['rev3b', 'rev1']))
+        self.assertEqual(set(['rev2a', 'rev2b']),
+                         graph.heads(['rev2a', 'rev2b']))
+        self.assertEqual(set(['rev3a']),
+                         graph.heads(['rev3a', 'rev2a']))
+        self.assertEqual(set(['rev3a']),
+                         graph.heads(['rev3a', 'rev2b']))
+        self.assertEqual(set(['rev3a']),
+                         graph.heads(['rev3a', 'rev2a', 'rev2b']))
+        self.assertEqual(set(['rev3b']),
+                         graph.heads(['rev3b', 'rev2a']))
+        self.assertEqual(set(['rev3b']),
+                         graph.heads(['rev3b', 'rev2b']))
+        self.assertEqual(set(['rev3b']),
+                         graph.heads(['rev3b', 'rev2a', 'rev2b']))
+        self.assertEqual(set(['rev3a', 'rev3b']),
+                         graph.heads(['rev3a', 'rev3b']))
+        self.assertEqual(set(['rev3a', 'rev3b']),
+                         graph.heads(['rev3a', 'rev3b', 'rev2a', 'rev2b']))
+
+    def test_heads_shortcut(self):
+        graph = self.make_known_graph(test_graph.history_shortcut)
+        self.assertEqual(set(['rev2a', 'rev2b', 'rev2c']),
+                         graph.heads(['rev2a', 'rev2b', 'rev2c']))
+        self.assertEqual(set(['rev3a', 'rev3b']),
+                         graph.heads(['rev3a', 'rev3b']))
+        self.assertEqual(set(['rev3a', 'rev3b']),
+                         graph.heads(['rev2a', 'rev3a', 'rev3b']))
+        self.assertEqual(set(['rev2a', 'rev3b']),
+                         graph.heads(['rev2a', 'rev3b']))
+        self.assertEqual(set(['rev2c', 'rev3a']),
+                         graph.heads(['rev2c', 'rev3a']))
+
+    def test_heads_linear(self):
+        graph = self.make_known_graph(test_graph.racing_shortcuts)
+        self.assertEqual(set(['w']), graph.heads(['w', 's']))
+        self.assertEqual(set(['z']), graph.heads(['w', 's', 'z']))
+        self.assertEqual(set(['w', 'q']), graph.heads(['w', 's', 'q']))
+        self.assertEqual(set(['z']), graph.heads(['s', 'z']))

=== added file 'bzrlib/tests/test_bencode.py'
--- bzrlib/tests/test_bencode.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_bencode.py	2009-06-04 17:12:29 +0000
@@ -0,0 +1,235 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for bencode structured encoding"""
+
+from bzrlib import tests
+
+def load_tests(standard_tests, module, loader):
+    # parameterize all tests in this module
+    suite = loader.suiteClass()
+    import bzrlib.util._bencode_py as py_module
+    scenarios = [('python', {'bencode': py_module})]
+    if CompiledBencodeFeature.available():
+        import bzrlib._bencode_pyx as c_module
+        scenarios.append(('C', {'bencode': c_module}))
+    else:
+        # the compiled module isn't available, so we add a failing test
+        class FailWithoutFeature(tests.TestCase):
+            def test_fail(self):
+                self.requireFeature(CompiledBencodeFeature)
+        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
+    tests.multiply_tests(standard_tests, scenarios, suite)
+    return suite
+
+
+class _CompiledBencodeFeature(tests.Feature):
+
+    def _probe(self):
+        try:
+            import bzrlib._bencode_pyx
+        except ImportError:
+            return False
+        return True
+
+    def feature_name(self):
+        return 'bzrlib._bencode_pyx'
+
+CompiledBencodeFeature = _CompiledBencodeFeature()
+
+
+class TestBencodeDecode(tests.TestCase):
+
+    bencode = None
+
+    def _check(self, expected, source):
+        self.assertEquals(expected, self.bencode.bdecode(source))
+
+    def _run_check_error(self, exc, bad):
+        """Check that bdecoding a string raises a particular exception."""
+        self.assertRaises(exc, self.bencode.bdecode, bad)
+
+    def test_int(self):
+        self._check(0, 'i0e')
+        self._check(4, 'i4e')
+        self._check(123456789, 'i123456789e')
+        self._check(-10, 'i-10e')
+        self._check(int('1' * 1000), 'i' + ('1' * 1000) + 'e')
+
+    def test_long(self):
+        self._check(12345678901234567890L, 'i12345678901234567890e')
+        self._check(-12345678901234567890L, 'i-12345678901234567890e')
+
+    def test_malformed_int(self):
+        self._run_check_error(ValueError, 'ie')
+        self._run_check_error(ValueError, 'i-e')
+        self._run_check_error(ValueError, 'i-010e')
+        self._run_check_error(ValueError, 'i-0e')
+        self._run_check_error(ValueError, 'i00e')
+        self._run_check_error(ValueError, 'i01e')
+        self._run_check_error(ValueError, 'i-03e')
+        self._run_check_error(ValueError, 'i')
+        self._run_check_error(ValueError, 'i123')
+        self._run_check_error(ValueError, 'i341foo382e')
+
+    def test_string(self):
+        self._check('', '0:')
+        self._check('abc', '3:abc')
+        self._check('1234567890', '10:1234567890')
+
+    def test_large_string(self):
+        self.assertRaises(ValueError, self.bencode.bdecode, "2147483639:foo")
+
+    def test_malformed_string(self):
+        self._run_check_error(ValueError, '10:x')
+        self._run_check_error(ValueError, '10:')
+        self._run_check_error(ValueError, '10')
+        self._run_check_error(ValueError, '01:x')
+        self._run_check_error(ValueError, '00:')
+        self._run_check_error(ValueError, '35208734823ljdahflajhdf')
+        self._run_check_error(ValueError, '432432432432432:foo')
+        self._run_check_error(ValueError, ' 1:x') # leading whitespace
+        self._run_check_error(ValueError, '-1:x') # negative
+        self._run_check_error(ValueError, '1 x') # space vs colon
+        self._run_check_error(ValueError, '1x') # missing colon
+        self._run_check_error(ValueError, ('1' * 1000) + ':')
+
+    def test_list(self):
+        self._check([], 'le')
+        self._check(['', '', ''], 'l0:0:0:e')
+        self._check([1, 2, 3], 'li1ei2ei3ee')
+        self._check(['asd', 'xy'], 'l3:asd2:xye')
+        self._check([['Alice', 'Bob'], [2, 3]], 'll5:Alice3:Bobeli2ei3eee')
+
+    def test_list_deepnested(self):
+        self._run_check_error(RuntimeError, ("l" * 10000) + ("e" * 10000))
+
+    def test_malformed_list(self):
+        self._run_check_error(ValueError, 'l')
+        self._run_check_error(ValueError, 'l01:ae')
+        self._run_check_error(ValueError, 'l0:')
+        self._run_check_error(ValueError, 'li1e')
+        self._run_check_error(ValueError, 'l-3:e')
+
+    def test_dict(self):
+        self._check({}, 'de')
+        self._check({'':3}, 'd0:i3ee')
+        self._check({'age': 25, 'eyes': 'blue'}, 'd3:agei25e4:eyes4:bluee')
+        self._check({'spam.mp3': {'author': 'Alice', 'length': 100000}},
+                            'd8:spam.mp3d6:author5:Alice6:lengthi100000eee')
+
+    def test_dict_deepnested(self):
+        self._run_check_error(RuntimeError, ("d0:" * 10000) + 'i1e' + ("e" * 10000))
+
+    def test_malformed_dict(self):
+        self._run_check_error(ValueError, 'd')
+        self._run_check_error(ValueError, 'defoobar')
+        self._run_check_error(ValueError, 'd3:fooe')
+        self._run_check_error(ValueError, 'di1e0:e')
+        self._run_check_error(ValueError, 'd1:b0:1:a0:e')
+        self._run_check_error(ValueError, 'd1:a0:1:a0:e')
+        self._run_check_error(ValueError, 'd0:0:')
+        self._run_check_error(ValueError, 'd0:')
+        self._run_check_error(ValueError, 'd432432432432432432:e')
+
+    def test_empty_string(self):
+        self.assertRaises(ValueError, self.bencode.bdecode, '')
+
+    def test_junk(self):
+        self._run_check_error(ValueError, 'i6easd')
+        self._run_check_error(ValueError, '2:abfdjslhfld')
+        self._run_check_error(ValueError, '0:0:')
+        self._run_check_error(ValueError, 'leanfdldjfh')
+
+    def test_unknown_object(self):
+        self.assertRaises(ValueError, self.bencode.bdecode, 'relwjhrlewjh')
+
+    def test_unsupported_type(self):
+        self._run_check_error(TypeError, float(1.5))
+        self._run_check_error(TypeError, None)
+        self._run_check_error(TypeError, lambda x: x)
+        self._run_check_error(TypeError, object)
+        self._run_check_error(TypeError, u"ie")
+
+    def test_decoder_type_error(self):
+        self.assertRaises(TypeError, self.bencode.bdecode, 1)
+
+
+class TestBencodeEncode(tests.TestCase):
+
+    bencode = None
+
+    def _check(self, expected, source):
+        self.assertEquals(expected, self.bencode.bencode(source))
+
+    def test_int(self):
+        self._check('i4e', 4)
+        self._check('i0e', 0)
+        self._check('i-10e', -10)
+
+    def test_long(self):
+        self._check('i12345678901234567890e', 12345678901234567890L)
+        self._check('i-12345678901234567890e', -12345678901234567890L)
+
+    def test_string(self):
+        self._check('0:', '')
+        self._check('3:abc', 'abc')
+        self._check('10:1234567890', '1234567890')
+
+    def test_list(self):
+        self._check('le', [])
+        self._check('li1ei2ei3ee', [1, 2, 3])
+        self._check('ll5:Alice3:Bobeli2ei3eee', [['Alice', 'Bob'], [2, 3]])
+
+    def test_list_as_tuple(self):
+        self._check('le', ())
+        self._check('li1ei2ei3ee', (1, 2, 3))
+        self._check('ll5:Alice3:Bobeli2ei3eee', (('Alice', 'Bob'), (2, 3)))
+
+    def test_list_deep_nested(self):
+        top = []
+        l = top
+        for i in range(10000):
+            l.append([])
+            l = l[0]
+        self.assertRaises(RuntimeError, self.bencode.bencode, 
+            top)
+
+    def test_dict(self):
+        self._check('de', {})
+        self._check('d3:agei25e4:eyes4:bluee', {'age': 25, 'eyes': 'blue'})
+        self._check('d8:spam.mp3d6:author5:Alice6:lengthi100000eee',
+                            {'spam.mp3': {'author': 'Alice',
+                                          'length': 100000}})
+
+    def test_dict_deep_nested(self):
+        d = top = {}
+        for i in range(10000):
+            d[''] = {}
+            d = d['']
+        self.assertRaises(RuntimeError, self.bencode.bencode, 
+            top)
+
+    def test_bencached(self):
+        self._check('i3e', self.bencode.Bencached(self.bencode.bencode(3)))
+
+    def test_invalid_dict(self):
+        self.assertRaises(TypeError, self.bencode.bencode, {1:"foo"})
+
+    def test_bool(self):
+        self._check('i1e', True)
+        self._check('i0e', False)
+

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_bzrdir.py	2009-06-10 08:05:05 +0000
@@ -20,8 +20,6 @@
 """
 
 import os
-import os.path
-from StringIO import StringIO
 import subprocess
 import sys
 
@@ -31,7 +29,6 @@
     help_topics,
     repository,
     osutils,
-    symbol_versioning,
     remote,
     urlutils,
     win32utils,
@@ -47,7 +44,6 @@
     TestCaseWithMemoryTransport,
     TestCaseWithTransport,
     TestSkipped,
-    test_sftp_transport
     )
 from bzrlib.tests import(
     http_server,

=== modified file 'bzrlib/tests/test_chk_map.py'
--- bzrlib/tests/test_chk_map.py	2009-05-13 21:59:57 +0000
+++ bzrlib/tests/test_chk_map.py	2009-06-05 18:03:40 +0000
@@ -1560,13 +1560,66 @@
         child.map(None, ("baz",), "val")
         node.add_node("b", child)
 
-        key_filter = (('foo',), ('fob',), ('bar',), ('baz',))
+        # Note that 'ram' doesn't match anything, so it should be freely
+        # ignored
+        key_filter = (('foo',), ('fob',), ('bar',), ('baz',), ('ram',))
         for child, node_key_filter in node._iter_nodes(None,
                                                        key_filter=key_filter):
-            # each child could matches two key filters, so make sure they were
+            # each child could match two key filters, so make sure they were
             # both included.
             self.assertEqual(2, len(node_key_filter))
 
+    def make_fo_fa_node(self):
+        node = InternalNode('f')
+        child = LeafNode()
+        child.set_maximum_size(100)
+        child.map(None, ("foo",), "val")
+        child.map(None, ("fob",), "val")
+        node.add_node('fo', child)
+        child = LeafNode()
+        child.set_maximum_size(100)
+        child.map(None, ("far",), "val")
+        child.map(None, ("faz",), "val")
+        node.add_node("fa", child)
+        return node
+
+    def test__iter_nodes_single_entry(self):
+        node = self.make_fo_fa_node()
+        key_filter = [('foo',)]
+        nodes = list(node._iter_nodes(None, key_filter=key_filter))
+        self.assertEqual(1, len(nodes))
+        self.assertEqual(key_filter, nodes[0][1])
+
+    def test__iter_nodes_single_entry_misses(self):
+        node = self.make_fo_fa_node()
+        key_filter = [('bar',)]
+        nodes = list(node._iter_nodes(None, key_filter=key_filter))
+        self.assertEqual(0, len(nodes))
+
+    def test__iter_nodes_mixed_key_width(self):
+        node = self.make_fo_fa_node()
+        key_filter = [('foo', 'bar'), ('foo',), ('fo',), ('b',)]
+        nodes = list(node._iter_nodes(None, key_filter=key_filter))
+        self.assertEqual(1, len(nodes))
+        matches = key_filter[:]
+        matches.remove(('b',))
+        self.assertEqual(sorted(matches), sorted(nodes[0][1]))
+
+    def test__iter_nodes_match_all(self):
+        node = self.make_fo_fa_node()
+        key_filter = [('foo', 'bar'), ('foo',), ('fo',), ('f',)]
+        nodes = list(node._iter_nodes(None, key_filter=key_filter))
+        self.assertEqual(2, len(nodes))
+
+    def test__iter_nodes_fixed_widths_and_misses(self):
+        node = self.make_fo_fa_node()
+        # foo and faa should both match one child, baz should miss
+        key_filter = [('foo',), ('faa',), ('baz',)]
+        nodes = list(node._iter_nodes(None, key_filter=key_filter))
+        self.assertEqual(2, len(nodes))
+        for node, matches in nodes:
+            self.assertEqual(1, len(matches))
+
     def test_iteritems_empty_new(self):
         node = InternalNode()
         self.assertEqual([], sorted(node.iteritems(None)))

=== added file 'bzrlib/tests/test_chk_serializer.py'
--- bzrlib/tests/test_chk_serializer.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_chk_serializer.py	2009-06-04 21:50:04 +0000
@@ -0,0 +1,116 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+from cStringIO import StringIO
+
+from bzrlib import (
+    errors,
+    revision,
+    serializer,
+    )
+from bzrlib.chk_serializer import (
+    chk_bencode_serializer,
+    )
+from bzrlib.revision import (
+    Revision,
+    )
+from bzrlib.tests import TestCase
+
+_working_revision_bencode1 = ('l'
+    'l6:formati10ee'
+    'l9:committer54:Canonical.com Patch Queue Manager <pqm@pqm.ubuntu.com>e'
+    'l8:timezonei3600ee'
+    'l10:propertiesd11:branch-nick6:+trunkee'
+    'l9:timestamp14:1242300770.844e'
+    'l11:revision-id50:pqm@pqm.ubuntu.com-20090514113250-jntkkpminfn3e0tze'
+    'l10:parent-ids'
+        'l'
+        '50:pqm@pqm.ubuntu.com-20090514104039-kggemn7lrretzpvc'
+        '48:jelmer@samba.org-20090510012654-jp9ufxquekaokbeo'
+        'ee'
+    'l14:inventory-sha140:4a2c7fb50e077699242cf6eb16a61779c7b680a7e'
+    'l7:message35:(Jelmer) Move dpush to InterBranch.e'
+    'e')
+
+_working_revision_bencode1_no_timezone = ('l'
+    'l6:formati10ee'
+    'l9:committer54:Canonical.com Patch Queue Manager <pqm@pqm.ubuntu.com>e'
+    'l9:timestamp14:1242300770.844e'
+    'l10:propertiesd11:branch-nick6:+trunkee'
+    'l11:revision-id50:pqm@pqm.ubuntu.com-20090514113250-jntkkpminfn3e0tze'
+    'l10:parent-ids'
+        'l'
+        '50:pqm@pqm.ubuntu.com-20090514104039-kggemn7lrretzpvc'
+        '48:jelmer@samba.org-20090510012654-jp9ufxquekaokbeo'
+        'ee'
+    'l14:inventory-sha140:4a2c7fb50e077699242cf6eb16a61779c7b680a7e'
+    'l7:message35:(Jelmer) Move dpush to InterBranch.e'
+    'e')
+
+
+class TestBEncodeSerializer1(TestCase):
+    """Test BEncode serialization"""
+
+    def test_unpack_revision(self):
+        """Test unpacking a revision"""
+        rev = chk_bencode_serializer.read_revision_from_string(
+                _working_revision_bencode1)
+        self.assertEquals(rev.committer,
+           "Canonical.com Patch Queue Manager <pqm@pqm.ubuntu.com>")
+        self.assertEquals(rev.inventory_sha1,
+           "4a2c7fb50e077699242cf6eb16a61779c7b680a7")
+        self.assertEquals(["pqm@pqm.ubuntu.com-20090514104039-kggemn7lrretzpvc",
+            "jelmer@samba.org-20090510012654-jp9ufxquekaokbeo"],
+            rev.parent_ids)
+        self.assertEquals("(Jelmer) Move dpush to InterBranch.", rev.message)
+        self.assertEquals("pqm@pqm.ubuntu.com-20090514113250-jntkkpminfn3e0tz",
+           rev.revision_id)
+        self.assertEquals({"branch-nick": u"+trunk"}, rev.properties)
+        self.assertEquals(3600, rev.timezone)
+
+    def test_written_form_matches(self):
+        rev = chk_bencode_serializer.read_revision_from_string(
+                _working_revision_bencode1)
+        as_str = chk_bencode_serializer.write_revision_to_string(rev)
+        self.assertEqualDiff(_working_revision_bencode1, as_str)
+
+    def test_unpack_revision_no_timezone(self):
+        rev = chk_bencode_serializer.read_revision_from_string(
+            _working_revision_bencode1_no_timezone)
+        self.assertEquals(None, rev.timezone)
+
+    def assertRoundTrips(self, serializer, orig_rev):
+        text = serializer.write_revision_to_string(orig_rev)
+        new_rev = serializer.read_revision_from_string(text)
+        self.assertEquals(orig_rev, new_rev)
+
+    def test_roundtrips_non_ascii(self):
+        rev = Revision("revid1")
+        rev.message = u"\n\xe5me"
+        rev.committer = u'Erik B\xe5gfors'
+        rev.timestamp = 1242385452
+        rev.inventory_sha1 = "4a2c7fb50e077699242cf6eb16a61779c7b680a7"
+        rev.timezone = 3600
+        self.assertRoundTrips(chk_bencode_serializer, rev)
+
+    def test_roundtrips_xml_invalid_chars(self):
+        rev = Revision("revid1")
+        rev.message = "\t\ue000"
+        rev.committer = u'Erik B\xe5gfors'
+        rev.timestamp = 1242385452
+        rev.timezone = 3600
+        rev.inventory_sha1 = "4a2c7fb50e077699242cf6eb16a61779c7b680a7"
+        self.assertRoundTrips(chk_bencode_serializer, rev)

=== modified file 'bzrlib/tests/test_commands.py'
--- bzrlib/tests/test_commands.py	2009-04-07 17:13:51 +0000
+++ bzrlib/tests/test_commands.py	2009-05-23 21:01:51 +0000
@@ -163,6 +163,7 @@
         del sys.modules['bzrlib.tests.fake_command']
         global lazy_command_imported
         lazy_command_imported = False
+        commands.install_bzr_command_hooks()
 
     @staticmethod
     def remove_fake():
@@ -205,6 +206,7 @@
         # commands are registered).
         # when they are simply created.
         hook_calls = []
+        commands.install_bzr_command_hooks()
         commands.Command.hooks.install_named_hook(
             "extend_command", hook_calls.append, None)
         # create a command, should not fire
@@ -237,3 +239,87 @@
             self.assertEqual([cmd], hook_calls)
         finally:
             commands.plugin_cmds.remove('fake')
+
+
+class TestGetCommandHook(tests.TestCase):
+
+    def test_fires_on_get_cmd_object(self):
+        # The get_command(cmd) hook fires when commands are delivered to the
+        # ui.
+        commands.install_bzr_command_hooks()
+        hook_calls = []
+        class ACommand(commands.Command):
+            """A sample command."""
+        def get_cmd(cmd_or_None, cmd_name):
+            hook_calls.append(('called', cmd_or_None, cmd_name))
+            if cmd_name in ('foo', 'info'):
+                return ACommand()
+        commands.Command.hooks.install_named_hook(
+            "get_command", get_cmd, None)
+        # create a command directly, should not fire
+        cmd = ACommand()
+        self.assertEqual([], hook_calls)
+        # ask by name, should fire and give us our command
+        cmd = commands.get_cmd_object('foo')
+        self.assertEqual([('called', None, 'foo')], hook_calls)
+        self.assertIsInstance(cmd, ACommand)
+        del hook_calls[:]
+        # ask by a name that is supplied by a builtin - the hook should still
+        # fire and we still get our object, but we should see the builtin
+        # passed to the hook.
+        cmd = commands.get_cmd_object('info')
+        self.assertIsInstance(cmd, ACommand)
+        self.assertEqual(1, len(hook_calls))
+        self.assertEqual('info', hook_calls[0][2])
+        self.assertIsInstance(hook_calls[0][1], builtins.cmd_info)
+
+
+class TestGetMissingCommandHook(tests.TestCase):
+
+    def test_fires_on_get_cmd_object(self):
+        # The get_missing_command(cmd) hook fires when commands are delivered to the
+        # ui.
+        hook_calls = []
+        class ACommand(commands.Command):
+            """A sample command."""
+        def get_missing_cmd(cmd_name):
+            hook_calls.append(('called', cmd_name))
+            if cmd_name in ('foo', 'info'):
+                return ACommand()
+        commands.Command.hooks.install_named_hook(
+            "get_missing_command", get_missing_cmd, None)
+        # create a command directly, should not fire
+        cmd = ACommand()
+        self.assertEqual([], hook_calls)
+        # ask by name, should fire and give us our command
+        cmd = commands.get_cmd_object('foo')
+        self.assertEqual([('called', 'foo')], hook_calls)
+        self.assertIsInstance(cmd, ACommand)
+        del hook_calls[:]
+        # ask by a name that is supplied by a builtin - the hook should not
+        # fire and we still get our object.
+        commands.install_bzr_command_hooks()
+        cmd = commands.get_cmd_object('info')
+        self.assertNotEqual(None, cmd)
+        self.assertEqual(0, len(hook_calls))
+
+
+class TestListCommandHook(tests.TestCase):
+
+    def test_fires_on_all_command_names(self):
+        # The list_commands() hook fires when all_command_names() is invoked.
+        hook_calls = []
+        commands.install_bzr_command_hooks()
+        def list_my_commands(cmd_names):
+            hook_calls.append('called')
+            cmd_names.update(['foo', 'bar'])
+            return cmd_names
+        commands.Command.hooks.install_named_hook(
+            "list_commands", list_my_commands, None)
+        # Get a command, which should not trigger the hook.
+        cmd = commands.get_cmd_object('info')
+        self.assertEqual([], hook_calls)
+        # Get all command classes (for docs and shell completion).
+        cmds = list(commands.all_command_names())
+        self.assertEqual(['called'], hook_calls)
+        self.assertSubset(['foo', 'bar'], cmds)

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2009-04-27 16:10:10 +0000
+++ bzrlib/tests/test_config.py	2009-06-10 03:56:49 +0000
@@ -1461,7 +1461,8 @@
     """Test AuthenticationConfig behaviour"""
 
     def _check_default_password_prompt(self, expected_prompt_format, scheme,
-                              host=None, port=None, realm=None, path=None):
+                                       host=None, port=None, realm=None,
+                                       path=None):
         if host is None:
             host = 'bar.org'
         user, password = 'jim', 'precious'
@@ -1470,17 +1471,20 @@
             'user': user, 'realm': realm}
 
         stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
         ui.ui_factory = tests.TestUIFactory(stdin=password + '\n',
-                                            stdout=stdout)
+                                            stdout=stdout, stderr=stderr)
         # We use an empty conf so that the user is always prompted
         conf = config.AuthenticationConfig()
         self.assertEquals(password,
                           conf.get_password(scheme, host, user, port=port,
                                             realm=realm, path=path))
-        self.assertEquals(stdout.getvalue(), expected_prompt)
+        self.assertEquals(expected_prompt, stderr.getvalue())
+        self.assertEquals('', stdout.getvalue())
 
     def _check_default_username_prompt(self, expected_prompt_format, scheme,
-                              host=None, port=None, realm=None, path=None):
+                                       host=None, port=None, realm=None,
+                                       path=None):
         if host is None:
             host = 'bar.org'
         username = 'jim'
@@ -1488,13 +1492,15 @@
             'scheme': scheme, 'host': host, 'port': port,
             'realm': realm}
         stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
         ui.ui_factory = tests.TestUIFactory(stdin=username+ '\n',
-                                            stdout=stdout)
+                                            stdout=stdout, stderr=stderr)
         # We use an empty conf so that the user is always prompted
         conf = config.AuthenticationConfig()
         self.assertEquals(username, conf.get_user(scheme, host, port=port,
                           realm=realm, path=path, ask=True))
-        self.assertEquals(stdout.getvalue(), expected_prompt)
+        self.assertEquals(expected_prompt, stderr.getvalue())
+        self.assertEquals('', stdout.getvalue())
 
     def test_username_defaults_prompts(self):
         # HTTP prompts can't be tested here, see test_http.py

=== modified file 'bzrlib/tests/test_eol_filters.py'
--- bzrlib/tests/test_eol_filters.py	2009-05-07 05:08:46 +0000
+++ bzrlib/tests/test_eol_filters.py	2009-06-10 23:29:48 +0000
@@ -66,3 +66,11 @@
         """
         prefs = (('eol','unknown-value'),)
         self.assertRaises(errors.BzrError, _get_filter_stack_for,  prefs)
+
+    def test_eol_missing_altogether_is_ok(self):
+        """
+        Not having eol in the set of preferences should be ok.
+        """
+        # In this case, 'eol' is looked up with a value of None.
+        prefs = (('eol', None),)
+        self.assertEqual([], _get_filter_stack_for(prefs))

=== modified file 'bzrlib/tests/test_filters.py'
--- bzrlib/tests/test_filters.py	2009-04-08 03:34:31 +0000
+++ bzrlib/tests/test_filters.py	2009-06-10 23:29:48 +0000
@@ -148,7 +148,7 @@
             self.assertEqual(a_stack, _get_filter_stack_for(prefs))
             prefs = (('foo','v2'),)
             self.assertEqual(z_stack, _get_filter_stack_for(prefs))
-            prefs = (('foo','v1'),('bar','v1'))
+            prefs = (('foo','v1'), ('bar','v1'))
             self.assertEqual(a_stack + d_stack, _get_filter_stack_for(prefs))
             # Test an unknown preference
             prefs = (('baz','v1'),)
@@ -156,6 +156,9 @@
             # Test an unknown value
             prefs = (('foo','v3'),)
             self.assertEqual([], _get_filter_stack_for(prefs))
+            # Test a value of None is skipped
+            prefs = (('foo',None), ('bar', 'v1'))
+            self.assertEqual(d_stack, _get_filter_stack_for(prefs))
         finally:
             # Restore the real registry
             filters._reset_registry(original_registry)

=== modified file 'bzrlib/tests/test_generate_docs.py'
--- bzrlib/tests/test_generate_docs.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_generate_docs.py	2009-06-15 09:41:37 +0000
@@ -22,6 +22,7 @@
 
 from cStringIO import StringIO
 
+import bzrlib.commands
 from bzrlib.tests import TestCase, TestSkipped
 
 
@@ -37,6 +38,7 @@
         self.sio = StringIO()
         self.options = Options()
         self.options.bzr_name = 'bzr'
+        bzrlib.commands.install_bzr_command_hooks()
 
     def test_man_page(self):
         try:

=== modified file 'bzrlib/tests/test_graph.py'
--- bzrlib/tests/test_graph.py	2009-05-12 02:24:54 +0000
+++ bzrlib/tests/test_graph.py	2009-06-10 18:58:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2008, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,6 +22,7 @@
     )
 from bzrlib.revision import NULL_REVISION
 from bzrlib.tests import TestCaseWithMemoryTransport
+from bzrlib.symbol_versioning import deprecated_in
 
 
 # Ancestry 1:
@@ -661,10 +662,36 @@
         self.assertEqual((set(['e']), set(['f', 'g'])),
                          graph.find_difference('e', 'f'))
 
+
     def test_stacked_parents_provider(self):
         parents1 = _mod_graph.DictParentsProvider({'rev2': ['rev3']})
         parents2 = _mod_graph.DictParentsProvider({'rev1': ['rev4']})
-        stacked = _mod_graph._StackedParentsProvider([parents1, parents2])
+        stacked = _mod_graph.StackedParentsProvider([parents1, parents2])
+        self.assertEqual({'rev1':['rev4'], 'rev2':['rev3']},
+                         stacked.get_parent_map(['rev1', 'rev2']))
+        self.assertEqual({'rev2':['rev3'], 'rev1':['rev4']},
+                         stacked.get_parent_map(['rev2', 'rev1']))
+        self.assertEqual({'rev2':['rev3']},
+                         stacked.get_parent_map(['rev2', 'rev2']))
+        self.assertEqual({'rev1':['rev4']},
+                         stacked.get_parent_map(['rev1', 'rev1']))
+    
+    def test_stacked_parents_provider_overlapping(self):
+        # rev2 is availible in both providers.
+        # 1
+        # |
+        # 2
+        parents1 = _mod_graph.DictParentsProvider({'rev2': ['rev1']})
+        parents2 = _mod_graph.DictParentsProvider({'rev2': ['rev1']})
+        stacked = _mod_graph.StackedParentsProvider([parents1, parents2])
+        self.assertEqual({'rev2': ['rev1']},
+                         stacked.get_parent_map(['rev2']))
+
+    def test__stacked_parents_provider_deprecated(self):
+        parents1 = _mod_graph.DictParentsProvider({'rev2': ['rev3']})
+        parents2 = _mod_graph.DictParentsProvider({'rev1': ['rev4']})
+        stacked = self.applyDeprecated(deprecated_in((1, 16, 0)),
+                    _mod_graph._StackedParentsProvider, [parents1, parents2])
         self.assertEqual({'rev1':['rev4'], 'rev2':['rev3']},
                          stacked.get_parent_map(['rev1', 'rev2']))
         self.assertEqual({'rev2':['rev3'], 'rev1':['rev4']},

=== modified file 'bzrlib/tests/test_help.py'
--- bzrlib/tests/test_help.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_help.py	2009-06-15 10:22:08 +0000
@@ -29,6 +29,13 @@
     )
 
 
+class TestHelp(tests.TestCase):
+
+    def setUp(self):
+        tests.TestCase.setUp(self)
+        commands.install_bzr_command_hooks()
+
+
 class TestCommandHelp(tests.TestCase):
     """Tests for help on commands."""
 
@@ -274,7 +281,7 @@
             '  Blah blah blah.\n\n')
 
 
-class TestRegisteredTopic(tests.TestCase):
+class TestRegisteredTopic(TestHelp):
     """Tests for the RegisteredTopic class."""
 
     def test_contruct(self):
@@ -313,7 +320,7 @@
         self.assertEqual('baz', topic.get_help_topic())
 
 
-class TestTopicIndex(tests.TestCase):
+class TestTopicIndex(TestHelp):
     """Tests for the HelpTopicIndex class."""
 
     def test_default_constructable(self):
@@ -346,7 +353,7 @@
         self.assertEqual('', index.prefix)
 
 
-class TestCommandIndex(tests.TestCase):
+class TestCommandIndex(TestHelp):
     """Tests for the HelpCommandIndex class."""
 
     def test_default_constructable(self):

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2009-05-27 13:59:47 +0000
+++ bzrlib/tests/test_http.py	2009-06-10 03:56:49 +0000
@@ -1569,15 +1569,18 @@
         self.server.add_user('joe', 'foo')
         t = self.get_user_transport(None, None)
         stdout = tests.StringIOWrapper()
-        ui.ui_factory = tests.TestUIFactory(stdin='joe\nfoo\n', stdout=stdout)
+        stderr = tests.StringIOWrapper()
+        ui.ui_factory = tests.TestUIFactory(stdin='joe\nfoo\n',
+                                            stdout=stdout, stderr=stderr)
         self.assertEqual('contents of a\n',t.get('a').read())
         # stdin should be empty
         self.assertEqual('', ui.ui_factory.stdin.readline())
-        stdout.seek(0)
+        stderr.seek(0)
         expected_prompt = self._expected_username_prompt(t._unqualified_scheme)
-        self.assertEquals(expected_prompt, stdout.read(len(expected_prompt)))
+        self.assertEquals(expected_prompt, stderr.read(len(expected_prompt)))
+        self.assertEquals('', stdout.getvalue())
         self._check_password_prompt(t._unqualified_scheme, 'joe',
-                                    stdout.readline())
+                                    stderr.readline())
 
     def test_prompt_for_password(self):
         if self._testing_pycurl():
@@ -1588,12 +1591,15 @@
         self.server.add_user('joe', 'foo')
         t = self.get_user_transport('joe', None)
         stdout = tests.StringIOWrapper()
-        ui.ui_factory = tests.TestUIFactory(stdin='foo\n', stdout=stdout)
-        self.assertEqual('contents of a\n',t.get('a').read())
+        stderr = tests.StringIOWrapper()
+        ui.ui_factory = tests.TestUIFactory(stdin='foo\n',
+                                            stdout=stdout, stderr=stderr)
+        self.assertEqual('contents of a\n', t.get('a').read())
         # stdin should be empty
         self.assertEqual('', ui.ui_factory.stdin.readline())
         self._check_password_prompt(t._unqualified_scheme, 'joe',
-                                    stdout.getvalue())
+                                    stderr.getvalue())
+        self.assertEquals('', stdout.getvalue())
         # And we shouldn't prompt again for a different request
         # against the same transport.
         self.assertEqual('contents of b\n',t.get('b').read())

=== modified file 'bzrlib/tests/test_knit.py'
--- bzrlib/tests/test_knit.py	2009-05-08 16:17:26 +0000
+++ bzrlib/tests/test_knit.py	2009-06-16 13:57:14 +0000
@@ -2059,7 +2059,6 @@
         # self.assertEqual([("annotate", key_basis)], basis.calls)
         self.assertEqual([('get_parent_map', set([key_basis])),
             ('get_parent_map', set([key_basis])),
-            ('get_parent_map', set([key_basis])),
             ('get_record_stream', [key_basis], 'unordered', True)],
             basis.calls)
 

=== modified file 'bzrlib/tests/test_mail_client.py'
--- bzrlib/tests/test_mail_client.py	2009-05-11 18:35:20 +0000
+++ bzrlib/tests/test_mail_client.py	2009-06-10 03:56:49 +0000
@@ -28,8 +28,10 @@
 
     def test_commandline(self):
         mutt = mail_client.Mutt(None)
-        commandline = mutt._get_compose_commandline(None, None, 'file%')
-        self.assertEqual(['-a', 'file%'], commandline)
+        commandline = mutt._get_compose_commandline(
+            None, None, 'file%', body="hello")
+        # The temporary filename is randomly generated, so it is not matched.
+        self.assertEqual(['-a', 'file%', '-i'], commandline[:-1])
         commandline = mutt._get_compose_commandline('jrandom@example.org',
                                                      'Hi there!', None)
         self.assertEqual(['-s', 'Hi there!', '--', 'jrandom@example.org'],
@@ -191,9 +193,10 @@
     def test_commandline(self):
         claws = mail_client.Claws(None)
         commandline = claws._get_compose_commandline(
-            None, None, 'file%')
+            'jrandom@example.org', None, 'file%')
         self.assertEqual(
-            ['--compose', 'mailto:?', '--attach', 'file%'], commandline)
+            ['--compose', 'mailto:jrandom@example.org?', '--attach', 'file%'],
+            commandline)
         commandline = claws._get_compose_commandline(
             'jrandom@example.org', 'Hi there!', None)
         self.assertEqual(
@@ -217,6 +220,30 @@
             self.assertFalse(isinstance(item, unicode),
                 'Command-line item %r is unicode!' % item)
 
+    def test_with_from(self):
+        claws = mail_client.Claws(None)
+        cmdline = claws._get_compose_commandline(
+            u'jrandom@example.org', None, None, None, u'qrandom@example.com')
+        self.assertEqual(
+            ['--compose',
+             'mailto:jrandom@example.org?from=qrandom%40example.com'],
+            cmdline)
+
+    def test_to_required(self):
+        claws = mail_client.Claws(None)
+        self.assertRaises(errors.NoMailAddressSpecified,
+                          claws._get_compose_commandline,
+                          None, None, 'file%')
+
+    def test_with_body(self):
+        claws = mail_client.Claws(None)
+        cmdline = claws._get_compose_commandline(
+            u'jrandom@example.org', None, None, 'This is some body text')
+        self.assertEqual(
+            ['--compose',
+             'mailto:jrandom@example.org?body=This%20is%20some%20body%20text'],
+            cmdline)
+
 
 class TestEditor(tests.TestCase):
 

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2009-04-03 20:05:25 +0000
+++ bzrlib/tests/test_options.py	2009-05-23 21:01:51 +0000
@@ -324,8 +324,8 @@
 
     def get_builtin_command_options(self):
         g = []
-        for cmd_name, cmd_class in sorted(commands.get_all_cmds()):
-            cmd = cmd_class()
+        for cmd_name in sorted(commands.all_command_names()):
+            cmd = commands.get_cmd_object(cmd_name)
             for opt_name, opt in sorted(cmd.options().items()):
                 g.append((cmd_name, opt))
         return g
@@ -338,14 +338,15 @@
         g = dict(option.Option.OPTIONS.items())
         used_globals = {}
         msgs = []
-        for cmd_name, cmd_class in sorted(commands.get_all_cmds()):
-            for option_or_name in sorted(cmd_class.takes_options):
+        for cmd_name in sorted(commands.all_command_names()):
+            cmd = commands.get_cmd_object(cmd_name)
+            for option_or_name in sorted(cmd.takes_options):
                 if not isinstance(option_or_name, basestring):
                     self.assertIsInstance(option_or_name, option.Option)
                 elif not option_or_name in g:
                     msgs.append("apparent reference to undefined "
                         "global option %r from %r"
-                        % (option_or_name, cmd_class))
+                        % (option_or_name, cmd))
                 else:
                     used_globals.setdefault(option_or_name, []).append(cmd_name)
         unused_globals = set(g.keys()) - set(used_globals.keys())

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2009-05-23 04:55:52 +0000
+++ bzrlib/tests/test_osutils.py	2009-06-10 03:56:49 +0000
@@ -1760,3 +1760,10 @@
     def test_os_readlink_link_decoding(self):
         self.assertEquals(self.target.encode(osutils._fs_enc),
                           os.readlink(self.link.encode(osutils._fs_enc)))
+
+
+class TestConcurrency(tests.TestCase):
+
+    def test_local_concurrency(self):
+        concurrency = osutils.local_concurrency()
+        self.assertIsInstance(concurrency, int)

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2009-03-24 01:53:42 +0000
+++ bzrlib/tests/test_plugins.py	2009-06-10 03:56:49 +0000
@@ -633,7 +633,7 @@
         path = plugin.get_standard_plugins_path()
         self.assertEqual(plugin.get_default_plugin_path(), path[0])
         for directory in path:
-            self.assertNotContainsRe(r'\\/$', directory)
+            self.assertNotContainsRe(directory, r'\\/$')
         try:
             from distutils.sysconfig import get_python_lib
         except ImportError:

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_progress.py	2009-06-10 03:56:49 +0000
@@ -18,29 +18,12 @@
 from StringIO import StringIO
 
 from bzrlib import errors
-from bzrlib.progress import (
-        DummyProgress,
-        ChildProgress,
-        TTYProgressBar,
-        DotsProgressBar,
-        ProgressBarStack,
-        InstrumentedProgress,
-        )
 from bzrlib.tests import TestCase
 from bzrlib.symbol_versioning import (
     deprecated_in,
     )
 
 
-class FakeStack:
-
-    def __init__(self, top):
-        self.__top = top
-
-    def top(self):
-        return self.__top
-
-
 class _TTYStringIO(StringIO):
     """A helper class which makes a StringIO look like a terminal"""
 
@@ -53,259 +36,3 @@
 
     def isatty(self):
         return False
-
-
-class TestProgress(TestCase):
-
-    def setUp(self):
-        TestCase.setUp(self)
-        q = DummyProgress()
-        self.top = ChildProgress(_stack=FakeStack(q))
-
-    def test_propogation(self):
-        self.top.update('foobles', 1, 2)
-        self.assertEqual(self.top.message, 'foobles')
-        self.assertEqual(self.top.current, 1)
-        self.assertEqual(self.top.total, 2)
-        self.assertEqual(self.top.child_fraction, 0)
-        child = ChildProgress(_stack=FakeStack(self.top))
-        child.update('baubles', 2, 4)
-        self.assertEqual(self.top.message, 'foobles')
-        self.assertEqual(self.top.current, 1)
-        self.assertEqual(self.top.total, 2)
-        self.assertEqual(self.top.child_fraction, 0.5)
-        grandchild = ChildProgress(_stack=FakeStack(child))
-        grandchild.update('barbells', 1, 2)
-        self.assertEqual(self.top.child_fraction, 0.625)
-        self.assertEqual(child.child_fraction, 0.5)
-        child.update('baubles', 3, 4)
-        self.assertEqual(child.child_fraction, 0)
-        self.assertEqual(self.top.child_fraction, 0.75)
-        grandchild.update('barbells', 1, 2)
-        self.assertEqual(self.top.child_fraction, 0.875)
-        grandchild.update('barbells', 2, 2)
-        self.assertEqual(self.top.child_fraction, 1)
-        child.update('baubles', 4, 4)
-        self.assertEqual(self.top.child_fraction, 1)
-        #test clamping
-        grandchild.update('barbells', 2, 2)
-        self.assertEqual(self.top.child_fraction, 1)
-
-    def test_implementations(self):
-        for implementation in (TTYProgressBar, DotsProgressBar,
-                               DummyProgress):
-            self.check_parent_handling(implementation)
-
-    def check_parent_handling(self, parentclass):
-        top = parentclass(to_file=StringIO())
-        top.update('foobles', 1, 2)
-        child = ChildProgress(_stack=FakeStack(top))
-        child.update('baubles', 4, 4)
-        top.update('lala', 2, 2)
-        child.update('baubles', 4, 4)
-
-    def test_stacking(self):
-        self.check_stack(TTYProgressBar, ChildProgress)
-        self.check_stack(DotsProgressBar, ChildProgress)
-        self.check_stack(DummyProgress, DummyProgress)
-
-    def check_stack(self, parent_class, child_class):
-        stack = self.applyDeprecated(
-            deprecated_in((1, 12, 0)),
-            ProgressBarStack,
-            klass=parent_class, to_file=StringIO())
-        parent = stack.get_nested()
-        try:
-            self.assertIs(parent.__class__, parent_class)
-            child = stack.get_nested()
-            try:
-                self.assertIs(child.__class__, child_class)
-            finally:
-                child.finished()
-        finally:
-            parent.finished()
-
-    def test_throttling(self):
-        pb = InstrumentedProgress(to_file=StringIO())
-        # instantaneous updates should be squelched
-        pb.update('me', 1, 1)
-        self.assertTrue(pb.always_throttled)
-        pb = InstrumentedProgress(to_file=StringIO())
-        # It's like an instant sleep(1)!
-        pb.start_time -= 1
-        # Updates after a second should not be squelched
-        pb.update('me', 1, 1)
-        self.assertFalse(pb.always_throttled)
-
-    def test_clear(self):
-        sio = StringIO()
-        pb = TTYProgressBar(to_file=sio, show_eta=False)
-        pb.width = 20 # Just make it easier to test
-        # This should not output anything
-        pb.clear()
-        # These two should not be displayed because
-        # of throttling
-        pb.update('foo', 1, 3)
-        pb.update('bar', 2, 3)
-        # So pb.clear() has nothing to do
-        pb.clear()
-
-        # Make sure the next update isn't throttled
-        pb.start_time -= 1
-        pb.update('baz', 3, 3)
-        pb.clear()
-
-        self.assertEqual('\r[=========] baz 3/3'
-                         '\r                   \r',
-                         sio.getvalue())
-
-    def test_no_eta(self):
-        # An old version of the progress bar would
-        # store every update if show_eta was false
-        # because the eta routine was where it was
-        # cleaned out
-        pb = InstrumentedProgress(to_file=StringIO(), show_eta=False)
-        # Just make sure this first few are throttled
-        pb.start_time += 5
-
-        # These messages are throttled, and don't contribute
-        for count in xrange(100):
-            pb.update('x', count, 300)
-        self.assertEqual(0, len(pb.last_updates))
-
-        # Unthrottle by time
-        pb.start_time -= 10
-
-        # These happen too fast, so only one gets through
-        for count in xrange(100):
-            pb.update('x', count+100, 200)
-        self.assertEqual(1, len(pb.last_updates))
-
-        pb.MIN_PAUSE = 0.0
-
-        # But all of these go through, don't let the
-        # last_update list grow without bound
-        for count in xrange(100):
-            pb.update('x', count+100, 200)
-
-        self.assertEqual(pb._max_last_updates, len(pb.last_updates))
-
-
-class TestProgressTypes(TestCase):
-    """Test that the right ProgressBar gets instantiated at the right time."""
-
-    def get_nested(self, outf, term, env_progress=None):
-        """Setup so that ProgressBar thinks we are in the supplied terminal."""
-        orig_term = os.environ.get('TERM')
-        orig_progress = os.environ.get('BZR_PROGRESS_BAR')
-        os.environ['TERM'] = term
-        if env_progress is not None:
-            os.environ['BZR_PROGRESS_BAR'] = env_progress
-        elif orig_progress is not None:
-            del os.environ['BZR_PROGRESS_BAR']
-
-        def reset():
-            if orig_term is None:
-                del os.environ['TERM']
-            else:
-                os.environ['TERM'] = orig_term
-            # We may have never created BZR_PROGRESS_BAR
-            # So we can't just delete like we can 'TERM' (which is always set)
-            if orig_progress is None:
-                if 'BZR_PROGRESS_BAR' in os.environ:
-                    del os.environ['BZR_PROGRESS_BAR']
-            else:
-                os.environ['BZR_PROGRESS_BAR'] = orig_progress
-
-        self.addCleanup(reset)
-
-        stack = self.applyDeprecated(
-            deprecated_in((1, 12, 0)),
-            ProgressBarStack,
-            to_file=outf)
-        pb = stack.get_nested()
-        pb.start_time -= 1 # Make sure it is ready to write
-        pb.width = 20 # And it is of reasonable size
-        return pb
-
-    def test_tty_progress(self):
-        # Make sure the ProgressBarStack thinks it is
-        # writing out to a terminal, and thus uses a TTYProgressBar
-        out = _TTYStringIO()
-        pb = self.get_nested(out, 'xterm')
-        self.assertIsInstance(pb, TTYProgressBar)
-        try:
-            pb.update('foo', 1, 2)
-            pb.update('bar', 2, 2)
-        finally:
-            pb.finished()
-
-        self.assertEqual('\r/ [====   ] foo 1/2'
-                         '\r- [=======] bar 2/2'
-                         '\r                   \r',
-                         out.getvalue())
-
-    def test_noninteractive_progress(self):
-        out = _NonTTYStringIO()
-        pb = self.get_nested(out, 'xterm')
-        self.assertIsInstance(pb, DummyProgress)
-        try:
-            pb.update('foo', 1, 2)
-            pb.update('bar', 2, 2)
-        finally:
-            pb.finished()
-        self.assertEqual('', out.getvalue())
-
-    def test_dots_progress(self):
-        # make sure we get the right progress bar when not on a terminal
-        out = _NonTTYStringIO()
-        pb = self.get_nested(out, 'xterm', 'dots')
-        self.assertIsInstance(pb, DotsProgressBar)
-        try:
-            pb.update('foo', 1, 2)
-            pb.update('bar', 2, 2)
-        finally:
-            pb.finished()
-        self.assertEqual('foo: .'
-                         '\nbar: .'
-                         '\n',
-                         out.getvalue())
-
-    def test_no_isatty_progress(self):
-        # Make sure ProgressBarStack handles a plain StringIO()
-        import cStringIO
-        out = cStringIO.StringIO()
-        pb = self.get_nested(out, 'xterm')
-        pb.finished()
-        self.assertIsInstance(pb, DummyProgress)
-
-    def test_dumb_progress(self):
-        # using a terminal that can't do cursor movement
-        out = _TTYStringIO()
-        pb = self.get_nested(out, 'dumb')
-        pb.finished()
-        self.assertIsInstance(pb, DummyProgress)
-
-    def test_progress_env_tty(self):
-        # The environ variable BZR_PROGRESS_BAR controls what type of
-        # progress bar we will get, even if it wouldn't usually be that type
-        import cStringIO
-
-        # Usually, this would be a DotsProgressBar
-        out = cStringIO.StringIO()
-        pb = self.get_nested(out, 'dumb', 'tty')
-        pb.finished()
-        # Even though we are not a tty, the env_var will override
-        self.assertIsInstance(pb, TTYProgressBar)
-
-    def test_progress_env_none(self):
-        # Even though we are in a valid tty, no progress
-        out = _TTYStringIO()
-        pb = self.get_nested(out, 'xterm', 'none')
-        pb.finished()
-        self.assertIsInstance(pb, DummyProgress)
-
-    def test_progress_env_invalid(self):
-        out = _TTYStringIO()
-        self.assertRaises(errors.InvalidProgressBarType, self.get_nested,
-            out, 'xterm', 'nonexistant')

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2009-05-07 05:08:46 +0000
+++ bzrlib/tests/test_remote.py	2009-06-17 03:53:51 +0000
@@ -58,6 +58,7 @@
     condition_isinstance,
     split_suite_by_condition,
     multiply_tests,
+    KnownFailure,
     )
 from bzrlib.transport import get_transport, http
 from bzrlib.transport.memory import MemoryTransport
@@ -153,6 +154,23 @@
         r = BzrDir.open_from_transport(t.clone('stackable')).open_repository()
         self.assertTrue(r._format.supports_external_lookups)
 
+    def test_remote_branch_set_append_revisions_only(self):
+        # Make a format 1.9 branch, which supports append_revisions_only
+        branch = self.make_branch('branch', format='1.9')
+        config = branch.get_config()
+        branch.set_append_revisions_only(True)
+        self.assertEqual(
+            'True', config.get_user_option('append_revisions_only'))
+        branch.set_append_revisions_only(False)
+        self.assertEqual(
+            'False', config.get_user_option('append_revisions_only'))
+
+    def test_remote_branch_set_append_revisions_only_upgrade_reqd(self):
+        branch = self.make_branch('branch', format='knit')
+        config = branch.get_config()
+        self.assertRaises(
+            errors.UpgradeRequired, branch.set_append_revisions_only, True)
+
 
 class FakeProtocol(object):
     """Lookalike SmartClientRequestProtocolOne allowing body reading tests."""
@@ -741,6 +759,61 @@
         self.assertEqual(network_name, repo._format.network_name())
 
 
+class TestBzrDirFormatInitializeEx(TestRemote):
+
+    def test_success(self):
+        """Simple test for typical successful call."""
+        fmt = bzrdir.RemoteBzrDirFormat()
+        default_format_name = BzrDirFormat.get_default_format().network_name()
+        transport = self.get_transport()
+        client = FakeClient(transport.base)
+        client.add_expected_call(
+            'BzrDirFormat.initialize_ex_1.16',
+                (default_format_name, 'path', 'False', 'False', 'False', '',
+                 '', '', '', 'False'),
+            'success',
+                ('.', 'no', 'no', 'yes', 'repo fmt', 'repo bzrdir fmt',
+                 'bzrdir fmt', 'False', '', '', 'repo lock token'))
+        # XXX: It would be better to call fmt.initialize_on_transport_ex, but
+        # it's currently hard to test that without supplying a real remote
+        # transport connected to a real server.
+        result = fmt._initialize_on_transport_ex_rpc(client, 'path',
+            transport, False, False, False, None, None, None, None, False)
+        client.finished_test()
+
+    def test_error(self):
+        """Error responses are translated, e.g. 'PermissionDenied' raises the
+        corresponding error from the client.
+        """
+        fmt = bzrdir.RemoteBzrDirFormat()
+        default_format_name = BzrDirFormat.get_default_format().network_name()
+        transport = self.get_transport()
+        client = FakeClient(transport.base)
+        client.add_expected_call(
+            'BzrDirFormat.initialize_ex_1.16',
+                (default_format_name, 'path', 'False', 'False', 'False', '',
+                 '', '', '', 'False'),
+            'error',
+                ('PermissionDenied', 'path', 'extra info'))
+        # XXX: It would be better to call fmt.initialize_on_transport_ex, but
+        # it's currently hard to test that without supplying a real remote
+        # transport connected to a real server.
+        err = self.assertRaises(errors.PermissionDenied,
+            fmt._initialize_on_transport_ex_rpc, client, 'path', transport,
+            False, False, False, None, None, None, None, False)
+        self.assertEqual('path', err.path)
+        self.assertEqual(': extra info', err.extra)
+        client.finished_test()
+
+    def test_error_from_real_server(self):
+        """Integration test for error translation."""
+        transport = self.make_smart_server('foo')
+        transport = transport.clone('no-such-path')
+        fmt = bzrdir.RemoteBzrDirFormat()
+        err = self.assertRaises(errors.NoSuchFile,
+            fmt.initialize_on_transport_ex, transport, create_prefix=False)
+
+
 class OldSmartClient(object):
     """A fake smart client for test_old_version that just returns a version one
     response to the 'hello' (query version) command.
@@ -1963,6 +2036,65 @@
         self.assertEqual(('AnUnexpectedError',), e.error_tuple)
 
 
+class TestRepositoryGetRevIdForRevno(TestRemoteRepository):
+
+    def test_ok(self):
+        repo, client = self.setup_fake_client_and_repository('quack')
+        client.add_expected_call(
+            'Repository.get_rev_id_for_revno', ('quack/', 5, (42, 'rev-foo')),
+            'success', ('ok', 'rev-five'))
+        result = repo.get_rev_id_for_revno(5, (42, 'rev-foo'))
+        self.assertEqual((True, 'rev-five'), result)
+        client.finished_test()
+
+    def test_history_incomplete(self):
+        repo, client = self.setup_fake_client_and_repository('quack')
+        client.add_expected_call(
+            'Repository.get_rev_id_for_revno', ('quack/', 5, (42, 'rev-foo')),
+            'success', ('history-incomplete', 10, 'rev-ten'))
+        result = repo.get_rev_id_for_revno(5, (42, 'rev-foo'))
+        self.assertEqual((False, (10, 'rev-ten')), result)
+        client.finished_test()
+
+    def test_history_incomplete_with_fallback(self):
+        """A 'history-incomplete' response causes the fallback repository to be
+        queried too, if one is set.
+        """
+        # Make a repo with a fallback repo, both using a FakeClient.
+        format = remote.response_tuple_to_repo_format(
+            ('yes', 'no', 'yes', 'fake-network-name'))
+        repo, client = self.setup_fake_client_and_repository('quack')
+        repo._format = format
+        fallback_repo, ignored = self.setup_fake_client_and_repository(
+            'fallback')
+        fallback_repo._client = client
+        repo.add_fallback_repository(fallback_repo)
+        # First the client should ask the primary repo
+        client.add_expected_call(
+            'Repository.get_rev_id_for_revno', ('quack/', 1, (42, 'rev-foo')),
+            'success', ('history-incomplete', 2, 'rev-two'))
+        # Then it should ask the fallback, using revno/revid from the
+        # history-incomplete response as the known revno/revid.
+        client.add_expected_call(
+            'Repository.get_rev_id_for_revno',('fallback/', 1, (2, 'rev-two')),
+            'success', ('ok', 'rev-one'))
+        result = repo.get_rev_id_for_revno(1, (42, 'rev-foo'))
+        self.assertEqual((True, 'rev-one'), result)
+        client.finished_test()
+
+    def test_nosuchrevision(self):
+        # 'nosuchrevision' is returned when the known-revid is not found in the
+        # remote repo.  The client translates that response to NoSuchRevision.
+        repo, client = self.setup_fake_client_and_repository('quack')
+        client.add_expected_call(
+            'Repository.get_rev_id_for_revno', ('quack/', 5, (42, 'rev-foo')),
+            'error', ('nosuchrevision', 'rev-foo'))
+        self.assertRaises(
+            errors.NoSuchRevision,
+            repo.get_rev_id_for_revno, 5, (42, 'rev-foo'))
+        client.finished_test()
+
+
 class TestRepositoryIsShared(TestRemoteRepository):
 
     def test_is_shared(self):

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2009-05-29 15:06:16 +0000
+++ bzrlib/tests/test_repository.py	2009-06-17 17:57:15 +0000
@@ -51,8 +51,8 @@
     get_transport,
     )
 from bzrlib.transport.memory import MemoryServer
-from bzrlib.util import bencode
 from bzrlib import (
+    bencode,
     bzrdir,
     errors,
     inventory,

=== modified file 'bzrlib/tests/test_serializer.py'
--- bzrlib/tests/test_serializer.py	2009-04-03 21:50:40 +0000
+++ bzrlib/tests/test_serializer.py	2009-06-10 03:56:49 +0000
@@ -19,6 +19,7 @@
 
 
 from bzrlib import (
+    chk_serializer,
     serializer,
     xml4,
     xml5,
@@ -43,3 +44,5 @@
                       serializer.format_registry.get('7'))
         self.assertIs(xml8.serializer_v8,
                       serializer.format_registry.get('8'))
+        self.assertIs(chk_serializer.chk_serializer_255_bigpage,
+                      serializer.format_registry.get('9'))

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2009-05-11 10:25:32 +0000
+++ bzrlib/tests/test_smart.py	2009-06-15 06:47:14 +0000
@@ -29,6 +29,7 @@
 import tarfile
 
 from bzrlib import (
+    bencode,
     bzrdir,
     errors,
     pack,
@@ -51,7 +52,6 @@
     split_suite_by_re,
     )
 from bzrlib.transport import chroot, get_transport
-from bzrlib.util import bencode
 
 
 def load_tests(standard_tests, module, loader):
@@ -351,7 +351,7 @@
 
 
 class TestSmartServerRequestBzrDirInitializeEx(tests.TestCaseWithMemoryTransport):
-    """Basic tests for BzrDir.initialize_ex in the smart server.
+    """Basic tests for BzrDir.initialize_ex_1.16 in the smart server.
 
     The main unit tests in test_bzrdir exercise the API comprehensively.
     """
@@ -381,7 +381,7 @@
             'subdir/dir', 'False', 'False', 'False', '', '', '', '', 'False')
 
     def test_initialized_dir(self):
-        """Initializing an extant dirctory should fail like the bzrdir api."""
+        """Initializing an extant directory should fail like the bzrdir api."""
         backing = self.get_transport()
         name = self.make_bzrdir('reference')._format.network_name()
         request = smart.bzrdir.SmartServerRequestBzrDirInitializeEx(backing)
@@ -1161,6 +1161,47 @@
             request.execute('', 'missingrevision'))
 
 
+class TestSmartServerRepositoryGetRevIdForRevno(tests.TestCaseWithMemoryTransport):
+
+    def test_revno_found(self):
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryGetRevIdForRevno(backing)
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        rev1_id_utf8 = u'\xc8'.encode('utf-8')
+        rev2_id_utf8 = u'\xc9'.encode('utf-8')
+        tree.commit('1st commit', rev_id=rev1_id_utf8)
+        tree.commit('2nd commit', rev_id=rev2_id_utf8)
+        tree.unlock()
+
+        self.assertEqual(SmartServerResponse(('ok', rev1_id_utf8)),
+            request.execute('', 1, (2, rev2_id_utf8)))
+
+    def test_known_revid_missing(self):
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryGetRevIdForRevno(backing)
+        repo = self.make_repository('.')
+        self.assertEqual(
+            FailedSmartServerResponse(('nosuchrevision', 'ghost')),
+            request.execute('', 1, (2, 'ghost')))
+
+    def test_history_incomplete(self):
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryGetRevIdForRevno(backing)
+        parent = self.make_branch_and_memory_tree('parent', format='1.9')
+        r1 = parent.commit(message='first commit')
+        r2 = parent.commit(message='second commit')
+        local = self.make_branch_and_memory_tree('local', format='1.9')
+        local.branch.pull(parent.branch)
+        local.set_parent_ids([r2])
+        r3 = local.commit(message='local commit')
+        local.branch.create_clone_on_transport(
+            self.get_transport('stacked'), stacked_on=self.get_url('parent'))
+        self.assertEqual(
+            SmartServerResponse(('history-incomplete', 2, r2)),
+            request.execute('stacked', 1, (3, r3)))
+
 class TestSmartServerRepositoryGetStream(tests.TestCaseWithMemoryTransport):
 
     def make_two_commit_repo(self):
@@ -1560,7 +1601,7 @@
             smart.bzrdir.SmartServerRequestFindRepositoryV2)
         self.assertHandlerEqual('BzrDirFormat.initialize',
             smart.bzrdir.SmartServerRequestInitializeBzrDir)
-        self.assertHandlerEqual('BzrDirFormat.initialize_ex',
+        self.assertHandlerEqual('BzrDirFormat.initialize_ex_1.16',
             smart.bzrdir.SmartServerRequestBzrDirInitializeEx)
         self.assertHandlerEqual('BzrDir.cloning_metadir',
             smart.bzrdir.SmartServerBzrDirRequestCloningMetaDir)
@@ -1576,6 +1617,8 @@
             smart.repository.SmartServerRepositoryGatherStats)
         self.assertHandlerEqual('Repository.get_parent_map',
             smart.repository.SmartServerRepositoryGetParentMap)
+        self.assertHandlerEqual('Repository.get_rev_id_for_revno',
+            smart.repository.SmartServerRepositoryGetRevIdForRevno)
         self.assertHandlerEqual('Repository.get_revision_graph',
             smart.repository.SmartServerRepositoryGetRevisionGraph)
         self.assertHandlerEqual('Repository.get_stream',

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2009-03-28 09:57:23 +0000
+++ bzrlib/tests/test_source.py	2009-06-10 03:56:49 +0000
@@ -42,9 +42,9 @@
 
 # Files which are listed here will be skipped when testing for Copyright (or
 # GPL) statements.
-COPYRIGHT_EXCEPTIONS = ['bzrlib/lsprof.py']
+COPYRIGHT_EXCEPTIONS = ['bzrlib/lsprof.py', 'bzrlib/_bencode_py.py']
 
-LICENSE_EXCEPTIONS = ['bzrlib/lsprof.py']
+LICENSE_EXCEPTIONS = ['bzrlib/lsprof.py', 'bzrlib/_bencode_py.py']
 # Technically, 'bzrlib/lsprof.py' should be 'bzrlib/util/lsprof.py',
 # (we do not check bzrlib/util/, since that is code bundled from elsewhere)
 # but for compatibility with previous releases, we don't want to move it.

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2009-05-23 04:55:52 +0000
+++ bzrlib/tests/test_transform.py	2009-06-10 03:56:49 +0000
@@ -20,6 +20,7 @@
 import sys
 
 from bzrlib import (
+    bencode,
     errors,
     generate_ids,
     osutils,
@@ -53,7 +54,6 @@
                               build_tree, get_backup_name,
                               _FileMover, resolve_checkout,
                               TransformPreview, create_from_tree)
-from bzrlib.util import bencode
 
 
 class TestTreeTransform(tests.TestCaseWithTransport):

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2009-04-24 13:30:48 +0000
+++ bzrlib/tests/test_ui.py	2009-06-17 05:16:48 +0000
@@ -25,12 +25,6 @@
 
 import bzrlib
 import bzrlib.errors as errors
-from bzrlib.progress import (
-    DotsProgressBar,
-    ProgressBarStack,
-    ProgressTask,
-    TTYProgressBar,
-    )
 from bzrlib.symbol_versioning import (
     deprecated_in,
     )
@@ -45,6 +39,7 @@
     SilentUIFactory,
     )
 from bzrlib.ui.text import (
+    NullProgressView,
     TextProgressView,
     TextUIFactory,
     )
@@ -67,15 +62,17 @@
         self.assertEqual('', stdout.getvalue())
 
     def test_text_factory_ascii_password(self):
-        ui = TestUIFactory(stdin='secret\n', stdout=StringIOWrapper())
+        ui = TestUIFactory(stdin='secret\n', stdout=StringIOWrapper(),
+                           stderr=StringIOWrapper())
         pb = ui.nested_progress_bar()
         try:
             self.assertEqual('secret',
                              self.apply_redirected(ui.stdin, ui.stdout,
-                                                   ui.stdout,
+                                                   ui.stderr,
                                                    ui.get_password))
             # ': ' is appended to prompt
-            self.assertEqual(': ', ui.stdout.getvalue())
+            self.assertEqual(': ', ui.stderr.getvalue())
+            self.assertEqual('', ui.stdout.readline())
             # stdin should be empty
             self.assertEqual('', ui.stdin.readline())
         finally:
@@ -88,24 +85,44 @@
         it to utf8 to test that we transport the password correctly.
         """
         ui = TestUIFactory(stdin=u'baz\u1234'.encode('utf8'),
-                           stdout=StringIOWrapper())
-        ui.stdin.encoding = 'utf8'
-        ui.stdout.encoding = ui.stdin.encoding
+                           stdout=StringIOWrapper(),
+                           stderr=StringIOWrapper())
+        ui.stderr.encoding = ui.stdout.encoding = ui.stdin.encoding = 'utf8'
         pb = ui.nested_progress_bar()
         try:
-            password = self.apply_redirected(ui.stdin, ui.stdout, ui.stdout,
+            password = self.apply_redirected(ui.stdin, ui.stdout, ui.stderr,
                                              ui.get_password,
                                              u'Hello \u1234 %(user)s',
                                              user=u'some\u1234')
             # We use StringIO objects, we need to decode them
             self.assertEqual(u'baz\u1234', password.decode('utf8'))
             self.assertEqual(u'Hello \u1234 some\u1234: ',
-                             ui.stdout.getvalue().decode('utf8'))
-            # stdin should be empty
+                             ui.stderr.getvalue().decode('utf8'))
+            # stdin and stdout should be empty
             self.assertEqual('', ui.stdin.readline())
+            self.assertEqual('', ui.stdout.readline())
         finally:
             pb.finished()
 
+    def test_progress_construction(self):
+        """TextUIFactory constructs the right progress view.
+        """
+        os.environ['BZR_PROGRESS_BAR'] = 'none'
+        self.assertIsInstance(TextUIFactory()._progress_view,
+            NullProgressView)
+
+        os.environ['BZR_PROGRESS_BAR'] = 'text'
+        self.assertIsInstance(TextUIFactory()._progress_view,
+            TextProgressView)
+
+        os.environ['BZR_PROGRESS_BAR'] = 'text'
+        self.assertIsInstance(TextUIFactory()._progress_view,
+            TextProgressView)
+
+        del os.environ['BZR_PROGRESS_BAR']
+        self.assertIsInstance(TextUIFactory()._progress_view,
+            TextProgressView)
+
     def test_progress_note(self):
         stderr = StringIO()
         stdout = StringIO()
@@ -161,38 +178,12 @@
         pb2.finished()
         pb1.finished()
 
-    def test_progress_stack(self):
-        # test the progress bar stack which the default text factory
-        # uses.
-        stderr = StringIO()
-        stdout = StringIO()
-        # make a stack, which accepts parameters like a pb.
-        stack = self.applyDeprecated(
-            deprecated_in((1, 12, 0)),
-            ProgressBarStack,
-            to_file=stderr, to_messages_file=stdout)
-        # but is not one
-        self.assertFalse(getattr(stack, 'note', False))
-        pb1 = stack.get_nested()
-        pb2 = stack.get_nested()
-        warnings, _ = self.callCatchWarnings(pb1.finished)
-        self.assertEqual(len(warnings), 1)
-        pb2.finished()
-        pb1.finished()
-        # the text ui factory never actually removes the stack once its setup.
-        # we need to be able to nest again correctly from here.
-        pb1 = stack.get_nested()
-        pb2 = stack.get_nested()
-        warnings, _ = self.callCatchWarnings(pb1.finished)
-        self.assertEqual(len(warnings), 1)
-        pb2.finished()
-        pb1.finished()
-
     def assert_get_bool_acceptance_of_user_input(self, factory):
         factory.stdin = StringIO("y\nyes with garbage\n"
                                  "yes\nn\nnot an answer\n"
                                  "no\nfoo\n")
         factory.stdout = StringIO()
+        factory.stderr = StringIO()
         # there is no output from the base factory
         self.assertEqual(True, factory.get_boolean(""))
         self.assertEqual(True, factory.get_boolean(""))
@@ -223,8 +214,10 @@
 
     def test_text_factory_prompt(self):
         # see <https://launchpad.net/bugs/365891>
-        factory = TextUIFactory(None, StringIO(), StringIO())
+        factory = TextUIFactory(None, StringIO(), StringIO(), StringIO())
         factory.prompt('foo %2e')
+        self.assertEqual('', factory.stdout.getvalue())
+        self.assertEqual('foo %2e', factory.stderr.getvalue())
 
     def test_text_factory_prompts_and_clears(self):
         # a get_boolean call should clear the pb before prompting
@@ -263,37 +256,41 @@
         factory = SilentUIFactory()
         factory.stdin = StringIO("someuser\n\n")
         factory.stdout = StringIO()
-        self.assertEquals(None, 
+        factory.stderr = StringIO()
+        self.assertEquals(None,
             factory.get_username(u'Hello\u1234 %(host)s', host=u'some\u1234'))
         self.assertEquals("", factory.stdout.getvalue())
+        self.assertEquals("", factory.stderr.getvalue())
         self.assertEquals("someuser\n\n", factory.stdin.getvalue())
 
     def test_text_ui_getusername(self):
         factory = TextUIFactory(None, None, None)
         factory.stdin = StringIO("someuser\n\n")
         factory.stdout = StringIO()
+        factory.stderr = StringIO()
         factory.stdout.encoding = "utf8"
         # there is no output from the base factory
-        self.assertEqual("someuser", 
-            factory.get_username('Hello %(host)s', host='some'))
-        self.assertEquals("Hello some: ", factory.stdout.getvalue())
+        self.assertEqual("someuser",
+                         factory.get_username('Hello %(host)s', host='some'))
+        self.assertEquals("Hello some: ", factory.stderr.getvalue())
+        self.assertEquals('', factory.stdout.getvalue())
         self.assertEqual("", factory.get_username("Gebruiker"))
         # stdin should be empty
         self.assertEqual('', factory.stdin.readline())
 
     def test_text_ui_getusername_utf8(self):
         ui = TestUIFactory(stdin=u'someuser\u1234'.encode('utf8'),
-                           stdout=StringIOWrapper())
-        ui.stdin.encoding = "utf8"
-        ui.stdout.encoding = ui.stdin.encoding
+                           stdout=StringIOWrapper(), stderr=StringIOWrapper())
+        ui.stderr.encoding = ui.stdout.encoding = ui.stdin.encoding = "utf8"
         pb = ui.nested_progress_bar()
         try:
             # there is no output from the base factory
-            username = self.apply_redirected(ui.stdin, ui.stdout, ui.stdout,
+            username = self.apply_redirected(ui.stdin, ui.stdout, ui.stderr,
                 ui.get_username, u'Hello\u1234 %(host)s', host=u'some\u1234')
             self.assertEquals(u"someuser\u1234", username.decode('utf8'))
-            self.assertEquals(u"Hello\u1234 some\u1234: ", 
-                ui.stdout.getvalue().decode("utf8"))
+            self.assertEquals(u"Hello\u1234 some\u1234: ",
+                              ui.stderr.getvalue().decode("utf8"))
+            self.assertEquals('', ui.stdout.getvalue())
         finally:
             pb.finished()
 

=== modified file 'bzrlib/tests/tree_implementations/test_list_files.py'
--- bzrlib/tests/tree_implementations/test_list_files.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/tree_implementations/test_list_files.py	2009-05-18 06:32:08 +0000
@@ -49,7 +49,68 @@
         try:
             actual = [(path, status, kind, file_id)
                       for path, status, kind, file_id, ie in
-                          tree.list_files(include_root=False)]
+                          tree.list_files()]
+        finally:
+            tree.unlock()
+        self.assertEqual(expected, actual)
+
+    def test_list_files_with_root_no_recurse(self):
+        work_tree = self.make_branch_and_tree('wt')
+        tree = self.get_tree_no_parents_abc_content(work_tree)
+        expected = [('', 'V', 'directory', 'root-id'),
+                    ('a', 'V', 'file', 'a-id'),
+                    ('b', 'V', 'directory', 'b-id'),
+                   ]
+        tree.lock_read()
+        try:
+            actual = [(path, status, kind, file_id)
+                for path, status, kind, file_id, ie in
+                    tree.list_files(include_root=True, recursive=False)]
+        finally:
+            tree.unlock()
+        self.assertEqual(expected, actual)
+
+    def test_list_files_no_root_no_recurse(self):
+        work_tree = self.make_branch_and_tree('wt')
+        tree = self.get_tree_no_parents_abc_content(work_tree)
+        expected = [('a', 'V', 'file', 'a-id'),
+                    ('b', 'V', 'directory', 'b-id'),
+                   ]
+        tree.lock_read()
+        try:
+            actual = [(path, status, kind, file_id)
+                for path, status, kind, file_id, ie in
+                    tree.list_files(recursive=False)]
+        finally:
+            tree.unlock()
+        self.assertEqual(expected, actual)
+
+    def test_list_files_from_dir(self):
+        work_tree = self.make_branch_and_tree('wt')
+        tree = self.get_tree_no_parents_abc_content(work_tree)
+        expected = [('c', 'V', 'file', 'c-id'),
+                   ]
+        tree.lock_read()
+        try:
+            actual = [(path, status, kind, file_id)
+                      for path, status, kind, file_id, ie in
+                          tree.list_files(from_dir='b')]
+        finally:
+            tree.unlock()
+        self.assertEqual(expected, actual)
+
+    def test_list_files_from_dir_no_recurse(self):
+        # The test trees don't have much nesting so test with an explicit root
+        work_tree = self.make_branch_and_tree('wt')
+        tree = self.get_tree_no_parents_abc_content(work_tree)
+        expected = [('a', 'V', 'file', 'a-id'),
+                    ('b', 'V', 'directory', 'b-id'),
+                   ]
+        tree.lock_read()
+        try:
+            actual = [(path, status, kind, file_id)
+                      for path, status, kind, file_id, ie in
+                          tree.list_files(from_dir='', recursive=False)]
         finally:
             tree.unlock()
         self.assertEqual(expected, actual)

=== modified file 'bzrlib/tests/workingtree_implementations/test_content_filters.py'
--- bzrlib/tests/workingtree_implementations/test_content_filters.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/workingtree_implementations/test_content_filters.py	2009-06-11 04:21:06 +0000
@@ -17,6 +17,7 @@
 """Tests for content filtering conformance"""
 
 from bzrlib.filters import ContentFilter
+from bzrlib.workingtree import WorkingTree
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 
 
@@ -44,8 +45,8 @@
 
 class TestWorkingTreeWithContentFilters(TestCaseWithWorkingTree):
 
-    def create_cf_tree(self, txt_reader, txt_writer):
-        tree = self.make_branch_and_tree('.')
+    def create_cf_tree(self, txt_reader, txt_writer, dir='.'):
+        tree = self.make_branch_and_tree(dir)
         def _content_filter_stack(path=None, file_id=None):
             if path.endswith('.txt'):
                 return [ContentFilter(txt_reader, txt_writer)]
@@ -53,8 +54,8 @@
                 return []
         tree._content_filter_stack = _content_filter_stack
         self.build_tree_contents([
-            ('file1.txt', 'Foo Txt'),
-            ('file2.bin', 'Foo Bin')])
+            (dir + '/file1.txt', 'Foo Txt'),
+            (dir + '/file2.bin', 'Foo Bin')])
         tree.add(['file1.txt', 'file2.bin'])
         tree.commit('commit raw content')
         txt_fileid = tree.path2id('file1.txt')
@@ -104,3 +105,57 @@
             filtered=False).read())
         self.assertEqual('Foo Bin', tree.get_file(bin_fileid,
             filtered=False).read())
+
+    def test_branch_source_filtered_target_not(self):
+        # Create a source branch with content filtering
+        source, txt_fileid, bin_fileid = self.create_cf_tree(
+            txt_reader=_uppercase, txt_writer=_lowercase, dir='source')
+        if not source.supports_content_filtering():
+            return
+        self.assertFileEqual("Foo Txt", 'source/file1.txt')
+        basis = source.basis_tree()
+        basis.lock_read()
+        self.addCleanup(basis.unlock)
+        self.assertEqual("FOO TXT", basis.get_file_text(txt_fileid))
+
+        # Now branch it
+        self.run_bzr('branch source target')
+        target = WorkingTree.open('target')
+        # Even though the content in source and target are different
+        # due to different filters, iter_changes should be clean
+        self.assertFileEqual("FOO TXT", 'target/file1.txt')
+        changes = target.changes_from(source.basis_tree())
+        self.assertFalse(changes.has_changed())
+
+    def test_branch_source_not_filtered_target_is(self):
+        # Create a source branch with content filtering
+        source, txt_fileid, bin_fileid = self.create_cf_tree(
+            txt_reader=None, txt_writer=None, dir='source')
+        if not source.supports_content_filtering():
+            return
+        self.assertFileEqual("Foo Txt", 'source/file1.txt')
+        basis = source.basis_tree()
+        basis.lock_read()
+        self.addCleanup(basis.unlock)
+        self.assertEqual("Foo Txt", basis.get_file_text(txt_fileid))
+
+        # Patch in a custom, symmetric content filter stack
+        self.real_content_filter_stack = WorkingTree._content_filter_stack
+        def restore_real_content_filter_stack():
+            WorkingTree._content_filter_stack = self.real_content_filter_stack
+        self.addCleanup(restore_real_content_filter_stack)
+        def _content_filter_stack(tree, path=None, file_id=None):
+            if path.endswith('.txt'):
+                return [ContentFilter(_swapcase, _swapcase)]
+            else:
+                return []
+        WorkingTree._content_filter_stack = _content_filter_stack
+
+        # Now branch it
+        self.run_bzr('branch source target')
+        target = WorkingTree.open('target')
+        # Even though the content in source and target are different
+        # due to different filters, iter_changes should be clean
+        self.assertFileEqual("fOO tXT", 'target/file1.txt')
+        changes = target.changes_from(source.basis_tree())
+        self.assertFalse(changes.has_changed())

=== modified file 'bzrlib/tests/workingtree_implementations/test_eol_conversion.py'
--- bzrlib/tests/workingtree_implementations/test_eol_conversion.py	2009-04-02 04:12:11 +0000
+++ bzrlib/tests/workingtree_implementations/test_eol_conversion.py	2009-06-10 06:48:01 +0000
@@ -17,8 +17,9 @@
 """Tests for eol conversion."""
 
 import sys
+from cStringIO import StringIO
 
-from bzrlib import rules
+from bzrlib import rules, status
 from bzrlib.tests import TestSkipped
 from bzrlib.tests.workingtree_implementations import TestCaseWithWorkingTree
 from bzrlib.workingtree import WorkingTree
@@ -29,6 +30,13 @@
 _sample_text_on_win  = """hello\r\nworld\r\n"""
 _sample_text_on_unix = """hello\nworld\n"""
 _sample_binary       = """hello\nworld\r\n\x00"""
+_sample_clean_lf     = _sample_text_on_unix
+_sample_clean_crlf   = _sample_text_on_win
+
+
+# Lists of formats for each storage policy
+_LF_IN_REPO = ['native', 'lf', 'crlf']
+_CRLF_IN_REPO = [ '%s-with-crlf-in-repo' % (f,) for f in _LF_IN_REPO]
 
 
 class TestEolConversion(TestCaseWithWorkingTree):
@@ -74,8 +82,11 @@
         return t, basis
 
     def assertNewContentForSetting(self, wt, eol, expected_unix,
-        expected_win=None):
-        """Clone a working tree and check the convenience content."""
+        expected_win, roundtrip):
+        """Clone a working tree and check the convenience content.
+        
+        If roundtrip is True, status and commit should see no changes.
+        """
         if expected_win is None:
             expected_win = expected_unix
         self.patch_rules_searcher(eol)
@@ -86,100 +97,241 @@
             self.assertEqual(expected_win, content)
         else:
             self.assertEqual(expected_unix, content)
+        # Confirm that status thinks nothing has changed if the text roundtrips
+        if roundtrip:
+            status_io = StringIO()
+            status.show_tree_status(wt2, to_file=status_io)
+            self.assertEqual('', status_io.getvalue())
 
     def assertContent(self, wt, basis, expected_raw, expected_unix,
-        expected_win):
-        """Check the committed content and content in cloned trees."""
+        expected_win, roundtrip_to=None):
+        """Check the committed content and content in cloned trees.
+        
+        :param roundtrip_to: the set of formats (excluding exact) we
+          can round-trip to or None for all
+        """
         basis_content = basis.get_file('file1-id').read()
         self.assertEqual(expected_raw, basis_content)
-        self.assertNewContentForSetting(wt, None, expected_raw)
+
+        # No setting and exact should always roundtrip
+        self.assertNewContentForSetting(wt, None,
+            expected_raw, expected_raw, roundtrip=True)
+        self.assertNewContentForSetting(wt, 'exact',
+            expected_raw, expected_raw, roundtrip=True)
+
+        # Roundtripping is otherwise dependent on whether the original
+        # text is clean - mixed line endings will prevent it. It also
+        # depends on whether the format in the repository is being changed.
+        if roundtrip_to is None:
+            roundtrip_to = _LF_IN_REPO + _CRLF_IN_REPO
         self.assertNewContentForSetting(wt, 'native',
-            expected_unix, expected_win)
+            expected_unix, expected_win, 'native' in roundtrip_to)
         self.assertNewContentForSetting(wt, 'lf',
-            expected_unix, expected_unix)
+            expected_unix, expected_unix, 'lf' in roundtrip_to)
         self.assertNewContentForSetting(wt, 'crlf',
-            expected_win, expected_win)
+            expected_win, expected_win, 'crlf' in roundtrip_to)
         self.assertNewContentForSetting(wt, 'native-with-crlf-in-repo',
-            expected_unix, expected_win)
+            expected_unix, expected_win,
+            'native-with-crlf-in-repo' in roundtrip_to)
         self.assertNewContentForSetting(wt, 'lf-with-crlf-in-repo',
-            expected_unix, expected_unix)
+            expected_unix, expected_unix,
+            'lf-with-crlf-in-repo' in roundtrip_to)
         self.assertNewContentForSetting(wt, 'crlf-with-crlf-in-repo',
-            expected_win, expected_win)
-        self.assertNewContentForSetting(wt, 'exact', expected_raw)
-
-    def test_eol_no_rules(self):
-        wt, basis = self.prepare_tree(_sample_text)
-        self.assertContent(wt, basis, _sample_text,
-            _sample_text_on_unix, _sample_text_on_win)
-
-    def test_eol_native(self):
-        wt, basis = self.prepare_tree(_sample_text, eol='native')
-        self.assertContent(wt, basis, _sample_text_on_unix,
-            _sample_text_on_unix, _sample_text_on_win)
+            expected_win, expected_win,
+            'crlf-with-crlf-in-repo' in roundtrip_to)
+
+    # Test binary files. These always roundtrip.
+
+    def test_eol_no_rules_binary(self):
+        wt, basis = self.prepare_tree(_sample_binary)
+        self.assertContent(wt, basis, _sample_binary, _sample_binary,
+            _sample_binary)
+
+    def test_eol_exact_binary(self):
+        wt, basis = self.prepare_tree(_sample_binary, eol='exact')
+        self.assertContent(wt, basis, _sample_binary, _sample_binary,
+            _sample_binary)
 
     def test_eol_native_binary(self):
         wt, basis = self.prepare_tree(_sample_binary, eol='native')
         self.assertContent(wt, basis, _sample_binary, _sample_binary,
             _sample_binary)
 
-    def test_eol_lf(self):
-        wt, basis = self.prepare_tree(_sample_text, eol='lf')
-        self.assertContent(wt, basis, _sample_text_on_unix,
-            _sample_text_on_unix, _sample_text_on_win)
-
     def test_eol_lf_binary(self):
         wt, basis = self.prepare_tree(_sample_binary, eol='lf')
         self.assertContent(wt, basis, _sample_binary, _sample_binary,
             _sample_binary)
 
-    def test_eol_crlf(self):
-        wt, basis = self.prepare_tree(_sample_text, eol='crlf')
-        self.assertContent(wt, basis, _sample_text_on_unix,
-            _sample_text_on_unix, _sample_text_on_win)
-
     def test_eol_crlf_binary(self):
         wt, basis = self.prepare_tree(_sample_binary, eol='crlf')
         self.assertContent(wt, basis, _sample_binary, _sample_binary,
             _sample_binary)
 
-    def test_eol_native_with_crlf_in_repo(self):
-        wt, basis = self.prepare_tree(_sample_text,
-            eol='native-with-crlf-in-repo')
-        self.assertContent(wt, basis, _sample_text_on_win,
-            _sample_text_on_unix, _sample_text_on_win)
-
     def test_eol_native_with_crlf_in_repo_binary(self):
         wt, basis = self.prepare_tree(_sample_binary,
             eol='native-with-crlf-in-repo')
         self.assertContent(wt, basis, _sample_binary, _sample_binary,
             _sample_binary)
 
-    def test_eol_lf_with_crlf_in_repo(self):
-        wt, basis = self.prepare_tree(_sample_text, eol='lf-with-crlf-in-repo')
-        self.assertContent(wt, basis, _sample_text_on_win,
-            _sample_text_on_unix, _sample_text_on_win)
-
     def test_eol_lf_with_crlf_in_repo_binary(self):
-        wt, basis = self.prepare_tree(_sample_binary, eol='lf-with-crlf-in-repo')
+        wt, basis = self.prepare_tree(_sample_binary,
+            eol='lf-with-crlf-in-repo')
         self.assertContent(wt, basis, _sample_binary, _sample_binary,
             _sample_binary)
 
-    def test_eol_crlf_with_crlf_in_repo(self):
-        wt, basis = self.prepare_tree(_sample_text, eol='crlf-with-crlf-in-repo')
-        self.assertContent(wt, basis, _sample_text_on_win,
-            _sample_text_on_unix, _sample_text_on_win)
-
     def test_eol_crlf_with_crlf_in_repo_binary(self):
-        wt, basis = self.prepare_tree(_sample_binary, eol='crlf-with-crlf-in-repo')
+        wt, basis = self.prepare_tree(_sample_binary,
+            eol='crlf-with-crlf-in-repo')
         self.assertContent(wt, basis, _sample_binary, _sample_binary,
             _sample_binary)
 
-    def test_eol_exact(self):
+    # Test text with mixed line endings ("dirty text").
+    # This doesn't roundtrip so status always thinks something has changed.
+
+    def test_eol_no_rules_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text)
+        self.assertContent(wt, basis, _sample_text,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_exact_dirty(self):
         wt, basis = self.prepare_tree(_sample_text, eol='exact')
         self.assertContent(wt, basis, _sample_text,
-            _sample_text_on_unix, _sample_text_on_win)
-
-    def test_eol_exact_binary(self):
-        wt, basis = self.prepare_tree(_sample_binary, eol='exact')
-        self.assertContent(wt, basis, _sample_binary, _sample_binary,
-            _sample_binary)
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_native_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text, eol='native')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_lf_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text, eol='lf')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_crlf_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text, eol='crlf')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_native_with_crlf_in_repo_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text,
+            eol='native-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_lf_with_crlf_in_repo_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text,
+            eol='lf-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    def test_eol_crlf_with_crlf_in_repo_dirty(self):
+        wt, basis = self.prepare_tree(_sample_text,
+            eol='crlf-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win, roundtrip_to=[])
+
+    # Test text with clean line endings, either always lf or always crlf.
+    # This selectively roundtrips (based on what's stored in the repo).
+
+    def test_eol_no_rules_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf)
+        self.assertContent(wt, basis, _sample_clean_lf,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_no_rules_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf)
+        self.assertContent(wt, basis, _sample_clean_crlf,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_exact_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf, eol='exact')
+        self.assertContent(wt, basis, _sample_clean_lf,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_exact_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf, eol='exact')
+        self.assertContent(wt, basis, _sample_clean_crlf,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_native_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf, eol='native')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_native_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf, eol='native')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_lf_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf, eol='lf')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_lf_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf, eol='lf')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_crlf_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf, eol='crlf')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_crlf_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf, eol='crlf')
+        self.assertContent(wt, basis, _sample_text_on_unix,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_LF_IN_REPO)
+
+    def test_eol_native_with_crlf_in_repo_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf,
+            eol='native-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_native_with_crlf_in_repo_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf,
+            eol='native-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_lf_with_crlf_in_repo_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf,
+            eol='lf-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_lf_with_crlf_in_repo_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf,
+            eol='lf-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_crlf_with_crlf_in_repo_clean_lf(self):
+        wt, basis = self.prepare_tree(_sample_clean_lf,
+            eol='crlf-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)
+
+    def test_eol_crlf_with_crlf_in_repo_clean_crlf(self):
+        wt, basis = self.prepare_tree(_sample_clean_crlf,
+            eol='crlf-with-crlf-in-repo')
+        self.assertContent(wt, basis, _sample_text_on_win,
+            _sample_text_on_unix, _sample_text_on_win,
+            roundtrip_to=_CRLF_IN_REPO)

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2009-05-28 14:25:00 +0000
+++ bzrlib/transform.py	2009-06-17 03:41:33 +0000
@@ -22,6 +22,7 @@
 lazy_import(globals(), """
 from bzrlib import (
     annotate,
+    bencode,
     bzrdir,
     delta,
     errors,
@@ -30,7 +31,6 @@
     osutils,
     revision as _mod_revision,
     )
-from bzrlib.util import bencode
 """)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
                            ReusingTransform, NotVersionedError, CantMoveRoot,
@@ -1748,7 +1748,7 @@
             if self._transform.final_file_id(trans_id) is None:
                 yield self._final_paths._determine_path(trans_id)
 
-    def _make_inv_entries(self, ordered_entries, specific_file_ids):
+    def _make_inv_entries(self, ordered_entries, specific_file_ids=None):
         for trans_id, parent_file_id in ordered_entries:
             file_id = self._transform.final_file_id(trans_id)
             if file_id is None:
@@ -1791,14 +1791,41 @@
                                                       specific_file_ids):
             yield unicode(self._final_paths.get_path(trans_id)), entry
 
-    def list_files(self, include_root=False):
-        """See Tree.list_files."""
+    def _iter_entries_for_dir(self, dir_path):
+        """Return path, entry for items in a directory without recursing down."""
+        dir_file_id = self.path2id(dir_path)
+        ordered_ids = []
+        for file_id in self.iter_children(dir_file_id):
+            trans_id = self._transform.trans_id_file_id(file_id)
+            ordered_ids.append((trans_id, file_id))
+        for entry, trans_id in self._make_inv_entries(ordered_ids):
+            yield unicode(self._final_paths.get_path(trans_id)), entry
+
+    def list_files(self, include_root=False, from_dir=None, recursive=True):
+        """See WorkingTree.list_files."""
         # XXX This should behave like WorkingTree.list_files, but is really
         # more like RevisionTree.list_files.
-        for path, entry in self.iter_entries_by_dir():
-            if entry.name == '' and not include_root:
-                continue
-            yield path, 'V', entry.kind, entry.file_id, entry
+        if recursive:
+            prefix = None
+            if from_dir:
+                prefix = from_dir + '/'
+            entries = self.iter_entries_by_dir()
+            for path, entry in entries:
+                if entry.name == '' and not include_root:
+                    continue
+                if prefix:
+                    if not path.startswith(prefix):
+                        continue
+                    path = path[len(prefix):]
+                yield path, 'V', entry.kind, entry.file_id, entry
+        else:
+            if from_dir is None and include_root is True:
+                root_entry = inventory.make_entry('directory', '',
+                    ROOT_PARENT, self.get_root_id())
+                yield '', 'V', 'directory', root_entry.file_id, root_entry
+            entries = self._iter_entries_for_dir(from_dir or '')
+            for path, entry in entries:
+                yield path, 'V', entry.kind, entry.file_id, entry
 
     def kind(self, file_id):
         trans_id = self._transform.trans_id_file_id(file_id)

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2009-03-23 14:59:43 +0000
+++ bzrlib/transport/sftp.py	2009-06-10 03:56:49 +0000
@@ -711,6 +711,12 @@
             # strange but true, for the paramiko server.
             if (e.args == ('Failure',)):
                 raise failure_exc(path, str(e) + more_info)
+            # Can be something like args = ('Directory not empty:
+            # '/srv/bazaar.launchpad.net/blah...: '
+            # [Errno 39] Directory not empty',)
+            if (e.args[0].startswith('Directory not empty: ')
+                or getattr(e, 'errno', None) == errno.ENOTEMPTY):
+                raise errors.DirectoryNotEmpty(path, str(e))
             mutter('Raising exception with args %s', e.args)
         if getattr(e, 'errno', None) is not None:
             mutter('Raising exception with errno %s', e.errno)

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2009-04-24 15:49:33 +0000
+++ bzrlib/ui/__init__.py	2009-06-10 03:56:49 +0000
@@ -227,7 +227,7 @@
             prompt = prompt % kwargs
         prompt = prompt.encode(osutils.get_terminal_encoding(), 'replace')
         self.clear_term()
-        self.stdout.write(prompt)
+        self.stderr.write(prompt)
 
     def note(self, msg):
         """Write an already-formatted message."""

=== modified file 'bzrlib/ui/text.py'
--- bzrlib/ui/text.py	2009-04-10 19:37:20 +0000
+++ bzrlib/ui/text.py	2009-06-17 05:03:18 +0000
@@ -19,6 +19,7 @@
 """Text UI, write output to the console.
 """
 
+import os
 import sys
 import time
 import warnings
@@ -56,8 +57,8 @@
             symbol_versioning.warn(symbol_versioning.deprecated_in((1, 11, 0))
                 % "bar_type parameter")
         # paints progress, network activity, etc
-        self._progress_view = TextProgressView(self.stderr)
-
+        self._progress_view = self._make_progress_view()
+        
     def clear_term(self):
         """Prepare the terminal for output.
 
@@ -69,6 +70,12 @@
         # to clear it.  We might need to separately check for the case of
         self._progress_view.clear()
 
+    def _make_progress_view(self):
+        if os.environ.get('BZR_PROGRESS_BAR') in ('text', None, ''):
+            return TextProgressView(self.stderr)
+        else:
+            return NullProgressView()
+
     def note(self, msg):
         """Write an already-formatted message, clearing the progress bar if necessary."""
         self.clear_term()
@@ -80,7 +87,7 @@
         This may update a progress bar, spinner, or similar display.
         By default it does nothing.
         """
-        self._progress_view._show_transport_activity(transport,
+        self._progress_view.show_transport_activity(transport,
             direction, byte_count)
 
     def _progress_updated(self, task):
@@ -98,6 +105,19 @@
         self._progress_view.clear()
 
 
+class NullProgressView(object):
+    """Soak up and ignore progress information."""
+
+    def clear(self):
+        pass
+
+    def show_progress(self, task):
+        pass
+
+    def show_transport_activity(self, transport, direction, byte_count):
+        pass
+    
+
 class TextProgressView(object):
     """Display of progress bar and other information on a tty.
 
@@ -216,7 +236,7 @@
         self._last_repaint = now
         self._repaint()
 
-    def _show_transport_activity(self, transport, direction, byte_count):
+    def show_transport_activity(self, transport, direction, byte_count):
         """Called by transports via the ui_factory, as they do IO.
 
         This may update a progress bar, spinner, or similar display.

=== renamed file 'bzrlib/util/bencode.py' => 'bzrlib/util/_bencode_py.py'
--- bzrlib/util/bencode.py	2009-02-23 15:29:35 +0000
+++ bzrlib/util/_bencode_py.py	2009-06-10 03:56:49 +0000
@@ -86,6 +86,8 @@
         return (r, f + 1)
 
     def bdecode(self, x):
+        if type(x) != str:
+            raise TypeError
         try:
             r, l = self.decode_func[x[0]](x, 0)
         except (IndexError, KeyError):

=== added file 'bzrlib/util/bencode.py'
--- bzrlib/util/bencode.py	1970-01-01 00:00:00 +0000
+++ bzrlib/util/bencode.py	2009-06-09 14:18:41 +0000
@@ -0,0 +1,24 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+from bzrlib import symbol_versioning
+
+dep_warning = symbol_versioning.deprecated_in((1, 16, 0)) % (
+    'bzrlib.util.bencode',) + '\n  Use bzrlib.bencode instead'
+
+symbol_versioning.warn(dep_warning, DeprecationWarning)
+
+from bzrlib.bencode import *

=== removed file 'bzrlib/util/tests/test_bencode.py'
--- bzrlib/util/tests/test_bencode.py	2009-02-23 15:29:35 +0000
+++ bzrlib/util/tests/test_bencode.py	1970-01-01 00:00:00 +0000
@@ -1,234 +0,0 @@
-# bencode structured encoding
-#
-# Written by Petru Paler
-#
-# Permission is hereby granted, free of charge, to any person
-# obtaining a copy of this software and associated documentation files
-# (the "Software"), to deal in the Software without restriction,
-# including without limitation the rights to use, copy, modify, merge,
-# publish, distribute, sublicense, and/or sell copies of the Software,
-# and to permit persons to whom the Software is furnished to do so,
-# subject to the following conditions:
-#
-# The above copyright notice and this permission notice shall be
-# included in all copies or substantial portions of the Software.
-#
-# The Software is provided "AS IS", without warranty of any kind,
-# express or implied, including but not limited to the warranties of
-# merchantability,  fitness for a particular purpose and
-# noninfringement. In no event shall the  authors or copyright holders
-# be liable for any claim, damages or other liability, whether in an
-# action of contract, tort or otherwise, arising from, out of or in
-# connection with the Software or the use or other dealings in the
-# Software.
-
-
-from bzrlib.util.bencode import bencode, bdecode, bdecode_as_tuple, Bencached
-from bzrlib.tests import TestCase
-
-class TestBencode(TestCase):
-    # tests moved from within the bencode module so they're not run on every
-    # startup
-
-    def test_bdecode(self):
-        try:
-            bdecode('0:0:')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('ie')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('i341foo382e')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode('i4e') == 4L
-        assert bdecode('i0e') == 0L
-        assert bdecode('i123456789e') == 123456789L
-        assert bdecode('i-10e') == -10L
-        try:
-            bdecode('i-0e')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('i123')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('i6easd')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('35208734823ljdahflajhdf')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('2:abfdjslhfld')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode('0:') == ''
-        assert bdecode('3:abc') == 'abc'
-        assert bdecode('10:1234567890') == '1234567890'
-        try:
-            bdecode('02:xy')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('l')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode('le') == []
-        try:
-            bdecode('leanfdldjfh')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode('l0:0:0:e') == ['', '', '']
-        try:
-            bdecode('relwjhrlewjh')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode('li1ei2ei3ee') == [1, 2, 3]
-        assert bdecode('l3:asd2:xye') == ['asd', 'xy']
-        assert bdecode('ll5:Alice3:Bobeli2ei3eee') == [['Alice', 'Bob'], [2, 3]]
-        try:
-            bdecode('d')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('defoobar')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode('de') == {}
-        assert bdecode('d3:agei25e4:eyes4:bluee') == {'age': 25, 'eyes': 'blue'}
-        assert bdecode('d8:spam.mp3d6:author5:Alice6:lengthi100000eee') == {'spam.mp3': {'author': 'Alice', 'length': 100000}}
-        try:
-            bdecode('d3:fooe')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('di1e0:e')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('d1:b0:1:a0:e')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('d1:a0:1:a0:e')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('i03e')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('l01:ae')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('9999:x')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('l0:')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('d0:0:')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('d0:')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('00:')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('l-3:e')
-            assert 0
-        except ValueError:
-            pass
-        try:
-            bdecode('i-03e')
-            assert 0
-        except ValueError:
-            pass
-        bdecode('d0:i3ee')
-
-
-    def test_bdecode_as_tuple(self):
-        assert bdecode_as_tuple('le') == ()
-        try:
-            bdecode_as_tuple('leanfdldjfh')
-            assert 0
-        except ValueError:
-            pass
-        assert bdecode_as_tuple('l0:0:0:e') == ('', '', '')
-        assert bdecode_as_tuple('li1ei2ei3ee') == (1, 2, 3)
-        assert bdecode_as_tuple('l3:asd2:xye') == ('asd', 'xy')
-        assert bdecode_as_tuple('ll5:Alice3:Bobeli2ei3eee') == (('Alice', 'Bob'),
-                (2, 3))
-        try:
-            bdecode_as_tuple('l-3:e')
-            assert 0
-        except ValueError:
-            pass
-
-
-    def test_bencode(self):
-        assert bencode(4) == 'i4e'
-        assert bencode(0) == 'i0e'
-        assert bencode(-10) == 'i-10e'
-        assert bencode(12345678901234567890L) == 'i12345678901234567890e'
-        assert bencode('') == '0:'
-        assert bencode('abc') == '3:abc'
-        assert bencode('1234567890') == '10:1234567890'
-        assert bencode([]) == 'le'
-        assert bencode([1, 2, 3]) == 'li1ei2ei3ee'
-        assert bencode([['Alice', 'Bob'], [2, 3]]) == 'll5:Alice3:Bobeli2ei3eee'
-        assert bencode({}) == 'de'
-        assert bencode({'age': 25, 'eyes': 'blue'}) == 'd3:agei25e4:eyes4:bluee'
-        assert bencode({'spam.mp3': {'author': 'Alice', 'length': 100000}}) == 'd8:spam.mp3d6:author5:Alice6:lengthi100000eee'
-        assert bencode(Bencached(bencode(3))) == 'i3e'
-        assert bencode(True) == 'i1e'
-        assert bencode(False) == 'i0e'
-        try:
-            bencode({1: 'foo'})
-            assert 0
-        except TypeError:
-            pass
-
-

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2009-04-29 17:02:36 +0000
+++ bzrlib/versionedfile.py	2009-06-10 03:56:49 +0000
@@ -40,14 +40,14 @@
     revision,
     ui,
     )
-from bzrlib.graph import DictParentsProvider, Graph, _StackedParentsProvider
+from bzrlib.graph import DictParentsProvider, Graph, StackedParentsProvider
 from bzrlib.transport.memory import MemoryTransport
 """)
 from bzrlib.inter import InterObject
 from bzrlib.registry import Registry
 from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge
-from bzrlib.util import bencode
+from bzrlib import bencode
 
 
 adapter_registry = Registry()
@@ -1333,7 +1333,7 @@
             result[revision.NULL_REVISION] = ()
         self._providers = self._providers[:1] + self.fallback_versionedfiles
         result.update(
-            _StackedParentsProvider(self._providers).get_parent_map(keys))
+            StackedParentsProvider(self._providers).get_parent_map(keys))
         for key, parents in result.iteritems():
             if parents == ():
                 result[key] = (revision.NULL_REVISION,)

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2009-04-08 16:33:19 +0000
+++ bzrlib/weave.py	2009-06-10 03:56:49 +0000
@@ -1,6 +1,4 @@
-#! /usr/bin/python
-
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1025,6 +1023,7 @@
         wr._add(name, lines, [wr._lookup(i) for i in combined_parents[name]])
     return wr
 
+
 def _reweave_parent_graphs(wa, wb):
     """Return combined parent ancestry for two weaves.
 
@@ -1035,206 +1034,3 @@
             p = combined.setdefault(name, set())
             p.update(map(weave._idx_to_name, weave._parents[idx]))
     return combined
-
-
-def weave_toc(w):
-    """Show the weave's table-of-contents"""
-    print '%6s %50s %10s %10s' % ('ver', 'name', 'sha1', 'parents')
-    for i in (6, 50, 10, 10):
-        print '-' * i,
-    print
-    for i in range(w.num_versions()):
-        sha1 = w._sha1s[i]
-        name = w._names[i]
-        parent_str = ' '.join(map(str, w._parents[i]))
-        print '%6d %-50.50s %10.10s %s' % (i, name, sha1, parent_str)
-
-
-
-def weave_stats(weave_file, pb):
-    from bzrlib.weavefile import read_weave
-
-    wf = file(weave_file, 'rb')
-    w = read_weave(wf)
-    # FIXME: doesn't work on pipes
-    weave_size = wf.tell()
-
-    total = 0
-    vers = len(w)
-    for i in range(vers):
-        pb.update('checking sizes', i, vers)
-        for origin, lineno, line in w._extract([i]):
-            total += len(line)
-
-    pb.clear()
-
-    print 'versions          %9d' % vers
-    print 'weave file        %9d bytes' % weave_size
-    print 'total contents    %9d bytes' % total
-    print 'compression ratio %9.2fx' % (float(total) / float(weave_size))
-    if vers:
-        avg = total/vers
-        print 'average size      %9d bytes' % avg
-        print 'relative size     %9.2fx' % (float(weave_size) / float(avg))
-
-
-def usage():
-    print """bzr weave tool
-
-Experimental tool for weave algorithm.
-
-usage:
-    weave init WEAVEFILE
-        Create an empty weave file
-    weave get WEAVEFILE VERSION
-        Write out specified version.
-    weave check WEAVEFILE
-        Check consistency of all versions.
-    weave toc WEAVEFILE
-        Display table of contents.
-    weave add WEAVEFILE NAME [BASE...] < NEWTEXT
-        Add NEWTEXT, with specified parent versions.
-    weave annotate WEAVEFILE VERSION
-        Display origin of each line.
-    weave merge WEAVEFILE VERSION1 VERSION2 > OUT
-        Auto-merge two versions and display conflicts.
-    weave diff WEAVEFILE VERSION1 VERSION2
-        Show differences between two versions.
-
-example:
-
-    % weave init foo.weave
-    % vi foo.txt
-    % weave add foo.weave ver0 < foo.txt
-    added version 0
-
-    (create updated version)
-    % vi foo.txt
-    % weave get foo.weave 0 | diff -u - foo.txt
-    % weave add foo.weave ver1 0 < foo.txt
-    added version 1
-
-    % weave get foo.weave 0 > foo.txt       (create forked version)
-    % vi foo.txt
-    % weave add foo.weave ver2 0 < foo.txt
-    added version 2
-
-    % weave merge foo.weave 1 2 > foo.txt   (merge them)
-    % vi foo.txt                            (resolve conflicts)
-    % weave add foo.weave merged 1 2 < foo.txt     (commit merged version)
-
-"""
-
-
-
-def main(argv):
-    import sys
-    import os
-    try:
-        import bzrlib
-    except ImportError:
-        # in case we're run directly from the subdirectory
-        sys.path.append('..')
-        import bzrlib
-    from bzrlib.weavefile import write_weave, read_weave
-    from bzrlib.progress import ProgressBar
-
-    try:
-        import psyco
-        psyco.full()
-    except ImportError:
-        pass
-
-    if len(argv) < 2:
-        usage()
-        return 0
-
-    cmd = argv[1]
-
-    def readit():
-        return read_weave(file(argv[2], 'rb'))
-
-    if cmd == 'help':
-        usage()
-    elif cmd == 'add':
-        w = readit()
-        # at the moment, based on everything in the file
-        name = argv[3]
-        parents = map(int, argv[4:])
-        lines = sys.stdin.readlines()
-        ver = w.add(name, parents, lines)
-        write_weave(w, file(argv[2], 'wb'))
-        print 'added version %r %d' % (name, ver)
-    elif cmd == 'init':
-        fn = argv[2]
-        if os.path.exists(fn):
-            raise IOError("file exists")
-        w = Weave()
-        write_weave(w, file(fn, 'wb'))
-    elif cmd == 'get': # get one version
-        w = readit()
-        sys.stdout.writelines(w.get_iter(int(argv[3])))
-
-    elif cmd == 'diff':
-        w = readit()
-        fn = argv[2]
-        v1, v2 = map(int, argv[3:5])
-        lines1 = w.get(v1)
-        lines2 = w.get(v2)
-        diff_gen = bzrlib.patiencediff.unified_diff(lines1, lines2,
-                                '%s version %d' % (fn, v1),
-                                '%s version %d' % (fn, v2))
-        sys.stdout.writelines(diff_gen)
-
-    elif cmd == 'annotate':
-        w = readit()
-        # newline is added to all lines regardless; too hard to get
-        # reasonable formatting otherwise
-        lasto = None
-        for origin, text in w.annotate(int(argv[3])):
-            text = text.rstrip('\r\n')
-            if origin == lasto:
-                print '      | %s' % (text)
-            else:
-                print '%5d | %s' % (origin, text)
-                lasto = origin
-
-    elif cmd == 'toc':
-        weave_toc(readit())
-
-    elif cmd == 'stats':
-        weave_stats(argv[2], ProgressBar())
-
-    elif cmd == 'check':
-        w = readit()
-        pb = ProgressBar()
-        w.check(pb)
-        pb.clear()
-        print '%d versions ok' % w.num_versions()
-
-    elif cmd == 'inclusions':
-        w = readit()
-        print ' '.join(map(str, w.inclusions([int(argv[3])])))
-
-    elif cmd == 'parents':
-        w = readit()
-        print ' '.join(map(str, w._parents[int(argv[3])]))
-
-    elif cmd == 'plan-merge':
-        # replaced by 'bzr weave-plan-merge'
-        w = readit()
-        for state, line in w.plan_merge(int(argv[3]), int(argv[4])):
-            if line:
-                print '%14s | %s' % (state, line),
-    elif cmd == 'merge':
-        # replaced by 'bzr weave-merge-text'
-        w = readit()
-        p = w.plan_merge(int(argv[3]), int(argv[4]))
-        sys.stdout.writelines(w.weave_merge(p))
-    else:
-        raise ValueError('unknown command %r' % cmd)
-
-
-if __name__ == '__main__':
-    import sys
-    sys.exit(main(sys.argv))

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2009-05-23 04:55:52 +0000
+++ bzrlib/win32utils.py	2009-06-10 06:25:56 +0000
@@ -267,7 +267,7 @@
 
     Returned value can be unicode or plain string.
     To convert plain string to unicode use
-    s.decode(bzrlib.user_encoding)
+    s.decode(osutils.get_user_encoding())
     (XXX - but see bug 262874, which asserts the correct encoding is 'mbcs')
     """
     local = _get_sh_special_folder_path(CSIDL_LOCAL_APPDATA)

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2009-05-21 12:16:23 +0000
+++ bzrlib/workingtree.py	2009-06-17 03:41:33 +0000
@@ -451,7 +451,7 @@
             path = self.id2path(file_id)
         file_obj = self.get_file_byname(path, filtered=False)
         stat_value = _fstat(file_obj.fileno())
-        if self.supports_content_filtering() and filtered:
+        if filtered and self.supports_content_filtering():
             filters = self._content_filter_stack(path)
             file_obj = filtered_input_file(file_obj, filters)
         return (file_obj, stat_value)
@@ -462,7 +462,7 @@
     def get_file_byname(self, filename, filtered=True):
         path = self.abspath(filename)
         f = file(path, 'rb')
-        if self.supports_content_filtering() and filtered:
+        if filtered and self.supports_content_filtering():
             filters = self._content_filter_stack(filename)
             return filtered_input_file(f, filters)
         else:
@@ -1115,15 +1115,16 @@
     def _kind(self, relpath):
         return osutils.file_kind(self.abspath(relpath))
 
-    def list_files(self, include_root=False):
-        """Recursively list all files as (path, class, kind, id, entry).
+    def list_files(self, include_root=False, from_dir=None, recursive=True):
+        """List all files as (path, class, kind, id, entry).
 
         Lists, but does not descend into unversioned directories.
-
         This does not include files that have been deleted in this
-        tree.
+        tree. Skips the control directory.
 
-        Skips the control directory.
+        :param include_root: if True, do not return an entry for the root
+        :param from_dir: start from this directory or None for the root
+        :param recursive: whether to recurse into subdirectories or not
         """
         # list_files is an iterator, so @needs_read_lock doesn't work properly
         # with it. So callers should be careful to always read_lock the tree.
@@ -1131,7 +1132,7 @@
             raise errors.ObjectNotLocked(self)
 
         inv = self.inventory
-        if include_root is True:
+        if from_dir is None and include_root is True:
             yield ('', 'V', 'directory', inv.root.file_id, inv.root)
         # Convert these into local objects to save lookup times
         pathjoin = osutils.pathjoin
@@ -1144,13 +1145,22 @@
         fk_entries = {'directory':TreeDirectory, 'file':TreeFile, 'symlink':TreeLink}
 
         # directory file_id, relative path, absolute path, reverse sorted children
-        children = os.listdir(self.basedir)
+        if from_dir is not None:
+            from_dir_id = inv.path2id(from_dir)
+            if from_dir_id is None:
+                # Directory not versioned
+                return
+            from_dir_abspath = pathjoin(self.basedir, from_dir)
+        else:
+            from_dir_id = inv.root.file_id
+            from_dir_abspath = self.basedir
+        children = os.listdir(from_dir_abspath)
         children.sort()
         # jam 20060527 The kernel sized tree seems equivalent whether we
         # use a deque and popleft to keep them sorted, or if we use a plain
         # list and just reverse() them.
         children = collections.deque(children)
-        stack = [(inv.root.file_id, u'', self.basedir, children)]
+        stack = [(from_dir_id, u'', from_dir_abspath, children)]
         while stack:
             from_dir_id, from_dir_relpath, from_dir_abspath, children = stack[-1]
 
@@ -1214,14 +1224,15 @@
                 if fk != 'directory':
                     continue
 
-                # But do this child first
-                new_children = os.listdir(fap)
-                new_children.sort()
-                new_children = collections.deque(new_children)
-                stack.append((f_ie.file_id, fp, fap, new_children))
-                # Break out of inner loop,
-                # so that we start outer loop with child
-                break
+                # But do this child first if recursing down
+                if recursive:
+                    new_children = os.listdir(fap)
+                    new_children.sort()
+                    new_children = collections.deque(new_children)
+                    stack.append((f_ie.file_id, fp, fap, new_children))
+                    # Break out of inner loop,
+                    # so that we start outer loop with child
+                    break
             else:
                 # if we finished all children, pop it off the stack
                 stack.pop()

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2009-05-28 13:46:52 +0000
+++ bzrlib/workingtree_4.py	2009-06-17 03:41:33 +0000
@@ -1440,13 +1440,20 @@
                 # Note: do NOT move this logic up higher - using the basis from
                 # the accelerator tree is still desirable because that can save
                 # a minute or more of processing on large trees!
+                # The original tree may not have the same content filters
+                # applied so we can't safely build the inventory delta from
+                # the source tree.
                 if wt.supports_content_filtering():
                     accelerator_tree = None
+                    delta_from_tree = False
+                else:
+                    delta_from_tree = True
                 # delta_from_tree is safe even for DirStateRevisionTrees,
                 # because wt4.apply_inventory_delta does not mutate the input
                 # inventory entries.
                 transform.build_tree(basis, wt, accelerator_tree,
-                                     hardlink=hardlink, delta_from_tree=True)
+                                     hardlink=hardlink,
+                                     delta_from_tree=delta_from_tree)
             finally:
                 basis.unlock()
         finally:
@@ -1837,12 +1844,19 @@
             return None
         return ie.executable
 
-    def list_files(self, include_root=False):
+    def list_files(self, include_root=False, from_dir=None, recursive=True):
         # We use a standard implementation, because DirStateRevisionTree is
         # dealing with one of the parents of the current state
         inv = self._get_inventory()
-        entries = inv.iter_entries()
-        if self.inventory.root is not None and not include_root:
+        if from_dir is None:
+            from_dir_id = None
+        else:
+            from_dir_id = inv.path2id(from_dir)
+            if from_dir_id is None:
+                # Directory not versioned
+                return
+        entries = inv.iter_entries(from_dir=from_dir_id, recursive=recursive)
+        if inv.root is not None and not include_root and from_dir is None:
             entries.next()
         for path, entry in entries:
             yield path, 'V', entry.kind, entry.file_id, entry

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2009-04-02 15:28:11 +0000
+++ bzrlib/xml4.py	2009-06-09 00:59:51 +0000
@@ -19,6 +19,7 @@
     ElementTree,
     SubElement,
     XMLSerializer,
+    escape_invalid_chars,
     )
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
@@ -125,7 +126,7 @@
         root.text = '\n'
 
         msg = SubElement(root, 'message')
-        msg.text = rev.message
+        msg.text = escape_invalid_chars(rev.message)[0]
         msg.tail = '\n'
 
         if rev.parents:

=== modified file 'bzrlib/xml8.py'
--- bzrlib/xml8.py	2009-04-08 20:21:06 +0000
+++ bzrlib/xml8.py	2009-06-09 00:59:51 +0000
@@ -28,6 +28,7 @@
     Element,
     SubElement,
     XMLSerializer,
+    escape_invalid_chars,
     )
 from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 from bzrlib.revision import Revision
@@ -345,7 +346,7 @@
             root.set('timezone', str(rev.timezone))
         root.text = '\n'
         msg = SubElement(root, 'message')
-        msg.text = rev.message
+        msg.text = escape_invalid_chars(rev.message)[0]
         msg.tail = '\n'
         if rev.parent_ids:
             pelts = SubElement(root, 'parents')

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2009-05-12 23:05:21 +0000
+++ bzrlib/xml_serializer.py	2009-06-09 00:59:51 +0000
@@ -52,6 +52,8 @@
 class XMLSerializer(Serializer):
     """Abstract XML object serialize/deserialize"""
 
+    squashes_xml_invalid_characters = True
+
     def read_inventory_from_string(self, xml_string, revision_id=None,
                                    entry_cache=None):
         """Read xml_string into an inventory object.
@@ -174,6 +176,8 @@
     :param message: Commit message to escape
     :return: tuple with escaped message and number of characters escaped
     """
+    if message is None:
+        return None, 0
     # Python strings can include characters that can't be
     # represented in well-formed XML; escape characters that
     # aren't listed in the XML specification

=== added file 'doc/developers/bug-handling.txt'
--- doc/developers/bug-handling.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/bug-handling.txt	2009-06-15 08:30:12 +0000
@@ -0,0 +1,298 @@
+***********************
+Tracking Bugs in Bazaar
+***********************
+
+This document describes the bug-tracking processes for developing Bazaar
+itself.  Bugs in Bazaar are recorded in Launchpad.
+
+
+See also:
+
+* `Bazaar Developer Documents <index.html>`_.
+
+* `The Bazaar Development Cycle <cycle.html>`_.
+
+* `The Bazaar User Guide <../en/user-guide/index.html>`_ -- for
+  information on integrating Bazaar with other bug trackers.
+
+
+Links
+*****
+
+* `bzr bugs home page <https://bugs.edge.launchpad.net/bzr>`_.
+
+* `Critical bugs <https://bugs.edge.launchpad.net/bzr/+bugs?search=Search&field.importance=Critical&field.status=New&field.status=Incomplete&field.status=Confirmed&field.status=Triaged&field.status=In+Progress&field.status=Fix+Committed>`_.
+
+* `Open bugs by importance <https://bugs.edge.launchpad.net/bzr/+bugs>`_.
+
+* `Open bugs most recently changed first
+  <https://bugs.edge.launchpad.net/bzr/+bugs?field.searchtext=&orderby=-date_last_updated&search=Search&field.status%3Alist=NEW&field.status%3Alist=INCOMPLETE_WITH_RESPONSE&field.status%3Alist=INCOMPLETE_WITHOUT_RESPONSE&field.status%3Alist=CONFIRMED&field.status%3Alist=TRIAGED&field.status%3Alist=INPROGRESS&field.status%3Alist=FIXCOMMITTED&field.assignee=&field.bug_reporter=&field.omit_dupes=on&field.has_patch=&field.has_no_package=>`_.
+
+
+Generalities
+************
+
+Anyone involved with Bazaar is welcome to contribute to managing our bug
+reports.  **Edit boldly**: try to help users out, assess importance or improve
+the bug description or status.  Other people will see the bugs: it's
+better to have 20 of them processed and later change the status of a
+couple than to leave them lie.
+
+When you file a bug as a Bazaar developer or active user, if you feel
+confident in doing so, make an assessment of status and importance at the
+time you file it, rather than leaving it for someone else.  It's more
+efficient to change the importance if someone else feel's it's higher or
+lower, than to have someone else edit all bugs.
+
+It's more useful to actually ship bug fixes than to garden the bug
+database.  It's more useful to take one bug through to a shipped fix than
+to partially investigate ten bugs.  You don't get credit for a bug until
+the fix is shipped in a release.  Users like getting a response to their
+report, but they generally care more about getting bugs fixed.
+
+The aim of investigating bugs before starting concentrated work on them is
+therefore only to: 
+
+* determine if they are critical or high priority (and
+  should displace existing work)
+
+* garden sufficiently to keep the database usable: meaningful summaries,
+  and duplicates removed
+
+It's OK to fix some bugs that just annoy you, even if they're not
+rationally high.
+
+You can use ``--fixes lp:12345678`` when committing to associate the
+commit with a particular bug.
+
+If there are multiple bugs with related fixes, putting "[master]" in the
+title of one of them helps find it
+
+It's often fastest to find bugs just using the regular Google search
+engine, rather than Launchpad's search.
+
+Martin Pitt says:
+
+ | One of the things you should not do often is to start asking
+ | questions/for more debug info and then forget about the bug. It's just
+ | a waste of the reporter's and your time, and will create frustration
+ | on the reporter side. 
+
+
+Priorities
+**********
+
+The suggested priorities for bug work are:
+
+1. Fix critical bugs.
+   
+2. Get existing fixes through review and landed.
+
+3. Fix bugs that are already in progress.
+
+4. Look at bugs already assigned to you, and either start them, or change
+   your mind and unassign them.
+
+5. Take new bugs from the top of the stack.
+
+6. Triage new bugs.
+
+It's not strict and of course there is personal discretion but our work
+should be biased to the top of this hierarchy.
+
+
+Clear Bugs
+**********
+
+Bugs should have clear edges, so that you can make a clear statement about
+whether a bug is fixed or not.  (Sometimes reality is complicated, but aim
+for each bug to be clear.)
+
+Bugs on documentation, performance, or UI are fine as long as they're
+clear bugs.
+
+Examples of good bugs:
+
+* "ValueError in frob_foo when committing changed symlink" - although
+  there may be many possible things that could cause a ValueError there,
+  you should at least know when you've fixed the problem described in this
+  bug.
+
+* "Unclear message about incompatible repositories" - even though the user
+  may not agree the new message is sufficiently clear, at least you know
+  when you've tried to fix it.
+
+Examples of bad bugs:
+
+* "Commit is too slow" - how fast is fast enough to close it?  "Commit
+  reads the working tree twice" is clearer.
+
+
+Bug Status
+**********
+
+New
+    The bug has just been filed and hasn't been examined by a developer
+    yet.
+Incomplete
+    The bug requires more information from the reporter to make progress.
+Confirmed
+    The bug report has been seen by a developer and we agree it's a bug.  
+    You don't have to reproduce the bug to mark it confirmed.  (Generally
+    it's not a good idea for a developer to spend time reproducing the bug
+    until they're going to work on it.)
+Triaged
+    We don't use this status.  If it is set, it means the same as
+    Confirmed.
+In Progress
+    Someone has started working on this.
+Won't Fix
+    The behaviour complained about is intentional and we won't fix it.
+    Needless to say, be thoughtful before using this status, and consider if
+    the user experience can be improved in some other way.
+Invalid
+    The reporter was confused, and this is not actually a bug.
+    Again, be sensitive in explaining this to the user.
+Fix Committed
+    A fix for this bug exists in a branch somewhere.  Ideally the bug will
+    be linked to the branch.
+Fix Released
+    The fix for this bug is now in the bzr trunk.  It's not necessarily
+    true that it's released yet, but it will be in the next release.  The
+    bug target milestone should be set to the release it went into, but
+    don't spend too much time updating this if you don't immediately know.
+
+
+Bug Importance
+**************
+
+Critical
+    This is a serious bug that could cause data loss, stop bzr being
+    usable in an important case, or represents a regression in something
+    previously working.  We should fix critical bugs before doing other
+    work, or seriously consider whether the bug is really critical
+    or whether the other change is more urgent.
+High
+    This is a bug that can seriously interfere with people's use of
+    Bazaar.  We should seriously consider fixing these bugs before
+    working on new features.
+Medium
+    A regular bug.  We'd like to fix them, but there may be a long delay.
+Low
+    Something suboptimal that may affect an unimportant case or have a
+    fairly easy workaround.
+Wishlist
+    These will basically never get done.
+
+Bugs rated Medium or lower are unlikely to get fixed unless they either
+pique the interest of a developer or are escalated due eg to many users
+being affected.
+
+Not every existing bug is correctly rated according to this scale, and we
+don't always follow this process, but we'd like to do it more.  But
+remember, fixing bugs is more helpful than gardening them.
+
+
+Assignment
+**********
+
+Assigning a bug to yourself, or someone else, indicates a real intention
+to work on that bug soon.
+
+
+Targetting Bugs
+***************
+
+It's possible to target a bug to a milestone, eg
+<https://bugs.edge.launchpad.net/bzr/+milestone/1.16>.  We use this mostly
+to help the release manager know what **must** be merged to make the
+release.
+
+Therefore, we don't target bugs that we'd like to have fixed or that could
+be fixed in a particular release, we only target bugs that must be fixed
+and that will or might cause us to decide to slip the release if they're
+not fixed.  At any time, very few if any of the bugs targetted to a
+release should be still open.  By definition, these bugs should normally
+be Critical priority.
+
+
+Backports
+*********
+
+Sometimes we'll want to make a special point-release update (eg 1.15.1)
+off an already-released branch including a fix for a particular bug.  To
+represent this, create a new bug task (ie link in the status table on the
+bug page) by clicking the `poorly-named
+<https://bugs.launchpad.net/bugs/132733>`_ "Target to Release" link.
+Target it to the appropriate series (ie 1.15) and then to the milestone
+within that release.  
+
+This bug task then has a separate status and importance to indicate the
+separate work to get it into that release.
+
+
+The News File
+*************
+
+Most bugs that are fixed should be mentioned in a `NEWS
+<../en/release-notes/NEWS.html>`_ file entry,
+including the bug number.
+(Exceptions might be bugs that are not at all user visible.)
+
+
+Tags
+****
+
+Here are some bug tags we use.  In Malone tags are currently of limited use, so don't feel obliged to tag bugs unless you're finding it useful.
+
+
+authentication
+    authenticating to servers
+
+backport 
+    candidate for backporting to an update of the previous release
+
+dirstate 
+    WorkingTree4
+
+easy 
+    should be possible to finish in an hour or two
+
+hpss 
+    bugs about the High-Performance Smart Server, i.e. bzr+ssh://, etc.
+
+launchpad 
+    bugs about interactions with launchpad (typically this means bzrlib.plugins.launchpad).
+
+locale 
+    problems using locales other than English
+
+memory 
+    problems where we use too much memory for some reason
+
+newformat 
+    fixing this would need a new disk format
+
+performance 
+    bugs about performance problems.
+
+test 
+    needs changes to the test framework
+
+transport 
+    virtual filesystem for http, sftp, etc
+
+trivial 
+    should be very easy to fix (10-20 minutes) and easily landed: typically just spelling errors and the like
+
+ui 
+    bugs relating to the bzr user interface, e.g. confusing error messages.
+
+win32 
+    bugs that mainly affects Windows. Also there is cygwin and win98 tags for marking specific bugs. 
+
+You can see the full list of tags in use at
+<https://bugs.edge.launchpad.net/bzr/+bugs>.  As of September 2008 the
+list is on the right. 
+
+.. vim: ft=rst

=== modified file 'doc/developers/cycle.txt'
--- doc/developers/cycle.txt	2008-10-17 08:05:03 +0000
+++ doc/developers/cycle.txt	2009-06-15 07:22:59 +0000
@@ -1,9 +1,32 @@
+============================
 The Bazaar Development Cycle
 ============================
 
 
-
-General process
+Overview
+--------
+
+Bazaar makes a release every four weeks, with one release candidate one
+week before the final release.  We may vary this schedule from time to
+time, amongst other things to respond to bugs reported in the release
+candidate or the final release.  Nevertheless, we value a regular release
+and we will normally slip only for serious bugs or regressions.
+
+See also:
+
+* `Bazaar Developer Document Catalog <index.html>`_
+
+* `Releasing Bazaar <releasing.html>`_ -- the process for actually making 
+  a release or release candidate.
+
+Longer-Term Planning
+--------------------
+
+Work spanning multiple releases is typically tracked in the bug tracker,
+and summarized in <http://bazaar-vcs.org/Roadmap>.
+
+
+General Process
 ---------------
 
 We normally have one person acting as the release manager, who 
@@ -93,13 +116,6 @@
    <releasing.html>`_ as the first RC.
 
 
-See also
---------
-
-* `Bazaar Developer Document Catalog <index.html>`_
-
-* `Releasing Bazaar <releasing.html>`_ -- the process for actually making 
-  a release or release candidate.
 
 
 ..

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2009-04-03 01:34:58 +0000
+++ doc/developers/index.txt	2009-06-15 07:22:59 +0000
@@ -49,6 +49,9 @@
 * `EC2 resources <ec2.html>`_ |--| A team resource for 
   Windows packaging and testing, and Ubuntu testing.
 
+* `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug 
+  tracker.
+
 Plans
 =====
 

=== removed file 'doc/developers/performance-contributing.txt'
--- doc/developers/performance-contributing.txt	2009-03-25 15:45:02 +0000
+++ doc/developers/performance-contributing.txt	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-Contributing to the performance drive
-=====================================
-
-.. contents:: :local:
-
-What needs doing?
------------------
-
-There is plenty of code to write. Testers are always welcome for experimental
-changes. In general, from the `Performance Tasks`_ graph, pick a BLUE node that has nothing
-pointing at it that is also BLUE, and start working on that.
-
-Ad-hoc performance work can also be done. One useful tool is the 'evil' debug
-flag. For instance running ``bzr -Devil commit -m "test"`` will log a backtrace
-to the bzr log file for every method call which triggers a slow or non-scalable
-part of the bzr library. So checking that a given command with ``-Devil`` has
-no backtraces logged to the log file is a good way to find problem function
-calls that might be nested deep in the code base.
-
-Status
-------
-
-The performance drive is well under way. At the moment we are finalising the
-analysis documents from the sprint at London. If you were not at that sprint,
-please read the analysis documents - consider them living documents much like
-code, to be patched and corrected.
-
-If you were at the London performance sprint, please help finish documenting
-the core command analysis work. The core commands that have not been analysed
-are listed in `Performance Tasks`_ as the BLUE nodes. For quick reference:
-
-* status
-* log
-* diff
-* uncommit
-* missing
-* update
-* cbranch
-
-Once a given command has had its analysis created, the bottleneck of 'folk who
-attended London' is removed. The next task is in general the creation of a
-targeted API stack for that command. This API stack is done by starting with
-the cmd object in ``builtins.py`` and cleaning up the code so that the API used
-there is one which allows an implementation matching the analysis document.
-This then gets repeated, iteratively, on each of the called API's, until all
-the current slow code is cleanly abstracted behind the ``Tree``, ``Branch`` and
-``Repository`` API's.
-
-Resources
----------
-
-The usual resources for contributing to bzr - the mailing list, wiki, bug
-tracker and IRC channels are documented in the `Bazaar Developer Guide`_. Additionally
-there are members of the project focusing on performance at the moment who are
-willing to mentor contributors on performance issues. Just send a mail to the
-list asking for mentoring on the step of the performance plan you want to help
-with.
-
-.. _`Bazaar Developer Guide`: ../en/developer-guide/HACKING.html
-.. _`Performance Tasks`: performance.png

=== modified file 'doc/developers/performance-roadmap.txt'
--- doc/developers/performance-roadmap.txt	2007-09-03 09:10:13 +0000
+++ doc/developers/performance-roadmap.txt	2009-06-10 05:00:47 +0000
@@ -18,8 +18,6 @@
 
 .. include:: planned-performance-changes.txt
 
-.. include:: performance-contributing.txt
-
 .. include:: planned-change-integration.txt
 
 Analysis of use cases

=== modified file 'doc/developers/planned-change-integration.txt'
--- doc/developers/planned-change-integration.txt	2009-03-20 02:25:19 +0000
+++ doc/developers/planned-change-integration.txt	2009-06-10 05:03:42 +0000
@@ -11,14 +11,16 @@
 integrate because we will often need to alter apis throughout the code base to
 expose the increased or reduced model of the preferred disk format.
 
-`Performance Tasks`_, which is generated from the Graphviz "dot" file ``performance.dot``, graphs out the dependencies to let us make
-accurate assessments of the changes needed in terms of code and API, hopefully
-minimising the number of different integration steps we have to take, while
-giving us a broad surface area for development. It's based on a summary in the
-next section of this document of the planned changes with their expected
-collaborators and dependencies. Where a command is listed, the expectation is
-that all uses of that command - local, remote, dumb transport and smart
-transport are being addressed together.
+You can generate a graph ``performance.png`` in the source tree from
+Graphviz "dot" file ``performance.dot``.  This graphs out the dependencies
+to let us make accurate assessments of the changes needed in terms of code
+and API, hopefully minimising the number of different integration steps we
+have to take, while giving us a broad surface area for development. It's
+based on a summary in the next section of this document of the planned
+changes with their expected collaborators and dependencies. Where a
+command is listed, the expectation is that all uses of that command -
+local, remote, dumb transport and smart transport are being addressed
+together.
 
 
 The following provides a summary of the planned changes and their expected
@@ -139,5 +141,3 @@
    data, making only explicit uses of it visible, and isolating the impact of
    removing it : allowing us to experiment sensibly. This covers both dropping
    the per-file merge graph and the hash-based-names proposals.
-
-.. _`Performance Tasks`: performance.png

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2009-03-25 16:44:45 +0000
+++ doc/developers/releasing.txt	2009-06-15 22:35:00 +0000
@@ -158,23 +158,26 @@
    ``Reply-To: bazaar@lists.canonical.com``, so that people who reply to
    the announcement don't spam other lists.
 
-   The announce mail will look something like this:
+   The announce mail will look something like this::
    
-    | Subject: bzr x.yy released!
-    | 
-    | <<Summary paragraph from news>>
-    |
-    | The Bazaar team is happy to announce availability of a new 
-    | release of the bzr adaptive version control system.
-    |
-    | Thanks to everyone who contributed patches, suggestions, and
-    | feedback.
-    | 
-    | Bazaar is now available for download from 
-    | http://bazaar-vcs.org/Download as a source tarball; packages 
-    | for various systems will be available soon.
-    | 
-    | <<NEWS section from this release back to the last major release>>
+      Subject: bzr x.yy released!
+      
+      <<Summary paragraph from news>>
+     
+      The Bazaar team is happy to announce availability of a new 
+      release of the bzr adaptive version control system.
+      Bazaar is part of the GNU system <http://gnu.org/>.
+     
+      Thanks to everyone who contributed patches, suggestions, and
+      feedback.
+      
+      Bazaar is now available for download from 
+      http://bazaar-vcs.org/Download as a source tarball; packages 
+      for various systems will be available soon.
+      
+      <<NEWS section from this release back to the last major release>>
+
+   Feel free to tweak this to your taste.
 
 #. Make an announcement through <https://launchpad.net/bzr/+announce>
 

=== modified file 'doc/en/developer-guide/HACKING.txt'
--- doc/en/developer-guide/HACKING.txt	2009-05-05 07:17:43 +0000
+++ doc/en/developer-guide/HACKING.txt	2009-06-15 07:22:34 +0000
@@ -46,6 +46,15 @@
 If nothing else, perhaps you'll find inspiration in how other developers
 have solved their challenges.
 
+Finding Something To Do
+=======================
+
+Ad-hoc performance work can also be done. One useful tool is the 'evil' debug
+flag. For instance running ``bzr -Devil commit -m "test"`` will log a backtrace
+to the bzr log file for every method call which triggers a slow or non-scalable
+part of the bzr library. So checking that a given command with ``-Devil`` has
+no backtraces logged to the log file is a good way to find problem function
+calls that might be nested deep in the code base.
 
 Planning and Discussing Changes
 ===============================
@@ -1549,16 +1558,6 @@
 Planning Releases
 =================
 
-Roadmaps
---------
-
-As the two senior developers, Martin Pool and Robert Collins coordinate
-the overall Bazaar product development roadmap. Core developers provide
-input and review into this, particularly during sprints. It's totally
-expected that community members ought to be working on things that
-interest them the most. The roadmap is valuable though because it provides
-context for understanding where the product is going as a whole and why.
-
 
 Using Releases and Milestones in Launchpad
 ------------------------------------------

=== modified file 'doc/en/quick-reference/Makefile'
--- doc/en/quick-reference/Makefile	2007-08-13 14:33:10 +0000
+++ doc/en/quick-reference/Makefile	2009-06-10 09:19:20 +0000
@@ -1,3 +1,7 @@
+# If you feel the need to duplicate this file, you'll win the right to refactor
+# doc/*/quick-reference/Makefile and update TARGETS and OBJECTS usages in
+# doc/Makefile
+
 TARGETS=quick-start-summary.png quick-start-summary.pdf
 OBJECTS=quick-start-summary.svg Makefile
 

=== modified file 'doc/en/quick-reference/quick-start-summary.png'
Binary files doc/en/quick-reference/quick-start-summary.png and doc/en/quick-reference/quick-start-summary.png differ
=== modified file 'doc/en/tutorials/using_bazaar_with_launchpad.txt'
--- doc/en/tutorials/using_bazaar_with_launchpad.txt	2009-04-04 02:50:01 +0000
+++ doc/en/tutorials/using_bazaar_with_launchpad.txt	2009-05-31 11:46:02 +0000
@@ -386,7 +386,7 @@
 Code review tracking
 --------------------
 
-A number of feature are under development in Launchpad to track the
+A number of features are under development in Launchpad to track the
 states, conversations and outcomes of code reviews. These features are
 expected to be integrated with branch merge proposals and branch
 browsing features.

=== modified file 'doc/en/user-guide/images/workflows_centralized.png'
Binary files doc/en/user-guide/images/workflows_centralized.png and doc/en/user-guide/images/workflows_centralized.png differ
=== modified file 'doc/en/user-guide/images/workflows_gatekeeper.png'
Binary files doc/en/user-guide/images/workflows_gatekeeper.png and doc/en/user-guide/images/workflows_gatekeeper.png differ
=== modified file 'doc/en/user-guide/images/workflows_localcommit.png'
Binary files doc/en/user-guide/images/workflows_localcommit.png and doc/en/user-guide/images/workflows_localcommit.png differ
=== modified file 'doc/en/user-guide/images/workflows_peer.png'
Binary files doc/en/user-guide/images/workflows_peer.png and doc/en/user-guide/images/workflows_peer.png differ
=== modified file 'doc/en/user-guide/images/workflows_pqm.png'
Binary files doc/en/user-guide/images/workflows_pqm.png and doc/en/user-guide/images/workflows_pqm.png differ
=== modified file 'doc/en/user-guide/images/workflows_shared.png'
Binary files doc/en/user-guide/images/workflows_shared.png and doc/en/user-guide/images/workflows_shared.png differ
=== modified file 'doc/en/user-guide/images/workflows_single.png'
Binary files doc/en/user-guide/images/workflows_single.png and doc/en/user-guide/images/workflows_single.png differ
=== modified file 'doc/en/user-guide/introducing_bazaar.txt'
--- doc/en/user-guide/introducing_bazaar.txt	2008-05-09 06:52:35 +0000
+++ doc/en/user-guide/introducing_bazaar.txt	2009-06-01 22:45:06 +0000
@@ -123,7 +123,7 @@
 functionality is understood. This material can be read when required and in
 any order.
 
-If you are already familar with other version control tools,
+If you are already familiar with other version control tools,
 you may wish to get started quickly by reading the following documents:
 
  * `Bazaar in five minutes`_ - a mini-tutorial

=== added file 'doc/index.ru.txt'
--- doc/index.ru.txt	1970-01-01 00:00:00 +0000
+++ doc/index.ru.txt	2009-06-02 18:07:12 +0000
@@ -0,0 +1,63 @@
+=================================
+Главный каталог документов Bazaar
+=================================
+
+Последняя версия этих документов доступа со страницы документации 
+на сайте Bazaar, <http://doc.bazaar-vcs.org/>. Еще больше информации 
+можно получить по адресу <http://bazaar-vcs.org/Documentation>.
+
+Основная документация
+=====================
+
+* `Руководство пользователя <ru/user-guide/index.html>`_
+
+* `Справочник пользователя <en/user-reference/bzr_man.html>`_ (англ.)
+
+* `Карточка быстрого старта <ru/quick-reference/quick-start-summary.svg>`_
+  (`PDF <ru/quick-reference/quick-start-summary.pdf>`_,
+  `PNG <ru/quick-reference/quick-start-summary.png>`_)
+
+* `Список изменений <en/release-notes/NEWS.html>`_ (англ.)
+
+* `Каталог информации для разработчиков <developers/index.html>`_ (англ.) |--| 
+  для разработчиков Bazaar и плагинов
+
+Учебники
+========
+
+* `Базар за пять минут <ru/mini-tutorial/index.html>`_
+
+* `Большой учебник <ru/tutorials/tutorial.html>`_
+
+* `Использование Bazaar с Launchpad 
+  <ru/tutorials/using_bazaar_with_launchpad.html>`_
+
+* `Работа в централизованном стиле
+  <ru/tutorials/centralized_workflow.html>`_
+
+Ссылки в сети
+=============
+
+* `Руководства по переходу <http://bazaar-vcs.org/BzrSwitching>`_
+  |--| для пользователей переходящих с других систем контроля версий
+
+* `Руководство по миграции <http://bazaar-vcs.org/BzrMigration>`_
+  |--| для команд переносящих историю с других систем контроля версий
+
+* `Словарь терминов <http://bazaar-vcs.org/BzrGlossary>`_ (англ.), 
+  см. также `русскую версию`__ 
+  
+__  http://groups.google.com/group/ru_bzr/web/%D0%B3%D0%BB%D0%BE%D1%81%D1%81%D0%B0%D1%80%D0%B8%D0%B9
+
+* `Часто задаваемые вопросы <http://bazaar-vcs.org/FAQ>`_ (англ.)
+
+Другие языки
+============
+
+* `Документация на английском <index.html>`_ |--| English Documentation
+* `Документация на испанском <index.es.html>`_
+
+.. |--| unicode:: U+2014
+
+..
+   vim: ft=rst tw=74 ai

=== modified file 'doc/index.txt'
--- doc/index.txt	2008-06-05 03:27:37 +0000
+++ doc/index.txt	2009-06-01 22:45:06 +0000
@@ -53,6 +53,7 @@
 ===============
 
 * `Spanish Documentation <index.es.html>`_
+* `Russian Documentation <index.ru.html>`_ |--| документация на русском
 
 .. |--| unicode:: U+2014
 

=== added directory 'doc/ru'
=== added directory 'doc/ru/mini-tutorial'
=== added file 'doc/ru/mini-tutorial/index.txt'
--- doc/ru/mini-tutorial/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/mini-tutorial/index.txt	2009-05-05 21:16:12 +0000
@@ -0,0 +1,289 @@
+======================
+Bazaar за пять минут
+======================
+
+.. contents::
+     Содержание
+
+Введение
+========
+
+Bazaar |--| это распределенная система контроля версий, которая упрощает
+совместную работу над программными проектами.
+
+В течении следующих пяти минут, вы узнаете как начать контролировать версии
+ваших файлов, как вносить изменения, проверять вашу работу, публиковать её и
+отправлять для объединения с главной веткой проекта.
+
+Если вы предпочитаете более подробное введение, обратитесь к разделу 
+`Узнать больше`_.
+
+Установка
+=========
+
+Это руководство не описывает как установить Bazaar, потому что обычно 
+это очень легко. Инструкции по установке вы найдете тут:
+
+- **GNU/Linux:** скорее всего Bazaar уже присутствует в вашем дистрибутиве GNU/Linux.
+- **Windows:** `инструкции по установке для Windows`_.
+- **Mac OS X:** `инструкции по установке для Mac OS X`_.
+
+Для других платформ и для установки из исходных кодов, обратитесь к страницам 
+Загрузка_ и Установка_.
+
+.. _инструкции по установке для Windows: http://bazaar-vcs.org/WindowsDownloads
+.. _инструкции по установке для Mac OS X: http://bazaar-vcs.org/MacOSXBundle
+.. _Загрузка: http://bazaar-vcs.org/Download
+.. _Установка: http://bazaar-vcs.org/InstallationFaq
+
+Представьтесь
+=============
+
+Прежде чем начать работать, было бы неплохо сообщить Bazaar кто вы такой. 
+В этом случае ваша работа будет корректно идентифицирована в истории ревизий.
+
+Используя ваше имя и адрес электронной почты, вместо данных Васи Пупкина,
+наберите::
+
+    $ bzr whoami "Vasya Pupkin <vasya.pupkin@mail.ru>"
+
+В этот момент Bazaar создаст или исправит файл настроек, включив в него ваше
+имя и адрес электронной почты.
+
+Теперь, проверьте правильно ли сохранены ваши имя и адрес::
+
+    $ bzr whoami
+    Vasya Pupkin <vasya.pupkin@mail.ru>
+
+
+Начинаем контролировать версии файлов
+=====================================
+
+Давайте создадим каталог и несколько файлов для использования с Bazaar::
+
+    $ mkdir myproject
+    $ cd myproject
+    $ mkdir subdirectory
+    $ touch test1.txt test2.txt test3.txt subdirectory/test4.txt
+
+**Замечание для пользователей Windows:** используйте Windows Explorer 
+для создания ваших каталогов, затем нажимайте правую кнопку мыши 
+в этих каталогах и выбирайте ``Новый файл``, чтобы создать ваши файлы.
+
+Теперь дадим Bazaar возможность инициализировать свои данные в каталоге вашего
+проекта::
+
+    $ bzr init
+
+Если всё выглядит так, как будто ничего не случилось |--| не волнуйтесь. Bazaar
+создал ветку_, в которой он будет хранить рабочие файлы и историю их изменений.
+
+.. _ветку: http://bazaar-vcs.org/Branch
+
+Следующий шаг |--| сказать Bazaar какие файлы вы хотите контролировать. Команда
+``bzr add`` рекурсивно добавит все файлы в проект::
+
+    $ bzr add
+    added subdirectory
+    added test1.txt
+    added test2.txt
+    added test3.txt
+    added subdirectory/test4.txt
+
+Далее, нужно сохранить текущее состояние ваших файлов зафиксировав их в вашей
+ветке. Добавьте сообщение объясняющее зачем вы сделали фиксацию::
+
+	$ bzr commit -m "Импортируем файлы"
+
+Т.к. Bazaar это распределенная система контроля версий, здесь нет необходимости
+соединяться с центральным сервером для выполнения фиксации. Вместо этого,
+Bazaar сохраняет вашу ветку и все её фиксации внутри каталога с которым вы
+работаете; обратите внимание на подкаталог ``.bzr``.
+
+
+Вносим изменения в файлы
+========================
+
+Давайте изменим какой-либо файл и зафиксируем это изменение в вашей ветке.
+
+Отредактируйте ``test1.txt`` в своем любимом редакторе и затем посмотрите на
+сделанные изменения::
+
+    $ bzr diff
+    === modified file 'test1.txt'
+    --- test1.txt 2007-10-08 17:56:14 +0000
+    +++ test1.txt 2007-10-08 17:46:22 +0000
+    @@ -0,0 +1,1 @@
+    +test test test
+
+Зафиксируйте вашу работу в ветке Bazaar::
+
+    $ bzr commit -m "Добавлена первая строка текста"
+    Committed revision 2.
+
+
+Просматриваем журнал изменений
+==============================
+
+Вы можете увидеть историю вашей ветки просмотрев её журнал::
+
+    $ bzr log
+    ------------------------------------------------------------
+    revno: 2
+    committer: Vasya Pupkin <vasya.pupkin@mail.ru>
+    branch nick: myproject
+    timestamp: Mon 2007-10-08 17:56:14 +0000
+    message:
+      Добавлена первая строка текста
+    ------------------------------------------------------------
+    revno: 1
+    committer: Vasya Pupkin <vasya.pupkin@mail.ru>
+    branch nick: myproject
+    timestamp: Mon 2006-10-08 17:46:22 +0000
+    message:
+      Импортируем файлы
+
+
+Публикуем ветку через SFTP
+==========================
+
+Есть несколько способов опубликовать вашу ветку. Если у вас уже есть SFTP
+сервер или вам несложно его настроить, вы можете опубликовать свою ветку через
+него.
+
+В противном случае, переходите к следующему разделу, чтобы опубликовать ветку
+на Launchpad_ |--| бесплатном хостинге для Bazaar.
+
+.. _Launchpad: https://launchpad.net/
+
+Предположим, что вы хотите опубликовать свою ветку на
+``www.example.com/myproject``::
+
+    $ bzr push --create-prefix sftp://your.name@example.com/~/public_html/myproject
+    2 revision(s) pushed.
+
+Bazaar создаст каталог ``myproject`` на удаленном сервере и поместит в него
+вашу ветку.
+
+Теперь любой желающий сможет создать свою собственную копию вашей ветки,
+выполнив::
+
+    $ bzr branch http://www.example.com/myproject
+
+**Замечание:** чтобы использовать SFTP, может понадобиться установить
+``paramiko`` и ``pyCrypto``. За подробностями обращайтесь к
+http://bazaar-vcs.org/InstallationFaq.
+
+
+Публикация ветки на Launchpad
+=============================
+
+Launchpad это набор инструментов для разработки и размещения проектов
+свободного программного обеспечения. Вы можете использовать его для публикации
+своей ветки.
+
+Если у вас нет учетной записи Launchpad, следуйте 
+`руководству по получению учетной записи`_ и `зарегистрируйте SSH ключ`_ 
+в своей новой учетной записи.
+
+.. _руководству по получению учетной записи: https://help.launchpad.net/CreatingYourLaunchpadAccount
+.. _зарегистрируйте SSH ключ: https://launchpad.net/people/+me/+editsshkeys
+
+Заменив ``vasya.pupkin`` на ваше имя пользователя Launchpad, выполните::
+
+	$ bzr push bzr+ssh://vasya.pupkin@bazaar.launchpad.net/~vasya.pupkin/+junk/myproject
+
+**Замечание:** ``+junk`` означает что ветка не связана с каким-либо проектом на
+Launchpad.
+
+Теперь любой желающий сможет создать свою собственную копию вашей ветки,
+выполнив::
+
+	$ bzr branch http://bazaar.launchpad.net/~vasya.pupkin/+junk/myproject
+
+Вы также сможете видеть информацию по вашей ветке, включая журнал изменений, по
+адресу https://code.launchpad.net/people/+me/+junk/myproject
+
+
+Создаем собственную копию другой ветки
+======================================
+
+Чтобы работать с чьим-либо кодом, вы можете создать собственную копию чужой
+ветки. Давайте возьмем реальный пример |--| GTK интерфейс для Bazaar::
+
+    $ bzr branch http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk bzr-gtk.vasya
+    Branched 292 revision(s).
+
+Bazaar загрузит все файлы и полный журнал изменений из основной ветки проекта
+bzr-gtk и создаст копию с именем bzr-gtk.vasya.
+
+Теперь у вас есть собственная копия ветки и вы можете фиксировать изменения и с
+сетевым подключением и без него. Вы можете поделиться своей веткой в любое
+время, опубликовав ветку. И если команда разработчиков bzr-gtk захочет
+использовать вашу работу, Bazaar легко позволит им объединить вашу ветку
+обратно в их основную ветку.
+
+Обновляем ветку изменениями из основной ветки
+=============================================
+
+Пока вы фиксируете изменения в вашей ветке, другие люди, скорее всего, так же
+продолжают фиксировать код в родительской ветке.
+
+Чтобы быть уверенным что ваша ветка содержит последние изменения, вам следует
+объединить родительскую ветку с вашей личной::
+
+    $ bzr merge
+    Merging from saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
+    All changes applied successfully.
+
+Проверьте что изменилось::
+
+    $ bzr diff
+
+Если изменения вас устраивают, вы можете зафиксировать их в своей ветке::
+
+    $ bzr commit -m "Изменения из основной ветки"
+    Committed revision 295.
+
+
+Объединяем свои изменения с родительской веткой
+===============================================
+
+После того как вы поработали в своей ветке bzr-gtk, вы можете захотеть
+отправить ваши изменения для включения в проект. Простейший способ заключается
+в использовании директивы объединения.
+
+Директива объединения |--| это машиночитаемый запрос на осуществление
+конкретного объединения. Обычно он содержит обзор изменений, которые
+планируется объединить. Также директива объединения содержит либо необходимые
+ревизии, либо указывает на ветку где они могут быть получены.
+
+Заменив ``mycode.patch``, создайте свою директиву объединения::
+
+    $ bzr send -o mycode.patch
+    Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
+
+Теперь вы можете отправить директиву объединения по электронной почте
+в проект bzr-gtk. Если разработчики bzr-gtk захотят, то смогут использовать 
+эту директиву для включения вашей работы в основную ветку.
+
+
+Узнать больше
+=============
+
+Больше информации о Bazaar вы найдете в 
+`Руководстве пользователя Bazaar <../user-guide/index.html>`_.
+
+Чтобы узнать больше о Bazaar из командой строки::
+
+    $ bzr help
+
+Чтобы узнать основные команды Bazaar::
+
+    $ bzr help commands
+
+Чтобы узнать о теме или команде "foo"::
+
+    $ bzr help foo
+
+.. |--| unicode:: U+2014

=== added directory 'doc/ru/quick-reference'
=== added file 'doc/ru/quick-reference/Makefile'
--- doc/ru/quick-reference/Makefile	1970-01-01 00:00:00 +0000
+++ doc/ru/quick-reference/Makefile	2008-08-19 06:29:48 +0000
@@ -0,0 +1,19 @@
+TARGETS=quick-start-summary.png quick-start-summary.pdf
+OBJECTS=quick-start-summary.svg Makefile
+
+all: $(TARGETS)
+
+.SUFFIXES: .svg .png .pdf
+
+.svg.pdf:
+	rsvg-convert -d 300 -p 300 -f pdf -o $@ $<
+
+.svg.png:
+	rsvg-convert -d 300 -p 300 -z 3.3346 -f png -o $@ $<
+
+bzr-quickref.png: $(OBJECTS)
+
+bzr-quickref.pdf: $(OBJECTS)
+
+clean:
+	rm -f $(TARGETS)

=== added file 'doc/ru/quick-reference/quick-start-summary.pdf'
Binary files doc/ru/quick-reference/quick-start-summary.pdf and doc/ru/quick-reference/quick-start-summary.pdf differ
=== added file 'doc/ru/quick-reference/quick-start-summary.png'
Binary files doc/ru/quick-reference/quick-start-summary.png and doc/ru/quick-reference/quick-start-summary.png differ
=== added file 'doc/ru/quick-reference/quick-start-summary.svg'
--- doc/ru/quick-reference/quick-start-summary.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/quick-reference/quick-start-summary.svg	2009-06-05 18:59:14 +0000
@@ -0,0 +1,1601 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2766"
+   sodipodi:version="0.32"
+   inkscape:version="0.46"
+   version="1.0"
+   sodipodi:docbase="/home/ian/bzr/repo.packs/bzr.quick-start-tweaks/doc/en/quick-reference"
+   sodipodi:docname="quick-start-summary.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ashtokalo/projects/bazaar/bzr/doc/ru/quick-reference/quick-start-summary.png"
+   inkscape:export-xdpi="300"
+   inkscape:export-ydpi="300">
+  <defs
+     id="defs2768">
+    <inkscape:perspective
+       sodipodi:type="inkscape:persp3d"
+       inkscape:vp_x="0 : 372.04724 : 1"
+       inkscape:vp_y="0 : 1000 : 0"
+       inkscape:vp_z="1052.3622 : 372.04724 : 1"
+       inkscape:persp3d-origin="526.18109 : 248.03149 : 1"
+       id="perspective299" />
+    <linearGradient
+       id="linearGradient3382">
+      <stop
+         style="stop-color:#2754b0;stop-opacity:1;"
+         offset="0"
+         id="stop3384" />
+      <stop
+         style="stop-color:#cecece;stop-opacity:1;"
+         offset="1"
+         id="stop3386" />
+    </linearGradient>
+    <linearGradient
+       gradientTransform="matrix(1.027169,0,0,1,118.6039,77.1455)"
+       gradientUnits="userSpaceOnUse"
+       y2="0"
+       x2="372.24512"
+       y1="69.037941"
+       x1="372.24512"
+       id="linearGradient2200"
+       xlink:href="#linearGradient5444"
+       inkscape:collect="always" />
+    <linearGradient
+       id="linearGradient5444">
+      <stop
+         style="stop-color:#729fcf;stop-opacity:1;"
+         offset="0"
+         id="stop5446" />
+      <stop
+         id="stop4547"
+         offset="0.5"
+         style="stop-color:#3465a4;stop-opacity:1;" />
+      <stop
+         style="stop-color:#204ab7;stop-opacity:1;"
+         offset="1"
+         id="stop5448" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient5444"
+       id="linearGradient3338"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.027169,0,0,1,417.31189,-41.4259)"
+       x1="372.24512"
+       y1="69.037941"
+       x2="372.24512"
+       y2="0" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient2733"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(0,26)"
+       x1="150.39197"
+       y1="104.09448"
+       x2="151.10625"
+       y2="155.92776" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3518"
+       x1="256.75"
+       y1="129.84448"
+       x2="256.75"
+       y2="194.09644"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3673"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(0,6.6792164e-6)"
+       spreadMethod="pad"
+       x1="15.75"
+       y1="133.84448"
+       x2="15.75"
+       y2="187.6799" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3727"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(-3.238024e-5,1e-5)"
+       spreadMethod="pad"
+       x1="256.75"
+       y1="129.84448"
+       x2="256.75"
+       y2="183.6799" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3733"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(-2.797738e-8,6.6341624e-6)"
+       spreadMethod="pad"
+       x1="256.75"
+       y1="129.84448"
+       x2="256.75"
+       y2="183.6799" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3745"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(-3e-5,9.4726875e-6)"
+       spreadMethod="pad"
+       x1="256.75"
+       y1="129.84448"
+       x2="256.75"
+       y2="183.6799" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3841"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(-3e-5,-18.00002)"
+       spreadMethod="pad"
+       x1="262.82553"
+       y1="400.06738"
+       x2="262.82553"
+       y2="453.20166" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3946"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(0,8.4764986e-6)"
+       spreadMethod="pad"
+       x1="255.99055"
+       y1="375.90359"
+       x2="255.99055"
+       y2="429.73904" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3980"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(-3e-5,-18.00002)"
+       spreadMethod="pad"
+       x1="262.82553"
+       y1="400.06738"
+       x2="262.82553"
+       y2="453.20166" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient3382"
+       id="linearGradient3984"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="translate(-3e-5,1.0501135e-5)"
+       spreadMethod="pad"
+       x1="262.82553"
+       y1="400.06738"
+       x2="262.82553"
+       y2="453.20166" />
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="1"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="536.00788"
+     inkscape:cy="344.00003"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09449px"
+     inkscape:showpageshadow="false"
+     showgrid="false"
+     inkscape:window-width="1280"
+     inkscape:window-height="969"
+     inkscape:window-x="0"
+     inkscape:window-y="24"
+     showguides="false"
+     inkscape:guide-bbox="true">
+    <sodipodi:guide
+       orientation="0,1"
+       position="736,32"
+       id="guide2724" />
+    <sodipodi:guide
+       orientation="1,0"
+       position="50,461"
+       id="guide3531" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="285.55009,613.5"
+       id="guide3613" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="514.90148,462.50001"
+       id="guide3659" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="710.07801,344.0271"
+       id="guide3835" />
+    <sodipodi:guide
+       orientation="0,1"
+       position="283.27176,368.32923"
+       id="guide3940" />
+    <sodipodi:guide
+       orientation="1,0"
+       position="999,424"
+       id="guide3986" />
+  </sodipodi:namedview>
+  <metadata
+     id="metadata2771">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <cc:license
+           rdf:resource="http://creativecommons.org/licenses/GPL/2.0/" />
+        <dc:title>Bazaar-NG quick reference</dc:title>
+        <dc:date>2007-07-23</dc:date>
+        <dc:creator>
+          <cc:Agent>
+            <dc:title>Sabin Iacob</dc:title>
+          </cc:Agent>
+        </dc:creator>
+        <dc:language>en</dc:language>
+        <dc:subject>
+          <rdf:Bag>
+            <rdf:li>bzr</rdf:li>
+            <rdf:li>bazaar</rdf:li>
+            <rdf:li>reference</rdf:li>
+          </rdf:Bag>
+        </dc:subject>
+      </cc:Work>
+      <cc:License
+         rdf:about="http://creativecommons.org/licenses/GPL/2.0/">
+        <cc:permits
+           rdf:resource="http://web.resource.org/cc/Reproduction" />
+        <cc:permits
+           rdf:resource="http://web.resource.org/cc/Distribution" />
+        <cc:requires
+           rdf:resource="http://web.resource.org/cc/Notice" />
+        <cc:permits
+           rdf:resource="http://web.resource.org/cc/DerivativeWorks" />
+        <cc:requires
+           rdf:resource="http://web.resource.org/cc/ShareAlike" />
+        <cc:requires
+           rdf:resource="http://web.resource.org/cc/SourceCode" />
+      </cc:License>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <rect
+       style="opacity:1;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+       id="rect3988"
+       width="1052"
+       height="744"
+       x="0"
+       y="0.094482422"
+       sodipodi:insensitive="true" />
+    <rect
+       style="fill:url(#linearGradient3984);fill-opacity:1;fill-rule:nonzero;stroke:#cecece;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+       id="rect3823"
+       width="229"
+       height="312"
+       x="770.50006"
+       y="400.59448"
+       ry="8.1168795"
+       rx="8.1168776" />
+    <rect
+       rx="8.1168776"
+       ry="8.1168776"
+       y="430.09451"
+       x="771"
+       height="282"
+       width="228"
+       id="rect3825"
+       style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
+    <g
+       id="g3942">
+      <rect
+         style="fill:url(#linearGradient3946);fill-opacity:1;fill-rule:nonzero;stroke:#cecece;stroke-width:0.99999988;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+         id="rect3930"
+         width="229"
+         height="336"
+         x="50.5"
+         y="376.59448"
+         ry="8.1168776"
+         rx="8.1168776" />
+      <rect
+         rx="8.1168776"
+         ry="8.1168776"
+         y="406.09448"
+         x="51"
+         height="306"
+         width="228"
+         id="rect3932"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
+    </g>
+    <rect
+       style="opacity:1;fill:none;fill-opacity:0;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+       id="rect2983"
+       width="1052.1749"
+       height="744"
+       x="0"
+       y="0.094482422"
+       ry="0" />
+    <g
+       id="g3675">
+      <rect
+         rx="8.1168776"
+         ry="8.1168776"
+         y="130.59448"
+         x="50.5"
+         height="230"
+         width="229"
+         id="rect3510"
+         style="fill:url(#linearGradient3673);fill-opacity:1;fill-rule:nonzero;stroke:#cecece;stroke-width:0.99999994000000003;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
+      <rect
+         style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+         id="rect3520"
+         width="228"
+         height="198.99998"
+         x="51"
+         y="161.0945"
+         ry="8.1168776"
+         rx="8.1168776" />
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="97.015038"
+       y="150.97269"
+       id="text3164"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3166"
+         x="97.015038"
+         y="150.97269">Инициализация</tspan></text>
+    <g
+       id="g3209"
+       transform="translate(1e-4,-2.2095387)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text2167"
+         y="193.07361"
+         x="63.794312"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan2171"
+           y="193.07361"
+           x="63.794312"
+           sodipodi:role="line">bzr init myproject</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3168"
+         y="179.83536"
+         x="58.209351"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="179.83536"
+           x="58.209351"
+           id="tspan3170"
+           sodipodi:role="line">Новый проект</tspan></text>
+    </g>
+    <g
+       id="g3215"
+       transform="translate(1e-4,-1.1449276)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text2175"
+         y="226.45848"
+         x="64.448624"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           y="226.45848"
+           x="64.448624"
+           id="tspan2177"
+           sodipodi:role="line">cd myproject</tspan><tspan
+           id="tspan2179"
+           y="237.53181"
+           x="64.448624"
+           sodipodi:role="line">bzr init</tspan><tspan
+           id="tspan2181"
+           y="248.60515"
+           x="64.448624"
+           sodipodi:role="line">bzr add .</tspan><tspan
+           id="tspan2183"
+           y="259.67847"
+           x="64.448624"
+           sodipodi:role="line" /></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3172"
+         y="213.22023"
+         x="58.174194"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="213.22023"
+           x="58.174194"
+           id="tspan3174"
+           sodipodi:role="line">Существующий проект</tspan></text>
+    </g>
+    <g
+       id="g3224"
+       transform="translate(1e-4,5.3457864e-2)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text2185"
+         y="277.48495"
+         x="64.448624"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           y="277.48495"
+           x="64.448624"
+           id="tspan2187"
+           sodipodi:role="line">bzr branch mp myproject</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3176"
+         y="266.6666"
+         x="58.209351"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="266.6666"
+           x="58.209351"
+           id="tspan3178"
+           sodipodi:role="line">Новая ветка</tspan></text>
+    </g>
+    <g
+       id="g3230"
+       transform="translate(1e-4,1.1181147)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text3404"
+         y="308.44989"
+         x="64.448624"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           y="308.44989"
+           x="64.448624"
+           id="tspan3406"
+           sodipodi:role="line">bzr checkout mp myproject</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3408"
+         y="297.63153"
+         x="58.209351"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="297.63153"
+           x="58.209351"
+           id="tspan3410"
+           sodipodi:role="line">Новая рабочая копия</tspan></text>
+    </g>
+    <g
+       id="g3236"
+       transform="translate(1e-4,2.1828937)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text3414"
+         y="341.88864"
+         x="64.448624"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           y="341.88864"
+           x="64.448624"
+           sodipodi:role="line"
+           id="tspan3424">bzr checkout --lightweight mp \</tspan><tspan
+           id="tspan2780"
+           y="352.96198"
+           x="64.448624"
+           sodipodi:role="line"> myproject</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3418"
+         y="328.59634"
+         x="58.209351"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="328.59634"
+           x="58.209351"
+           sodipodi:role="line"
+           id="tspan3422">Новая копия без истории</tspan></text>
+    </g>
+    <rect
+       rx="8.1168776"
+       ry="8.1168785"
+       y="130.59448"
+       x="302.5"
+       height="151"
+       width="236.99998"
+       id="rect3623"
+       style="fill:url(#linearGradient3733);fill-opacity:1;fill-rule:nonzero;stroke:#cecece;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
+    <rect
+       style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+       id="rect3625"
+       width="236"
+       height="120"
+       x="303"
+       y="161.09448"
+       ry="8.1168776"
+       rx="8.1168776" />
+    <text
+       xml:space="preserve"
+       style="font-size:16.82818985px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="295.88339"
+       y="158.7634"
+       id="text3563"
+       sodipodi:linespacing="100%"
+       transform="scale(1.0517619,0.9507855)"><tspan
+         sodipodi:role="line"
+         id="tspan3565"
+         x="295.88339"
+         y="158.7634">Операции с файлами</tspan></text>
+    <g
+       id="g3243"
+       transform="matrix(1.0549376,0,0,1,-32.744004,-1.9729054)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text3610"
+         y="203.36041"
+         x="332.47345"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan3612"
+           y="203.36041"
+           x="332.47345"
+           sodipodi:role="line">bzr add foo.py</tspan><tspan
+           y="214.43375"
+           x="332.47345"
+           sodipodi:role="line"
+           id="tspan3618">bzr add bar/</tspan></text>
+      <text
+         sodipodi:linespacing="110%"
+         id="text3614"
+         y="179.59872"
+         x="326.88849"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="179.59872"
+           x="326.88849"
+           id="tspan3616"
+           sodipodi:role="line">Добавить файл для</tspan><tspan
+           id="tspan3047"
+           y="192.79872"
+           x="326.88849"
+           sodipodi:role="line">контроля</tspan></text>
+    </g>
+    <g
+       id="g3250"
+       transform="matrix(1.0549376,0,0,1,-32.744004,7.0676505)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text3622"
+         y="233.11641"
+         x="331.78732"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan3624"
+           y="233.11641"
+           x="331.78732"
+           sodipodi:role="line">bzr remove --keep foo.py</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3626"
+         y="221.35472"
+         x="326.20236"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="221.35472"
+           x="326.20236"
+           id="tspan3628"
+           sodipodi:role="line">Отменить контроль файла</tspan></text>
+    </g>
+    <g
+       id="g3256"
+       transform="matrix(1.0549376,0,0,1,-32.744004,4.1322158)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text3632"
+         y="266.08142"
+         x="331.81714"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan3634"
+           y="266.08142"
+           x="331.81714"
+           sodipodi:role="line">bzr remove --force foo.py</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text3636"
+         y="253.26308"
+         x="326.23218"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           id="tspan3049"
+           y="253.26308"
+           x="326.23218"
+           sodipodi:role="line">Отменить контроль и удалить</tspan></text>
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="103.15869"
+       y="396.96985"
+       id="text3786"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3788"
+         x="103.15869"
+         y="396.96985">Информация</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.69986"
+       y="437.78763"
+       id="text3234"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         x="62.69986"
+         y="437.78763"
+         id="tspan3236">bzr status</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="57.114899"
+       y="424.54938"
+       id="text3238"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3240"
+         x="57.114899"
+         y="424.54938">Состояние рабочего дерева</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.72134"
+       y="470.33978"
+       id="text3244"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         x="62.72134"
+         y="470.33978"
+         id="tspan3250">bzr log</tspan><tspan
+         id="tspan3294"
+         sodipodi:role="line"
+         x="62.72134"
+         y="481.41312">bzr log foo.py</tspan><tspan
+         sodipodi:role="line"
+         x="62.72134"
+         y="492.48645"
+         id="tspan3252" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="56.446926"
+       y="457.04749"
+       id="text3254"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3256"
+         x="56.446926"
+         y="457.04749">Журнал ревизий</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="63.35416"
+       y="515.93146"
+       id="text3260"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan3262"
+         x="63.35416"
+         y="515.93146">bzr diff</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="57.114902"
+       y="502.69315"
+       id="text3264"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3266"
+         x="57.114902"
+         y="502.69315">Изменения в рабочем дереве</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.744778"
+       y="626.90851"
+       id="text3298"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan3300"
+         x="62.744778"
+         y="626.90851">bzr missing</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="56.50552"
+       y="613.67029"
+       id="text3302"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3304"
+         x="56.50552"
+         y="613.67029">Отсутствующие ревизии</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.7565"
+       y="703.50507"
+       id="text3308"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan3310"
+         x="62.7565"
+         y="703.50507">bzr cat -r3 foo.py</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="56.517242"
+       y="678.26678"
+       id="text3312"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         x="56.517242"
+         y="678.26678"
+         id="tspan3043">Содержимое foo.py в</tspan><tspan
+         sodipodi:role="line"
+         x="56.517242"
+         y="690.26678"
+         id="tspan3046">ревизии 3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.686188"
+       y="659.00696"
+       id="text3318"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan3320"
+         x="62.686188"
+         y="659.00696">bzr info</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="56.44693"
+       y="648.1886"
+       id="text3322"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3324"
+         x="56.44693"
+         y="648.1886">Информация о ветке</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.879551"
+       y="548.42957"
+       id="text3330"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan3332"
+         x="62.879551"
+         y="548.42957">bzr diff foo.py</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="56.640293"
+       y="535.19128"
+       id="text3334"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3336"
+         x="56.640293"
+         y="535.19128">Изменения в foo.py</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="62.000778"
+       y="592.45911"
+       id="text3699"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan3701"
+         x="62.000778"
+         y="592.45911">bzr diff -r1..3 foo.py</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="55.76152"
+       y="567.64081"
+       id="text3703"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         x="55.76152"
+         y="567.64081"
+         id="tspan2746">Изменения в foo.py между</tspan><tspan
+         sodipodi:role="line"
+         x="55.76152"
+         y="579.64081"
+         id="tspan3039">ревизиями 1 and 3</tspan></text>
+    <rect
+       style="fill:url(#linearGradient3727);fill-opacity:1;fill-rule:nonzero;stroke:#cecece;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+       id="rect3685"
+       width="188.99971"
+       height="151"
+       x="560.50012"
+       y="130.59448"
+       ry="8.1168785"
+       rx="8.1168776" />
+    <rect
+       rx="8.1168776"
+       ry="8.1168776"
+       y="161.09448"
+       x="561"
+       height="120"
+       width="188"
+       id="rect3687"
+       style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
+    <text
+       xml:space="preserve"
+       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="577.6239"
+       y="150.94995"
+       id="text4134"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4136"
+         x="577.6239"
+         y="150.94995">Контроль версий</tspan></text>
+    <g
+       id="g3262"
+       transform="translate(16.728023,-2.4445851)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text4140"
+         y="190.88873"
+         x="559.03162"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan4142"
+           y="190.88873"
+           x="559.03162"
+           sodipodi:role="line">bzr commit foo.py -m &quot;foo&quot;</tspan><tspan
+           y="201.96207"
+           x="559.03162"
+           sodipodi:role="line"
+           id="tspan4144">bzr commit -m &quot;the rest&quot;</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text4146"
+         y="180.0704"
+         x="553.44666"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="180.0704"
+           x="553.44666"
+           id="tspan4148"
+           sodipodi:role="line">Фиксировать изменения</tspan></text>
+    </g>
+    <g
+       id="g3269"
+       transform="translate(16.728023,7.3032391)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text4152"
+         y="234.2924"
+         x="558.37482"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan4154"
+           y="234.2924"
+           x="558.37482"
+           sodipodi:role="line">bzr uncommit</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text4156"
+         y="209.47408"
+         x="552.78986"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="209.47408"
+           x="552.78986"
+           id="tspan4158"
+           sodipodi:role="line">Откатить последную</tspan><tspan
+           id="tspan3045"
+           y="221.47408"
+           x="552.78986"
+           sodipodi:role="line">фиксацию</tspan></text>
+    </g>
+    <g
+       id="g3275"
+       transform="translate(16.728023,6.3548354)">
+      <text
+         sodipodi:linespacing="110%"
+         id="text4162"
+         y="263.73889"
+         x="558.37488"
+         style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+         xml:space="preserve"><tspan
+           id="tspan4164"
+           y="263.73889"
+           x="558.37488"
+           sodipodi:role="line">bzr revert</tspan></text>
+      <text
+         sodipodi:linespacing="100%"
+         id="text4166"
+         y="250.50064"
+         x="552.78992"
+         style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="250.50064"
+           x="552.78992"
+           id="tspan4168"
+           sodipodi:role="line">Отменить изменения</tspan></text>
+    </g>
+    <g
+       id="g3741">
+      <rect
+         style="fill:url(#linearGradient3745);fill-opacity:1;fill-rule:nonzero;stroke:#cecece;stroke-width:1;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1"
+         id="rect3735"
+         width="229"
+         height="254"
+         x="770.50006"
+         y="130.59448"
+         ry="8.1168795"
+         rx="8.1168776" />
+      <rect
+         rx="8.1168776"
+         ry="8.1168776"
+         y="161.09448"
+         x="771"
+         height="223"
+         width="228"
+         id="rect3737"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:0.99999994;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:1;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1" />
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="825.24872"
+       y="150.97269"
+       id="text4236"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4238"
+         x="825.24872"
+         y="150.97269">Объединение</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="783.75763"
+       y="190.86407"
+       id="text4242"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         x="783.75763"
+         y="190.86407"
+         id="tspan4244">cd myproject</tspan><tspan
+         sodipodi:role="line"
+         x="783.75763"
+         y="201.93741"
+         id="tspan4296">bzr merge ../myproject-foo</tspan><tspan
+         sodipodi:role="line"
+         x="783.75763"
+         y="213.01074"
+         id="tspan4298">bzr commit</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="778.17267"
+       y="177.62582"
+       id="text4246"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4248"
+         x="778.17267"
+         y="177.62582">Объединение двух веток</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="784.44708"
+       y="255.5088"
+       id="text4252"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan4254"
+         x="784.44708"
+         y="255.5088">cd myproject-foo</tspan><tspan
+         sodipodi:role="line"
+         x="784.44708"
+         y="266.58215"
+         id="tspan4258">bzr pull ../myproject</tspan><tspan
+         sodipodi:role="line"
+         x="784.44708"
+         y="277.65549"
+         id="tspan4260" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="778.17267"
+       y="232.27057"
+       id="text4262"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4264"
+         x="778.17267"
+         y="232.27057">Получить изменения из </tspan><tspan
+         sodipodi:role="line"
+         x="778.17267"
+         y="244.27057"
+         id="tspan2726">myproject</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="784.41193"
+       y="300.93793"
+       id="text4268"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan4270"
+         x="784.41193"
+         y="300.93793">bzr update</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="778.17267"
+       y="287.7934"
+       id="text4272"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4274"
+         x="778.17267"
+         y="287.7934">Обновить рабочую копию</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="785.4549"
+       y="345.02151"
+       id="text4278"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan4280"
+         x="785.4549"
+         y="345.02151">bzr resolve</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="779.21564"
+       y="320.14914"
+       id="text4282"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         x="779.21564"
+         y="320.14914"
+         id="tspan3055">Автоопределение решенных</tspan><tspan
+         sodipodi:role="line"
+         x="779.21564"
+         y="332.14914"
+         id="tspan2692">конфликтов</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="784.65216"
+       y="375.57367"
+       id="text4288"
+       sodipodi:linespacing="110%"><tspan
+         id="tspan4290"
+         sodipodi:role="line"
+         x="784.65216"
+         y="375.57367">bzr resolve foo.py</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="778.4129"
+       y="364.28137"
+       id="text4292"
+       sodipodi:linespacing="100%"><tspan
+         id="tspan4294"
+         sodipodi:role="line"
+         x="778.4129"
+         y="364.28137">Снять пометку о конфликте</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:16px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="830.59387"
+       y="420.96985"
+       id="text4535"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4537"
+         x="830.59387"
+         y="420.96985">Публикация</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="781.75757"
+       y="507.81726"
+       id="text4616"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         x="781.75757"
+         y="507.81726"
+         id="tspan4618">bzr push sftp://host/myproject-fo1</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="776.17261"
+       y="482.57898"
+       id="text4620"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4622"
+         x="776.17261"
+         y="482.57898">Опубликовать ревизии </tspan><tspan
+         sodipodi:role="line"
+         x="776.17261"
+         y="494.57898"
+         id="tspan2742">удаленно</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="782.38531"
+       y="461.36774"
+       id="text4457"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         x="782.38531"
+         y="461.36774"
+         id="tspan4459">bzr push ../myproject-fo1</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="776.80035"
+       y="448.54938"
+       id="text4461"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4463"
+         x="776.80035"
+         y="448.54938">Опубликовать ревизии</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="782.40686"
+       y="553.90088"
+       id="text4467"
+       sodipodi:linespacing="110%"><tspan
+         id="tspan8805"
+         sodipodi:role="line"
+         x="782.40686"
+         y="553.90088">bzr send</tspan><tspan
+         sodipodi:role="line"
+         x="782.40686"
+         y="564.97418"
+         id="tspan4473" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="776.13245"
+       y="529.0285"
+       id="text4475"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         x="776.13245"
+         y="529.0285"
+         id="tspan3063">Отправить почтой директиву</tspan><tspan
+         sodipodi:role="line"
+         x="776.13245"
+         y="541.0285"
+         id="tspan3042">объединения</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="783.03967"
+       y="647.42365"
+       id="text4481"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan4483"
+         x="783.03967"
+         y="647.42365">bzr export ../myproject-dist/</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="776.80042"
+       y="622.18542"
+       id="text4485"
+       sodipodi:linespacing="100%"><tspan
+         id="tspan4610"
+         sodipodi:role="line"
+         x="776.80042"
+         y="622.18542">Экспортировать текущую </tspan><tspan
+         sodipodi:role="line"
+         x="776.80042"
+         y="634.18542"
+         id="tspan2736">ревизию как каталог</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="782.56512"
+       y="695.45319"
+       id="text4521"
+       sodipodi:linespacing="110%"><tspan
+         sodipodi:role="line"
+         id="tspan4523"
+         x="782.56512"
+         y="695.45319">bzr export ../myproject-dist.zip</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="776.32587"
+       y="668.63489"
+       id="text4525"
+       sodipodi:linespacing="100%"><tspan
+         id="tspan4612"
+         sodipodi:role="line"
+         x="776.32587"
+         y="668.63489">Экспортировать текущую </tspan><tspan
+         sodipodi:role="line"
+         x="776.32587"
+         y="680.63489"
+         id="tspan2732">ревизию как архив</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:10.0666666px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:110.00000238%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+       x="780.99316"
+       y="600.0423"
+       id="text2448"
+       sodipodi:linespacing="110%"><tspan
+         id="tspan2450"
+         sodipodi:role="line"
+         x="780.99316"
+         y="600.0423">bzr send -o ../base.patch</tspan><tspan
+         sodipodi:role="line"
+         x="780.99316"
+         y="611.1156"
+         id="tspan2452" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="776.71875"
+       y="575.16986"
+       id="text2454"
+       sodipodi:linespacing="100%"><tspan
+         id="tspan2456"
+         sodipodi:role="line"
+         x="776.71875"
+         y="575.16986">Создать директиву</tspan><tspan
+         sodipodi:role="line"
+         x="776.71875"
+         y="587.16986"
+         id="tspan2738">объединения</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:40px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:30.5;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="144.32812"
+       y="64.254639"
+       id="text2774"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan2776"
+         x="144.32812"
+         y="64.254639">Bazaar </tspan></text>
+    <g
+       style="display:inline"
+       id="g3653"
+       transform="matrix(0.6461515,0,0,0.6526216,160.93614,144.01237)"
+       inkscape:export-filename="/home/matt/Projects/Ubuntu/Bazaar Website/bzr icon 64.png"
+       inkscape:export-xdpi="45.012665"
+       inkscape:export-ydpi="45.012665">
+      <path
+         id="path2749"
+         d="M -143.51431,-75.4275 C -158.48768,-90.57687 -171.17625,-103.66019 -171.7111,-104.50153 C -174.63909,-109.10738 -172.34363,-112.16647 -143.7155,-141.81059 C -119.96256,-166.4065 -114.08422,-171.84722 -111.26302,-171.84722 C -108.45655,-171.84722 -102.57922,-166.49332 -79.566158,-142.97326 C -59.704508,-122.67403 -51.314608,-113.24681 -51.314608,-111.22876 C -51.314608,-107.03298 -109.21126,-47.88319 -113.31814,-47.88319 C -115.49463,-47.88319 -123.57621,-55.25503 -143.51431,-75.4275 z "
+         style="opacity:1;fill:#fce94f;fill-opacity:1;stroke:#fce94f;stroke-width:4;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
+      <path
+         id="path2721"
+         d="M -118.75152,-74.850683 C -119.22012,-75.319283 -119.60352,-85.958443 -119.60352,-98.493313 L -119.60352,-121.28395 L -124.85215,-121.28395 C -131.2088,-121.28395 -131.22918,-121.19503 -121.27316,-136.90004 C -116.77235,-143.99978 -113.38241,-148.09169 -112.19584,-147.85705 C -110.34853,-147.49175 -95.321883,-124.90849 -95.321883,-122.4975 C -95.321883,-121.83004 -97.640303,-121.28395 -100.47393,-121.28395 C -103.84689,-121.28395 -105.87693,-120.6299 -106.35276,-119.38989 C -107.55959,-116.24495 -103.45251,-106.32746 -97.296233,-97.520823 C -90.988133,-88.497013 -90.461803,-86.665103 -93.461883,-84.175253 C -95.128693,-82.791933 -96.185063,-83.268713 -100.25177,-87.239733 C -102.90055,-89.826193 -105.46285,-91.547323 -105.94572,-91.064423 C -106.42862,-90.581523 -106.8237,-86.544203 -106.8237,-82.092573 L -106.8237,-73.998703 L -112.36162,-73.998703 C -115.40746,-73.998703 -118.28294,-74.382103 -118.75152,-74.850683 z "
+         style="opacity:1;fill:#c4a000;fill-opacity:1;stroke:#c4a000;display:inline" />
+      <path
+         id="path2727"
+         d="M -120.75152,-76.85072 C -121.22012,-77.31932 -121.60352,-87.95848 -121.60352,-100.49335 L -121.60352,-123.28399 L -126.85215,-123.28399 C -133.2088,-123.28399 -133.22918,-123.19507 -123.27316,-138.90007 C -118.77235,-145.99981 -115.38241,-150.09172 -114.19584,-149.85708 C -112.34853,-149.49178 -97.321888,-126.90852 -97.321888,-124.49754 C -97.321888,-123.83008 -99.640308,-123.28399 -102.47393,-123.28399 C -105.84689,-123.28399 -107.87693,-122.62994 -108.35276,-121.38993 C -109.55959,-118.24499 -105.45251,-108.3275 -99.296238,-99.52086 C -92.988138,-90.49705 -92.461808,-88.66514 -95.461888,-86.17529 C -97.128698,-84.79197 -98.185068,-85.26875 -102.25177,-89.23977 C -104.90055,-91.82623 -107.46285,-93.54736 -107.94572,-93.06446 C -108.42862,-92.58156 -108.8237,-88.54424 -108.8237,-84.09261 L -108.8237,-75.99874 L -114.36162,-75.99874 C -117.40746,-75.99874 -120.28294,-76.38214 -120.75152,-76.85072 z "
+         style="opacity:1;fill:#555753;fill-opacity:1;stroke:#2e3436;stroke-opacity:1;display:inline" />
+      <path
+         d="M -143.51431,-75.4275 C -158.48768,-90.57687 -171.17625,-103.66019 -171.7111,-104.50153 C -174.63909,-109.10738 -172.34363,-112.16647 -143.7155,-141.81059 C -119.96256,-166.4065 -114.08422,-171.84722 -111.26302,-171.84722 C -108.45655,-171.84722 -102.57922,-166.49332 -79.566162,-142.97326 C -59.704512,-122.67403 -51.314612,-113.24681 -51.314612,-111.22876 C -51.314612,-107.03298 -109.21126,-47.88319 -113.31814,-47.88319 C -115.49463,-47.88319 -123.57621,-55.25503 -143.51431,-75.4275 z M -82.734602,-78.80831 C -63.284082,-98.78654 -53.870592,-109.3496 -53.870592,-111.19708 C -53.870592,-114.35673 -108.28764,-170.68595 -111.26979,-170.61328 C -113.31427,-170.56346 -167.39892,-115.6112 -169.81635,-111.12752 C -171.82156,-107.40842 -170.53236,-105.76188 -145.24612,-79.74648 C -117.66227,-51.36719 -115.36413,-49.16116 -113.38369,-49.16116 C -112.40192,-49.16116 -98.609822,-62.50237 -82.734602,-78.80831 z "
+         style="opacity:1;fill:#555753;fill-opacity:1;stroke:#2e3436;stroke-width:2;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
+         id="path2736" />
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="146.57143"
+       y="97.808769"
+       id="text3409"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan3411"
+         x="146.57143"
+         y="97.808769">Карточка быстрого старта</tspan></text>
+    <g
+       id="g12314"
+       transform="translate(3.6699829,1.7472534)"
+       style="fill:#333333;fill-opacity:1">
+      <text
+         sodipodi:linespacing="100%"
+         id="text8833"
+         y="527.43823"
+         x="297.99408"
+         style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:#333333;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;font-family:Bitstream Vera Sans"
+           y="527.43823"
+           x="297.99408"
+           id="tspan8835"
+           sodipodi:role="line">Поддерживаемые префиксы URL</tspan></text>
+      <g
+         id="g12288"
+         style="fill:#333333;fill-opacity:1">
+        <text
+           xml:space="preserve"
+           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+           x="299.33002"
+           y="547.94214"
+           id="text8837"
+           sodipodi:linespacing="150%"><tspan
+             sodipodi:role="line"
+             id="tspan8841"
+             x="299.33002"
+             y="547.94214">aftp://</tspan><tspan
+             sodipodi:role="line"
+             id="tspan8843"
+             x="299.33002"
+             y="565.94214">bzr://</tspan><tspan
+             sodipodi:role="line"
+             x="299.33002"
+             y="583.94214"
+             id="tspan10799">bzr+ssh://</tspan><tspan
+             sodipodi:role="line"
+             x="299.33002"
+             y="601.94214"
+             id="tspan3050">file://</tspan><tspan
+             sodipodi:role="line"
+             id="tspan8849"
+             x="299.33002"
+             y="619.94214">ftp:// </tspan><tspan
+             sodipodi:role="line"
+             id="tspan8851"
+             x="299.33002"
+             y="637.94214">http://</tspan><tspan
+             sodipodi:role="line"
+             id="tspan8853"
+             x="299.33002"
+             y="655.94214">https://</tspan><tspan
+             sodipodi:role="line"
+             x="299.33002"
+             y="673.94214"
+             id="tspan10797" /><tspan
+             sodipodi:role="line"
+             id="tspan8855"
+             x="299.33002"
+             y="691.94214">sftp://</tspan><tspan
+             sodipodi:role="line"
+             id="tspan8857"
+             x="299.33002"
+             y="709.94214" /></text>
+        <text
+           xml:space="preserve"
+           style="font-size:12px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;opacity:1;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+           x="379.22845"
+           y="547.94214"
+           id="text12260"
+           sodipodi:linespacing="150%"><tspan
+             sodipodi:role="line"
+             id="tspan12262"
+             x="379.22845"
+             y="547.94214">Доступ, используя активный FTP</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="565.94214"
+             id="tspan12264">Быстрый доступ, используя сервер Bazaar</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="583.94214"
+             id="tspan12270">Быстрый доступ через SSH, используя сервер Bazaar</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="601.94214"
+             id="tspan3048">Доступ, используя файловую систему (по-умолчанию)</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="619.94214"
+             id="tspan12272">Доступ, используя пассивный FTP</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="637.94214"
+             id="tspan12274">Доступ для чтения веток размещенных в интернете</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="655.94214"
+             id="tspan3058">Доступ через SSL для чтения веток размещенных</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="673.94214"
+             id="tspan3068">в интернете</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="691.94214"
+             id="tspan12282">Доступ, используя SFTP (большинство SSH серверов</tspan><tspan
+             sodipodi:role="line"
+             x="379.22845"
+             y="709.94214"
+             id="tspan3072">предоставляют SFTP)</tspan></text>
+      </g>
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:#333333;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="302.50391"
+       y="320.09448"
+       id="text4624"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan4626"
+         x="302.50391"
+         y="320.09448"
+         style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;font-family:Bitstream Vera Sans">Концепции</tspan></text>
+    <text
+       transform="scale(0.9968065,1.0032037)"
+       xml:space="preserve"
+       style="font-size:12.03844452px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="455.10013"
+       y="340.18164"
+       id="text12146"
+       sodipodi:linespacing="150%"><tspan
+         sodipodi:role="line"
+         id="tspan12148"
+         x="455.10013"
+         y="340.18164">направление разработки проекта</tspan><tspan
+         sodipodi:role="line"
+         x="455.10013"
+         y="358.23932"
+         id="tspan12150">каталог под контролем версий </tspan><tspan
+         sodipodi:role="line"
+         x="455.10013"
+         y="376.29697"
+         id="tspan12152">хранилище ревизий Bazaar</tspan><tspan
+         sodipodi:role="line"
+         x="455.10013"
+         y="394.35464"
+         id="tspan12156">версия исходного кода зафиксированная</tspan><tspan
+         id="tspan2710"
+         sodipodi:role="line"
+         x="455.10013"
+         y="412.41229">в хранилище</tspan><tspan
+         sodipodi:role="line"
+         x="455.10013"
+         y="430.46997"
+         id="tspan12158">именованная ревизия</tspan><tspan
+         sodipodi:role="line"
+         x="455.10013"
+         y="448.52765"
+         id="tspan12160">ветки имеющие общего предка</tspan><tspan
+         sodipodi:role="line"
+         x="455.10013"
+         y="466.5853"
+         id="tspan12164">операция применения к ветке всех </tspan><tspan
+         id="tspan3886"
+         sodipodi:role="line"
+         x="455.10013"
+         y="484.64297">изменений сделанных в другой ветке</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:12px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:150%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+       x="303"
+       y="341.21167"
+       id="text12400"
+       sodipodi:linespacing="150%"><tspan
+         sodipodi:role="line"
+         id="tspan12402"
+         x="303"
+         y="341.21167">Ветка:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="359.21167"
+         id="tspan12404">Рабочее дерево:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="377.21167"
+         id="tspan12406">Репозиторий:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="395.21167"
+         id="tspan12408">Ревизия:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="413.21167"
+         id="tspan12410" /><tspan
+         sodipodi:role="line"
+         x="303"
+         y="431.21167"
+         id="tspan12412">Метка:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="449.21167"
+         id="tspan12414">Родственные ветки:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="467.21167"
+         id="tspan12416">Объединение:</tspan><tspan
+         sodipodi:role="line"
+         x="303"
+         y="485.21167"
+         id="tspan12418" /></text>
+    <g
+       id="g6327"
+       transform="translate(6.5601196,0)"
+       style="fill:#333333;fill-opacity:1">
+      <text
+         sodipodi:linespacing="100%"
+         id="text6294"
+         y="50.289795"
+         x="645.77582"
+         style="font-size:20px;font-style:normal;font-variant:normal;font-weight:bold;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;opacity:1;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+         xml:space="preserve"><tspan
+           y="50.289795"
+           x="645.77582"
+           id="tspan6296"
+           sodipodi:role="line">Дополнительная информация</tspan></text>
+      <g
+         id="g6320"
+         style="fill:#333333;fill-opacity:1"
+         transform="translate(-142.82842,0)">
+        <text
+           xml:space="preserve"
+           style="font-size:20px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans Mono"
+           x="787.72699"
+           y="76.095581"
+           id="text6298"
+           sodipodi:linespacing="100%"><tspan
+             sodipodi:role="line"
+             id="tspan6300"
+             x="787.72699"
+             y="76.095581">bzr help</tspan></text>
+        <a
+           id="a6316"
+           style="fill:#333333;fill-opacity:1"
+           xlink:href="http://bazaar-vcs.org">
+          <text
+             sodipodi:linespacing="100%"
+             id="text6302"
+             y="97.901367"
+             x="787.79535"
+             style="font-size:20px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#333333;fill-opacity:1;fill-rule:nonzero;stroke:none;stroke-width:1;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;font-family:Bitstream Vera Sans"
+             xml:space="preserve"><tspan
+               y="97.901367"
+               x="787.79535"
+               id="tspan6304"
+               sodipodi:role="line">http://bazaar-vcs.org</tspan></text>
+        </a>
+      </g>
+    </g>
+  </g>
+</svg>

=== added directory 'doc/ru/tutorials'
=== added file 'doc/ru/tutorials/centralized_workflow.txt'
--- doc/ru/tutorials/centralized_workflow.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/tutorials/centralized_workflow.txt	2009-06-05 18:59:14 +0000
@@ -0,0 +1,319 @@
+===============================
+Работа в централизованном стиле
+===============================
+
+.. sectnum::
+
+
+Обзор
+=====
+
+Этот документ описывает один из возможных подходов к использованию
+Bazaar_. А именно, использование распределенной системы контроля версий
+Bazaar_, в централизованном стиле. Bazaar_ разработана, что бы быть гибкой
+и допускать различные подходы к работе, начиная от полностью
+децентрализованного, до практически централизованного. Подход описанный
+здесь позволяет новым пользователям проще вникнуть в более продвинутое
+использование Bazaar_ и смешивать централизованные и децентрализованные
+операции.
+
+В общем случае, данный документ интересен для пользователей переходящих с
+централизованных систем, таких как CVS, или Subversion. В таких системах
+обычно есть единственный центральный сервер на котором хранится код
+проекта и участники команды работают над этим кодом, синхронизируя свою
+работу. Такой режим так же подходит для разработчика-одиночки,
+работающего на нескольких различных машинах.
+
+.. _Bazaar: http://bazaar-vcs.org
+
+.. contents::
+        Содержание
+
+
+Начальные установки
+===================
+
+В самом начале, для более удобной работы с Bazaar_, желательно осуществить
+достаточно простые шаги по настройке.
+
+
+Настройка e-mail пользователя
+-----------------------------
+
+Строка идентифицирующая пользователя сохраняется при каждой фиксации. Хотя
+она не обязательно должна быть аккуратной или уникальной она будет
+использоваться в сообщениях журнала и аннотациях, таким образом лучше что
+бы она была похожа на что-то реальное.
+
+::  
+
+   % bzr whoami "Иван Пупкин <ivan@pupkin.ru>"
+
+
+Настройка локального репозитория
+--------------------------------
+
+В общем случае ветки Bazaar_ копируют полную историю изменений вместе с
+собой, что, кстати, позволяет работать в полностью децентрализованном
+стиле. Как оптимизация для связанных веток возможно объединять их
+хранилища таким образом, что отпадает необходимость в копировании полной
+истории изменений при создании новой ветки.
+
+Лучший способ сделать это - создать `Разделяемый репозиторий`_. В общем
+случае, ветки будут разделять хранилище если они находятся в подкаталоге
+этого репозитория. Давайте создадим `Разделяемый репозиторий`_ в нашем
+домашнем каталоге и таким образом все ветки которые мы будем создавать
+под ним будут разделять хранилище истории.
+
+::
+
+  % bzr init-repo --trees ~
+
+
+Настройка удаленного репозитория
+--------------------------------
+
+Во многих случаях нужно создавать место где данные хранятся отдельно от
+рабочего каталога. Такой подход необходим для централизованных систем
+(CVS/SVN). Обычно эти каталоги находятся на различных машинах, хотя и не
+всегда. На самом деле это достаточно хороший подход, особенно в рабочей
+среде. Так как здесь существует центральная точка, где могут быть сохранены
+все данные и даже если что-то случится с машиной разработчика
+зафиксированная работа не будет потеряна.
+
+Давайте создадим разделяемое место для нашего проекта на удаленной машине
+и назовем его ``centralhost``. Мы снова используем `Разделяемый
+репозиторий`_ для оптимизации использования дисков.
+
+::
+
+  % bzr init-repo --no-trees sftp://centralhost/srv/bzr/
+
+Можно рассматривать этот шаг как похожий на установку CVSROOT, или
+репозитория Subversion. Опция {{{--no-trees}}} указывает Bazaar не
+создавать рабочий каталог в репозитории. Нам это подходит, т.к. никто
+не будет напрямую что-то изменять на ветках в центральном репозитории.
+
+
+Миграция рабочего проекта в Bazaar
+==================================
+
+Теперь, когда у нас есть репозиторий давайте создадим проект под контролем
+версий. В большинстве случаев у вас уже есть какой-то код с которым вы
+работаете и для хранения которого вы хотели бы использовать Bazaar_. Если
+код изначально уже был под контролем версий существует много способов
+конвертировать проект в Bazaar_ без потери истории изменений. Но эти
+способы находятся вне тем рассматриваемых в данном документе. Смотрите
+`Отслеживание изменений на основной ветке`_ для некоторых способов (секция
+"Конвертирование и сохранение истории").
+
+.. _Отслеживание изменений на основной ветке: http://bazaar-vcs.org/TrackingUpstream
+
+.. 
+   TODO: На самом деле нам нужен другой документ для описания
+   конвертирования проекта. Но пока ссылка выше - это лучшее.
+
+
+Разработчик 1: Создание первой ревизии
+--------------------------------------
+
+Сначала нам нужно создать ветку в нашем удаленном репозитории, там где мы
+хотели бы хранить наш проект. Допустим, что у нас уже есть проект "sigil",
+который мы хотели бы хранить под контролем версий.
+
+::
+
+  % bzr init sftp://centralhost/srv/bzr/sigil
+
+Это можно рассматривать как ветку "HEAD" в терминах CVS, или как "trunk" в
+терминах Subversion. Назовем это веткой разработки ``dev``.
+
+Я предпочитаю работать в подкаталоге моего домашнего каталога, что бы
+избегать коллизий со всеми другими файлами которые в ней находятся. Также
+нам понадобится каталог для проекта где мы сможем хранить различные ветки
+проекта над которыми работаем.
+
+::
+
+  % cd ~
+  % mkdir work
+  % cd work
+  % mkdir sigil
+  % cd sigil
+  % bzr checkout sftp://centralhost/srv/bzr/sigil dev
+  % cd dev
+  % cp -ar ~/sigil/* .
+  % bzr add
+  % bzr commit -m "Первый импорт Sigil"
+
+Выше мы создали пустую ветку ``/sigil`` на ``centralhost`` и затем
+загрузили эту пустую ветку на нашу рабочую машину что бы добавить файлы из
+нашего старого проекта. Есть много способов настроить свой рабочий
+каталог, но шаги выше упрощают дальнейшую работу с ветками для работы
+над ошибками, или новыми функциями. И одна из наиболее сильных сторон
+Bazaar_ - это именно отличная работа с ветками.
+
+На этом этапе, т.к. мы создали рабочую копию (checkout) удаленной ветки,
+все фиксации которые будут сделаны в ``~/work/sigil/dev/`` будут
+автоматически сохранены и локально и на ``centralhost``.
+
+
+Разработчик N: Получение рабочей копии проекта
+----------------------------------------------
+
+Так как первый разработчик проделал всю работу по созданию проекта все
+остальные разработчики могут просто получить рабочую копию ветки. Хотя
+**они все еще должны следовать** разделам `Настройка e-mail пользователя`_ и
+`Настройка локального репозитория`_.
+
+Получим рабочую копию текущего дерева разработки::
+
+  % cd ~/work/sigil
+  % bzr checkout sftp://centralhost/srv/bzr/sigil dev
+
+Теперь, когда два человека имею рабочую копию
+``sftp://centralhost/srv/bzr/sigil`` будут ситуации когда одна из копий
+будет не синхронизирована с текущей версией. Во время фиксации Bazaar_
+проинформирует пользователя об этом и не допустит фиксации. Для получения
+последних изменений нужно использовать ``bzr update``. Эта команда может
+потребовать разрешения конфликтов если были изменены одни и те же файлы.
+
+
+Разработка на отдельных ветках
+==============================
+
+До этого момента все работали и фиксировали изменения на одну и ту же
+ветку. Это значит, что каждый должен периодически обновлять свою ветку и
+иметь дело с изменениями других разработчиков. Так же если один
+разработчик фиксирует что-то, что приводит к ошибкам, то после
+синхронизации эта проблема коснется каждого.
+
+Обычно лучше вести разработку на различных ветках и затем, как только
+изменения достаточно стабильны, интегрировать их обратно на основную
+ветку. Это одно из наибольших изменений по сравнению с работой в CVS/SVN.
+Обе эти системы позволяют работать с отдельными ветками, но их алгоритмы
+объединения достаточно слабы и поэтому с ними сложно держать все
+синхронизировано. Bazaar_ отслеживает что уже было объединено и может даже
+прикладывать изменения к файлам которые были переименованы.
+
+
+Создание и работа на новой ветке
+--------------------------------
+
+Мы бы хотели, что бы наши изменения были доступны другим даже если они
+пока еще не закончены. Таким образом мы создадим новую публичную ветку на
+``centralhost`` и будем отслеживать ее локально.
+
+::
+
+  % cd ~/work/sigil
+  % bzr branch sftp://centralhost/srv/bzr/sigil \
+               sftp://centralhost/srv/bzr/sigil/doodle-fixes
+  % bzr checkout sftp://centralhost/srv/bzr/sigil/doodle-fixes doodle-fixes
+  % cd doodle-fixes
+
+Теперь у нас есть место где мы можем исправлять все ошибки для ``doodle``.
+И мы не будем прерывать никого кто работает над другими частями кода. Так
+как у нас есть рабочая копия (checkout) все фиксации которые мы делаем на
+``~/work/sigil/doodle-fixes/`` так же появятся и на ``centralhost``.
+[#nestedbranches]_ Также возможно, что бы два разработчика совместно
+работали над одной из этих веток, так же как они совместно работают над
+веткой ``dev``. [#cbranch]_
+
+.. [#nestedbranches] Может показаться странным иметь ветку в подкаталоге
+   другой ветки. Но это нормально, можно думать об этом как о
+   иерархическом пространстве имен где вложенная ветка является
+   производной от внешней ветки.
+
+.. [#cbranch] Когда используется множество независимых веток каждый раз
+   набирать полный URL занимает много времени. Мы рассматриваем различные
+   методы, что бы обойти это, например псевдонимы для веток и т.п. Но пока
+   плагин bzrtools_ предоставляет команду ``bzr cbranch``. Эта команда на
+   основе базовой ветки создает новую публичную ветку и рабочую копию этой
+   ветки всего одной командой. Конфигурирование ``cbranch`` не входит в
+   рамки описания этого документа, но финальная команда выглядит следующим
+   образом:
+
+   ::
+
+   % bzr cbranch dev my-feature-branch
+
+.. _bzrtools: http://bazaar-vcs.org/BzrTools
+
+
+Объединение изменений обратно
+-----------------------------
+
+Когда решено что некоторые изменения из ``doodle-fixes`` готовы для
+объединения на основную ветку нужно просто сделать следующее::
+
+  % cd ~/work/sigil/dev
+  % bzr merge ../doodle-fixes
+
+Теперь изменения доступны на ветке ``dev``, но они пока еще не были
+зафиксированы. В этот момент нужно просмотреть финальные изменения и
+проверить, что код компилируется и проходят все тесты. Команды ``bzr
+status`` и ``bzr diff`` хорошие инструменты для этого. Так же нужно
+разрешить возможные конфликты. Bazaar_ не допустит фиксации пока не будут
+разрешены все конфликты. В этом случае вы случайно не зафиксируете маркеры
+конфликта. Команда ``bzr status`` покажет конфликты и изменения, или можно
+использовать ``bzr conflicts`` что бы увидеть только конфликты.
+Используйте ``bzr resolve file/name``, или ``bzr resolve --all`` как
+только конфликты были разрешены. [#resolve]_ Если существуют конфликты
+которые особенно сложно разрешить можно использовать команду ``bzr
+remerge``. Эта команда позволит использовать другие алгоритмы объединения
+и также позволит увидеть строки оригинального кода (``--show-base``).
+
+.. [#resolve] Некоторые системы позволяют разрешать конфликты как часть
+   процесса объединения. Мы обнаружили, что обычно проще разрешать
+   конфликты когда можно просматривать полное дерево, а не только
+   отдельные файлы. Это дает намного больше контекста и также позволяет
+   запускать тесты когда проблема будет решена.
+
+
+Рекомендации по созданию веток
+------------------------------
+
+Один из часто используемых способов работы с набором веток - это дать
+каждому разработчику свою собственную ветку и собственное место для работы
+на центральном сервере. Это можно сделать так::
+
+  % bzr branch sftp://centralhost/srv/bzr/sigil \
+               sftp://centralhost/srv/bzr/sigil/user-a
+  % bzr branch sftp://centralhost/srv/bzr/sigil \
+               sftp://centralhost/srv/bzr/sigil/user-b
+
+Это дает каждому разработчику собственную ветку для работы. И они смогут
+легко создать новые ветки с помощью [#cbranch]_
+::
+
+  % bzr branch sftp://centralhost/srv/bzr/sigil/user-a \
+               sftp://centralhost/srv/bzr/sigil/user-a/feature 
+  % cd ~/work/sigil
+  % bzr checkout sftp://centralhost/srv/bzr/sigil/user-a/feature myfeature
+
+
+Глоссарий
+=========
+
+Разделяемый репозиторий
+-----------------------
+
+Bazaar_ поддерживает концепцию "Разделяемый репозиторий". Эта концепция
+похожа на традиционные концепции репозиториев в других системах контроля
+версий, таких как CVS, или Subversion. Например, в Subversion у вас есть
+удаленный репозиторий, где хранится вся история и локально история не
+хранится, а хранится только рабочая копия файлов. Конечно "Разделяемый" в
+данном контексте значит, что он разделен между ветками. Он *может* быть
+разделен между людьми, но отдельные ветки также могут быть разделены между
+людьми.
+
+В Bazaar_ термин "Разделяемый репозиторий" - это место где несколько веток
+могут *разделять* их историю ревизий. Что бы поддерживать
+децентрализованную схему работы каждая ветка может хранить свою
+собственную историю ревизий. Но часто это не эффективно, т.к. зависимые
+ветки разделяют историю и они могут так же разделять и хранилище истории.
+
+
+.. 
+   vim: tw=74 ft=rst spell spelllang=en_us

=== added file 'doc/ru/tutorials/tutorial.txt'
--- doc/ru/tutorials/tutorial.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/tutorials/tutorial.txt	2009-06-05 18:59:14 +0000
@@ -0,0 +1,591 @@
+.. Этот файл в формате ReStructuredText - он может быть отформатирован в HTML,
+.. или текст. В будущем планируется выделять примеры команд и автоматически
+.. тестировать их.
+
+.. Данный текст сначала был на Wiki
+.. http://bazaar.canonical.com/IntroductionToBzr
+.. но был перемещен в дерево исходного кода что бы синхронизироваться
+.. с исходным кодом и возможно автоматически тестироваться.
+
+==============
+Учебник Bazaar
+==============
+
+Текущая версия для bzr-0.91, 2007-08
+
+
+Введение
+========
+
+Если вы уже знакомы с распределенными системами контроля версий, то можете
+сразу перейти к "Представляемся Bazaar". Если, с другой стороны, вы знакомы с
+системами контроля версий, но не знакомы с распределенными системами, тогда
+стоит начать с "Чем отличаются распределенные системы". Иначе, возьмите кофе
+или чай, расположитесь поудобнее и продолжим чтение.
+
+Назначение контроля версий
+==========================
+
+Есть шансы, что вы уже работали с какими-либо текстовыми данными -- исходниками
+программ, Web-сайтами, или конфигурационными файлами с которыми имеют дело
+администраторы систем Unix в /etc. Также есть хорошие шансы, что вы делали
+ошибки, которые вызывали потом глубокое сожаление. Возможно вы удалили
+конфигурационный файл для вашего почтового сервера, или повредили исходный код
+любимого проекта. Не важно что конкретно случилось, но вы просто удалили важную
+информацию которую вы безнадежно хотели бы вернуть. Если такое когда либо
+случалось с вами, то вы возможно готовы для Bazaar.
+
+Системы контроля версий, такие как Bazaar дают возможность отслеживать
+изменения для каталога, который они изменяют в нечто более сложное, что
+называется **ветка**. Ветка не только сохраняет то как каталог выглядит в
+данный момент, но также как он выглядел в различные моменты в прошлом. Затем,
+когда вы сделаете что-то, что бы вы не хотели делать, вы сможете восстановить
+каталог в том виде как он выглядел в какой-то момент в прошлом.
+
+Системы контроля версий дают пользователям возможность сохранять изменения на
+ветке "фиксируя **ревизию**". Созданная ревизия фактически является сводкой
+изменений, которые были сделаны с последнего момента когда дерево было
+сохранено.
+
+Эти ревизии имеют также и другое назначение. Например, можно комментировать
+ревизии, записав, что значит данный набор изменений, через необязательную
+запись в журнале. Реальные записи в журнале могут быть похожи на "Исправлен
+Web-шаблон для закрытия таблицы" и "Добавлена поддержка SFTP. Исправлен #595"
+
+Мы храним этот журнал, что бы позже, в случае каких-либо проблем с SFTP, можно
+было определить когда могла произойти проблема.
+
+Чем отличаются распределенные системы
+-------------------------------------
+
+Многие системы контроля версий хранят данные на серверах. Если кто-то хочет
+работать с кодом, который хранится в системе тогда ему нужно установить
+соединение с сервером и "создать рабочую копию" кода. При этом создается
+каталог в котором можно менять файлы и затем фиксировать изменения. Клиент
+системы затем соединяется с сервером системы и сохраняет изменения. Этот метод
+известен как централизованная модель.
+
+Централизованная модель может иметь некоторые недостатки. Централизованная
+система требует наличия соединения с сервером для любых действий по контролю
+версий. Это может быть проблематичным если сервер находится на другой машине в
+интернете, а клиент - нет. Или, хуже, клиент **в** интернете, а сервер - нет.
+
+Распределенные системы контроля версий обходят эту проблему сохраняя ветки на
+той же машине на которой находится клиент. В случае с Bazaar, ветка находится в
+том же самом месте, что и код хранящийся под контролем версий. Это позволяет
+пользователю сохранять (**фиксировать**) изменения когда он захочет -- даже без
+сетевого подключения. Пользователю нужен доступ к интернету только когда он
+хочет получить доступ к чьей-либо ветке в другом месте.
+
+Общее требование, что многие люди хотят отслеживать изменения для каталога,
+такие как изменения файлов и изменения в подкаталогах. Отслеживать это
+"руками" ужасный процесс, который со временем становится громоздким. До тех пор
+пока вы не попробуете систему контроля версий, такую как Bazaar. Такие
+инструменты автоматизируют процесс сохранения данных, создавая **ревизии**
+дерева каталога когда пользователь запрашивает сделать это.
+
+Системы контроля версий, такие как Bazaar, могут делать намного больше чем
+просто хранить изменения и отменять ошибочные действия. Например, с помощью
+Bazaar разработчики могут взять изменения кода на одной ветке и объединить их
+со связанной веткой -- даже если эти изменения хранятся на ветке которую создал
+кто-то другой. Это позволяет разработчикам сотрудничать без необходимости
+открывать доступ на запись к репозиторию.
+
+Bazaar помнит ''предков'' ревизии: предыдущие ревизии на которых основана
+текущая ревизия. Одна ревизия может иметь больше одного прямого потомка, каждый
+из которых со своими изменениями, что представляет дивергенцию в эволюции
+дерева. Создание веток в Bazaar позволяет нескольким людям сотрудничать в
+эволюции проекта, без необходимости работать жестко по шагам. Создание веток
+может быть полезным даже для одного разработчика.
+
+Представляемся Bazaar
+=====================
+
+Bazaar устанавливает единственную новую команду, **bzr**. Все возможности
+предоставляются через под-команды этой команды. Вы можете просмотреть краткую
+справку командой ``bzr help``. Некоторые идеи группируются по темам,
+используйте ``bzr help topics`` для списка доступных тем.
+
+Одна из функций системы контроля версий -- отслеживать кто сделал изменения. В
+распределенных системах для этого требуется идентифицировать каждого автора
+уникально в глобальном плане. Большинство людей уже имеют такой идентификатор:
+email адрес. Bazaar достаточно умен, что бы автоматически создавать email адрес
+из текущего имени и адреса хоста. Если вам не нравится предположение которое
+делает Bazaar вы сможете выбрать из трех опций:
+
+ #. Установить email адрес через ``bzr whoami``. Это наиболее простой путь.
+
+    Что бы установить такой глобальный идентификатор, используйте::
+
+     % bzr whoami "Ваше Имя <email@example.com>"
+
+    Если вы хотите использовать разные адреса для разных веток, то зайдите
+    в каталог с веткой и используйте::
+
+     % bzr whoami --branch "Ваше Имя <email@example.com>"
+
+ #. Установить email адрес в ``~/.bazaar/bazaar.conf`` [1]_, добавив следующие
+    строчки. Заметьте, что ``[DEFAULT]`` зависит от регистра символов::
+
+        [DEFAULT]
+        email=Ваше Имя <email@isp.com>
+
+    Как и выше вы можете переопределить эти установки для каждой ветки
+    создав секцию для ветки в ``~/.bazaar/locations.conf`` и добавив
+    следующие строчки::
+
+        [/путь/к/ветке]
+        email=Ваше Имя <email@isp.com>
+
+ #. Переопределить два предыдущих способа, установив ваш полный email адрес в
+    глобальную переменную среды ``$BZR_EMAIL``, или ``$EMAIL`` (``$BZR_EMAIL``
+    имеет больший приоритет).
+
+.. [1] Для Windows пользовательские файлы конфигурации могут быть найдены в
+   каталоге с данными приложений. Таким образом вместо
+   ``~/.bazaar/branch.conf`` конфигурация может быть найдена в:
+   ``C:\Documents and Settings\<пользователь>\Application Data\Bazaar\2.0\branch.conf``. Там же могут
+   быть найдены ``locations.conf``, ``ignore`` и каталог ``plugins``.
+
+Создаем ветку
+=============
+
+История по-умолчанию хранится на ветке в каталоге .bzr. В будущих версиях
+Bazaar будут средства для хранения истории в отдельном репозитории, который
+также сможет быть удаленным.
+
+Мы создаем новую ветку выполнив ``bzr init`` в уже созданном каталоге::
+
+    % mkdir tutorial
+    % cd tutorial
+    % ls -a
+    ./  ../
+    % pwd
+    /home/mbp/work/bzr.test/tutorial
+    %
+    % bzr init
+    % ls -aF
+    ./  ../  .bzr/
+    %
+
+Как и в CVS здесь три класса файлов: неизвестные, игнорируемые и под контролем
+версий. Команда **add** ставит файл под контроль версий, т.е. изменения в нем
+будут записываться системой::
+
+    % echo 'hello world' > hello.txt
+    % bzr status
+    unknown:
+      hello.txt
+    % bzr add hello.txt
+    added hello.txt
+    % bzr status
+    added:
+      hello.txt
+
+Если вы добавили не тот файл просто сделайте ``bzr remove``, что бы сделать его
+опять неизвестным. Рабочая копия файла не будет удалена в этом случае, хотя она
+может быть удалена в других случаях [2]_.
+
+.. [2] ``bzr remove`` удалит рабочую копию если она находится под контролем
+   версий, но не имеет изменений с последней зафиксированной версии. Вы
+   можете оставить файл указав опцию ``--keep`` для ``bzr remove``, или
+   удалить с опцией ``--force``.
+
+Размещение веток
+================
+
+Вся история хранится на ветке, которая является всего лишь каталогом на диске
+содержащим файлы управления. По-умолчанию здесь нет отдельного репозитория, или
+базы данных как в svn, или svk. По желанию вы можете создать репозиторий (см.
+команду ``bzr init-repo``). Это можно сделать в случае очень больших веток, или
+большого количества веток для проекта среднего размера.
+
+Мы обычно обращаемся к веткам на нашем компьютере просто передав имя каталога
+содержащего ветку. bzr также поддерживает доступ к веткам через http и sftp,
+например::
+
+    % bzr log http://bazaar-vcs.org/bzr/bzr.dev/
+    % bzr log sftp://bazaar-vcs.org/bzr/bzr.dev/
+
+Установив для bzr плагины можно также осуществлять доступ к веткам с
+использованием rsync.
+
+Смотрите секцию `Публикация ветки`_ что бы получить больше информации о том как
+поместить свою ветку в нужное место.
+
+Просмотр изменений
+==================
+
+Как только вы закончили свою работу, вы захотите **зафиксировать** ее в истории
+ревизий. Хорошая практика фиксировать изменения достаточно часто: когда
+заработала новая функциональность, исправлена ошибка, или улучшен код, или
+документация. При этом стоит проверить, что код компилируется и проходит все
+тесты перед фиксацией, что бы быть уверенным, что каждая ревизия в хорошем
+состоянии. Также можно просмотреть свои изменения, для уверенности, что вы
+фиксируете именно то, что хотели и получить шанс проверить свою работу перед
+тем как записать ее постоянно.
+
+Две команды bzr особенно полезны здесь: **status** и **diff**.
+
+bzr status
+----------
+
+Команда **status** показывает какие изменения были сделаны в рабочем каталоге
+с момента последней ревизии::
+
+    % bzr status
+    modified:
+       foo
+
+``bzr status`` скрывает "неинтересные" файлы которые, либо не менялись, либо
+игнорируются. Также команде status могут быть переданы необязательные имена
+файлов, или каталогов для проверки.
+
+bzr diff
+--------
+
+Команда **diff** показывает изменения в тексте файлов в стандартном формате
+diff. Вывод этой команды может быть передан другим командам, таким как
+''patch'', ''diffstat'', ''filterdiff'' и ''colordiff''::
+
+    % bzr diff
+    === added file 'hello.txt'
+    --- hello.txt   1970-01-01 00:00:00 +0000
+    +++ hello.txt   2005-10-18 14:23:29 +0000
+    @@ -0,0 +1,1 @@
+    +hello world
+
+С опцией ``-r`` дерево файлов сравнивается с ранней ревизией, или показываются
+изменения между двумя ревизиями::
+
+    % bzr diff -r 1000..          # изменения начиная с r1000
+    % bzr diff -r 1000..1100      # изменения c 1000 до 1100
+
+Опция ``--diff-options`` говорит bzr запустить внешнюю программу diff, передав
+ей опции. Например::
+
+    % bzr diff --diff-options --side-by-side foo
+
+Некоторые проекты предпочитают показывать префиксы в начале текста изменений
+для старых (old) и новых (new) файлов. Опция ``--prefix`` может быть
+использована для установки такого префикса. Плюс к этому команда ``bzr diff
+-p1`` выводит префиксы в форме которая подходит для команды ``patch -p1``.
+
+Фиксация изменений
+==================
+
+Когда состояние рабочего дерева подходит для сохранения оно может быть
+**зафиксировано** на ветке, что создаст новую ревизию содержащую снимок
+состояния дерева.
+
+bzr commit
+----------
+
+Команде **commit** можно передать сообщение описывающее изменения в ревизии.
+Она также записывает идентификатор пользователя, текущее время и временную
+зону, плюс список измененных файлов и их содержимого. Сообщение описывающее
+изменения определяется через опцию ``-m``, или ``--message``. Можно также
+вводить сообщения состоящие из нескольких строк; в большинстве оболочек вы
+можете сделать это оставив открытую кавычку в конце строки.
+
+::
+
+    % bzr commit -m "добавлен первый файл"
+
+Также можно использовать опцию ``-F``, для получения сообщения из файла.
+Некоторые люди делают заметки изменений во время работы над ними, а затем
+просматривают изменения, что бы быть уверенными, что они сделали то, что хотели
+сделать. (Этот файл может быть также полезен когда вы возвращаетесь к своей
+работе после перерыва.)
+
+Сообщение из текстового редактора
+=================================
+
+Если вы не используете опции ``-m`` и ``-F`` тогда bzr откроет текстовый
+редактор для ввода сообщения. Какой редактор запускать может быть настроено
+через переменные среды ``$VISUAL``, или ``$EDITOR``, которые могут быть
+переопределены опцией ``editor`` в файле ``~/.bazaar/bazaar.conf``; опция
+``$BZR_EDITOR`` переопределяет все описанные выше настройки. Если вы выходите
+из редактора без каких-либо изменений, то фиксация будет прервана.
+
+Файл который открывается в редакторе содержит горизонтальную линию. Часть файла
+ниже этой линии включена только для информации и не будет частью сообщения об
+изменениях. Ниже линии показывается список файлов которые были изменены. Для
+создания сообщения вам надо написать свое сообщение выше линии, сохранить его и
+выйти из редактора.
+
+Если вы хотите увидеть изменения содержимого файлов которые будут
+зафиксированы, при редактировании сообщения вам нужно указать опцию
+``--show-diff`` для команды ``commit``. Эта опция добавит изменения в файл
+который будет открыт в редакторе ниже линии и списка измененных файлов. Это
+значит, что вы можете читать изменения при редактировании сообщения, но они не
+будут включены в сообщение когда вы закончите редактировать. Если вы хотите,
+что бы части изменений были включены в сообщение вы можете скопировать и
+вставить их выше ограничительной линии.
+
+Выборочная фиксация
+-------------------
+
+Если вы передадите список имен файлов, или каталогов после команды commit, то
+будут зафиксированы только изменения для переданных объектов. Например::
+
+    % bzr commit -m "исправления документации" commit.py
+
+По умолчанию bzr всегда фиксирует все изменения для дерева, даже если запущен
+из подкаталога. Что бы зафиксировать только изменения от текущего каталога
+и ниже, используйте::
+
+    % bzr commit .
+
+
+Удаление не зафиксированных изменений
+=====================================
+
+Если вы сделали какие-либо изменения и не хотите оставлять их, используйте
+команду **revert**, что бы вернутся к состоянию предыдущей ревизии. Хорошая
+идея, использовать сначала ``bzr diff`` для просмотра изменений. По умолчанию
+команда revert отменяет изменения на всем дереве, но если ей переданы имена
+файлов, или каталогов то будут затронуты только они. ``bzr revert`` также
+очищает список ревизий ожидающих объединения.
+
+Игнорирование файлов
+====================
+
+Многие деревья с исходным кодом содержат файлы которые не нужно хранить под
+контролем версий, например резервные файлы текстового редактора, объектные
+файлы и собранные программы. Вы можете просто не добавлять их, но они всегда
+будут обнаруживаться как неизвестные. Вы также можете сказать bzr игнорировать
+их добавив их в файл ``.bzrignore`` в корне рабочего дерева.
+
+Этот файл содержит список шаблонов файлов, по одному в каждой строчке. Обычное
+содержимое может быть таким::
+
+    *.o
+    *~
+    *.tmp
+    *.py[co]
+
+Если шаблон содержит слеш, то он будет сопоставлен с полным путем начиная от
+корня рабочего дерева; иначе он сопоставляется только с именем файла. Таким
+образом пример выше игнорирует файлы с расширением ``.o`` во всех
+подкаталогах, но пример ниже игнорирует только ``config.h`` в корне рабочего
+дерева и HTML файлы в каталоге ``doc/``::
+
+    ./config.h
+    doc/*.html
+
+Для получения списка файлов которые игнорируются и соответствующих им шаблонов
+используйте команду ``bzr ignored``::
+
+    % bzr ignored
+    config.h                 ./config.h
+    configure.in~            *~
+
+Нет проблем если шаблон для игнорирования подходит для файла под контролем
+версий, или вы добавили файл который игнорируется. Шаблоны не имеют никакого
+эффекта на файлы под контролем версий, они только определяют показываются
+неизвестные файлы, или просто игнорируются.
+
+Файл ``.bzrignore`` обычно должен быть под контролем версий, что бы новые копии
+ветки видели такие же шаблоны::
+
+    % bzr add .bzrignore
+    % bzr commit -m "Добавлены шаблоны для игнорирования"
+
+
+Глобальные шаблоны для игнорирования
+------------------------------------
+
+Обычно есть файлы которые нужно игнорировать и они не специфичны для отдельных
+проектов, а скорее специфичны для пользователя. Например, временные файлы
+текстового редактора, или персональные временные файлы. Вместо того, что бы
+добавлять их для игнорирования в каждом проекте, bzr поддерживает глобальный
+файл игнорирования ``~/.bazaar/ignore`` [1]_. Он имеет такой же синтаксис, что
+и файл игнорирования для каждого проекта.
+
+
+Просмотр истории
+================
+
+bzr log
+-------
+
+Команда ``bzr log`` показывает список предыдущих ревизий. Команда ``bzr log
+--forward`` делает тоже самое, но в хронологическом порядке, показывая более
+поздние ревизии в конце.
+
+Как и ``bzr diff``, ``bzr log`` поддерживает опцию ``-r``::
+
+    % bzr log -r 1000..          # Ревизия 1000 и все после нее
+    % bzr log -r ..1000          # Все до и включая r1000
+    % bzr log -r 1000..1100      # изменения с 1000 до 1100
+    % bzr log -r 1000            # Изменения только для ревизии 1000
+
+
+Статистика ветки
+================
+
+Команда ``bzr info`` показывает суммарную информацию о рабочем дереве и истории
+на ветке.
+
+
+Каталоги под контролем версий
+=============================
+
+bzr может контролировать файлы и каталоги, отслеживая переименования и
+упрощая их последующее объединение::
+
+    % mkdir src
+    % echo 'int main() {}' > src/simple.c
+    % bzr add src
+    added src
+    added src/simple.c
+    % bzr status
+    added:
+      src/
+      src/simple.c
+
+
+Удаление файлов
+===============
+
+Вы можете удалить файл, или каталог из под контроля версий просто удалив их
+из рабочего каталога. Это немного отличается от CVS, которая требует что бы вы
+также сделали ``cvs remove``.
+
+``bzr remove`` удаляет файл из под контроля версий, но может и не удалять
+рабочую копию файла [2]_. Это удобно когда вы добавили не тот файл, или решили,
+что файл на самом деле не должен быть под контролем версий.
+
+::
+
+    % rm -r src
+    % bzr remove -v hello.txt
+    ?       hello.txt
+    % bzr status
+    removed:
+      hello.txt
+      src/
+      src/simple.c
+    unknown:
+      hello.txt
+
+Если вы вдруг удалили не тот файл, то вы можете использовать ``bzr revert`` что
+бы восстановить его.
+
+
+Ветвление
+=========
+
+Часто вместо того что бы начинать свой собственный проект, вы хотите предложить
+изменения для уже готового проекта. Что бы сделать это вам нужно получить копию
+готовой ветки. Так как эта копия может быть потенциальной новой веткой эта
+команда называется **branch**::
+
+    % bzr branch http://bazaar-vcs.org/bzr/bzr.dev 
+    % cd bzr.dev
+
+Эта команда копирует полную историю ветки и после этого вы можете делать все
+операции с ней локально: просматривать журнал, создавать и объединять другие
+ветки. Здесь также есть опция для получения только части истории если это
+необходимо.
+
+Копию другой ветки можно также получить просто скопировав ее каталог,
+развернув архив, или скопировав удаленно через такую утилиту как rsync.
+
+
+Следование за изменениями основного проекта
+===========================================
+
+Вы можете обновлять свою ветку из родительской через получение ее изменений::
+
+    % bzr pull
+
+После этого локальный каталог будет копией родительского. Это включает и
+''историю ревизий'' - список изменений сделанных на родительской ветке, а не
+объединенных с других веток.
+
+Эта команда работает только если локальная ветка, либо более старая копия
+родительской ветки без новых фиксаций, либо все последние фиксации уже были
+объединены с родительской веткой.
+
+Объединение со связанных веток
+==============================
+
+Если две ветки разошлись (обе имеют уникальные изменения) тогда ``bzr merge`` -
+это подходящая команда для использования. Объединение автоматически вычислит
+изменения которые существуют на объединяемой ветке и отсутствуют в локальной
+ветке и попытается объединить их с локальной веткой.
+
+::
+
+  % bzr merge URL
+
+В случае конфликта при объединении будут созданы три файла с одними именем, но
+разными расширениями. Файл с общими изменениями будет с расширением ".BASE",
+файл с локальными изменениями будет с расширением ".THIS" и файл с изменениями
+из объединяемой ветки будет с расширением ".OTHER". Используя такую программу
+как kdiff3 вы теперь сможете достаточно легко объединить их в один файл. Для
+фиксации изменений вам нужно переименовать объединенный файл (".THIS") в файл с
+оригинальным именем. И для завершения исправления конфликта нужно использовать
+команду resolve, которая удалит файлы ".OTHER" и ".BASE". Команда commit будет
+выдавать ошибку пока существует один из файлов с расширением .BASE, .THIS, или
+.OTHER.
+
+::
+
+  % kdiff3 file.BASE file.OTHER file.THIS
+  % mv file.THIS file
+  % bzr resolve file
+
+[**TODO**: описать маркеры конфликтов внутри файлов]
+
+
+Публикация ветки
+================
+
+Для публикации ветки bzr вам не нужен специализированный сервер, нужен просто
+обычный Web-сервер. Просто перенесите файлы на ваш сервер, включая каталог
+.bzr. Можно опубликовать ветку (или изменения на ветке) одним из следующих трех
+способов:
+
+* Лучший способ - использовать для этого сам bzr.
+
+  ::
+
+    % bzr push sftp://servername.com/path/to/directory 
+
+  (Каталог назначения должна быть создан заранее, если только не указана
+  опция ``--create-prefix``)
+
+* Другой способ - плагин ``rspush`` который включен в BzrTools и использует
+  rsync для публикации изменений в истории ревизий и рабочем дереве.
+
+* Вы также можете скопировать файлы руками, переслав архив, или используя
+  rsync, или другой метод пересылки. Обычно это менее безопасно чем
+  использовать команду ``push``, но может быть быстрее и проще в каких-то
+  ситуациях.
+
+Перемещение изменений между деревьями
+=====================================
+
+Это случается и с лучшими из нас: в какой-то момент вы делаете изменения не в
+том дереве файлов. Возможно потому, что вы случайно начали работать не в том
+каталоге, либо изменений оказались больше чем вы ожидали и вы решили создать
+для них новую ветку.
+
+Для перемещения изменений из одного дерева в другое используйте
+
+::
+
+  % cd NEWDIR
+  % bzr merge --uncommitted OLDDIR
+
+Эта команда перенесет все не зафиксированные изменения с ветки OLDDIR на ветку
+NEWDIR. Команда не будет переносить зафиксированные изменения, даже если они
+могли бы быть объединены с NEWDIR обычным объединением. Изменения также
+остаются и в OLDDIR, но вы можете использовать ``bzr revert OLDDIR`` для их
+удаления, как-то только убедитесь, что с NEWDIR все нормально.
+
+NEWDIR не обязательно должен быть копией OLDDIR, но они должны быть связанными
+ветками. Чем больше они отличаются, тем больше шанс возникновения конфликтов.

=== added file 'doc/ru/tutorials/using_bazaar_with_launchpad.txt'
--- doc/ru/tutorials/using_bazaar_with_launchpad.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/tutorials/using_bazaar_with_launchpad.txt	2009-05-31 11:46:02 +0000
@@ -0,0 +1,461 @@
+================================
+Использование Bazaar с Launchpad
+================================
+
+.. contents::
+	Содержание
+.. sectnum::
+
+Мотивация
+=========
+
+Сообщества отличаются от команд
+-------------------------------
+
+Количество человек в команде, необходимой для создания первой версии
+какого-либо программного обеспечения, может различаться в разы - от одного
+человека до нескольких тысяч. В зависимости от требований, сложность задач, как
+технических, так и управленческих, может быть просто огромна. Как описано в
+Руководстве пользователя Bazaar, выбор "правильных" процессов и использование
+таких инструментов как Bazaar, может существенно помочь в поддержке
+соответствующих рабочих циклов.
+
+Но успех программного обеспечения требует больше чем просто хорошую команду -
+здесь требуется здоровое и активное *сообщество*. Обычно эта группа намного
+больше команды, поскольку включает всех заинтересованных в данном программном
+обеспечении: команду разработки, пользователей, партнеров по подготовке
+кадров, партнеров по поддержке, сторонних разработчиков и так далее.
+
+Хорошие сообщества хорошо известны в мире открытого исходного кода. Но их
+полезность намного выше этого: большинство успешных поставщиков коммерческого
+программного обеспечения достаточно опытны в создании и управлении
+сообществами, которые растут вокруг их флагманских продуктов.
+
+Как и хорошие команды, хорошие сообщества не появляются просто так. Правильная
+политика и руководящие принципы имеют основополагающее значение при развитии
+правильного поведения и здорового отношения между участниками. Для более
+подробного понимания этой темы можно обратится к основополагающей книге Карла
+Фогеля (Karl Fogel): `Создание программного обеспечения с открытым кодом
+(Producing Open Source Software) <http://www.producingoss.com/>`_.
+
+
+Потребность в совместных средах разработки
+------------------------------------------
+
+Развитый набор инструментов также важен для отслеживания и управления
+информацией и рабочими процессами в сообществе. Такие инструменты называются
+совместными средами разработки (Collaborative Development Environments
+(CDEs)). Обычно эти инструменты работают на базе Web'а и управляют такими
+вещами как анонсы, задачи и ошибки, вопросы и ответы, ресурсы для скачивания,
+документы и исходный код. Вот несколько примеров совместных сред разработки:
+`Launchpad <https://launchpad.net>`_,
+`SourceForge <http://sourceforge.net>`_,
+`java.net <http://java.net>`_ и
+`SAP Community Network <https://www.sdn.sap.com/irj/sdn>`_.
+
+
+Помощь сообществам в работе с зависимыми от них сообществами
+------------------------------------------------------------
+
+Многие успешные продукты имеют большое число зависящих от них проектов.
+Другими словами, с успехом проекта появляется новая задача: общение с другими
+сообществами и понимание того как ваши изменения скажутся на них. Это наиболее
+очевидно для таких проектов как:
+
+* языков программирования, например, Python, PHP, Ruby, Java, Perl и др.
+* компиляторов, например, gcc, JDK и др.
+* библиотек, например, zlib, openssl и др.
+* каркасов, например, Zope, Ruby on Rails, Spring и др.
+
+В равной степени это относится и к популярным приложениям для которых могут
+создаваться дополнения, например, Firefox, Thunderbird, OpenOffice.org,
+Drupal, Wordpress, Joomla и др.
+
+Здесь необходимы инструменты, которые помогают сообществам работать вместе над
+отслеживанием и управлением задачами и исправлениями между сообществами. Такие
+инструменты помогают людям по обе стороны:
+
+* пользователи могут сообщить о проблемах своими словами, например, построение
+  изображения типа X не работает в приложении Y под операционной системой Z.
+
+* разработчики могут лучше оценить реакцию на сделанное изменение или
+  исправление, например, сделает ли исправление этой ошибки в графической
+  библиотеки счастливее пользователей этих 5-и приложений под этими 10-ю
+  операционными системами.
+
+Посредники играют важную роль *соединяя точки* и создавая коммуникацию между
+верхней и нижней точками линии. Во многих случаях, они могут так же исправить
+проблему для конечного пользователя, выпустив заплатку и передав рекомендуемое
+исправление основной команде разработчиков. Отслеживание всего этого в течении
+продолжительного времени - задача не из легких.
+
+Launchpad: Больше разработки, меньше трений
+-------------------------------------------
+
+Кроме спонсорства разработки `Ubuntu <http://www.ubuntu.com>`_ и `Bazaar
+<http://bazaar-vcs.org>`_, Canonical так же предоставляет Launchpad,
+https://launchpad.net, как бесплатный сервис для сообществ с открытым исходным
+кодом. Launchpad является одной из самых интересных сред совместной разработки
+по следующим причинам:
+
+* он создает связь между многими отслеживаемыми сущностями, например, ветки
+  исходного кода могут быть связаны с исправлением ошибок
+
+* кроме управления накопленными знаниями, также предоставляется планирование и
+  поддержка будущего разработки через такие возможности как отслеживание
+  направления развития, контрольные точки и планы развития
+
+* предоставляются инструменты для перевода и сборки пакетов, что снижает
+  барьер для переводчиков и тестеров пожелавших присоединиться к вашему
+  сообществу с помощью
+
+* служит связующим звеном между различными сообществами для совместной работы
+  над связанными задачами и направлениями развития.
+
+Иными словами, Launchpad был разработан чтобы помочь росту вашего сообщества и
+снизить трения при работе как *внутри* сообщества, так и *между* сообществами.
+В конечном счете, это означает, что тратится меньше времени на рутинные задачи
+и больше на интересные разработки.
+
+
+Bazaar: клиент системы контроля версий для Launchpad
+----------------------------------------------------
+
+Это руководство рассматривает как Bazaar и Launchpad могут быть использованы
+вместе и дополнять друг друга. Важно помнить о том, что:
+
+1. Bazaar можно использовать без Launchpad
+2. Launchpad можно использовать без Bazaar.
+
+И все же, по замыслу, их сумма больше чем каждый из инструментов по
+отдельности.
+
+
+Поиск и просмотр веток с помощью Launchpad
+==========================================
+
+Поиск доступных веток
+---------------------
+
+Хотя использование распределённой системы контроля версий даёт много
+преимуществ, в то же время исчезает всезнающий центральный сервер, который
+знает обо всех доступных ветках. Действительно, в распределённой среде
+интересующие ветки могут буквально существовать в сотнях мест во всему
+Интернету (или внутри Интранета).
+
+Launchpad заполняет этот пробел, предоставляя реестр веток.
+
+
+Регистрация веток
+-----------------
+
+Ветки могут быть загружены на Launchpad или просто зарегистрированы как
+доступные из внешних источников. Веткам так же можно назначать статусы, такие
+как *Новая*, *В разработке*, *Готовая* или *Отмененная*.
+
+Заметка: Внешние ветки могут даже располагаться в старых системах контроля
+версий, таких как CVS и Subversion. Код из этих систем будет периодически
+сканироваться и преобразовываться в ветки Bazaar. Конечно же, для максимальной
+точности, предпочтительнее чтобы внешние ветки были в формате Bazaar.
+
+
+Просмотр веток
+--------------
+
+Для веток можно просматривать их список, фильтровать и сортировать по
+множеству атрибутов, включая Имя, Регистратора, Автора, Состояние, Возраст и
+время последней фиксации. Также работает просмотр веток, что легко позволяет
+увидеть следующее:
+
+* откуда можно скачать ветку
+* как залить изменения
+* недавние фиксации и изменения, сделанные каждым разработчиком
+* исходный код отдельных файлов для указанной ревизии.
+
+
+Доступ к коду в Launchpad с помощью Bazaar
+==========================================
+
+Получение кода для проекта с открытым исходным кодом
+----------------------------------------------------
+
+Launchpad отслеживает тысячи проектов с открытым исходным кодом и вне
+зависимости от того хранится этот код в Bazaar, CVS или Subversion
+пользователи Bazaar легко могут получить этот код так::
+
+	bzr branch lp:имя-проекта
+
+где `имя-проекта` - это идентификатор проекта на Launchpad. Вот некоторые
+примеры::
+
+	bzr branch lp:inkscape
+	bzr branch lp:amarok
+	bzr branch lp:python
+	bzr branch lp:rails
+	bzr branch lp:java-gnome
+
+После этого вы можете просматривать код локально с помощью вашего любимого
+редактора или среды разработки и при желании изменять его.
+
+Если для проекта зарегистрировано несколько выпусков (например, выпуск
+разработки в выпуск поддержки), тогда свежий код для заданного выпуска можно
+получить используя команду::
+
+	bzr branch lp:имя-проекта/выпуск
+
+Публикация ваших изменений
+--------------------------
+
+Исправив эту надоедливую ошибку или добавив новую крутую возможность, о
+которой вы давно мечтали, пришло время удивить ваших друзей и сделать мир
+лучше, сделав ваш код доступным для других. Как уже объяснялось раньше,
+Launchpad это бесплатная служба для размещения веток Bazaar и поэтому вы
+можете опубликовать свою ветку на нём, так чтобы другие смогли получить доступ
+к вашему коду. Например, предположим что вы уже участник соответствующей
+команды, авторизуйтесь на Launchpad таким образом::
+
+	bzr launchpad-login пользователь
+
+где `пользователь` - это ваш идентификатор пользователя Launchpad. После этого
+вы можете залить ваши изменения на ветку команды вот так::
+
+	bzr push lp:~имя-команды/имя-проекта/имя-ветки
+
+Теперь другие могут скачать ваш код таким образом::
+
+	bzr branch lp:~имя-команды/имя-проекта/имя-ветки
+
+
+Личные ветки
+------------
+
+Даже если вы не член какой-либо команды Launchpad можно использовать для
+публикации ваших изменений. В этом случае просто создайте личную ветку::
+
+	bzr push lp:~пользователь/имя-проекта/имя-ветки
+
+Другие затем могут скачать ваш код таким образом::
+
+	bzr branch lp:~пользователь/имя-проекта/имя-ветки
+
+Заметка: даже в случае публикации личной ветки будет вежливо уведомить
+основных разработчиков о вашей ветке, чтобы они смогли взять ваши изменения,
+если они подходят и для других пользователей и соответствуют стандартам
+качества проекта.
+
+
+Связывание веток в Launchpad
+============================
+
+Привязка ветки к сообщению об ошибке
+------------------------------------
+
+После регистрации ветки вы можете связать её с ошибкой, чтобы заинтересованные
+в ее исправлении люди могли отслеживать изменения и скачать исправление, когда
+оно станет доступно.
+
+Чтобы сделать это выполните следующие шаги:
+
+1. Перейдите к странице с нужной ошибкой.
+
+2. Выберите `Add branch` (Добавить ветку) в разделе `Actions` (Действия).
+
+3. Выберите ветку.
+
+4. При желании вы можете изменить состояние (State) связи. По умолчанию
+   состояние будет *Fix In Progress* (Работа над исправлением), но вы можете
+   установить другое состояние, например *Fix Available* (Исправление
+   доступно), если ветка уже содержит исправление.
+
+При желании вы также можете добавить произвольный комментарий о связи между
+ошибкой и веткой.
+
+
+Изменение состояния ветки в Launchpad во время фиксации в Bazaar
+----------------------------------------------------------------
+
+Bazaar и Launchpad способны работать вместе, чтобы уменьшить ваши заботы по
+управлению состоянием ветки. Когда вы выполняете фиксацию с помощью Bazaar,
+используйте параметр --fixes::
+
+	bzr commit --fixes lp:1234 -m "..."
+
+где 1234 |--| это идентификатор ошибки. Эти данные изменят State (состояние
+отношения ветки к ошибке) на *Fix Available* (Исправление доступно). Если одна
+единственная фиксация исправляет несколько ошибок, то параметр --fixes может
+быть указан несколько раз.
+
+Самое интересное здесь заключается в том, что вам не обязательно иметь доступ
+к Launchpad в момент фиксации. При использовании ``--fixes`` идентификатор
+ошибки сохраняется в виде специальных метаданных, которые Launchpad увидит при
+очередной публикации ваших изменений или когда ваша публичная ветка будет
+просканирована в очередной раз.
+
+Заметка: Launchpad не будет закрывать сообщение об ошибке только потому, что
+существует ветка с исправлением. Для этого есть несколько причин. Во-первых,
+обычно исправления из вашей ветки должны быть объединены с главной веткой
+разработки, иначе большинство команд не будет считать ошибку исправленной.
+Во-вторых, многие команды придерживаются отдельного процесса для подтверждения
+исправлений ошибок, в добавление к утверждению разработчика об этом.
+
+Как поясняется далее, функция отслеживания объединений веток на Launchpad в
+настоящее время находится в стадии разработки. Как только эта функция будет
+готова более подходящим поведением станет автоматическое изменение состояния
+ошибки на *Fix Committed* (исправление зафиксировано). 
+
+
+Связь ветки с планом
+--------------------
+
+После регистрации ветки вы можете связать её с планом, чтобы люди,
+заинтересованные в этом плане могли отслеживать и тестировать новые
+возможности по мере разработки.
+
+Чтобы это сделать, выполните следующие шаги:
+
+1. Перейдите к нужному плану (Blueprint).
+
+2. Выберите `Link branch` (Связать ветку) в разделе `Actions` (Действия).
+
+3. Выберите ветку.
+
+При желании вы также можете добавить произвольный комментарий об отношении
+ветки к плану.
+
+
+Управление релизами с помощью Launchpad
+=======================================
+
+Интеграция изменений
+--------------------
+
+Когда разработка на ветке закончена и она опубликована, сообщества обычно
+проходят через строгий процесс, прежде чем изменения будут интегрированы в
+основной продукт и предоставлены конечным пользователям. Вот некоторые из
+возможных шагов:
+
+* просмотр изменений другими участниками проекта
+
+* принятие решения, в какой релиз будут включены изменения, например, в
+  следующий релиз с исправлениями, или в следующее крупное обновление, или в
+  оба
+
+* прогон функциональных тестов для выявления ошибок
+
+* измерение производительности
+
+* включение в предварительные версии для тестирования конечными пользователями
+
+* обновление документации, например, заметок о выпуске
+
+* перевод пользовательского интерфейса и документации на разные языки.
+
+Этот раздел дает обзор возможностей Launchpad, которые помогают получить
+высокое качество кода в конечном продукте. Хорошая интеграция с Bazaar
+является основой для того, чтобы это прошло гладко.
+
+Примечание: в тех случаях, когда указано, некоторые из следующих возможностей
+всё ещё находятся в стадии разработки. Если одна или несколько таких
+возможностей вам интересны, рассмотрите возможность вступления в команду
+бета-тестирования Launchpad по следующей ссылке:
+https://help.launchpad.net/JoiningLaunchpadBetaTesters. В этом случае, вы
+сможете получить предварительный доступ к возможностям и сможете дать отзыв
+разработчиками до широкого внедрения.
+
+
+Предложение по объединению веток
+--------------------------------
+
+После перехода к ветке в Launchpad, одно из доступных действий - *Propose for
+merging* (Предложить объединение). Это действие позволяет вам указать, с какой
+веткой этот код мог бы быть объединен.
+
+Отслеживание знаний о том, какие ветки предлагается объединить в главную,
+помогает менеджерам выпусков держать на виду то, что ещё должно быть
+завершено, либо может быть завершено, до даты выпуска. Используя эту
+информацию, они могут убедиться, что ветки объединены после завершения их
+необходимых обзоров. В простом случае, менеджер выпуска может объединить ветки
+вручную. В более сложных ситуациях, объединение может быть сделано роботом
+(таким, как `PQM`_) автоматически, когда ветки перейдут в правильное состояние
+(например, *Review completed* (Обзор завершен)).
+
+.. _PQM: https://launchpad.net/pqm
+
+
+Отслеживание обзора кода
+------------------------
+
+Некоторые функции в Launchpad все еще в стадии разработки, например
+отслеживание состояний, обсуждений и результатов обзора кода. Ожидается, что
+эти функции будут интегрированы с предложениями по объединению веток и
+просмотром веток.
+
+
+Архивы личных пакетов (PPAs)
+----------------------------
+
+PPAs помогают разработчикам и командам разработки выдать определенный выпуск
+на руки пользователям для раннего тестирования и получения отзывов. Другими
+словами, PPA позволяет разработчику создать сообщество тестеров,
+заинтересованных в их изменениях. Тестирующее сообщество может установить
+пакеты, запускать их в течение тестового периода, а затем аккуратно удалить их
+из системы.
+
+Дальнейшую информацию можно найти по адресу
+https://help.launchpad.net/PPAQuickStart
+
+
+Переводы
+--------
+
+Модуль переводов в Launchpad сделан для того чтобы любой желающий мог легко
+присоединиться к переводу приложений на известные ему языки. Переводчики
+защищены от подробностей низкого уровня.
+
+Launchpad отслеживает переводы для каждой основной версии проекта по
+отдельности, что позволяет переводчикам продолжать совершенствовать перевод
+ваших стабильных релизов, пока другие могут начать работу над новыми версиями,
+которые все ещё находятся в разработке. Скорость перевода увеличивается из-за
+совместного использования ресурсов между проектами. Автоматические подсказки,
+из библиотеки в 750 тысяч переведенных строк, а также сообщество из
+19 тысяч зарегистрированных переводчиков может радикально сократить время,
+необходимое для локализации вашего проекта на многие языки.
+
+
+Итоги
+=====
+
+Сообщества к которым мы присоединяемся, будь то в реальной жизни, или онлайн,
+говорят многое о нас. Обратная сторона этого заключается в инструментах
+которые вы выбираете для сообщества - в частности, CDE и инструмент контроля
+версий. Это может иметь большое значение для тех кто пожелает присоединиться,
+и насколько легко они смогут помочь.
+
+Сами по себе, Launchpad и Bazaar являются очень полезными инструментами.
+Вместе они могут:
+
+* помочь вашему сообществу отслеживать основные ресурсы, такие как исходный
+  код и знания;
+* помочь ему расти, снизив вступительный барьер;
+* помочь ему во взаимодействии с зависимыми сообществами.
+
+В частности, Launchpad является сервисом хранения свободного кода для ваших
+веток Bazaar. Ветки можно просматривать онлайн, их можно связать с ошибками и
+планами. А их статус по отношению к ошибке может автоматически управляться
+упоминанием об ошибке при сохранении в Bazaar. Дальнейшая интеграция находится
+в стадии развития с целью оптимизации процесса от *большой идеи* до
+*работающего кода в руках конечных пользователей*.
+
+Если у вас есть отзывы или пожелания о том, как лучше интегрировать Bazaar и
+Launchpad, пожалуйста связывайтесь с нами через список рассылки
+bazaar@lists.canonical.com.
+
+Хотя Launchpad разработан как бесплатный сервис для поддержки проектов с
+открытыми исходными текстами, Canonical может сделать его доступным и для
+разработчиков коммерческого программного обеспечения, в зависимости от их
+требований. Мы с удовольствием выслушаем ваше мнение, если вы считаете, что
+Launchpad был бы полезен для управления вашим сообществом, будь оно открытое
+или нет.
+
+
+.. |--| unicode:: U+2014

=== added directory 'doc/ru/user-guide'
=== added file 'doc/ru/user-guide/branching_a_project.txt'
--- doc/ru/user-guide/branching_a_project.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/branching_a_project.txt	2009-06-02 11:14:10 +0000
@@ -0,0 +1,112 @@
+Branching a project
+===================
+
+Branch URLs
+-----------
+
+Before someone else can get a copy of your work, you need to
+agree on a transfer technology.
+You may decide to make the top level directory of your branch
+a network share, an approach familiar to Windows users.
+Linux and OS X users might prefer access to be
+via SFTP, a secure protocol built-in to most SSH servers.
+Bazaar is *very* flexible in this regard with support for
+lots of protocols some of which are given below.
+
+  ===========         ======================================================
+  Prefix              Description
+  ===========         ======================================================
+  file://             Access using the standard filesystem (default)
+  sftp://             Access using SFTP (most SSH servers provide SFTP).
+  bzr://              Fast access using the Bazaar smart server.
+  ftp://              Access using passive FTP.
+  http://             Read-only access to branches exported by a web server.
+  ===========         ======================================================
+
+As indicated above, branches are identified using URLs with the
+prefix indicating the transfer technology. If no prefix is given,
+normal filenames are assumed. For a complete list of supported
+protocols, see the ``urlspec`` online help topic or the
+`URL Identifiers <../user-reference/bzr_man.html#url-identifiers>`_
+section of the Bazaar User Reference.
+
+.. _a-reminder-about-shared-repositories:
+
+Напоминание о разделяемых репозиториях
+--------------------------------------
+
+Before getting a copy of a branch, have a quick think about
+where to put it on your filesystem. For maximum storage
+efficiency down the track, it is recommended that branches
+be created somewhere under a directory that has been set up
+as a shared repository. (See `Feature branches`_ in
+n `Organizing your workspace`_ for a commonly used layout.)
+For example::
+
+  bzr init-repo my-repo
+  cd my-repo
+
+You are now ready to grab a branch from someone else and
+hack away.
+
+The branch command
+------------------
+
+To get a branch based on an existing branch, use the ``branch`` command.
+The syntax is::
+
+  bzr branch URL [directory]
+
+If a directory is not given, one is created based on the last part of
+the URL. Here are some examples showing a drive qualified path (M:/) and an
+sftp URL respectively::
+
+  bzr branch M:/cool-trunk
+  bzr branch sftp://bill@mary-laptop/cool-repo/cool-trunk
+
+This example shows explicitly giving the directory name to use for the
+new branch::
+
+  bzr branch /home/mary/cool-repo/cool-trunk cool
+
+Time and space considerations
+-----------------------------
+
+Depending on the size of the branch being transferred and the
+speed and latency of the network between your computer and the
+source branch, this initial transfer might take some time.
+Subsequent updates should be much faster as only the
+changes are transferred then.
+
+Keep in mind that Bazaar is transferring the
+complete history of the branch, not just the latest snapshot.
+As a consequence, you can be off the network (or disconnected
+from the network share) after ``branch`` completes but you'll
+still be able to ``log`` and ``diff`` the history of the
+branch as much as you want. Furthermore, these operations
+are quick as the history is stored locally.
+
+Note that Bazaar uses smart compression technology to
+minimize the amount of disk space required to store version
+history. In many cases, the complete history of a project
+will take up less disk space than the working copy of
+the latest version.
+
+As explained in later chapters, Bazaar also has support for
+`lightweight checkouts <#getting-a-lightweight-checkout>`_ 
+of a branch, i.e. working trees with
+no local storage of history. Of course, disconnected usage
+is not available then but that's a tradeoff you can decide
+to make if local disk space is really tight for you. Support for
+limited lookback into history - *history horizons* - is
+currently under development as well.
+
+Viewing branch information
+--------------------------
+
+If you wish to see information about a branch including where it came from,
+use the ``info`` command. For example::
+
+  bzr info cool
+
+If no branch is given, information on the current branch is displayed.

=== added file 'doc/ru/user-guide/core_concepts.txt'
--- doc/ru/user-guide/core_concepts.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/core_concepts.txt	2009-06-05 18:59:14 +0000
@@ -0,0 +1,115 @@
+Основные концепции
+==================
+
+Простая модель для пользователя
+-------------------------------
+
+Для использования Bazaar нужно понимать четыре основные концепции:
+
+* **Ревизия** - снимок файлов с которыми вы работаете.
+
+* **Рабочее дерево** - каталог содержащий файлы и каталоги под контролем версий
+
+* **Ветка** - упорядоченный набор ревизий, описывающий историю набора файлов.
+
+* **Репозиторий** - хранилище ревизий.
+
+Давайте рассмотрим каждую концепцию более детально.
+
+Ревизия
+-------
+
+Ревизия - это *снимок* состояния дерева файлов и каталогов включающий их
+содержимое и форму. С ревизией так же связаны некоторые мета-данные, например:
+
+* Кто зафиксировал ревизию
+* Когда ревизия была зафиксирована
+* Комментарий к ревизии
+* Родительские ревизии от которых была унаследована данная ревизия
+
+Ревизии не изменяются и могут быть глобально и уникально идентифицированы
+*идентификатором ревизии*. Пример идентификатора::
+
+ pqm@pqm.ubuntu.com-20071129184101-u9506rihe4zbzyyz
+
+Идентификаторы ревизий создаются во время фиксации, или, в случае импорта из
+других систем, в момент импорта. Хотя идентификаторы ревизий необходимы для
+внутреннего использования и интеграции с внешними инструментами, специфичные
+для веток *номера ревизий* предпочтительны для людей.
+
+Номера ревизий - это разделенные точками десятичные идентификаторы, такие как
+1, 42 и 2977.1.59, которые отслеживают путь через граф номеров ревизий на
+ветке. Номера ревизий обычно короче чем идентификаторы ревизий и, в пределах
+одной ветки, могут сравниваться друг с другом для получения картины их
+отношений. Например, ревизия 10 - это основная ревизия (см. ниже) следующая
+непосредственно после ревизии 9. Номера ревизий создаются налету, при
+выполнении каждой команды, т.к. они зависят от ревизии являющейся верхушкой
+(т.е. самой последней ревизией) на ветке.
+
+Смотрите `Определение ревизий`_ в приложениях для более детального описания
+огромного количества методов задания ревизий и их диапазонов в Bazaar и
+`Понимание номеров ревизий`_ для более детального описания нумерации ревизий.
+
+.. *TODO: добавить диаграмму*
+
+Рабочее дерево
+--------------
+
+Рабочее дерево - это *каталог под контролем версий* содержащий файлы которые
+может редактировать пользователь. Рабочее дерево связано с *веткой*.
+
+Многие команды используют рабочее дерево как контекст, например ``commit``
+создает новую ревизию используя текущее содержимое файлов в рабочем дереве.
+
+.. *TODO: добавить диаграмму*
+
+Ветка
+-----
+
+В простейшем случае, ветка - это *упорядоченная серия ревизий*. Самая последняя
+ревизия известна как *верхушка*.
+
+Ветки могут быть разделены и *объединены* обратно, формируя *граф* ревизий.
+Технически, граф показывает прямые отношения (между родительской и дочерними
+ревизиями) и не имеет петель, и известен как *направленный ациклический граф*
+(directed acyclic graph (DAG)).
+
+Но не стоит бояться этого названия. Основные вещи которые нужно помнить:
+
+* Основная линия разработки внутри графа называется *основная линия*,
+  или просто *левая сторона*.
+
+* Ветка может иметь другие линии разработки и в этом случае они начинаются
+  в одной точке и заканчиваются в другой.
+
+.. *TODO: добавить диаграмму*
+
+Репозиторий
+-----------
+
+Репозиторий - это просто *хранилище ревизий*. В простейшем случае, каждая ветка
+имеет свой собственный репозиторий. В других случаях имеет смысл разделять
+репозиторий между ветками для оптимизации дискового пространства.
+
+.. *TODO: добавить диаграмму*
+
+Складывая концепции вместе
+--------------------------
+
+Как только вы поняли описанные выше концепции, различные пути использования
+Bazaar станут более понятными. Простейший способ использования Bazaar - это
+использовать *самостоятельное дерево*, совмещающее рабочее дерево, ветку и
+репозиторий в одном месте. Другие часто используемые сценарии включают:
+
+* `Разделяемые репозитории <#a-reminder-about-shared-repositories>`_ -
+  рабочее дерево и ветка находятся вместе, но репозиторий находится в
+  каталоге выше.
+
+* `Стек веток <#using-stacked-branches>`_ - ветка хранит только уникальные
+  для нее ревизии и использует родительский репозиторий для общих ревизий.
+
+* `Легковесные рабочие копии <#getting-a-lightweight-checkout>`_ -
+  ветка хранится в другом месте по сравнению с рабочим деревом.
+
+Лучший путь для использования Bazaar конечно зависит от ваших потребностей.
+Давайте дальше рассмотрим некоторые часто употребляемые способы использования.

=== added directory 'doc/ru/user-guide/images'
=== added file 'doc/ru/user-guide/images/workflows_centralized.png'
Binary files doc/ru/user-guide/images/workflows_centralized.png and doc/ru/user-guide/images/workflows_centralized.png differ
=== added file 'doc/ru/user-guide/images/workflows_centralized.svg'
--- doc/ru/user-guide/images/workflows_centralized.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_centralized.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,1542 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_centralized.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_centralized.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1.4142136"
+     inkscape:cx="536.99132"
+     inkscape:cy="369.73871"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1024"
+     inkscape:window-height="712"
+     inkscape:window-x="-4"
+     inkscape:window-y="-4" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,207.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
+       x="140"
+       y="521.23737"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="140"
+         y="521.23737">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr checkout</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(492.85715,-2.8571472)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="777.71429"
+       y="191.52307"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="777.71429"
+         y="191.52307">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="819.5625"
+       y="191.21948"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9568"
+         x="819.5625"
+         y="191.21948">bzr update</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.29065037;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 539.95542,466.93556 L 415.85387,476.71718 L 426.49116,461.93102 L 358.1094,466.70812 C 358.1094,466.70812 347.47211,481.94916 346.96566,481.94916 C 346.45858,481.94916 322.14533,462.15846 322.14533,462.15846 C 322.14533,462.15846 379.38334,441.45772 379.88978,441.45772 C 379.38334,441.00284 369.25249,456.01673 369.25249,456.24417 L 448.27282,451.23935 L 437.63489,466.48068 L 551.09912,456.92649 L 539.95542,466.93556 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(51.511043,348.5966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="334.36819"
+       y="540.97681"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="334.36819"
+         y="540.97681">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="369.5625"
+       y="544.09448"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="369.5625"
+         y="544.09448">bzr commit</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/images/workflows_gatekeeper.png'
Binary files doc/ru/user-guide/images/workflows_gatekeeper.png and doc/ru/user-guide/images/workflows_gatekeeper.png differ
=== added file 'doc/ru/user-guide/images/workflows_gatekeeper.svg'
--- doc/ru/user-guide/images/workflows_gatekeeper.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_gatekeeper.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,2137 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_gatekeeper.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_manualpqm.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient7932"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7934"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7936"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7938"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7940"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7942"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7944"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient7946"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7948"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7950"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient7952"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7954"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7956"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7958"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7960"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7962"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient7964"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7966"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient7968"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7990"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <radialGradient
+       xlink:href="#linearGradient1861"
+       r="26.285225"
+       inkscape:collect="always"
+       id="radialGradient1887"
+       fy="44.906904"
+       fx="34.609807"
+       cy="45.317611"
+       cx="33.865884"
+       gradientTransform="scale(1.3025634,0.767717)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1861"
+       r="27.313507"
+       inkscape:collect="always"
+       id="radialGradient1885"
+       fy="96.522109"
+       fx="44.745902"
+       cy="96.948882"
+       cx="45.838441"
+       gradientTransform="scale(1.0963096,0.9121511)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="69.990188"
+       y1="60.176033"
+       xlink:href="#linearGradient1864"
+       x2="54.084046"
+       x1="51.210938"
+       inkscape:collect="always"
+       id="linearGradient1883"
+       gradientTransform="scale(1.2343409,0.8101489)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1858">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop1859" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop1860" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1861">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop1862" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1863" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1864">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop1865" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1866" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1867">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop1868" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1869" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11180">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop11182" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11184" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11174">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop11176" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11178" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11168">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop11170" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11172" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11162">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop11164" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop11166" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="559.94128"
+     inkscape:cy="472.46874"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1416"
+     inkscape:window-height="825"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,39.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,227.66157)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(635.63525,491.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="73.4375"
+       y="510.12573"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="73.4375"
+         y="510.12573">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(466.18527,201.5491)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="751.04242"
+       y="395.37573"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="751.04242"
+         y="395.37573">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="778.89062"
+       y="392.32886"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         x="778.89062"
+         y="392.32886"
+         id="tspan2963">make changes</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.52894235;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 578.13978,492.35651 L 518.11306,536.64644 L 515.93459,528.2361 L 482.53728,552.4378 C 482.53728,552.4378 484.9546,560.99862 484.68867,561.16617 C 484.42242,561.33391 461.26447,562.83001 461.26447,562.83001 C 461.26447,562.83001 480.44933,537.04707 480.71524,536.87954 C 480.21048,536.89659 482.77445,545.21473 482.89387,545.28997 L 521.75768,517.49359 L 524.17482,526.05472 L 578.73553,485.35896 L 578.13978,492.35651 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(449.56027,418.37723)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="732.41742"
+       y="611.97729"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="732.41742"
+         y="611.97729">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="768.26562"
+       y="608.23511"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="768.26562"
+         y="608.23511">request merge</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="75.5625"
+       y="228.09448"
+       id="text2965"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2967"
+         x="75.5625"
+         y="228.09448">main branch</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="556.98438"
+       y="165.64139"
+       id="text2969"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2971"
+         x="556.98438"
+         y="165.64139">local branches</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path4930"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(1.9161749,0,0,1.0419298,-477.33182,37.826027)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path7839"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(2.0657387,0,0,1.0382501,-36.482679,-19.544354)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.27460909;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path7875"
+       d="M 313.49127,554.98551 L 266.8349,508.88833 L 275.69462,507.21539 L 250.19978,481.56811 C 250.19978,481.56811 241.18156,483.42447 241.00507,483.22026 C 240.82835,483.0158 239.25232,465.23179 239.25232,465.23179 C 239.25232,465.23179 266.41286,479.96469 266.58935,480.16889 C 266.57138,479.78127 257.8088,481.75026 257.72954,481.84196 L 287.01109,511.6872 L 277.99254,513.54344 L 320.8627,555.44302 L 313.49127,554.98551 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <g
+       id="g7884"
+       transform="translate(322.22009,479.97324)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient7932);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path7886"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient7934);fill-opacity:1"
+         id="g7888">
+        <path
+           style="fill:url(#linearGradient7936);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path7890"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient7938);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path7892"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient7940);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path7894"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient7942);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient7944);stroke-width:1.44734821pt"
+         id="rect7896"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient7946);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path7898"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient7948);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path7900"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient7950);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect7902"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient7952);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient7954);stroke-width:1.4649456pt"
+         id="rect7904"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient7956);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path7906"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g7908">
+        <path
+           style="fill:url(#linearGradient7958);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path7910"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient7960);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path7912"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient7962);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path7914"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient7964);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path7916"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient7966);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path7918"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient7968);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path7920"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient7990);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path7922"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text7924"><tspan
+           id="tspan7926">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text7928"><tspan
+           id="tspan7930">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g11201"
+       transform="translate(224.98935,560.87966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11204"
+         d="M 61.208646,74.540863 C 65.958047,79.724425 68.980394,89.011639 75.672733,89.01164 C 82.14919,87.211791 83.012718,71.805094 83.876245,68.493375 C 76.536261,73.532948 68.980395,76.412704 61.208646,74.540863 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,-0.8485902,18.11889)"
+         style="fill:#ebd5bb;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path11206"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#354b63;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path11208"
+         d="M 32.210275,101.34753 C 31.819634,126.54379 96.449036,129.42515 96.292736,101.34753 C 97.837516,79.018786 86.732289,66.323086 83.972618,68.481556 C 82.571377,69.577533 82.050742,93.917319 72.58281,88.318677 C 67.97993,85.596878 62.831472,75.141814 60.578865,74.794949 C 57.17979,74.271545 50.671042,71.519447 44.693328,66.368738 C 43.125035,65.017418 32.739724,78.907727 32.210275,101.34753 z " />
+      <path
+         style="fill:#7e5429;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccscc"
+         id="path14564"
+         d="M 67.304802,16.686453 C 54.985668,-4.2976037 31.742548,13.847204 34.832083,38.13111 C 28.606909,39.936495 13.38594,55.735942 54.610465,51.217079 C 72.973357,49.204214 127.11969,28.718598 84.679736,22.863615 C 78.797006,1.2972292 67.040662,6.1031815 67.304802,16.686453 z " />
+      <path
+         style="fill:url(#linearGradient1883);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1879"
+         d="M 89.582928,41.074792 C 78.886738,46.748497 62.561318,51.815798 53.926678,52.762292 C 47.018518,53.519536 42.160188,53.578455 38.114178,53.356042 C 39.550848,66.152312 50.849068,76.168541 64.707928,76.168542 C 79.538378,76.168542 91.582928,64.747093 91.582928,50.668542 C 91.582928,47.276803 90.850878,44.035951 89.582928,41.074792 z " />
+      <path
+         style="fill:url(#radialGradient1885);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1884"
+         d="M 43.031249,70.1875 C 35.995246,80.448202 32.902215,93.581638 34.156249,105.875 C 40.334493,118.62839 56.831543,120.43683 69.499999,119.875 C 80.494576,119.32475 94.949065,113.14258 93.695531,100.00002 C 93.939855,90.023763 92.261916,78.780004 84.874999,71.5 C 82.650684,78.396104 83.536195,89.443626 74.999999,91.84375 C 65.062996,91.017122 64.05284,76.914438 54.283675,75.750529 C 50.352102,75.051855 46.009593,69.547093 43.031249,70.1875 z " />
+      <path
+         style="fill:url(#radialGradient1887);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1886"
+         d="M 51.968749,10.15625 C 40.703741,13.843837 36.038494,27.433868 37.531249,38.375 C 35.900906,41.584912 25.71302,45.254989 31.843749,49.03125 C 53.068339,53.154256 75.12687,46.221276 93.715523,36.077723 C 100.42684,33.740896 99.810666,26.846559 92.384918,26.66513 C 86.324151,26.558371 81.674394,23.81643 81.165374,17.307044 C 79.826948,13.582045 74.107596,6.6890987 71.01108,12.623276 C 71.073069,19.511996 65.891703,20.102559 63.230392,14.042893 C 60.468574,10.851605 56.135557,9.1882781 51.968749,10.15625 z " />
+    </g>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2488"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(82.857147,474.9866)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="365.71429"
+       y="668.60229"
+       id="text2490"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2492"
+         x="365.71429"
+         y="668.60229">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="401.5625"
+       y="665.76636"
+       id="text2494"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2496"
+         x="401.5625"
+         y="665.76636">accept or reject</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/images/workflows_localcommit.png'
Binary files doc/ru/user-guide/images/workflows_localcommit.png and doc/ru/user-guide/images/workflows_localcommit.png differ
=== added file 'doc/ru/user-guide/images/workflows_localcommit.svg'
--- doc/ru/user-guide/images/workflows_localcommit.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_localcommit.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,1575 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_localcommit.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_localcommit.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient8493"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient8491"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient8485">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop8487" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop8489" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.70710678"
+     inkscape:cx="503.09779"
+     inkscape:cy="201.79714"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1024"
+     inkscape:window-height="712"
+     inkscape:window-x="-4"
+     inkscape:window-y="-4" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,207.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
+       x="140"
+       y="521.23737"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="140"
+         y="521.23737">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="763.75"
+       y="188.09448"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="763.75"
+         y="188.09448">bzr commit --local</tspan><tspan
+         sodipodi:role="line"
+         x="763.75"
+         y="228.09448"
+         id="tspan7922" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="801.4375"
+       y="609.46948"
+       id="text7881"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan7883"
+         x="801.4375"
+         y="609.46948">bzr unbind</tspan><tspan
+         sodipodi:role="line"
+         x="801.4375"
+         y="641.46948"
+         id="tspan8507">bzr commit</tspan><tspan
+         sodipodi:role="line"
+         x="801.4375"
+         y="673.46948"
+         id="tspan8511">bzr bind</tspan></text>
+    <g
+       id="g7903"
+       transform="translate(21.8125,50.285718)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path7897"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text7899"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan7901"
+           sodipodi:role="line">1</tspan></text>
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="351.375"
+       y="272.69269"
+       id="text7908"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan7910"
+         x="351.375"
+         y="272.69269">bzr checkout</tspan></text>
+    <g
+       id="g7912"
+       transform="translate(438.71429,-31.85714)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path7914"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text7916"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan7918"
+           sodipodi:role="line">2</tspan></text>
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.58159733;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path8495"
+       d="M 530.64409,443.90791 L 411.93077,455.56731 L 422.10621,437.94266 L 356.69344,443.63682 C 356.69344,443.63682 346.51796,461.80368 346.0335,461.80368 C 345.54844,461.80368 322.2908,438.21377 322.2908,438.21377 C 322.2908,438.21377 377.0437,413.53911 377.52817,413.53911 C 377.0437,412.99691 367.35272,430.89301 367.35272,431.16411 L 442.94217,425.19852 L 432.76613,443.36572 L 541.30393,431.97742 L 530.64409,443.90791 z " />
+    <g
+       id="g8497"
+       transform="translate(446.57144,390.28572)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path8499"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text8501"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan8503"
+           sodipodi:role="line">2</tspan></text>
+    </g>
+    <g
+       id="g8513"
+       transform="translate(59.142865,311.71429)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path8515"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text8517"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan8519"
+           sodipodi:role="line">3</tspan></text>
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="389.375"
+       y="534.40698"
+       id="text8525"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan8527"
+         x="389.375"
+         y="534.40698">bzr commit</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/images/workflows_peer.png'
Binary files doc/ru/user-guide/images/workflows_peer.png and doc/ru/user-guide/images/workflows_peer.png differ
=== added file 'doc/ru/user-guide/images/workflows_peer.svg'
--- doc/ru/user-guide/images/workflows_peer.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_peer.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,1589 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_peer.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_peer.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="536.99132"
+     inkscape:cy="369.73871"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1759"
+     inkscape:window-height="875"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       id="g5256"
+       transform="translate(601.5744,309.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(541.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(111.5744,317.66157)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,300.80614,215.0989)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 357.16674,263.66524 L 470.27399,251.12251 L 460.57906,270.08242 L 522.9028,263.95688 C 522.9028,263.95688 532.59773,244.41369 533.05931,244.41369 C 533.52148,244.41369 555.68079,269.79078 555.68079,269.79078 C 555.68079,269.79078 503.51355,296.33479 503.05197,296.33479 C 503.51355,296.91808 512.74689,277.66616 512.74689,277.37453 L 440.72705,283.79207 L 450.42255,264.24852 L 347.01023,276.4996 L 357.16674,263.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="635.5625"
+       y="201.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="635.5625"
+         y="201.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(318.85715,7.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="601.71429"
+       y="199.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="601.71429"
+         y="199.52307">2</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.49513507;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 426.28539,558.28183 L 482.38891,565.59894 L 477.58003,554.5382 L 508.49388,558.1117 C 508.49388,558.1117 513.30276,569.51271 513.53172,569.51271 C 513.76096,569.51271 524.75243,554.70834 524.75243,554.70834 C 524.75243,554.70834 498.87641,539.22321 498.64746,539.22321 C 498.87641,538.88294 503.45634,550.11403 503.45634,550.28417 L 467.73303,546.54033 L 472.54219,557.94156 L 421.24757,550.79458 L 426.28539,558.28183 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(-194.48896,372.41254)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="87.591393"
+       y="566.02826"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="87.591393"
+         y="566.02826">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="119.03906"
+       y="543.19232"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="119.03906"
+         y="543.19232">merge changes</tspan><tspan
+         sodipodi:role="line"
+         x="119.03906"
+         y="583.19232"
+         id="tspan2716">from peer</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2670"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(-187.14285,5.361605)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="94.539062"
+       y="198.97729"
+       id="text2672"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2674"
+         x="94.539062"
+         y="198.97729">1</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="129.5625"
+       y="195.43823"
+       id="text2676"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2678"
+         x="129.5625"
+         y="195.43823">start project</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2680"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(-20.189728,217.62723)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="261.83594"
+       y="411.22729"
+       id="text2682"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2684"
+         x="261.83594"
+         y="411.22729">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="294.51562"
+       y="388.40698"
+       id="text2686"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2688"
+         x="294.51562"
+         y="388.40698">record</tspan><tspan
+         sodipodi:role="line"
+         x="294.51562"
+         y="428.40698"
+         id="tspan2712">changes</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2690"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(321.8001,372.41254)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="603.88049"
+       y="566.02826"
+       id="text2692"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2694"
+         x="603.88049"
+         y="566.02826">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="635.32812"
+       y="543.19232"
+       id="text2696"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2698"
+         x="635.32812"
+         y="543.19232">merge changes</tspan><tspan
+         sodipodi:role="line"
+         x="635.32812"
+         y="583.19232"
+         id="tspan2718">from peer</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2700"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(462.85715,216.65848)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="744.88281"
+       y="410.25854"
+       id="text2702"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2704"
+         x="744.88281"
+         y="410.25854">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="777.5625"
+       y="387.43823"
+       id="text2706"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2708"
+         x="777.5625"
+         y="387.43823">record</tspan><tspan
+         sodipodi:role="line"
+         x="777.5625"
+         y="427.43823"
+         id="tspan2714">changes</tspan></text>
+    <path
+       inkscape:export-ydpi="41.964157"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       d="M 515.71461,505.61603 L 459.61109,512.93314 L 464.41997,501.8724 L 433.50612,505.4459 C 433.50612,505.4459 428.69724,516.84691 428.46828,516.84691 C 428.23904,516.84691 417.24757,502.04254 417.24757,502.04254 C 417.24757,502.04254 443.12359,486.55741 443.35254,486.55741 C 443.12359,486.21714 438.54366,497.44823 438.54366,497.61837 L 474.26697,493.87453 L 469.45781,505.27576 L 520.75243,498.12878 L 515.71461,505.61603 z "
+       id="path2710"
+       sodipodi:nodetypes="cccccccccccc"
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.49513507;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1" />
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/images/workflows_pqm.png'
Binary files doc/ru/user-guide/images/workflows_pqm.png and doc/ru/user-guide/images/workflows_pqm.png differ
=== added file 'doc/ru/user-guide/images/workflows_pqm.svg'
--- doc/ru/user-guide/images/workflows_pqm.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_pqm.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,1794 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_pqm.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_pqm.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7934"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       id="linearGradient1858">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop1859" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop1860" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1861">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop1862" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1863" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1864">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop1865" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1866" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1867">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop1868" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1869" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11180">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop11182" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11184" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11174">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop11176" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11178" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11168">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop11170" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11172" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11162">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop11164" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop11166" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="559.94128"
+     inkscape:cy="392.13154"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1416"
+     inkscape:window-height="825"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2791"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(562.85715,227.14285)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="844.88281"
+       y="420.74292"
+       id="text2793"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2795"
+         x="844.88281"
+         y="420.74292">3</tspan></text>
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,39.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,227.66157)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(593.63525,509.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,417.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,874.16045,452.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="92.546875"
+       y="509.71948"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="92.546875"
+         y="509.71948">Server</tspan><tspan
+         sodipodi:role="line"
+         x="92.546875"
+         y="569.71948"
+         id="tspan2803">(PQM)</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(558.85715,89.5491)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="841.25"
+       y="283.37573"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="841.25"
+         y="283.37573">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="874.89062"
+       y="264.32886"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         x="874.89062"
+         y="264.32886"
+         id="tspan2788">make</tspan><tspan
+         sodipodi:role="line"
+         x="874.89062"
+         y="304.32886"
+         id="tspan2815">changes</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(449.56027,432.37723)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="732.41742"
+       y="625.97729"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="732.41742"
+         y="625.97729">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="768.26562"
+       y="622.23511"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="768.26562"
+         y="622.23511">accept or reject</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="75.5625"
+       y="228.09448"
+       id="text2965"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2967"
+         x="75.5625"
+         y="228.09448">main branch</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="556.98438"
+       y="165.64139"
+       id="text2969"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2971"
+         x="556.98438"
+         y="165.64139">local branches</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path4930"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(1.9161749,0,0,1.0419298,-477.33182,37.826027)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path7839"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(2.0657387,0,0,1.0382501,-36.482679,-19.544354)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <g
+       id="g11201"
+       transform="translate(224.98935,560.87966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2488"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(44.857147,386.9866)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="327.71429"
+       y="580.60229"
+       id="text2490"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2492"
+         x="327.71429"
+         y="580.60229">5</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="363.5625"
+       y="577.76636"
+       id="text2494"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2496"
+         x="363.5625"
+         y="577.76636">request merge</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path2801"
+       d="M 530.83326,472.52373 L 417.72601,485.06646 L 427.42094,466.10655 L 365.0972,472.23209 C 365.0972,472.23209 355.40227,491.77528 354.94069,491.77528 C 354.47852,491.77528 332.31921,466.39819 332.31921,466.39819 C 332.31921,466.39819 384.48645,439.85418 384.94803,439.85418 C 384.48645,439.27089 375.25311,458.52281 375.25311,458.81444 L 447.27295,452.3969 L 437.57745,471.94045 L 540.98977,459.68937 L 530.83326,472.52373 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="878.89062"
+       y="396.40698"
+       id="text2811"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         x="878.89062"
+         y="396.40698"
+         id="tspan2813">request</tspan><tspan
+         sodipodi:role="line"
+         x="878.89062"
+         y="436.40698"
+         id="tspan2817">review</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/images/workflows_shared.png'
Binary files doc/ru/user-guide/images/workflows_shared.png and doc/ru/user-guide/images/workflows_shared.png differ
=== added file 'doc/ru/user-guide/images/workflows_shared.svg'
--- doc/ru/user-guide/images/workflows_shared.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_shared.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,1594 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_shared.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_shared.png"
+   inkscape:export-xdpi="49.419998"
+   inkscape:export-ydpi="49.419998">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.8"
+     inkscape:cx="578.40513"
+     inkscape:cy="404.22798"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1405"
+     inkscape:window-height="869"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,207.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
+       x="140"
+       y="521.23737"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="140"
+         y="521.23737">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(492.85715,-2.8571472)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="777.71429"
+       y="191.52307"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="777.71429"
+         y="191.52307">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="819.5625"
+       y="179.59448"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9568"
+         x="819.5625"
+         y="179.59448">bzr pull</tspan><tspan
+         sodipodi:role="line"
+         x="819.5625"
+         y="219.59448"
+         id="tspan2963">bzr merge</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.29065037;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 539.95542,466.93556 L 415.85387,476.71718 L 426.49116,461.93102 L 358.1094,466.70812 C 358.1094,466.70812 347.47211,481.94916 346.96566,481.94916 C 346.45858,481.94916 322.14533,462.15846 322.14533,462.15846 C 322.14533,462.15846 379.38334,441.45772 379.88978,441.45772 C 379.38334,441.00284 369.25249,456.01673 369.25249,456.24417 L 448.27282,451.23935 L 437.63489,466.48068 L 551.09912,456.92649 L 539.95542,466.93556 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(51.511043,348.5966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="334.36819"
+       y="540.97681"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="334.36819"
+         y="540.97681">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="369.5625"
+       y="544.09448"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="369.5625"
+         y="544.09448">bzr commit</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="61.5625"
+       y="240.09448"
+       id="text2965"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan2967"
+         x="61.5625"
+         y="240.09448">main branch</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="563.43756"
+       y="582.09442"
+       id="text2969"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan2971"
+         x="563.43756"
+         y="582.09442">local branches</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006169;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path4930"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(1.9161749,0,0,1.0419298,-501.33182,49.826027)" />
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path7839"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(2.1405493,0,0,1.0364644,-57.067817,396.76108)" />
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/images/workflows_single.png'
Binary files doc/ru/user-guide/images/workflows_single.png and doc/ru/user-guide/images/workflows_single.png differ
=== added file 'doc/ru/user-guide/images/workflows_single.svg'
--- doc/ru/user-guide/images/workflows_single.svg	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/images/workflows_single.svg	2009-06-01 20:15:36 +0000
@@ -0,0 +1,1079 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_single.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1.4142136"
+     inkscape:cx="536.99132"
+     inkscape:cy="529.01021"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1465"
+     inkscape:window-height="896"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       id="g5256"
+       transform="translate(631.5744,227.66157)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="345.5625"
+       y="218.05542"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         x="345.5625"
+         y="218.05542"
+         id="tspan2399">create project</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(32.857147,24.174103)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="314.53906"
+       y="217.78979"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="314.53906"
+         y="217.78979">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(33.388397,76.658478)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="315.78125"
+       y="270.48511"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="315.78125"
+         y="270.48511">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="344.92188"
+       y="267.43823"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9568"
+         x="344.92188"
+         y="267.43823">record changes</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(32.857147,128.5416)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="314.88281"
+       y="322.14166"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="314.88281"
+         y="322.14166">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="346.9086"
+       y="319.32135"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="346.9086"
+         y="319.32135">browse history</tspan></text>
+    <flowRoot
+       xml:space="preserve"
+       id="flowRoot2405"><flowRegion
+         id="flowRegion2407"><rect
+           id="rect2409"
+           width="274.35742"
+           height="94.045197"
+           x="293.44931"
+           y="485.2934" /></flowRegion><flowPara
+         id="flowPara2411"></flowPara></flowRoot>    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2427"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(32.857147,180.5416)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="314.9375"
+       y="374.15729"
+       id="text2429"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2431"
+         x="314.9375"
+         y="374.15729">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="346.9086"
+       y="371.32135"
+       id="text2433"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2435"
+         x="346.9086"
+         y="371.32135">package release</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ru/user-guide/index.txt'
--- doc/ru/user-guide/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/index.txt	2009-06-02 11:14:10 +0000
@@ -0,0 +1,121 @@
+###############################
+Руководство пользователя Bazaar
+###############################
+
+.. Пожалуйста отмечайте секции в подключаемых файлах следующим образом:
+..   уровень 1 ========
+..   уровень 2 --------
+..   уровень 3 ~~~~~~~~
+..   уровень 4 ^^^^^^^^ (лучше не использовать вложенность больше 3-х уровней)
+
+.. contents::
+   Содержание
+   :depth: 2
+.. sectnum::
+
+
+Введение
+########
+
+.. include:: introducing_bazaar.txt
+.. include:: core_concepts.txt
+.. include:: ../../en/user-guide/bazaar_workflows.txt
+
+
+Начинаем работать
+#################
+
+.. include:: ../../en/user-guide/installing_bazaar.txt
+.. include:: ../../en/user-guide/entering_commands.txt
+.. include:: ../../en/user-guide/getting_help.txt
+.. include:: ../../en/user-guide/configuring_bazaar.txt
+.. include:: ../../en/user-guide/using_aliases.txt
+.. include:: ../../en/user-guide/plugins.txt
+.. include:: zen.txt
+
+
+Личный контроль версий
+######################
+
+.. include:: ../../en/user-guide/solo_intro.txt
+.. include:: ../../en/user-guide/starting_a_project.txt
+.. include:: ../../en/user-guide/controlling_registration.txt
+.. include:: ../../en/user-guide/reviewing_changes.txt
+.. include:: ../../en/user-guide/recording_changes.txt
+.. include:: ../../en/user-guide/browsing_history.txt
+.. include:: ../../en/user-guide/releasing_a_project.txt
+.. include:: ../../en/user-guide/undoing_mistakes.txt
+
+
+Делимся с другими
+#################
+
+.. include:: ../../en/user-guide/partner_intro.txt
+.. include:: branching_a_project.txt
+.. include:: ../../en/user-guide/merging_changes.txt
+.. include:: ../../en/user-guide/resolving_conflicts.txt
+.. include:: ../../en/user-guide/annotating_changes.txt
+
+
+Сотрудничество в команде, централизованный стиль
+################################################
+
+.. include:: ../../en/user-guide/central_intro.txt
+.. include:: ../../en/user-guide/publishing_a_branch.txt
+.. include:: using_checkouts.txt
+.. include:: ../../en/user-guide/working_offline_central.txt
+.. include:: ../../en/user-guide/reusing_a_checkout.txt
+
+
+Сотрудничество в команде, распределенный стиль
+##############################################
+
+.. include:: ../../en/user-guide/distributed_intro.txt
+.. include:: ../../en/user-guide/organizing_branches.txt
+.. include:: ../../en/user-guide/using_gatekeepers.txt
+.. include:: ../../en/user-guide/sending_changes.txt
+
+
+Различные темы
+##############
+
+.. include:: ../../en/user-guide/part2_intro.txt
+.. include:: ../../en/user-guide/adv_merging.txt
+.. include:: ../../en/user-guide/shelving_changes.txt
+.. include:: ../../en/user-guide/filtered_views.txt
+.. include:: stacked.txt
+.. include:: ../../en/user-guide/server.txt
+.. include:: ../../en/user-guide/hooks.txt
+.. include:: ../../en/user-guide/version_info.txt
+ 
+
+Краткое описание некоторых популярных плагинов
+##############################################
+
+.. include:: ../../en/user-guide/bzrtools_plugin.txt
+.. include:: ../../en/user-guide/svn_plugin.txt
+.. include later looms_plugin.txt
+
+
+Интегрируем Bazaar в нашу среду
+###############################
+
+.. include:: ../../en/user-guide/web_browsing.txt
+.. include later - file_explorers.txt
+.. include later - desktop_integration.txt
+.. include later - editors_and_ides.txt
+.. include later - email.txt
+.. include:: ../../en/user-guide/bug_trackers.txt
+
+
+Приложения
+##########
+
+.. include:: specifying_revisions.txt
+.. include:: ../../en/user-guide/organizing_your_workspace.txt
+.. include:: ../../en/user-guide/shared_repository_layouts.txt
+.. include:: ../../en/user-guide/setting_up_email.txt
+.. include:: ../../en/user-guide/http_smart_server.txt
+.. include:: ../../en/user-guide/writing_a_plugin.txt
+
+.. |--| unicode:: U+2014

=== added file 'doc/ru/user-guide/introducing_bazaar.txt'
--- doc/ru/user-guide/introducing_bazaar.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/introducing_bazaar.txt	2009-06-02 11:14:10 +0000
@@ -0,0 +1,150 @@
+Представляем Bazaar
+===================
+
+Что такое Bazaar?
+-----------------
+
+Bazaar - это инструмент помогающий людям сотрудничать. Он отслеживает
+изменения, которые вы и другие люди делают с группой файлов, (таких как
+исходный код программы) для того что бы дать вам снимок каждого этапа их
+эволюции. Используя эту информацию, Bazaar может без проблем объединить вашу
+работу с работой других людей.
+
+Такие инструменты как Bazaar называются системами контроля версий (Version
+Control System (VCS)) и уже долгое время популярны среди разработчиков ПО.
+Легкость использования, гибкость и простота настройки Bazaar делают его
+идеальным не только для разработчиков ПО, но так же и для других групп,
+работающих совместно с файлами и документами, таких как технические писатели,
+Web-дизайнеры и переводчики.
+
+Это руководство описывает установку и использование Bazaar вне зависимости от
+того работает вы один, или в команде с другими людьми. Если вы уже знаете, что
+такое распределенная система контроля версий и хотите перейти прямо к описанию
+работы вы можете бегло просмотреть эту секцию и перейти прямо к
+`Продолжаем изучение`_.
+
+Краткая история систем контроля версий
+--------------------------------------
+
+Инструменты для контроля версий на данный момент развиваются уже в течение
+нескольких десятилетий. Простыми словами можно описать 4 поколения таких
+инструментов:
+
+ 1. инструменты контроля версий файлов, например CSSC, RCS
+ 2. инструменты контроля дерева файлов - централизованный стиль, например CVS
+ 3. инструменты контроля дерева файлов - централизованный стиль, этап 2,
+    например Subversion
+ 4. инструменты контроля дерева файлов - распределенный стиль, например Bazaar.
+
+Дизайн и реализация Bazaar учитывает уроки полученные на каждом из этих этапов
+развития подобных инструментов. В частности, Bazaar аккуратно поддерживает и
+централизованную и распределенную модели контроля версий и таким образом вы
+можете менять модель работы (когда это имеет смысл) без необходимости смены
+инструмента.
+
+Централизованная модель против распределенной
+---------------------------------------------
+
+Многие традиционные инструменты контроля версий требуют наличия центрального
+сервера, который хранит историю изменений (или *репозиторий*) для дерева
+файлов. Что бы работать с файлами пользователю необходимо установить соединение
+с сервером и получить *рабочую версию* файлов. Таким образом пользователь
+получает *рабочее дерево* в котором он может работать. Для сохранения, или
+*фиксации* изменений пользователю нужен доступ к центральному серверу и он
+должен убедиться, что перед фиксацией он объединил свою работу с последней
+версией сохраненной на сервере. Такой подход известен как централизованная
+модель.
+
+Централизованная модель проверена достаточно долгой практикой, но она имеет и
+некоторые значительные недостатки. Во-первых, централизованная система требует
+наличия соединения с сервером при выполнении большинства операций по контролю
+версий. Во-вторых, централизованная модель жестко связывает момент **фиксации**
+изменений с моментом их **публикации**. В каких-то ситуациях это может быть
+нормально, но может сказываться негативно в других.
+
+Распределенные системы контроля версий позволяют отдельным пользователям и
+командам иметь несколько репозиториев, вместо одного центрального. В случае с
+Bazaar история обычно хранится в том же месте, что и код который находится под
+контролем версий. Это позволяет пользователю фиксировать свои изменения в любой
+момент когда это нужно, даже при отсутствии сетевого соединения. Сетевое
+соединение требуется только для публикации изменений, или когда нужен доступ к
+изменениям в другом месте.
+
+На самом деле для разработчиков использование распределенных систем контроля
+версий может иметь другие преимущества, кроме очевидных, связанных с работой
+при отсутствии сетевого соединения. Другие преимущества включают:
+
+ * более легкое создание разработчиками экспериментальных веток
+ * более легкое сотрудничество с другими разработчикам
+ * меньше времени требуется для механических задач и больше для творчества
+
+ * увеличение гибкости в управлении релизами через использование
+   фиксаций включающих набор изменений для конкретной функциональности
+
+ * качество и стабильность основной ветки может быть выше, что делает
+   работу проще для каждого
+
+ * для сообществ с открытым исходным кодом:
+
+   * более легкое создание и поддержка изменений для сторонних разработчиков 
+
+   * упрощение взаимодействия основных разработчиков со сторонними
+     разработчиками и более простая миграция сторонних разработчиков в основные 
+
+ * для компаний - упрощение работы с распределенными и внешними командами.
+
+Для более детального взгляда на преимущества распределенных систем контроля
+версий по сравнению с централизованными смотрите http://bazaar-vcs.org/BzrWhy.
+
+
+Ключевые особенности Bazaar
+---------------------------
+
+Хотя Bazaar не единственная распределенная система контроля версий, она имеет
+некоторые значимые преимущества, которые делают ее прекрасным выбором для
+многих команд и сообществ. Описание этих особенностей и сравнение с другими
+системами контроля версий может быть найдено на Wiki Bazaar -
+http://bazaar-vcs.org.
+
+Из большинства особенностей, одна требует особого упоминания: Bazaar - это
+полностью свободное ПО написанное на языке Python. Это упрощает сотрудничество
+для внесения улучшений. Если вы хотите помочь, обратите внимание на
+http://bazaar-vcs.org/BzrSupport.
+
+
+Продолжаем изучение
+-------------------
+
+Это руководство представляет из себя легкое для чтения введение в Bazaar и
+описание его использования. Всем пользователям рекомендуется прочесть хотя бы
+окончание этой главы, так как:
+
+ * она описывает основные концепции, которые нужно знать пользователям
+ * она описывает некоторые популярные пути использования Bazaar для
+   сотрудничества.
+
+Главы 2-6 более детально описывают использование Bazaar для выполнения
+различных задач. Большинству пользователей рекомендуется прочесть их одну за
+другой сразу после начала использования Bazaar. Глава 7 и дальше содержат
+дополнительную информацию, которая поможет получить максимум от Bazaar после
+того как понятны основные функции. Этот материал может быть прочитан когда
+потребуется и в любом порядке.
+
+Если вы уже хорошо знакомы с другими системами контроля версий, вы возможно
+захотите вникнуть скорее через чтение следующих документов:
+
+ * `Bazaar за пять минут`_ - небольшое введение
+
+ * `Bazaar. Карточка быстрого старта`_ - наиболее часто используемые команды на
+   одной странице.
+
+Плюс к этому справка на сайте и `Справка по Bazaar`_ предоставляют все детали
+по доступным командам и опциям.
+
+.. _Bazaar за пять минут: ../mini-tutorial/index.html
+.. _Bazaar. Карточка быстрого старта: ../quick-reference/quick-start-summary.svg
+.. _Справка по Bazaar: ../../en/user-reference/bzr_man.html
+
+Мы надеемся, что вам понравится это руководство. Если у вас есть пожелания по
+улучшению документации Bazaar вы можете написать в список рассылки
+bazaar@lists.canonical.com.

=== added file 'doc/ru/user-guide/specifying_revisions.txt'
--- doc/ru/user-guide/specifying_revisions.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/specifying_revisions.txt	2009-06-02 11:14:10 +0000
@@ -0,0 +1,153 @@
+Определение ревизий
+===================
+
+Revision identifiers and ranges
+-------------------------------
+
+Bazaar has a very expressive way to specify a revision or a range of revisions.
+To specify a range of revisions, the upper and lower bounds are separated by the
+``..`` symbol. For example::
+
+    $ bzr log -r 1..4
+
+You can omit one bound like::
+
+    $ bzr log -r 1..
+    $ bzr log -r ..4
+
+Some commands take only one revision, not a range. For example::
+
+    $ bzr cat -r 42 foo.c
+
+In other cases, a range is required but you want the length of the range to
+be one. For commands where this is relevant, the ``-c`` option is used like this::
+
+    $ bzr diff -c 42
+
+
+Available revision identifiers
+------------------------------
+
+The revision, or the bounds of the range, can be given using
+different format specifications as shown below.
+
+ +----------------------+------------------------------------+
+ |  argument type       | description                        |
+ +----------------------+------------------------------------+
+ | *number*             | revision number                    |
+ +----------------------+------------------------------------+
+ | **revno**:*number*   | positive revision number           |
+ +----------------------+------------------------------------+
+ | **last**:*number*    | negative revision number           |
+ +----------------------+------------------------------------+
+ | **revid**:*guid*     | globally unique revision id        |
+ +----------------------+------------------------------------+
+ | **before**:*rev*     | leftmost parent of ''rev''         |
+ +----------------------+------------------------------------+
+ | **date**:*value*     | first entry after a given date     |
+ +----------------------+------------------------------------+
+ | **tag**:*value*      | revision matching a given tag      |
+ +----------------------+------------------------------------+
+ | **ancestor**:*path*  | last merged revision from a branch |
+ +----------------------+------------------------------------+
+ | **branch**:*path*    | latest revision on another branch  |
+ +----------------------+------------------------------------+
+ | **submit**:*path*    | common ancestor with submit branch |
+ +----------------------+------------------------------------+
+
+A brief introduction to some of these formats is given below.
+For complete details, see `Revision Identifiers`_ in the
+Bazaar User Reference.
+
+.. _Revision Identifiers: ../user-reference/bzr_man.html#revision-identifiers
+
+Numbers
+~~~~~~~
+
+Positive numbers denote revision numbers in the current branch. Revision
+numbers are labelled as "revno" in the output of ``bzr log``.  To display
+the log for the first ten revisions::
+
+    $ bzr log -r ..10
+
+Negative numbers count from the latest revision, -1 is the last committed
+revision.
+
+To display the log for the last ten revisions::
+
+    $ bzr log -r -10..
+
+revid
+~~~~~
+
+**revid** allows specifying a an internal revision ID, as shown by ``bzr
+log`` and some other commands.
+
+For example::
+
+    $ bzr log -r revid:Matthieu.Moy@imag.fr-20051026185030-93c7cad63ee570df
+
+before
+~~~~~~
+
+**before**
+    ''rev'' specifies the leftmost parent of ''rev'', that is the revision
+    that appears before ''rev'' in the revision history, or the revision that
+    was current when ''rev'' was committed.
+
+''rev'' can be any revision specifier and may be chained.
+
+For example::
+
+    $ bzr log -r before:before:4
+    ...
+    revno: 2
+    ...
+
+date
+~~~~
+
+**date**
+    ''value'' matches the first history entry after a given date, either at
+    midnight or at a specified time.
+
+Legal values are:
+
+ * **yesterday**
+ * **today**
+ * **tomorrow**
+ * A **YYYY-MM-DD** format date.
+ * A **YYYY-MM-DD,HH:MM:SS** format date/time, seconds are optional (note the
+   comma)
+
+The proper way of saying "give me all the log entries for today" is::
+
+    $ bzr log -r date:yesterday..date:today
+
+Ancestor
+~~~~~~~~
+
+**ancestor**:*path*
+    specifies the common ancestor between the current branch and a 
+    different branch. This is the same ancestor that would be used for
+    merging purposes.
+
+*path* may be the URL of a remote branch, or the file path to a local branch.
+
+For example, to see what changes were made on a branch since it was forked
+off ``../parent``::
+
+    $ bzr diff -r ancestor:../parent
+
+Branch
+~~~~~~
+
+branch
+   ``path`` specifies the latest revision in another branch.
+
+``path`` may be the URL of a remote branch, or the file path to a local branch.
+
+For example, to get the differences between this and another branch::
+
+    $ bzr diff -r branch:http://example.com/bzr/foo.dev
+

=== added file 'doc/ru/user-guide/stacked.txt'
--- doc/ru/user-guide/stacked.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/stacked.txt	2009-06-05 18:59:14 +0000
@@ -0,0 +1,84 @@
+.. _using-stacked-branches:
+
+Использование стека веток
+=========================
+
+Что такое ветка в стеке?
+------------------------
+
+Ветка в стеке - это ветка которая знает как найти ревизии в другой ветке. Ветка
+в стеке хранит только уникальные ревизии, которые при этом быстрее создавать и
+они более эффективны по занимаемому месту. По этим показателям стек веток похож
+на разделяемые репозитории. Конечно стек веток имеет дополнительные
+преимущества:
+
+* Новая ветка может быть в абсолютно другом месте по сравнению с веткой на
+  которой она основана как стек.
+
+* Удаление ветки в стеке на самом деле удаляет ревизии (а не оставляет их в
+  разделяемом репозитории).
+
+* Стек веток более безопасен чем разделяемые репозитории, т.к. репозиторий на
+  котором основан стек может иметь доступ только для чтения для разработчиков
+  которые фиксируют изменения на ветке в стеке.
+
+Эти преимущества делают стек веток идеальным выбором для различных сценариев,
+включая экспериментальные ветки и сайты с хостингом кода.
+
+
+Создание ветки в стеке
+----------------------
+
+Что бы создать ветку в стеке нужно использовать опцию ``stacked`` для команды
+``branch``. Например::
+
+  bzr branch --stacked source-url my-dir
+
+Здесь мы создадим ``my-dir`` как ветку в стеке без локальных ревизий. Если
+определено открытая ветка связанная с ``source-url`` будет использована как
+*основа стека*. Иначе ``source-url`` будет *основой стека*.
+
+
+Создание рабочего каталога в стеке
+-----------------------------------
+
+Поддержка прямого создания рабочего каталога в стеке скоро ожидается. Пока
+для этого требуется два шага:
+
+1. Создать ветку в стеке, как описано выше.
+
+2. Конвертировать ветку в рабочий каталог используя либо команду
+   ``reconfigure``, либо команду ``bind``.
+
+
+Публикация ветки в стеке
+------------------------
+
+Многие изменения в большинстве проектов создаются на основе готовых веток,
+таких как *основная линия разработки*, или *текущая стабильная*. Создание новой
+ветки в стеке основанной на таких ветках легко сделать с использованием команды
+``push``::
+
+  bzr push --stacked-on reference-url my-url
+
+Эта команда создаст новую ветку ``my-url``, которая будет основана на
+``reference-url`` и содержать только ревизии из текущей ветки, которых еще нет
+на ветке ``reference-url``.
+
+Если локальная ветка была создана как ветка в стеке то мы можем использовать
+опцию ``--stacked`` для команды ``push`` и тогда ветка на которой будет основан
+стек будет задана неявно. Например::
+
+  bzr branch --stacked source-url my-dir
+  cd my-dir
+  (меняем, меняем, меняем)
+  bzr commit -m "исправление ошибки"
+  bzr push --stacked
+
+
+Ограничения веток в стеке
+-------------------------
+
+Важная вещь которую надо запомнить в отношении веток в стеке - ветка на которой
+основан стек должна быть доступна практически для всех операций. Конечно это не
+проблема если обе ветки локальные, или находятся на одном сервере.

=== added file 'doc/ru/user-guide/using_checkouts.txt'
--- doc/ru/user-guide/using_checkouts.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/using_checkouts.txt	2009-06-02 11:14:10 +0000
@@ -0,0 +1,98 @@
+Using checkouts
+===============
+
+Turning a branch into a checkout
+--------------------------------
+
+If you have a local branch and wish to make it a checkout, use the
+``bind`` command like this::
+
+  bzr bind sftp://centralhost/srv/bzr/PROJECT/trunk
+
+This is necessary, for example, after creating a central branch using
+``push`` as illustrated in the previous section.
+
+After this, commits will be applied to the bound branch before
+being applied locally.
+
+Turning a checkout into a branch
+--------------------------------
+
+If you have a checkout and wish to make it a normal branch, use the
+``unbind`` command like this::
+
+  bzr unbind
+
+After this, commits will only be applied locally.
+
+Getting a checkout
+------------------
+
+When working in a team using a central branch, one person needs
+to provide some initial content as shown in the previous section.
+After that, each person should use the ``checkout`` command to
+create their local checkout, i.e. the sandbox in which they
+will make their changes.
+
+Unlike Subversion and CVS, in Bazaar the ``checkout`` command creates a
+local full copy of history in addition to creating a working tree holding
+the latest content. This means that operations such as ``diff`` and ``log``
+are fast and can still be used when disconnected from the central location.
+
+.. _getting-a-lightweight-checkout:
+
+Создание легковесной рабочей копии
+----------------------------------
+
+While Bazaar does its best to efficiently store version history, there
+are occasions when the history is simply not wanted. For example, if your
+team is managing the content of a web site using Bazaar with a
+central repository, then your release process might be as simple as
+updating a checkout of the content on the public web server. In this
+case, you probably don't want the history downloaded to that location
+as doing so:
+
+ * wastes disk space holding history that isn't needed there
+ * exposes a Bazaar branch that you may want kept private.
+
+To get a history-less checkout in Bazaar, use the ``--lightweight``
+option like this::
+
+  bzr checkout --lightweight sftp://centralhost/srv/bzr/PROJECT/trunk
+
+Of course, many of the benefits of a normal checkout are lost by doing
+this but that's a tradeoff you can make if and when it makes sense.
+
+The ``--lightweight`` option only applies to checkouts, not to all branches.
+
+Note: If your code base is really large and disk space on your computer
+is limited, lightweight checkouts may be the right choice for you.
+Be sure to consider all your options though including
+`shared repositories <#a-reminder-about-shared-repositories>`_,
+`stacked branches <#using-stacked-branches>`_, and `reusing a checkout`_.
+
+Updating to the latest content
+------------------------------
+
+One of the important aspects of working in lockstep with others is
+keeping your checkout up to date with the latest changes made to
+the central branch. Just as you would in Subversion or CVS, you do
+this in Bazaar by using the ``update`` command like this::
+
+  bzr update
+
+This gets any new revisions available in the bound branch and
+merges your local changes, if any.
+
+Handling commit failures
+------------------------
+
+Note that your checkout *must* be up to date with the bound branch
+before running ``commit``. Bazaar is actually stricter about this
+than Subversion or CVS - you need to be up to date with the full
+tree, not just for the files you've changed. Bazaar will ask you
+to run ``update`` if it detects that a revision has been added to
+the central location since you last updated.
+
+If the network connection to the bound branch is lost, the commit will
+fail. Some alternative ways of working around that are outlined next.

=== added file 'doc/ru/user-guide/zen.txt'
--- doc/ru/user-guide/zen.txt	1970-01-01 00:00:00 +0000
+++ doc/ru/user-guide/zen.txt	2009-06-05 20:06:14 +0000
@@ -0,0 +1,215 @@
+Путь Bazaar
+===========
+
+Глубокое понимание Bazaar
+-------------------------
+
+Хотя Bazaar во многом похож на другие инструменты контроля версий, есть 
+некоторые важные различия, которые не всегда очевидны на первый взгляд. Этот
+раздел пытается объяснить некоторые вещи, который пользователь должен знать
+чтобы разбираться в Bazaar, т.е. глубоко его понимать.
+
+Заметьте: чтобы использовать Bazaar совсем необязательно полностью понимать 
+этот раздел. Вы можете просмотреть этот раздел сейчас и вернуться к нему позже. 
+
+Понимание номеров ревизий
+-------------------------
+
+All revisions in the mainline of a branch have a simple increasing
+integer. (First commit gets 1, 10th commit gets 10, etc.) This makes them
+fairly natural to use when you want to say "grab the 10th revision from my
+branch", or "fixed in revision 3050".
+
+For revisions which have been merged into a branch, a dotted notation is used
+(e.g., 3112.1.5). Dotted revision numbers have three numbers [#]_. The first
+number indicates what mainline revision change is derived from. The second
+number is the branch counter. There can be many branches derived from the
+same revision, so they all get a unique number. The third number is the
+number of revisions since the branch started. For example, 3112.1.5 is the
+first branch from revision 3112, the fifth revision on that branch.
+
+.. [#] Versions prior to bzr 1.2 used a slightly different algorithm.
+   Some nested branches would get extra numbers (such as 1.1.1.1.1)
+   rather than the simpler 3-number system.
+
+Hierarchical history is good
+----------------------------
+
+Imagine a project with multiple developers contributing changes where
+many changes consist of a series of commits. To give a concrete example,
+consider the case where:
+
+ * The tip of the project's trunk is revision 100.
+ * Mary makes 3 changes to deliver feature X.
+ * Bill makes 4 changes to deliver feature Y.
+
+If the developers are working in parallel and using a traditional
+centralized VCS approach, the project history will most likely be linear
+with Mary's changes and Bill's changes interleaved. It might look like this::
+
+  107: Add documentation for Y
+  106: Fix bug found in testing Y
+  105: Fix bug found in testing X
+  104: Add code for Y
+  103: Add documentation for X
+  102: Add code and tests for X
+  101: Add tests for Y
+  100: ...
+  
+Many teams use this approach because their tools make branching and merging
+difficult. As a consequence, developers update from and commit to the trunk
+frequently, minimizing integration pain by spreading it over every commit.
+If you wish, you can use Bazaar exactly like this. Bazaar does offer other
+ways though that you ought to consider.
+
+An alternative approach encouraged by distributed VCS tools is to create
+feature branches and to integrate those when they are ready. In this case,
+Mary's feature branch would look like this::
+
+  103: Fix bug found in testing X
+  102: Add documentation for X
+  101: Add code and tests for X
+  100: ...
+
+And Bill's would look like this::
+
+  104: Add documentation for Y
+  103: Fix bug found in testing Y
+  102: Add code for Y
+  101: Add tests for Y
+  100: ...
+
+If the features were independent and you wanted to keep linear history,
+the changes could be pushed back into the trunk in batches. (Technically,
+there are several ways of doing that but that's beyond the scope of
+this discussion.) The resulting history might look like this::
+
+  107: Fix bug found in testing X
+  106: Add documentation for X
+  105: Add code and tests for X
+  104: Add documentation for Y
+  103: Fix bug found in testing Y
+  102: Add code for Y
+  101: Add tests for Y
+  100: ...
+
+While this takes a bit more effort to achieve, it has some advantages over
+having revisions randomly intermixed. Better still though, branches can
+be merged together forming a non-linear history. The result might look
+like this::
+
+  102: Merge feature X
+       100.2.3: Fix bug found in testing X
+       100.2.2: Add documentation for X
+       100.2.1: Add code and tests for X
+  101: Merge feature Y
+       100.1.4: Add documentation for Y
+       100.1.3: Fix bug found in testing Y
+       100.1.2: Add code for Y
+       100.1.1: Add tests for Y
+  100: ...
+
+Or more likely this::
+
+  102: Merge feature X
+       100.2.3: Fix bug
+       100.2.2: Add documentation
+       100.2.1: Add code and tests
+  101: Merge feature Y
+       100.1.4: Add documentation
+       100.1.3: Fix bug found in testing
+       100.1.2: Add code
+       100.1.1: Add tests
+  100: ...
+
+This is considered good for many reasons:
+
+ * It makes it easier to understand the history of a project.
+   Related changes are clustered together and clearly partitioned.
+
+ * You can easily collapse history to see just the commits on the mainline
+   of a branch. When viewing the trunk history like this, you only see
+   high level commits (instead of a large number of commits uninteresting
+   at this level).
+
+ * If required, it makes backing out a feature much easier.
+
+ * Continuous integration tools can be used to ensure that
+   all tests still pass before committing a merge to the mainline.
+   (In many cases, it isn't appropriate to trigger CI tools after
+   every single commit as some tests will fail during development.
+   In fact, adding the tests first - TDD style - will guarantee it!)
+
+In summary, the important points are:
+
+  *Organize your work using branches.*
+
+  *Integrate changes using merge.*
+
+  *Ordered revision numbers and hierarchy make history easier to follow.*
+
+
+Each branch has its own view of history
+---------------------------------------
+
+As explained above, Bazaar makes the distinction between:
+
+ * mainline revisions, i.e. ones you committed in your branch, and
+
+ * merged revisions, i.e. ones added as ancestors by committing a merge.
+
+Each branch effectively has its own view of history, i.e. different
+branches can give the same revision a different "local" revision number.
+Mainline revisions always get allocated single number revision numbers
+while merged revisions always get allocated dotted revision numbers.
+
+To extend the example above, here's what the revision history of
+Mary's branch would look like had she decided to merge the project
+trunk into her branch after completing her changes::
+
+  104: Merge mainline
+       100.2.1: Merge feature Y
+       100.1.4: Add documentation
+       100.1.3: Fix bug found in testing
+       100.1.2: Add code
+       100.1.1: Add tests
+  103: Fix bug found in testing X
+  102: Add documentation for X
+  101: Add code and tests for X
+  100: ...
+
+Once again, it's easy for Mary to look at just *her* top level of history
+to see the steps she has taken to develop this change. In this context,
+merging the trunk (and resolving any conflicts caused by doing that) is
+just one step as far as the history of this branch is concerned.
+
+It's important to remember that Bazaar is not changing history here, nor
+is it changing the global revision identifiers. You can always use the
+latter if you really want to. In fact, you can use the branch specific
+revision numbers when communicating *as long as* you provide the branch
+URL as context. (In many Bazaar projects, developers imply the central
+trunk branch if they exchange a revision number without a branch URL.)
+
+Merges do not change revision numbers in a branch, though they do
+allocate local revision numbers to newly merged revisions. The only time
+Bazaar will change revision numbers in a branch is when you explicitly
+ask it to mirror another branch.
+
+Note: Revisions are numbered in a stable way: if two branches have
+the same revision in their mainline, all revisions in the ancestry of that
+revision will have the same revision numbers. For example, if Alice and Bob's
+branches agree on revision 10, they will agree on all revisions before
+that.
+
+Резюме
+------
+
+Обычно, если вы следовали ранее полученным советам - организовать вашу работу
+в ветках и использовать объединение для сотрудничества - вы обнаружите что 
+чаще всего Bazaar делает то что вы ожидаете.
+
+В следующих главах, мы проверим различный способы использования Bazaar, начиная 
+с самого простого: использование Bazaar для личных проектов.
+
+..
+   vim: ft=rst tw=74 ai

=== modified file 'generate_docs.py'
--- generate_docs.py	2009-03-23 14:59:43 +0000
+++ generate_docs.py	2009-06-15 08:56:52 +0000
@@ -33,6 +33,7 @@
 Run "%(prog)s --help" for the option reference.
 """
 
+import bzrlib.commands
 import sys
 from optparse import OptionParser
 
@@ -68,6 +69,8 @@
     if len(args) != 2:
         parser.print_help()
         sys.exit(1)
+    
+    bzrlib.commands.install_bzr_command_hooks()
 
     infogen_type = args[1]
     infogen_mod = tools.doc_generate.get_module(infogen_type)

=== modified file 'setup.py'
--- setup.py	2009-05-23 04:55:52 +0000
+++ setup.py	2009-06-15 17:02:13 +0000
@@ -259,17 +259,19 @@
         define_macros=define_macros, libraries=libraries))
 
 
+add_pyrex_extension('bzrlib._bencode_pyx')
 add_pyrex_extension('bzrlib._btree_serializer_c')
+add_pyrex_extension('bzrlib._chunks_to_lines_pyx')
 add_pyrex_extension('bzrlib._groupcompress_pyx',
                     extra_source=['bzrlib/diff-delta.c'])
-add_pyrex_extension('bzrlib._chunks_to_lines_pyx')
 add_pyrex_extension('bzrlib._knit_load_data_c')
+add_pyrex_extension('bzrlib._known_graph_pyx')
 add_pyrex_extension('bzrlib._rio_pyx')
-add_pyrex_extension('bzrlib._chk_map_pyx', libraries=['z'])
 if sys.platform == 'win32':
     add_pyrex_extension('bzrlib._dirstate_helpers_c',
                         libraries=['Ws2_32'])
     add_pyrex_extension('bzrlib._walkdirs_win32')
+    z_lib = 'zdll'
 else:
     if have_pyrex and pyrex_version == '0.9.4.1':
         # Pyrex 0.9.4.1 fails to compile this extension correctly
@@ -284,6 +286,8 @@
     else:
         add_pyrex_extension('bzrlib._dirstate_helpers_c')
     add_pyrex_extension('bzrlib._readdir_pyx')
+    z_lib = 'z'
+add_pyrex_extension('bzrlib._chk_map_pyx', libraries=[z_lib])
 ext_modules.append(Extension('bzrlib._patiencediff_c', ['bzrlib/_patiencediff_c.c']))
 
 

=== added file 'tools/time_graph.py'
--- tools/time_graph.py	1970-01-01 00:00:00 +0000
+++ tools/time_graph.py	2009-06-12 18:05:15 +0000
@@ -0,0 +1,97 @@
+#!/usr/bin/env python
+import random
+import os
+import time
+import sys
+import optparse
+from bzrlib import (
+    branch,
+    commands,
+    graph,
+    ui,
+    trace,
+    _known_graph_py,
+    _known_graph_pyx,
+    )
+from bzrlib.ui import text
+
+p = optparse.OptionParser()
+p.add_option('--max-combinations', default=500, type=int)
+p.add_option('--lsprof', default=None, type=str)
+opts, args = p.parse_args(sys.argv[1:])
+trace.enable_default_logging()
+ui.ui_factory = text.TextUIFactory()
+
+if len(args) >= 1:
+    b = branch.Branch.open(args[0])
+else:
+    b = branch.Branch.open('.')
+b.lock_read()
+try:
+    g = b.repository.get_graph()
+    parent_map = dict(p for p in g.iter_ancestry([b.last_revision()])
+                         if p[1] is not None)
+finally:
+    b.unlock()
+
+print 'Found %d nodes' % (len(parent_map),)
+
+def all_heads_comp(g, combinations):
+    h = []
+    pb = ui.ui_factory.nested_progress_bar()
+    try:
+        for idx, combo in enumerate(combinations):
+            if idx & 0x1f == 0:
+                pb.update('proc', idx, len(combinations))
+            h.append(g.heads(combo))
+    finally:
+        pb.finished()
+    return h
+combinations = []
+# parents = parent_map.keys()
+# for p1 in parents:
+#     for p2 in random.sample(parents, 10):
+#         combinations.append((p1, p2))
+# Times for random sampling of 10x1150 of bzrtools
+#   Graph        KnownGraph
+#   96.1s   vs   25.7s  :)
+# Times for 500 'merge parents' from bzr.dev
+#   25.6s   vs   45.0s  :(
+
+for revision_id, parent_ids in parent_map.iteritems():
+    if parent_ids is not None and len(parent_ids) > 1:
+        combinations.append(parent_ids)
+if opts.max_combinations > 0 and len(combinations) > opts.max_combinations:
+    combinations = random.sample(combinations, opts.max_combinations)
+
+print '      %d combinations' % (len(combinations),)
+t1 = time.clock()
+known_g = _known_graph_py.KnownGraph(parent_map)
+if opts.lsprof is not None:
+    h_known = commands.apply_lsprofiled(opts.lsprof,
+        all_heads_comp, known_g, combinations)
+else:
+    h_known = all_heads_comp(known_g, combinations)
+t2 = time.clock()
+print "Known: %.3fs" % (t2-t1,)
+print "  %s" % (graph._counters,)
+t1 = time.clock()
+known_g = _known_graph_pyx.KnownGraph(parent_map)
+if opts.lsprof is not None:
+    h_known = commands.apply_lsprofiled(opts.lsprof,
+        all_heads_comp, known_g, combinations)
+else:
+    h_known = all_heads_comp(known_g, combinations)
+t2 = time.clock()
+print "Known (pyx): %.3fs" % (t2-t1,)
+print "  %s" % (graph._counters,)
+simple_g = graph.Graph(graph.DictParentsProvider(parent_map))
+graph._counters[1] = 0
+graph._counters[2] = 0
+h_simple = all_heads_comp(simple_g, combinations)
+t3 = time.clock()
+print "Orig: %.3fs" % (t3-t2,)
+print "  %s" % (graph._counters,)
+if h_simple != h_known:
+    import pdb; pdb.set_trace()
+print 'ratio: %.3fs' % ((t2-t1) / (t3-t2))

